/* A Bison parser, made by GNU Bison 2.4.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006,
   2009, 2010 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yylval          base_yylval
#define yychar          base_yychar
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs
#define yylloc          base_yylloc

/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "gram.y"


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 1996-2010, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  $PostgreSQL: pgsql/src/backend/parser/gram.y,v 2.711 2010/02/23 22:51:42 tgl Exp $
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *	  SQL92-specific syntax is separated from plain SQL/Postgres syntax
 *	  to help isolate the non-extensible portions of the parser.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET SQL_inheritance TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.  The handling of SQL_inheritance is
 *	  a good example.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/gramparse.h"
#include "parser/parser.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/* Location tracking support --- simpler than bison's default */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if (N) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (Rhs)[0]; \
	} while (0)

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	GrantObjectType objtype;
	List	   *objs;
} PrivTarget;


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static FuncCall *makeOverlaps(List *largs, List *rargs,
							  int location, core_yyscan_t yyscanner);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static SelectStmt *findLeftmostSelect(SelectStmt *node);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);



/* Line 189 of yacc.c  */
#line 217 "gram.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENT = 258,
     FCONST = 259,
     SCONST = 260,
     BCONST = 261,
     XCONST = 262,
     Op = 263,
     ICONST = 264,
     PARAM = 265,
     TYPECAST = 266,
     DOT_DOT = 267,
     COLON_EQUALS = 268,
     ABORT_P = 269,
     ABSOLUTE_P = 270,
     ACCESS = 271,
     ACTION = 272,
     ADD_P = 273,
     ADMIN = 274,
     AFTER = 275,
     AGGREGATE = 276,
     ALL = 277,
     ALSO = 278,
     ALTER = 279,
     ALWAYS = 280,
     ANALYSE = 281,
     ANALYZE = 282,
     AND = 283,
     ANY = 284,
     ARRAY = 285,
     AS = 286,
     ASC = 287,
     ASSERTION = 288,
     ASSIGNMENT = 289,
     ASYMMETRIC = 290,
     AT = 291,
     AUTHORIZATION = 292,
     BACKWARD = 293,
     BEFORE = 294,
     BEGIN_P = 295,
     BETWEEN = 296,
     BIGINT = 297,
     BINARY = 298,
     BIT = 299,
     BOOLEAN_P = 300,
     BOTH = 301,
     BY = 302,
     CACHE = 303,
     CALLED = 304,
     CASCADE = 305,
     CASCADED = 306,
     CASE = 307,
     CAST = 308,
     CATALOG_P = 309,
     CHAIN = 310,
     CHAR_P = 311,
     CHARACTER = 312,
     CHARACTERISTICS = 313,
     CHECK = 314,
     CHECKPOINT = 315,
     CLASS = 316,
     CLOSE = 317,
     CLUSTER = 318,
     COALESCE = 319,
     COLLATE = 320,
     COLUMN = 321,
     COMMENT = 322,
     COMMENTS = 323,
     COMMIT = 324,
     COMMITTED = 325,
     CONCURRENTLY = 326,
     CONFIGURATION = 327,
     CONNECTION = 328,
     CONSTRAINT = 329,
     CONSTRAINTS = 330,
     CONTENT_P = 331,
     CONTINUE_P = 332,
     CONVERSION_P = 333,
     COPY = 334,
     COST = 335,
     CREATE = 336,
     CREATEDB = 337,
     CREATEROLE = 338,
     CREATEUSER = 339,
     CROSS = 340,
     CSV = 341,
     CURRENT_P = 342,
     CURRENT_CATALOG = 343,
     CURRENT_DATE = 344,
     CURRENT_ROLE = 345,
     CURRENT_SCHEMA = 346,
     CURRENT_TIME = 347,
     CURRENT_TIMESTAMP = 348,
     CURRENT_USER = 349,
     CURSOR = 350,
     CYCLE = 351,
     DATA_P = 352,
     DATABASE = 353,
     DAY_P = 354,
     DEALLOCATE = 355,
     DEC = 356,
     DECIMAL_P = 357,
     DECLARE = 358,
     DEFAULT = 359,
     DEFAULTS = 360,
     DEFERRABLE = 361,
     DEFERRED = 362,
     DEFINER = 363,
     DELETE_P = 364,
     DELIMITER = 365,
     DELIMITERS = 366,
     DESC = 367,
     DICTIONARY = 368,
     DISABLE_P = 369,
     DISCARD = 370,
     DISTINCT = 371,
     DO = 372,
     DOCUMENT_P = 373,
     DOMAIN_P = 374,
     DOUBLE_P = 375,
     DROP = 376,
     EACH = 377,
     ELSE = 378,
     ENABLE_P = 379,
     ENCODING = 380,
     ENCRYPTED = 381,
     END_P = 382,
     ENUM_P = 383,
     ESCAPE = 384,
     EXCEPT = 385,
     EXCLUDE = 386,
     EXCLUDING = 387,
     EXCLUSIVE = 388,
     EXECUTE = 389,
     EXISTS = 390,
     EXPLAIN = 391,
     EXTERNAL = 392,
     EXTRACT = 393,
     FALSE_P = 394,
     FAMILY = 395,
     FETCH = 396,
     FIRST_P = 397,
     FLOAT_P = 398,
     FOLLOWING = 399,
     FOR = 400,
     FORCE = 401,
     FOREIGN = 402,
     FORWARD = 403,
     FREEZE = 404,
     FROM = 405,
     FULL = 406,
     FUNCTION = 407,
     FUNCTIONS = 408,
     GLOBAL = 409,
     GRANT = 410,
     GRANTED = 411,
     GREATEST = 412,
     GROUP_P = 413,
     HANDLER = 414,
     HAVING = 415,
     HEADER_P = 416,
     HOLD = 417,
     HOUR_P = 418,
     IDENTITY_P = 419,
     IF_P = 420,
     ILIKE = 421,
     IMMEDIATE = 422,
     IMMUTABLE = 423,
     IMPLICIT_P = 424,
     IN_P = 425,
     INCLUDING = 426,
     INCREMENT = 427,
     INDEX = 428,
     INDEXES = 429,
     INHERIT = 430,
     INHERITS = 431,
     INITIALLY = 432,
     INLINE_P = 433,
     INNER_P = 434,
     INOUT = 435,
     INPUT_P = 436,
     INSENSITIVE = 437,
     INSERT = 438,
     INSTEAD = 439,
     INT_P = 440,
     INTEGER = 441,
     INTERSECT = 442,
     INTERVAL = 443,
     INTO = 444,
     INVOKER = 445,
     IS = 446,
     ISNULL = 447,
     ISOLATION = 448,
     JOIN = 449,
     KEY = 450,
     LABEL = 451,
     LANGUAGE = 452,
     LARGE_P = 453,
     LAST_P = 454,
     LC_COLLATE_P = 455,
     LC_CTYPE_P = 456,
     LEADING = 457,
     LEAST = 458,
     LEFT = 459,
     LEVEL = 460,
     LIKE = 461,
     LIMIT = 462,
     LISTEN = 463,
     LOAD = 464,
     LOCAL = 465,
     LOCALTIME = 466,
     LOCALTIMESTAMP = 467,
     LOCATION = 468,
     LOCK_P = 469,
     LOGIN_P = 470,
     MAPPING = 471,
     MATCH = 472,
     MAXVALUE = 473,
     MINUTE_P = 474,
     MINVALUE = 475,
     MODE = 476,
     MONTH_P = 477,
     MOVE = 478,
     NAME_P = 479,
     NAMES = 480,
     NATIONAL = 481,
     NATURAL = 482,
     NCHAR = 483,
     NEXT = 484,
     NO = 485,
     NOCREATEDB = 486,
     NOCREATEROLE = 487,
     NOCREATEUSER = 488,
     NOINHERIT = 489,
     NOLOGIN_P = 490,
     NONE = 491,
     NOSUPERUSER = 492,
     NOT = 493,
     NOTHING = 494,
     NOTIFY = 495,
     NOTNULL = 496,
     NOWAIT = 497,
     NULL_P = 498,
     NULLIF = 499,
     NULLS_P = 500,
     NUMERIC = 501,
     OBJECT_P = 502,
     OF = 503,
     OFF = 504,
     OFFSET = 505,
     OIDS = 506,
     ON = 507,
     ONLY = 508,
     OPERATOR = 509,
     OPTION = 510,
     OPTIONS = 511,
     OR = 512,
     ORDER = 513,
     OUT_P = 514,
     OUTER_P = 515,
     OVER = 516,
     OVERLAPS = 517,
     OVERLAY = 518,
     OWNED = 519,
     OWNER = 520,
     PARSER = 521,
     PARTIAL = 522,
     PARTITION = 523,
     PASSWORD = 524,
     PLACING = 525,
     PLANS = 526,
     POSITION = 527,
     PRECEDING = 528,
     PRECISION = 529,
     PRESERVE = 530,
     PREPARE = 531,
     PREPARED = 532,
     PRIMARY = 533,
     PRIOR = 534,
     PRIVILEGES = 535,
     PROCEDURAL = 536,
     PROCEDURE = 537,
     QUOTE = 538,
     RANGE = 539,
     READ = 540,
     REAL = 541,
     REASSIGN = 542,
     RECHECK = 543,
     RECURSIVE = 544,
     REFERENCES = 545,
     REINDEX = 546,
     RELATIVE_P = 547,
     RELEASE = 548,
     RENAME = 549,
     REPEATABLE = 550,
     REPLACE = 551,
     REPLICA = 552,
     RESET = 553,
     RESTART = 554,
     RESTRICT = 555,
     RETURNING = 556,
     RETURNS = 557,
     REVOKE = 558,
     RIGHT = 559,
     ROLE = 560,
     ROLLBACK = 561,
     ROW = 562,
     ROWS = 563,
     RULE = 564,
     SAVEPOINT = 565,
     SCHEMA = 566,
     SCROLL = 567,
     SEARCH = 568,
     SECOND_P = 569,
     SECURITY = 570,
     SELECT = 571,
     SEQUENCE = 572,
     SEQUENCES = 573,
     SERIALIZABLE = 574,
     SERVER = 575,
     SESSION = 576,
     SESSION_USER = 577,
     SET = 578,
     SETOF = 579,
     SHARE = 580,
     SHOW = 581,
     SIMILAR = 582,
     SIMPLE = 583,
     SMALLINT = 584,
     SOME = 585,
     STABLE = 586,
     STANDALONE_P = 587,
     START = 588,
     STATEMENT = 589,
     STATISTICS = 590,
     STDIN = 591,
     STDOUT = 592,
     STORAGE = 593,
     STRICT_P = 594,
     STRIP_P = 595,
     SUBSTRING = 596,
     SUPERUSER_P = 597,
     SYMMETRIC = 598,
     SYSID = 599,
     SYSTEM_P = 600,
     TABLE = 601,
     TABLES = 602,
     TABLESPACE = 603,
     TEMP = 604,
     TEMPLATE = 605,
     TEMPORARY = 606,
     TEXT_P = 607,
     THEN = 608,
     TIME = 609,
     TIMESTAMP = 610,
     TO = 611,
     TRAILING = 612,
     TRANSACTION = 613,
     TREAT = 614,
     TRIGGER = 615,
     TRIM = 616,
     TRUE_P = 617,
     TRUNCATE = 618,
     TRUSTED = 619,
     TYPE_P = 620,
     UNBOUNDED = 621,
     UNCOMMITTED = 622,
     UNENCRYPTED = 623,
     UNION = 624,
     UNIQUE = 625,
     UNKNOWN = 626,
     UNLISTEN = 627,
     UNTIL = 628,
     UPDATE = 629,
     USER = 630,
     USING = 631,
     VACUUM = 632,
     VALID = 633,
     VALIDATOR = 634,
     VALUE_P = 635,
     VALUES = 636,
     VARCHAR = 637,
     VARIADIC = 638,
     VARYING = 639,
     VERBOSE = 640,
     VERSION_P = 641,
     VIEW = 642,
     VOLATILE = 643,
     WHEN = 644,
     WHERE = 645,
     WHITESPACE_P = 646,
     WINDOW = 647,
     WITH = 648,
     WITHOUT = 649,
     WORK = 650,
     WRAPPER = 651,
     WRITE = 652,
     XML_P = 653,
     XMLATTRIBUTES = 654,
     XMLCONCAT = 655,
     XMLELEMENT = 656,
     XMLFOREST = 657,
     XMLPARSE = 658,
     XMLPI = 659,
     XMLROOT = 660,
     XMLSERIALIZE = 661,
     YEAR_P = 662,
     YES_P = 663,
     ZONE = 664,
     NULLS_FIRST = 665,
     NULLS_LAST = 666,
     WITH_TIME = 667,
     POSTFIXOP = 668,
     UMINUS = 669
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 146 "gram.y"

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	FuncWithArgs		*funwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;



/* Line 214 of yacc.c  */
#line 706 "gram.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 731 "gram.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  684
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   63705

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  432
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  517
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2105
/* YYNRULES -- Number of states.  */
#define YYNSTATES  3862

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   669

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   421,     2,     2,
     426,   427,   419,   417,   430,   418,   428,   420,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   431,   429,
     414,   413,   415,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   424,     2,   425,   422,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   416,   423
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     9,    11,    13,    15,    17,    19,
      21,    23,    25,    27,    29,    31,    33,    35,    37,    39,
      41,    43,    45,    47,    49,    51,    53,    55,    57,    59,
      61,    63,    65,    67,    69,    71,    73,    75,    77,    79,
      81,    83,    85,    87,    89,    91,    93,    95,    97,    99,
     101,   103,   105,   107,   109,   111,   113,   115,   117,   119,
     121,   123,   125,   127,   129,   131,   133,   135,   137,   139,
     141,   143,   145,   147,   149,   151,   153,   155,   157,   159,
     161,   163,   165,   167,   169,   171,   173,   175,   177,   179,
     181,   183,   185,   187,   189,   191,   193,   195,   197,   199,
     201,   203,   205,   207,   209,   211,   213,   215,   217,   218,
     224,   226,   227,   230,   231,   234,   235,   238,   241,   245,
     249,   251,   253,   255,   257,   259,   261,   263,   265,   267,
     269,   271,   273,   277,   281,   284,   286,   289,   292,   295,
     299,   303,   309,   315,   316,   320,   326,   332,   337,   341,
     347,   351,   357,   363,   370,   372,   374,   378,   384,   391,
     396,   398,   399,   402,   403,   405,   407,   409,   411,   413,
     415,   418,   422,   426,   430,   434,   438,   442,   446,   450,
     453,   459,   462,   465,   468,   471,   475,   479,   483,   485,
     489,   491,   495,   497,   499,   501,   504,   507,   510,   512,
     514,   516,   518,   520,   522,   524,   528,   535,   537,   539,
     541,   543,   545,   546,   548,   550,   553,   557,   562,   566,
     569,   572,   574,   577,   581,   586,   590,   593,   598,   600,
     602,   604,   606,   608,   611,   614,   617,   620,   625,   630,
     635,   640,   642,   646,   649,   653,   658,   665,   672,   679,
     685,   691,   698,   705,   710,   718,   721,   728,   733,   737,
     741,   746,   751,   755,   759,   763,   768,   773,   777,   781,
     785,   789,   793,   797,   802,   807,   811,   814,   818,   822,
     826,   829,   832,   836,   839,   841,   843,   844,   847,   848,
     852,   855,   856,   858,   862,   866,   868,   874,   878,   881,
     884,   895,   902,   904,   906,   908,   910,   912,   914,   918,
     921,   922,   924,   926,   930,   934,   936,   938,   942,   946,
     950,   954,   959,   961,   962,   965,   966,   970,   971,   973,
     974,   976,   980,   983,   985,   987,   989,   991,   995,   996,
     998,  1002,  1004,  1006,  1018,  1029,  1031,  1033,  1036,  1039,
    1042,  1045,  1046,  1048,  1049,  1053,  1054,  1056,  1060,  1062,
    1066,  1068,  1070,  1072,  1074,  1076,  1080,  1085,  1088,  1089,
    1093,  1095,  1097,  1100,  1102,  1106,  1111,  1116,  1119,  1125,
    1127,  1130,  1133,  1136,  1140,  1144,  1148,  1149,  1151,  1153,
    1155,  1157,  1159,  1161,  1165,  1167,  1173,  1181,  1190,  1200,
    1212,  1216,  1217,  1219,  1223,  1225,  1228,  1231,  1234,  1235,
    1237,  1241,  1245,  1252,  1257,  1258,  1260,  1262,  1265,  1268,
    1269,  1273,  1277,  1280,  1282,  1284,  1287,  1290,  1295,  1296,
    1299,  1302,  1305,  1306,  1310,  1315,  1320,  1321,  1324,  1325,
    1330,  1331,  1339,  1345,  1349,  1350,  1352,  1356,  1358,  1361,
    1365,  1366,  1372,  1377,  1379,  1380,  1382,  1385,  1388,  1390,
    1393,  1397,  1400,  1403,  1406,  1409,  1413,  1417,  1419,  1423,
    1425,  1426,  1428,  1431,  1433,  1440,  1451,  1453,  1454,  1456,
    1459,  1462,  1463,  1466,  1469,  1471,  1472,  1478,  1486,  1488,
    1489,  1496,  1499,  1500,  1504,  1510,  1518,  1525,  1534,  1542,
    1549,  1556,  1561,  1562,  1564,  1568,  1573,  1575,  1579,  1581,
    1584,  1587,  1590,  1593,  1595,  1597,  1608,  1611,  1612,  1615,
    1618,  1620,  1621,  1626,  1633,  1639,  1644,  1649,  1658,  1660,
    1662,  1664,  1672,  1682,  1691,  1707,  1728,  1730,  1732,  1734,
    1738,  1740,  1742,  1744,  1748,  1750,  1754,  1755,  1757,  1758,
    1760,  1762,  1767,  1768,  1770,  1774,  1775,  1777,  1779,  1781,
    1783,  1785,  1787,  1790,  1791,  1793,  1796,  1798,  1801,  1802,
    1805,  1807,  1810,  1813,  1820,  1829,  1838,  1843,  1849,  1854,
    1859,  1864,  1868,  1876,  1885,  1892,  1899,  1906,  1913,  1917,
    1919,  1923,  1927,  1929,  1931,  1933,  1935,  1937,  1939,  1943,
    1947,  1951,  1953,  1957,  1961,  1963,  1964,  1966,  1970,  1984,
    1986,  1990,  1995,  2001,  2006,  2014,  2017,  2019,  2020,  2023,
    2024,  2026,  2027,  2034,  2043,  2052,  2054,  2058,  2064,  2070,
    2078,  2088,  2096,  2106,  2112,  2119,  2126,  2131,  2133,  2135,
    2137,  2139,  2141,  2143,  2145,  2147,  2151,  2155,  2159,  2163,
    2165,  2169,  2171,  2174,  2177,  2181,  2187,  2190,  2193,  2194,
    2201,  2209,  2217,  2225,  2234,  2243,  2250,  2259,  2269,  2279,
    2287,  2298,  2306,  2315,  2324,  2333,  2342,  2344,  2346,  2348,
    2350,  2352,  2354,  2356,  2358,  2360,  2362,  2364,  2366,  2368,
    2370,  2373,  2376,  2378,  2381,  2385,  2389,  2393,  2397,  2402,
    2407,  2411,  2415,  2419,  2424,  2429,  2433,  2438,  2443,  2445,
    2447,  2449,  2450,  2458,  2466,  2477,  2479,  2481,  2484,  2489,
    2495,  2497,  2501,  2504,  2507,  2510,  2513,  2515,  2518,  2521,
    2526,  2530,  2533,  2536,  2539,  2543,  2546,  2549,  2555,  2561,
    2567,  2569,  2573,  2575,  2578,  2582,  2583,  2585,  2589,  2592,
    2599,  2606,  2616,  2620,  2621,  2625,  2626,  2632,  2635,  2636,
    2640,  2644,  2648,  2656,  2664,  2675,  2677,  2679,  2681,  2696,
    2698,  2699,  2701,  2702,  2704,  2705,  2708,  2709,  2711,  2715,
    2720,  2725,  2732,  2734,  2737,  2738,  2740,  2742,  2743,  2745,
    2747,  2748,  2758,  2771,  2779,  2782,  2783,  2787,  2790,  2792,
    2796,  2800,  2803,  2805,  2809,  2813,  2817,  2820,  2823,  2825,
    2827,  2829,  2831,  2834,  2836,  2838,  2840,  2842,  2847,  2853,
    2855,  2859,  2863,  2865,  2868,  2873,  2879,  2881,  2883,  2885,
    2887,  2891,  2895,  2898,  2901,  2904,  2907,  2909,  2912,  2915,
    2917,  2919,  2921,  2925,  2928,  2929,  2932,  2934,  2938,  2944,
    2946,  2949,  2951,  2952,  2958,  2966,  2972,  2980,  2986,  2994,
    2998,  3004,  3010,  3016,  3018,  3022,  3025,  3027,  3030,  3032,
    3035,  3047,  3058,  3069,  3072,  3075,  3076,  3086,  3089,  3090,
    3095,  3100,  3105,  3107,  3109,  3111,  3112,  3120,  3127,  3134,
    3141,  3148,  3156,  3166,  3176,  3183,  3190,  3197,  3204,  3211,
    3220,  3229,  3236,  3243,  3250,  3256,  3262,  3271,  3280,  3289,
    3298,  3305,  3307,  3308,  3311,  3312,  3320,  3327,  3334,  3341,
    3348,  3355,  3362,  3370,  3377,  3384,  3391,  3398,  3406,  3414,
    3422,  3432,  3442,  3449,  3456,  3463,  3472,  3481,  3490,  3497,
    3502,  3507,  3512,  3520,  3525,  3530,  3535,  3541,  3547,  3552,
    3557,  3571,  3573,  3575,  3579,  3583,  3585,  3587,  3589,  3591,
    3593,  3595,  3597,  3598,  3600,  3602,  3604,  3606,  3608,  3610,
    3611,  3618,  3627,  3631,  3634,  3635,  3638,  3641,  3644,  3647,
    3651,  3655,  3658,  3661,  3664,  3667,  3671,  3674,  3680,  3685,
    3689,  3693,  3697,  3699,  3701,  3702,  3706,  3709,  3712,  3714,
    3718,  3721,  3723,  3724,  3733,  3744,  3748,  3753,  3758,  3759,
    3762,  3768,  3771,  3772,  3776,  3780,  3784,  3788,  3792,  3796,
    3800,  3804,  3808,  3812,  3816,  3820,  3824,  3829,  3833,  3837,
    3839,  3840,  3846,  3853,  3858,  3861,  3862,  3867,  3871,  3877,
    3884,  3889,  3896,  3903,  3909,  3917,  3919,  3920,  3927,  3939,
    3951,  3963,  3977,  3987,  3999,  4010,  4015,  4018,  4024,  4027,
    4028,  4033,  4039,  4045,  4050,  4057,  4059,  4063,  4065,  4067,
    4069,  4071,  4074,  4079,  4081,  4083,  4085,  4086,  4088,  4089,
    4091,  4092,  4096,  4097,  4100,  4105,  4109,  4115,  4117,  4119,
    4121,  4123,  4125,  4127,  4129,  4131,  4135,  4138,  4140,  4142,
    4144,  4146,  4148,  4150,  4151,  4157,  4161,  4162,  4164,  4166,
    4168,  4170,  4174,  4183,  4187,  4188,  4191,  4195,  4198,  4202,
    4208,  4210,  4215,  4218,  4220,  4224,  4227,  4230,  4231,  4238,
    4241,  4242,  4248,  4252,  4253,  4256,  4259,  4262,  4266,  4268,
    4272,  4274,  4277,  4279,  4280,  4288,  4290,  4294,  4296,  4298,
    4302,  4308,  4311,  4313,  4317,  4325,  4327,  4328,  4332,  4335,
    4338,  4341,  4342,  4345,  4348,  4350,  4352,  4356,  4360,  4362,
    4365,  4370,  4375,  4378,  4382,  4388,  4394,  4396,  4398,  4408,
    4410,  4413,  4418,  4423,  4428,  4431,  4435,  4437,  4441,  4446,
    4449,  4450,  4454,  4458,  4463,  4468,  4473,  4478,  4481,  4483,
    4485,  4486,  4488,  4490,  4491,  4493,  4499,  4501,  4502,  4504,
    4505,  4509,  4511,  4515,  4520,  4524,  4527,  4530,  4532,  4534,
    4536,  4537,  4540,  4545,  4551,  4554,  4558,  4560,  4562,  4564,
    4566,  4570,  4571,  4573,  4575,  4577,  4579,  4581,  4585,  4586,
    4589,  4590,  4592,  4596,  4598,  4599,  4601,  4604,  4609,  4614,
    4617,  4618,  4621,  4625,  4628,  4629,  4631,  4635,  4637,  4640,
    4642,  4645,  4651,  4658,  4664,  4666,  4669,  4671,  4676,  4680,
    4685,  4691,  4696,  4702,  4707,  4713,  4716,  4721,  4723,  4726,
    4729,  4732,  4734,  4736,  4737,  4742,  4745,  4747,  4750,  4753,
    4758,  4760,  4764,  4766,  4769,  4773,  4775,  4778,  4779,  4782,
    4787,  4788,  4790,  4794,  4797,  4800,  4804,  4810,  4817,  4820,
    4824,  4828,  4833,  4834,  4836,  4838,  4840,  4842,  4844,  4847,
    4853,  4855,  4857,  4859,  4861,  4864,  4868,  4872,  4873,  4875,
    4877,  4879,  4881,  4883,  4886,  4889,  4892,  4895,  4898,  4900,
    4904,  4905,  4907,  4909,  4911,  4913,  4919,  4922,  4924,  4926,
    4928,  4930,  4936,  4939,  4942,  4945,  4947,  4951,  4955,  4958,
    4960,  4961,  4965,  4966,  4972,  4975,  4981,  4984,  4986,  4989,
    4993,  4994,  4996,  4998,  5000,  5002,  5004,  5006,  5010,  5014,
    5018,  5022,  5026,  5030,  5034,  5035,  5037,  5042,  5044,  5048,
    5054,  5057,  5060,  5064,  5068,  5072,  5076,  5080,  5084,  5088,
    5092,  5096,  5100,  5103,  5106,  5110,  5114,  5117,  5121,  5127,
    5132,  5139,  5143,  5149,  5154,  5161,  5166,  5173,  5179,  5187,
    5191,  5194,  5199,  5202,  5206,  5210,  5215,  5219,  5224,  5228,
    5233,  5239,  5246,  5253,  5261,  5268,  5276,  5283,  5291,  5295,
    5300,  5305,  5312,  5315,  5319,  5324,  5326,  5330,  5333,  5336,
    5340,  5344,  5348,  5352,  5356,  5360,  5364,  5368,  5372,  5376,
    5379,  5382,  5388,  5395,  5402,  5410,  5414,  5419,  5421,  5423,
    5426,  5431,  5433,  5435,  5437,  5440,  5443,  5446,  5448,  5453,
    5459,  5466,  5475,  5482,  5490,  5498,  5504,  5506,  5508,  5513,
    5515,  5520,  5522,  5527,  5529,  5534,  5536,  5538,  5540,  5542,
    5544,  5546,  5553,  5558,  5563,  5568,  5573,  5580,  5586,  5592,
    5598,  5603,  5610,  5615,  5620,  5625,  5630,  5636,  5644,  5652,
    5662,  5667,  5674,  5680,  5688,  5696,  5704,  5707,  5711,  5715,
    5719,  5724,  5725,  5730,  5732,  5736,  5740,  5742,  5744,  5746,
    5749,  5752,  5753,  5756,  5757,  5759,  5763,  5767,  5770,  5773,
    5774,  5781,  5783,  5784,  5788,  5789,  5792,  5795,  5796,  5798,
    5803,  5806,  5809,  5812,  5815,  5818,  5823,  5827,  5833,  5835,
    5837,  5839,  5841,  5843,  5845,  5847,  5849,  5851,  5853,  5855,
    5857,  5859,  5861,  5863,  5868,  5870,  5875,  5877,  5882,  5884,
    5887,  5889,  5892,  5894,  5898,  5900,  5904,  5906,  5910,  5912,
    5916,  5920,  5924,  5927,  5929,  5933,  5937,  5938,  5940,  5942,
    5944,  5946,  5948,  5950,  5952,  5954,  5959,  5963,  5966,  5970,
    5971,  5975,  5979,  5982,  5985,  5987,  5988,  5991,  5994,  5998,
    6001,  6003,  6005,  6009,  6015,  6017,  6020,  6025,  6028,  6029,
    6031,  6032,  6034,  6037,  6040,  6043,  6047,  6053,  6055,  6058,
    6059,  6062,  6064,  6065,  6067,  6069,  6071,  6075,  6079,  6081,
    6085,  6089,  6092,  6094,  6096,  6098,  6102,  6104,  6107,  6109,
    6113,  6115,  6117,  6119,  6121,  6123,  6125,  6127,  6130,  6132,
    6134,  6136,  6138,  6140,  6143,  6149,  6152,  6156,  6163,  6165,
    6167,  6169,  6171,  6173,  6175,  6177,  6180,  6183,  6185,  6189,
    6191,  6193,  6195,  6197,  6199,  6201,  6203,  6205,  6207,  6209,
    6211,  6213,  6215,  6217,  6219,  6221,  6223,  6225,  6227,  6229,
    6231,  6233,  6235,  6237,  6239,  6241,  6243,  6245,  6247,  6249,
    6251,  6253,  6255,  6257,  6259,  6261,  6263,  6265,  6267,  6269,
    6271,  6273,  6275,  6277,  6279,  6281,  6283,  6285,  6287,  6289,
    6291,  6293,  6295,  6297,  6299,  6301,  6303,  6305,  6307,  6309,
    6311,  6313,  6315,  6317,  6319,  6321,  6323,  6325,  6327,  6329,
    6331,  6333,  6335,  6337,  6339,  6341,  6343,  6345,  6347,  6349,
    6351,  6353,  6355,  6357,  6359,  6361,  6363,  6365,  6367,  6369,
    6371,  6373,  6375,  6377,  6379,  6381,  6383,  6385,  6387,  6389,
    6391,  6393,  6395,  6397,  6399,  6401,  6403,  6405,  6407,  6409,
    6411,  6413,  6415,  6417,  6419,  6421,  6423,  6425,  6427,  6429,
    6431,  6433,  6435,  6437,  6439,  6441,  6443,  6445,  6447,  6449,
    6451,  6453,  6455,  6457,  6459,  6461,  6463,  6465,  6467,  6469,
    6471,  6473,  6475,  6477,  6479,  6481,  6483,  6485,  6487,  6489,
    6491,  6493,  6495,  6497,  6499,  6501,  6503,  6505,  6507,  6509,
    6511,  6513,  6515,  6517,  6519,  6521,  6523,  6525,  6527,  6529,
    6531,  6533,  6535,  6537,  6539,  6541,  6543,  6545,  6547,  6549,
    6551,  6553,  6555,  6557,  6559,  6561,  6563,  6565,  6567,  6569,
    6571,  6573,  6575,  6577,  6579,  6581,  6583,  6585,  6587,  6589,
    6591,  6593,  6595,  6597,  6599,  6601,  6603,  6605,  6607,  6609,
    6611,  6613,  6615,  6617,  6619,  6621,  6623,  6625,  6627,  6629,
    6631,  6633,  6635,  6637,  6639,  6641,  6643,  6645,  6647,  6649,
    6651,  6653,  6655,  6657,  6659,  6661,  6663,  6665,  6667,  6669,
    6671,  6673,  6675,  6677,  6679,  6681,  6683,  6685,  6687,  6689,
    6691,  6693,  6695,  6697,  6699,  6701,  6703,  6705,  6707,  6709,
    6711,  6713,  6715,  6717,  6719,  6721,  6723,  6725,  6727,  6729,
    6731,  6733,  6735,  6737,  6739,  6741,  6743,  6745,  6747,  6749,
    6751,  6753,  6755,  6757,  6759,  6761,  6763,  6765,  6767,  6769,
    6771,  6773,  6775,  6777,  6779,  6781,  6783,  6785,  6787,  6789,
    6791,  6793,  6795,  6797,  6799,  6801,  6803,  6805,  6807,  6809,
    6811,  6813,  6815,  6817,  6819,  6821,  6823,  6825,  6827,  6829,
    6831,  6833,  6835,  6837,  6839,  6841,  6843,  6845,  6847,  6849,
    6851,  6853,  6855,  6857,  6859,  6861,  6863,  6865,  6867,  6869,
    6871,  6873,  6875,  6877,  6879,  6881,  6883,  6885,  6887,  6889,
    6891,  6893,  6895,  6897,  6899,  6901,  6903,  6905,  6907,  6909,
    6911,  6913,  6915,  6917,  6919,  6921,  6923,  6925,  6927,  6929,
    6931,  6933,  6935,  6937,  6939,  6941,  6943,  6945,  6947,  6949,
    6951,  6953,  6955,  6957,  6959,  6961,  6963,  6965,  6967,  6969,
    6971,  6973,  6975,  6977,  6979,  6981,  6983,  6985,  6987,  6989,
    6991,  6993,  6995,  6997,  6999,  7001
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     433,     0,    -1,   434,    -1,   434,   429,   435,    -1,   435,
      -1,   736,    -1,   737,    -1,   653,    -1,   742,    -1,   563,
      -1,   577,    -1,   687,    -1,   451,    -1,   708,    -1,   709,
      -1,   710,    -1,   544,    -1,   476,    -1,   445,    -1,   443,
      -1,   745,    -1,   744,    -1,   581,    -1,   447,    -1,   446,
      -1,   752,    -1,   474,    -1,   486,    -1,   747,    -1,   631,
      -1,   471,    -1,   487,    -1,   537,    -1,   597,    -1,   698,
      -1,   746,    -1,   741,    -1,   561,    -1,   572,    -1,   668,
      -1,   450,    -1,   610,    -1,   616,    -1,   617,    -1,   550,
      -1,   454,    -1,   543,    -1,   502,    -1,   558,    -1,   582,
      -1,   436,    -1,   442,    -1,   578,    -1,   732,    -1,   769,
      -1,   788,    -1,   599,    -1,   775,    -1,   475,    -1,   695,
      -1,   598,    -1,   700,    -1,   562,    -1,   576,    -1,   453,
      -1,   620,    -1,   621,    -1,   622,    -1,   556,    -1,   719,
      -1,   624,    -1,   560,    -1,   596,    -1,   448,    -1,   449,
      -1,   580,    -1,   740,    -1,   767,    -1,   758,    -1,   634,
      -1,   638,    -1,   649,    -1,   658,    -1,   770,    -1,   722,
      -1,   731,    -1,   777,    -1,   720,    -1,   764,    -1,   623,
      -1,   702,    -1,   691,    -1,   690,    -1,   692,    -1,   705,
      -1,   639,    -1,   650,    -1,   712,    -1,   792,    -1,   724,
      -1,   629,    -1,   723,    -1,   781,    -1,   749,    -1,   468,
      -1,   458,    -1,   470,    -1,   729,    -1,    -1,    81,   305,
     939,   437,   438,    -1,   393,    -1,    -1,   438,   441,    -1,
      -1,   439,   440,    -1,    -1,   269,   938,    -1,   269,   243,
      -1,   126,   269,   938,    -1,   368,   269,   938,    -1,   342,
      -1,   237,    -1,   175,    -1,   234,    -1,    82,    -1,   231,
      -1,    83,    -1,   232,    -1,    84,    -1,   233,    -1,   215,
      -1,   235,    -1,    73,   207,   940,    -1,   378,   373,   938,
      -1,   375,   928,    -1,   440,    -1,   344,   937,    -1,    19,
     928,    -1,   305,   928,    -1,   170,   305,   928,    -1,   170,
     158,   928,    -1,    81,   375,   939,   437,   438,    -1,    24,
     305,   939,   437,   439,    -1,    -1,   170,    98,   930,    -1,
      24,   305,   939,   444,   469,    -1,    24,   375,   939,   437,
     439,    -1,    24,   375,   939,   469,    -1,   121,   305,   928,
      -1,   121,   305,   165,   135,   928,    -1,   121,   375,   928,
      -1,   121,   375,   165,   135,   928,    -1,    81,   158,   939,
     437,   438,    -1,    24,   158,   939,   452,   375,   928,    -1,
      18,    -1,   121,    -1,   121,   158,   928,    -1,   121,   158,
     165,   135,   928,    -1,    81,   311,   455,    37,   939,   456,
      -1,    81,   311,   942,   456,    -1,   942,    -1,    -1,   456,
     457,    -1,    -1,   502,    -1,   658,    -1,   543,    -1,   582,
      -1,   638,    -1,   729,    -1,   323,   459,    -1,   323,   210,
     459,    -1,   323,   321,   459,    -1,   460,   356,   461,    -1,
     460,   413,   461,    -1,   460,   356,   104,    -1,   460,   413,
     104,    -1,   460,   150,    87,    -1,   354,   409,   465,    -1,
     358,   727,    -1,   321,    58,    31,   358,   727,    -1,    54,
     938,    -1,   311,   938,    -1,   225,   466,    -1,   305,   467,
      -1,   321,    37,   467,    -1,   321,    37,   104,    -1,   398,
     255,   876,    -1,   942,    -1,   460,   428,   942,    -1,   462,
      -1,   461,   430,   462,    -1,   464,    -1,   467,    -1,   549,
      -1,   285,   367,    -1,   285,    70,    -1,   295,   285,    -1,
     319,    -1,   362,    -1,   139,    -1,   252,    -1,   249,    -1,
     938,    -1,     3,    -1,   863,   938,   865,    -1,   863,   426,
     937,   427,   938,   865,    -1,   549,    -1,   104,    -1,   210,
      -1,   938,    -1,   104,    -1,    -1,   942,    -1,   938,    -1,
     298,   460,    -1,   298,   354,   409,    -1,   298,   358,   193,
     205,    -1,   298,   321,    37,    -1,   298,    22,    -1,   323,
     459,    -1,   468,    -1,   326,   460,    -1,   326,   354,   409,
      -1,   326,   358,   193,   205,    -1,   326,   321,    37,    -1,
     326,    22,    -1,   323,    75,   472,   473,    -1,    22,    -1,
     926,    -1,   107,    -1,   167,    -1,    60,    -1,   115,    22,
      -1,   115,   349,    -1,   115,   351,    -1,   115,   271,    -1,
      24,   346,   835,   477,    -1,    24,   173,   927,   477,    -1,
      24,   317,   927,   477,    -1,    24,   387,   927,   477,    -1,
     478,    -1,   477,   430,   478,    -1,    18,   510,    -1,    18,
      66,   510,    -1,    24,   706,   942,   479,    -1,    24,   706,
     942,   121,   238,   243,    -1,    24,   706,   942,   323,   238,
     243,    -1,    24,   706,   942,   323,   335,   940,    -1,    24,
     706,   942,   323,   482,    -1,    24,   706,   942,   298,   482,
      -1,    24,   706,   942,   323,   338,   942,    -1,   121,   706,
     165,   135,   942,   480,    -1,   121,   706,   942,   480,    -1,
      24,   706,   942,   707,   365,   843,   481,    -1,    18,   519,
      -1,   121,    74,   165,   135,   929,   480,    -1,   121,    74,
     929,   480,    -1,   323,   393,   251,    -1,   323,   394,   251,
      -1,   323,   393,   315,   196,    -1,   323,   394,   315,   196,
      -1,    63,   252,   929,    -1,   323,   394,    63,    -1,   124,
     360,   929,    -1,   124,    25,   360,   929,    -1,   124,   297,
     360,   929,    -1,   124,   360,    22,    -1,   124,   360,   375,
      -1,   114,   360,   929,    -1,   114,   360,    22,    -1,   114,
     360,   375,    -1,   124,   309,   929,    -1,   124,    25,   309,
     929,    -1,   124,   297,   309,   929,    -1,   114,   309,   929,
      -1,   175,   927,    -1,   230,   175,   927,    -1,   265,   356,
     939,    -1,   323,   348,   929,    -1,   323,   482,    -1,   298,
     482,    -1,   323,   104,   867,    -1,   121,   104,    -1,    50,
      -1,   300,    -1,    -1,   376,   867,    -1,    -1,   426,   484,
     427,    -1,   393,   482,    -1,    -1,   485,    -1,   484,   430,
     485,    -1,   944,   413,   603,    -1,   944,    -1,   944,   428,
     944,   413,   603,    -1,   944,   428,   944,    -1,    62,   789,
      -1,    62,    22,    -1,    79,   493,   927,   521,   494,   488,
     489,   495,   437,   490,    -1,    79,   793,   356,   489,   437,
     490,    -1,   150,    -1,   356,    -1,   938,    -1,   336,    -1,
     337,    -1,   491,    -1,   426,   497,   427,    -1,   491,   492,
      -1,    -1,    43,    -1,   251,    -1,   110,   743,   938,    -1,
     243,   743,   938,    -1,    86,    -1,   161,    -1,   283,   743,
     938,    -1,   129,   743,   938,    -1,   146,   283,   522,    -1,
     146,   283,   419,    -1,   146,   238,   243,   522,    -1,    43,
      -1,    -1,   393,   251,    -1,    -1,   496,   111,   938,    -1,
      -1,   376,    -1,    -1,   498,    -1,   497,   430,   498,    -1,
     944,   499,    -1,   464,    -1,   467,    -1,   549,    -1,   419,
      -1,   426,   500,   427,    -1,    -1,   501,    -1,   500,   430,
     501,    -1,   464,    -1,   467,    -1,    81,   503,   346,   927,
     426,   504,   427,   532,   533,   534,   535,    -1,    81,   503,
     346,   927,   248,   627,   505,   533,   534,   535,    -1,   351,
      -1,   349,    -1,   210,   351,    -1,   210,   349,    -1,   154,
     351,    -1,   154,   349,    -1,    -1,   506,    -1,    -1,   426,
     507,   427,    -1,    -1,   508,    -1,   506,   430,   508,    -1,
     509,    -1,   507,   430,   509,    -1,   510,    -1,   516,    -1,
     519,    -1,   511,    -1,   519,    -1,   942,   843,   512,    -1,
     942,   393,   256,   512,    -1,   512,   513,    -1,    -1,    74,
     929,   514,    -1,   514,    -1,   515,    -1,   238,   243,    -1,
     243,    -1,   370,   684,   536,    -1,   278,   195,   684,   536,
      -1,    59,   426,   867,   427,    -1,   104,   868,    -1,   290,
     927,   521,   524,   528,    -1,   106,    -1,   238,   106,    -1,
     177,   107,    -1,   177,   167,    -1,   206,   927,   517,    -1,
     517,   171,   518,    -1,   517,   132,   518,    -1,    -1,   105,
      -1,    75,    -1,   174,    -1,   338,    -1,    68,    -1,    22,
      -1,    74,   929,   520,    -1,   520,    -1,    59,   426,   867,
     427,   593,    -1,   370,   426,   522,   427,   684,   536,   593,
      -1,   278,   195,   426,   522,   427,   684,   536,   593,    -1,
     131,   662,   426,   525,   427,   684,   536,   527,   593,    -1,
     147,   195,   426,   522,   427,   290,   927,   521,   524,   528,
     593,    -1,   426,   522,   427,    -1,    -1,   523,    -1,   522,
     430,   523,    -1,   942,    -1,   217,   151,    -1,   217,   267,
      -1,   217,   328,    -1,    -1,   526,    -1,   525,   430,   526,
      -1,   664,   393,   694,    -1,   664,   393,   254,   426,   694,
     427,    -1,   390,   426,   867,   427,    -1,    -1,   529,    -1,
     530,    -1,   529,   530,    -1,   530,   529,    -1,    -1,   252,
     374,   531,    -1,   252,   109,   531,    -1,   230,    17,    -1,
     300,    -1,    50,    -1,   323,   243,    -1,   323,   104,    -1,
     176,   426,   926,   427,    -1,    -1,   393,   482,    -1,   393,
     251,    -1,   394,   251,    -1,    -1,   252,    69,   121,    -1,
     252,    69,   109,   308,    -1,   252,    69,   275,   308,    -1,
      -1,   348,   929,    -1,    -1,   376,   173,   348,   929,    -1,
      -1,    81,   503,   346,   538,    31,   792,   542,    -1,   927,
     539,   533,   534,   535,    -1,   426,   540,   427,    -1,    -1,
     541,    -1,   540,   430,   541,    -1,   942,    -1,   393,    97,
      -1,   393,   230,    97,    -1,    -1,    81,   503,   317,   927,
     545,    -1,    24,   317,   927,   546,    -1,   546,    -1,    -1,
     547,    -1,   546,   547,    -1,    48,   549,    -1,    96,    -1,
     230,    96,    -1,   172,   548,   549,    -1,   218,   549,    -1,
     220,   549,    -1,   230,   218,    -1,   230,   220,    -1,   264,
      47,   627,    -1,   333,   437,   549,    -1,   299,    -1,   299,
     437,   549,    -1,    47,    -1,    -1,     4,    -1,   418,     4,
      -1,   940,    -1,    81,   669,   551,   557,   197,   467,    -1,
      81,   669,   551,   557,   197,   467,   159,   552,   553,   555,
      -1,   364,    -1,    -1,   929,    -1,   929,   628,    -1,   178,
     552,    -1,    -1,   379,   552,    -1,   230,   379,    -1,   554,
      -1,    -1,   121,   557,   197,   467,   480,    -1,   121,   557,
     197,   165,   135,   467,   480,    -1,   281,    -1,    -1,    81,
     348,   929,   559,   213,   938,    -1,   265,   929,    -1,    -1,
     121,   348,   929,    -1,   121,   348,   165,   135,   929,    -1,
      81,   147,    97,   396,   929,   555,   564,    -1,   121,   147,
      97,   396,   929,   480,    -1,   121,   147,    97,   396,   165,
     135,   929,   480,    -1,    24,   147,    97,   396,   929,   554,
     566,    -1,    24,   147,    97,   396,   929,   554,    -1,    24,
     147,    97,   396,   929,   566,    -1,   256,   426,   565,   427,
      -1,    -1,   569,    -1,   565,   430,   569,    -1,   256,   426,
     567,   427,    -1,   568,    -1,   567,   430,   568,    -1,   569,
      -1,   323,   569,    -1,    18,   569,    -1,   121,   570,    -1,
     570,   571,    -1,   944,    -1,   938,    -1,    81,   320,   929,
     573,   575,   147,    97,   396,   929,   564,    -1,   365,   938,
      -1,    -1,   386,   938,    -1,   386,   243,    -1,   574,    -1,
      -1,   121,   320,   929,   480,    -1,   121,   320,   165,   135,
     929,   480,    -1,    24,   320,   929,   574,   566,    -1,    24,
     320,   929,   574,    -1,    24,   320,   929,   566,    -1,    81,
     375,   216,   145,   579,   320,   929,   564,    -1,    94,    -1,
     375,    -1,   939,    -1,   121,   375,   216,   145,   579,   320,
     929,    -1,   121,   375,   216,   165,   135,   145,   579,   320,
     929,    -1,    24,   375,   216,   145,   579,   320,   929,   566,
      -1,    81,   360,   929,   583,   584,   252,   927,   586,   589,
     134,   282,   935,   426,   590,   427,    -1,    81,    74,   360,
     929,    20,   584,   252,   927,   592,   593,   145,   122,   307,
     589,   134,   282,   935,   426,   590,   427,    -1,    39,    -1,
      20,    -1,   585,    -1,   584,   257,   585,    -1,   183,    -1,
     109,    -1,   374,    -1,   374,   248,   522,    -1,   363,    -1,
     145,   587,   588,    -1,    -1,   122,    -1,    -1,   307,    -1,
     334,    -1,   389,   426,   867,   427,    -1,    -1,   591,    -1,
     590,   430,   591,    -1,    -1,   937,    -1,     4,    -1,   938,
      -1,     6,    -1,     7,    -1,   942,    -1,   150,   927,    -1,
      -1,   594,    -1,   594,   595,    -1,   595,    -1,   595,   594,
      -1,    -1,   238,   106,    -1,   106,    -1,   177,   167,    -1,
     177,   107,    -1,   121,   360,   929,   252,   927,   480,    -1,
     121,   360,   165,   135,   929,   252,   927,   480,    -1,    81,
      33,   929,    59,   426,   867,   427,   593,    -1,   121,    33,
     929,   480,    -1,    81,    21,   935,   604,   600,    -1,    81,
      21,   935,   605,    -1,    81,   254,   694,   600,    -1,    81,
     365,   627,   600,    -1,    81,   365,   627,    -1,    81,   365,
     627,    31,   426,   841,   427,    -1,    81,   365,   627,    31,
     128,   426,   608,   427,    -1,    81,   352,   313,   266,   627,
     600,    -1,    81,   352,   313,   113,   627,   600,    -1,    81,
     352,   313,   350,   627,   600,    -1,    81,   352,   313,    72,
     627,   600,    -1,   426,   601,   427,    -1,   602,    -1,   601,
     430,   602,    -1,   944,   413,   603,    -1,   944,    -1,   678,
      -1,   948,    -1,   893,    -1,   549,    -1,   938,    -1,   426,
     898,   427,    -1,   426,   419,   427,    -1,   426,   606,   427,
      -1,   607,    -1,   606,   430,   607,    -1,     3,   413,   603,
      -1,   609,    -1,    -1,   938,    -1,   609,   430,   938,    -1,
      81,   254,    61,   627,   613,   145,   365,   843,   376,   931,
     614,    31,   611,    -1,   612,    -1,   611,   430,   612,    -1,
     254,   937,   694,   615,    -1,   254,   937,   694,   693,   615,
      -1,   152,   937,   935,   670,    -1,   152,   937,   426,   898,
     427,   935,   670,    -1,   338,   843,    -1,   104,    -1,    -1,
     140,   627,    -1,    -1,   288,    -1,    -1,    81,   254,   140,
     627,   376,   931,    -1,    24,   254,   140,   627,   376,   931,
      18,   611,    -1,    24,   254,   140,   627,   376,   931,   121,
     618,    -1,   619,    -1,   618,   430,   619,    -1,   254,   937,
     426,   898,   427,    -1,   152,   937,   426,   898,   427,    -1,
     121,   254,    61,   627,   376,   931,   480,    -1,   121,   254,
      61,   165,   135,   627,   376,   931,   480,    -1,   121,   254,
     140,   627,   376,   931,   480,    -1,   121,   254,   140,   165,
     135,   627,   376,   931,   480,    -1,   121,   264,    47,   928,
     480,    -1,   287,   264,    47,   928,   356,   929,    -1,   121,
     625,   165,   135,   626,   480,    -1,   121,   625,   626,   480,
      -1,   346,    -1,   317,    -1,   387,    -1,   173,    -1,   365,
      -1,   119,    -1,    78,    -1,   311,    -1,   352,   313,   266,
      -1,   352,   313,   113,    -1,   352,   313,   350,    -1,   352,
     313,    72,    -1,   627,    -1,   626,   430,   627,    -1,   942,
      -1,   942,   628,    -1,   428,   932,    -1,   628,   428,   932,
      -1,   363,   802,   836,   630,   480,    -1,    77,   164,    -1,
     299,   164,    -1,    -1,    67,   252,   632,   627,   191,   633,
      -1,    67,   252,    21,   935,   604,   191,   633,    -1,    67,
     252,   152,   935,   670,   191,   633,    -1,    67,   252,   254,
     694,   693,   191,   633,    -1,    67,   252,    74,   929,   252,
     627,   191,   633,    -1,    67,   252,   309,   929,   252,   627,
     191,   633,    -1,    67,   252,   309,   929,   191,   633,    -1,
      67,   252,   360,   929,   252,   627,   191,   633,    -1,    67,
     252,   254,    61,   627,   376,   931,   191,   633,    -1,    67,
     252,   254,   140,   627,   376,   931,   191,   633,    -1,    67,
     252,   198,   247,   549,   191,   633,    -1,    67,   252,    53,
     426,   843,    31,   843,   427,   191,   633,    -1,    67,   252,
     557,   197,   627,   191,   633,    -1,    67,   252,   352,   313,
     266,   627,   191,   633,    -1,    67,   252,   352,   313,   113,
     627,   191,   633,    -1,    67,   252,   352,   313,   350,   627,
     191,   633,    -1,    67,   252,   352,   313,    72,   627,   191,
     633,    -1,    66,    -1,    98,    -1,   311,    -1,   173,    -1,
     317,    -1,   346,    -1,   119,    -1,   365,    -1,   387,    -1,
      78,    -1,   348,    -1,   305,    -1,   938,    -1,   243,    -1,
     141,   635,    -1,   223,   635,    -1,   789,    -1,   636,   789,
      -1,   229,   637,   789,    -1,   279,   637,   789,    -1,   142,
     637,   789,    -1,   199,   637,   789,    -1,    15,   940,   637,
     789,    -1,   292,   940,   637,   789,    -1,   940,   637,   789,
      -1,    22,   637,   789,    -1,   148,   637,   789,    -1,   148,
     940,   637,   789,    -1,   148,    22,   637,   789,    -1,    38,
     637,   789,    -1,    38,   940,   637,   789,    -1,    38,    22,
     637,   789,    -1,   150,    -1,   170,    -1,   636,    -1,    -1,
     155,   640,   252,   643,   356,   644,   646,    -1,   303,   640,
     252,   643,   150,   644,   480,    -1,   303,   155,   255,   145,
     640,   252,   643,   150,   644,   480,    -1,   641,    -1,    22,
      -1,    22,   280,    -1,    22,   426,   522,   427,    -1,    22,
     280,   426,   522,   427,    -1,   642,    -1,   641,   430,   642,
      -1,   316,   521,    -1,   290,   521,    -1,    81,   521,    -1,
     942,   521,    -1,   926,    -1,   346,   926,    -1,   317,   926,
      -1,   147,    97,   396,   928,    -1,   147,   320,   928,    -1,
     152,   647,    -1,    98,   928,    -1,   197,   928,    -1,   198,
     247,   941,    -1,   311,   928,    -1,   348,   928,    -1,    22,
     347,   170,   311,   928,    -1,    22,   318,   170,   311,   928,
      -1,    22,   153,   170,   311,   928,    -1,   645,    -1,   644,
     430,   645,    -1,   939,    -1,   158,   939,    -1,   393,   155,
     255,    -1,    -1,   648,    -1,   647,   430,   648,    -1,   935,
     670,    -1,   155,   641,   356,   928,   651,   652,    -1,   303,
     641,   150,   928,   652,   480,    -1,   303,    19,   255,   145,
     641,   150,   928,   652,   480,    -1,   393,    19,   255,    -1,
      -1,   156,    47,   939,    -1,    -1,    24,   104,   280,   654,
     656,    -1,   654,   655,    -1,    -1,   170,   311,   928,    -1,
     145,   305,   928,    -1,   145,   375,   928,    -1,   155,   640,
     252,   657,   356,   644,   646,    -1,   303,   640,   252,   657,
     150,   644,   480,    -1,   303,   155,   255,   145,   640,   252,
     657,   150,   644,   480,    -1,   347,    -1,   153,    -1,   318,
      -1,    81,   659,   173,   660,   661,   252,   927,   662,   426,
     663,   427,   483,   535,   839,    -1,   370,    -1,    -1,    71,
      -1,    -1,   933,    -1,    -1,   376,   931,    -1,    -1,   664,
      -1,   663,   430,   664,    -1,   942,   665,   666,   667,    -1,
     870,   665,   666,   667,    -1,   426,   867,   427,   665,   666,
     667,    -1,   627,    -1,   376,   627,    -1,    -1,    32,    -1,
     112,    -1,    -1,   410,    -1,   411,    -1,    -1,    81,   669,
     152,   935,   672,   302,   677,   680,   684,    -1,    81,   669,
     152,   935,   672,   302,   346,   426,   686,   427,   680,   684,
      -1,    81,   669,   152,   935,   672,   680,   684,    -1,   257,
     296,    -1,    -1,   426,   671,   427,    -1,   426,   427,    -1,
     674,    -1,   671,   430,   674,    -1,   426,   673,   427,    -1,
     426,   427,    -1,   679,    -1,   673,   430,   679,    -1,   675,
     676,   678,    -1,   676,   675,   678,    -1,   676,   678,    -1,
     675,   678,    -1,   678,    -1,   170,    -1,   259,    -1,   180,
      -1,   170,   259,    -1,   383,    -1,   943,    -1,   678,    -1,
     843,    -1,   943,   628,   421,   365,    -1,   324,   943,   628,
     421,   365,    -1,   674,    -1,   674,   104,   867,    -1,   674,
     413,   867,    -1,   682,    -1,   680,   682,    -1,    49,   252,
     243,   181,    -1,   302,   243,   252,   243,   181,    -1,   339,
      -1,   168,    -1,   331,    -1,   388,    -1,   137,   315,   108,
      -1,   137,   315,   190,    -1,   315,   108,    -1,   315,   190,
      -1,    80,   549,    -1,   308,   549,    -1,   469,    -1,    31,
     683,    -1,   197,   467,    -1,   392,    -1,   681,    -1,   938,
      -1,   938,   430,   938,    -1,   393,   600,    -1,    -1,   676,
     678,    -1,   685,    -1,   686,   430,   685,    -1,    24,   152,
     648,   688,   689,    -1,   681,    -1,   688,   681,    -1,   300,
      -1,    -1,   121,   152,   935,   670,   480,    -1,   121,   152,
     165,   135,   935,   670,   480,    -1,   121,    21,   935,   604,
     480,    -1,   121,    21,   165,   135,   935,   604,   480,    -1,
     121,   254,   694,   693,   480,    -1,   121,   254,   165,   135,
     694,   693,   480,    -1,   426,   843,   427,    -1,   426,   843,
     430,   843,   427,    -1,   426,   236,   430,   843,   427,    -1,
     426,   843,   430,   236,   427,    -1,   890,    -1,   942,   428,
     694,    -1,   117,   696,    -1,   697,    -1,   696,   697,    -1,
     938,    -1,   197,   467,    -1,    81,    53,   426,   843,    31,
     843,   427,   393,   152,   648,   699,    -1,    81,    53,   426,
     843,    31,   843,   427,   394,   152,   699,    -1,    81,    53,
     426,   843,    31,   843,   427,   393,   180,   699,    -1,    31,
     169,    -1,    31,    34,    -1,    -1,   121,    53,   701,   426,
     843,    31,   843,   427,   480,    -1,   165,   135,    -1,    -1,
     291,   703,   927,   704,    -1,   291,   345,   929,   704,    -1,
     291,    98,   929,   704,    -1,   173,    -1,   346,    -1,   146,
      -1,    -1,    24,    21,   935,   604,   294,   356,   929,    -1,
      24,    78,   627,   294,   356,   929,    -1,    24,    98,   930,
     294,   356,   930,    -1,    24,   152,   648,   294,   356,   929,
      -1,    24,   158,   939,   294,   356,   939,    -1,    24,   557,
     197,   929,   294,   356,   929,    -1,    24,   254,    61,   627,
     376,   931,   294,   356,   929,    -1,    24,   254,   140,   627,
     376,   931,   294,   356,   929,    -1,    24,   311,   929,   294,
     356,   929,    -1,    24,   346,   835,   294,   356,   929,    -1,
      24,   317,   927,   294,   356,   929,    -1,    24,   387,   927,
     294,   356,   929,    -1,    24,   173,   927,   294,   356,   929,
      -1,    24,   346,   835,   294,   706,   929,   356,   929,    -1,
      24,   360,   929,   252,   927,   294,   356,   929,    -1,    24,
     305,   939,   294,   356,   939,    -1,    24,   375,   939,   294,
     356,   939,    -1,    24,   348,   929,   294,   356,   929,    -1,
      24,   348,   929,   323,   482,    -1,    24,   348,   929,   298,
     482,    -1,    24,   352,   313,   266,   627,   294,   356,   929,
      -1,    24,   352,   313,   113,   627,   294,   356,   929,    -1,
      24,   352,   313,   350,   627,   294,   356,   929,    -1,    24,
     352,   313,    72,   627,   294,   356,   929,    -1,    24,   365,
     627,   294,   356,   929,    -1,    66,    -1,    -1,   323,    97,
      -1,    -1,    24,    21,   935,   604,   323,   311,   929,    -1,
      24,   119,   627,   323,   311,   929,    -1,    24,   152,   648,
     323,   311,   929,    -1,    24,   346,   835,   323,   311,   929,
      -1,    24,   317,   927,   323,   311,   929,    -1,    24,   387,
     927,   323,   311,   929,    -1,    24,   365,   627,   323,   311,
     929,    -1,    24,    21,   935,   604,   265,   356,   939,    -1,
      24,    78,   627,   265,   356,   939,    -1,    24,    98,   930,
     265,   356,   939,    -1,    24,   119,   627,   265,   356,   939,
      -1,    24,   152,   648,   265,   356,   939,    -1,    24,   557,
     197,   929,   265,   356,   939,    -1,    24,   198,   247,   937,
     265,   356,   939,    -1,    24,   254,   694,   693,   265,   356,
     939,    -1,    24,   254,    61,   627,   376,   931,   265,   356,
     939,    -1,    24,   254,   140,   627,   376,   931,   265,   356,
     939,    -1,    24,   311,   929,   265,   356,   939,    -1,    24,
     365,   627,   265,   356,   939,    -1,    24,   348,   929,   265,
     356,   939,    -1,    24,   352,   313,   113,   627,   265,   356,
     939,    -1,    24,   352,   313,    72,   627,   265,   356,   939,
      -1,    24,   147,    97,   396,   929,   265,   356,   939,    -1,
      24,   320,   929,   265,   356,   939,    -1,    24,    98,   930,
     711,    -1,    24,   311,   929,   711,    -1,    24,   346,   835,
     711,    -1,    24,   346,   835,    24,   706,   942,   711,    -1,
      24,   317,   927,   711,    -1,    24,   387,   927,   711,    -1,
      24,   152,   648,   711,    -1,    24,    21,   935,   604,   711,
      -1,    24,   198,   247,   937,   711,    -1,    24,   365,   627,
     711,    -1,   315,   196,   356,   938,    -1,    81,   669,   309,
     929,    31,   252,   717,   356,   927,   839,   117,   718,   713,
      -1,   239,    -1,   715,    -1,   426,   714,   427,    -1,   714,
     429,   716,    -1,   716,    -1,   792,    -1,   770,    -1,   781,
      -1,   775,    -1,   720,    -1,   715,    -1,    -1,   316,    -1,
     374,    -1,   109,    -1,   183,    -1,   184,    -1,    23,    -1,
      -1,   121,   309,   929,   252,   927,   480,    -1,   121,   309,
     165,   135,   929,   252,   927,   480,    -1,   240,   942,   721,
      -1,   430,   938,    -1,    -1,   208,   942,    -1,   372,   942,
      -1,   372,   419,    -1,    14,   725,    -1,    40,   725,   728,
      -1,   333,   358,   728,    -1,    69,   725,    -1,   127,   725,
      -1,   306,   725,    -1,   310,   942,    -1,   293,   310,   942,
      -1,   293,   942,    -1,   306,   725,   356,   310,   942,    -1,
     306,   725,   356,   942,    -1,   276,   358,   938,    -1,    69,
     277,   938,    -1,   306,   277,   938,    -1,   395,    -1,   358,
      -1,    -1,   193,   205,   463,    -1,   285,   253,    -1,   285,
     397,    -1,   726,    -1,   727,   430,   726,    -1,   727,   726,
      -1,   727,    -1,    -1,    81,   503,   387,   927,   521,    31,
     792,   730,    -1,    81,   257,   296,   503,   387,   927,   521,
      31,   792,   730,    -1,   393,    59,   255,    -1,   393,    51,
      59,   255,    -1,   393,   210,    59,   255,    -1,    -1,   209,
     934,    -1,    81,    98,   930,   437,   733,    -1,   733,   734,
      -1,    -1,   348,   735,   929,    -1,   348,   735,   104,    -1,
     213,   735,   938,    -1,   213,   735,   104,    -1,   350,   735,
     929,    -1,   350,   735,   104,    -1,   125,   735,   938,    -1,
     125,   735,   937,    -1,   125,   735,   104,    -1,   200,   735,
     938,    -1,   200,   735,   104,    -1,   201,   735,   938,    -1,
     201,   735,   104,    -1,    73,   207,   735,   940,    -1,   265,
     735,   929,    -1,   265,   735,   104,    -1,   413,    -1,    -1,
      24,    98,   930,   437,   738,    -1,    24,    98,   930,   323,
     348,   929,    -1,    24,    98,   930,   469,    -1,   738,   739,
      -1,    -1,    73,   207,   735,   940,    -1,   121,    98,   930,
      -1,   121,    98,   165,   135,   930,    -1,    81,   119,   627,
     743,   843,   512,    -1,    24,   119,   627,   479,    -1,    24,
     119,   627,   121,   238,   243,    -1,    24,   119,   627,   323,
     238,   243,    -1,    24,   119,   627,    18,   519,    -1,    24,
     119,   627,   121,    74,   929,   480,    -1,    31,    -1,    -1,
      24,   352,   313,   113,   627,   600,    -1,    24,   352,   313,
      72,   627,    18,   216,   145,   928,   393,   626,    -1,    24,
     352,   313,    72,   627,    24,   216,   145,   928,   393,   626,
      -1,    24,   352,   313,    72,   627,    24,   216,   296,   627,
     393,   627,    -1,    24,   352,   313,    72,   627,    24,   216,
     145,   928,   296,   627,   393,   627,    -1,    24,   352,   313,
      72,   627,   121,   216,   145,   928,    -1,    24,   352,   313,
      72,   627,   121,   216,   165,   135,   145,   928,    -1,    81,
     613,    78,   627,   145,   938,   356,   938,   150,   627,    -1,
      63,   754,   927,   748,    -1,    63,   754,    -1,    63,   754,
     933,   252,   927,    -1,   376,   933,    -1,    -1,   377,   755,
     756,   754,    -1,   377,   755,   756,   754,   927,    -1,   377,
     755,   756,   754,   752,    -1,   377,   426,   750,   427,    -1,
     377,   426,   750,   427,   927,   757,    -1,   751,    -1,   750,
     430,   751,    -1,   753,    -1,   385,    -1,   149,    -1,   151,
      -1,   753,   754,    -1,   753,   754,   927,   757,    -1,    27,
      -1,    26,    -1,   385,    -1,    -1,   151,    -1,    -1,   149,
      -1,    -1,   426,   928,   427,    -1,    -1,   136,   759,    -1,
     136,   753,   754,   759,    -1,   136,   385,   759,    -1,   136,
     426,   760,   427,   759,    -1,   792,    -1,   770,    -1,   781,
      -1,   775,    -1,   788,    -1,   537,    -1,   767,    -1,   761,
      -1,   760,   430,   761,    -1,   762,   763,    -1,   942,    -1,
     753,    -1,   385,    -1,   464,    -1,   467,    -1,   549,    -1,
      -1,   276,   929,   765,    31,   766,    -1,   426,   898,   427,
      -1,    -1,   792,    -1,   770,    -1,   781,    -1,   775,    -1,
     134,   929,   768,    -1,    81,   503,   346,   538,    31,   134,
     929,   768,    -1,   426,   895,   427,    -1,    -1,   100,   929,
      -1,   100,   276,   929,    -1,   100,    22,    -1,   100,   276,
      22,    -1,   183,   189,   927,   771,   774,    -1,   792,    -1,
     426,   772,   427,   792,    -1,   104,   381,    -1,   773,    -1,
     772,   430,   773,    -1,   942,   919,    -1,   301,   924,    -1,
      -1,   109,   150,   837,   776,   840,   774,    -1,   376,   828,
      -1,    -1,   214,   802,   836,   778,   780,    -1,   170,   779,
     221,    -1,    -1,    16,   325,    -1,   307,   325,    -1,   307,
     133,    -1,   325,   374,   133,    -1,   325,    -1,   325,   307,
     133,    -1,   133,    -1,    16,   133,    -1,   242,    -1,    -1,
     374,   837,   323,   782,   827,   840,   774,    -1,   783,    -1,
     782,   430,   783,    -1,   784,    -1,   785,    -1,   786,   413,
     921,    -1,   426,   787,   427,   413,   923,    -1,   942,   919,
      -1,   786,    -1,   787,   430,   786,    -1,   103,   789,   790,
      95,   791,   145,   792,    -1,   929,    -1,    -1,   790,   230,
     312,    -1,   790,   312,    -1,   790,    43,    -1,   790,   182,
      -1,    -1,   393,   162,    -1,   394,   162,    -1,   794,    -1,
     793,    -1,   426,   794,   427,    -1,   426,   793,   427,    -1,
     796,    -1,   795,   806,    -1,   795,   805,   821,   810,    -1,
     795,   805,   809,   822,    -1,   797,   795,    -1,   797,   795,
     806,    -1,   797,   795,   805,   821,   810,    -1,   797,   795,
     805,   809,   822,    -1,   796,    -1,   793,    -1,   316,   804,
     924,   800,   827,   839,   819,   820,   878,    -1,   826,    -1,
     346,   835,    -1,   795,   369,   803,   795,    -1,   795,   187,
     803,   795,    -1,   795,   130,   803,   795,    -1,   393,   798,
      -1,   393,   289,   798,    -1,   799,    -1,   798,   430,   799,
      -1,   929,   757,    31,   793,    -1,   189,   801,    -1,    -1,
     351,   802,   927,    -1,   349,   802,   927,    -1,   210,   351,
     802,   927,    -1,   210,   349,   802,   927,    -1,   154,   351,
     802,   927,    -1,   154,   349,   802,   927,    -1,   346,   927,
      -1,   927,    -1,   346,    -1,    -1,    22,    -1,   116,    -1,
      -1,   116,    -1,   116,   252,   426,   895,   427,    -1,    22,
      -1,    -1,   806,    -1,    -1,   258,    47,   807,    -1,   808,
      -1,   807,   430,   808,    -1,   867,   376,   893,   667,    -1,
     867,   666,   667,    -1,   811,   812,    -1,   812,   811,    -1,
     811,    -1,   812,    -1,   809,    -1,    -1,   207,   813,    -1,
     207,   813,   430,   814,    -1,   141,   818,   815,   817,   253,
      -1,   250,   814,    -1,   250,   816,   817,    -1,   867,    -1,
      22,    -1,   867,    -1,   940,    -1,   426,   867,   427,    -1,
      -1,   869,    -1,   307,    -1,   308,    -1,   142,    -1,   229,
      -1,   158,    47,   895,    -1,    -1,   160,   867,    -1,    -1,
     823,    -1,   145,   285,   253,    -1,   821,    -1,    -1,   824,
      -1,   823,   824,    -1,   145,   374,   825,   780,    -1,   145,
     325,   825,   780,    -1,   248,   926,    -1,    -1,   381,   923,
      -1,   826,   430,   923,    -1,   150,   828,    -1,    -1,   829,
      -1,   828,   430,   829,    -1,   835,    -1,   835,   831,    -1,
     838,    -1,   838,   831,    -1,   838,    31,   426,   841,   427,
      -1,   838,    31,   942,   426,   841,   427,    -1,   838,   942,
     426,   841,   427,    -1,   793,    -1,   793,   831,    -1,   830,
      -1,   426,   830,   427,   831,    -1,   426,   830,   427,    -1,
     829,    85,   194,   829,    -1,   829,   832,   194,   829,   834,
      -1,   829,   194,   829,   834,    -1,   829,   227,   832,   194,
     829,    -1,   829,   227,   194,   829,    -1,    31,   942,   426,
     928,   427,    -1,    31,   942,    -1,   942,   426,   928,   427,
      -1,   942,    -1,   151,   833,    -1,   204,   833,    -1,   304,
     833,    -1,   179,    -1,   260,    -1,    -1,   376,   426,   928,
     427,    -1,   252,   867,    -1,   927,    -1,   927,   419,    -1,
     253,   927,    -1,   253,   426,   927,   427,    -1,   835,    -1,
     836,   430,   835,    -1,   835,    -1,   835,   942,    -1,   835,
      31,   942,    -1,   870,    -1,   390,   867,    -1,    -1,   390,
     867,    -1,   390,    87,   248,   929,    -1,    -1,   842,    -1,
     841,   430,   842,    -1,   942,   843,    -1,   845,   844,    -1,
     324,   845,   844,    -1,   845,    30,   424,   937,   425,    -1,
     324,   845,    30,   424,   937,   425,    -1,   845,    30,    -1,
     324,   845,    30,    -1,   844,   424,   425,    -1,   844,   424,
     937,   425,    -1,    -1,   847,    -1,   849,    -1,   851,    -1,
     855,    -1,   862,    -1,   863,   865,    -1,   863,   426,   937,
     427,   865,    -1,   849,    -1,   852,    -1,   856,    -1,   862,
      -1,   943,   848,    -1,   943,   628,   848,    -1,   426,   895,
     427,    -1,    -1,   185,    -1,   186,    -1,   329,    -1,    42,
      -1,   286,    -1,   143,   850,    -1,   120,   274,    -1,   102,
     848,    -1,   101,   848,    -1,   246,   848,    -1,    45,    -1,
     426,   937,   427,    -1,    -1,   853,    -1,   854,    -1,   853,
      -1,   854,    -1,    44,   860,   426,   895,   427,    -1,    44,
     860,    -1,   857,    -1,   858,    -1,   857,    -1,   858,    -1,
     859,   426,   937,   427,   861,    -1,   859,   861,    -1,    57,
     860,    -1,    56,   860,    -1,   382,    -1,   226,    57,   860,
      -1,   226,    56,   860,    -1,   228,   860,    -1,   384,    -1,
      -1,    57,   323,   942,    -1,    -1,   355,   426,   937,   427,
     864,    -1,   355,   864,    -1,   354,   426,   937,   427,   864,
      -1,   354,   864,    -1,   188,    -1,   412,   409,    -1,   394,
     354,   409,    -1,    -1,   407,    -1,   222,    -1,    99,    -1,
     163,    -1,   219,    -1,   866,    -1,   407,   356,   222,    -1,
      99,   356,   163,    -1,    99,   356,   219,    -1,    99,   356,
     866,    -1,   163,   356,   219,    -1,   163,   356,   866,    -1,
     219,   356,   866,    -1,    -1,   314,    -1,   314,   426,   937,
     427,    -1,   869,    -1,   867,    11,   843,    -1,   867,    36,
     354,   409,   867,    -1,   417,   867,    -1,   418,   867,    -1,
     867,   417,   867,    -1,   867,   418,   867,    -1,   867,   419,
     867,    -1,   867,   420,   867,    -1,   867,   421,   867,    -1,
     867,   422,   867,    -1,   867,   414,   867,    -1,   867,   415,
     867,    -1,   867,   413,   867,    -1,   867,   892,   867,    -1,
     892,   867,    -1,   867,   892,    -1,   867,    28,   867,    -1,
     867,   257,   867,    -1,   238,   867,    -1,   867,   206,   867,
      -1,   867,   206,   867,   129,   867,    -1,   867,   238,   206,
     867,    -1,   867,   238,   206,   867,   129,   867,    -1,   867,
     166,   867,    -1,   867,   166,   867,   129,   867,    -1,   867,
     238,   166,   867,    -1,   867,   238,   166,   867,   129,   867,
      -1,   867,   327,   356,   867,    -1,   867,   327,   356,   867,
     129,   867,    -1,   867,   238,   327,   356,   867,    -1,   867,
     238,   327,   356,   867,   129,   867,    -1,   867,   191,   243,
      -1,   867,   192,    -1,   867,   191,   238,   243,    -1,   867,
     241,    -1,   888,   262,   888,    -1,   867,   191,   362,    -1,
     867,   191,   238,   362,    -1,   867,   191,   139,    -1,   867,
     191,   238,   139,    -1,   867,   191,   371,    -1,   867,   191,
     238,   371,    -1,   867,   191,   116,   150,   867,    -1,   867,
     191,   238,   116,   150,   867,    -1,   867,   191,   248,   426,
     898,   427,    -1,   867,   191,   238,   248,   426,   898,   427,
      -1,   867,    41,   920,   868,    28,   868,    -1,   867,   238,
      41,   920,   868,    28,   868,    -1,   867,    41,   343,   868,
      28,   868,    -1,   867,   238,    41,   343,   868,    28,   868,
      -1,   867,   170,   910,    -1,   867,   238,   170,   910,    -1,
     867,   894,   889,   793,    -1,   867,   894,   889,   426,   867,
     427,    -1,   370,   793,    -1,   867,   191,   118,    -1,   867,
     191,   238,   118,    -1,   869,    -1,   868,    11,   843,    -1,
     417,   868,    -1,   418,   868,    -1,   868,   417,   868,    -1,
     868,   418,   868,    -1,   868,   419,   868,    -1,   868,   420,
     868,    -1,   868,   421,   868,    -1,   868,   422,   868,    -1,
     868,   414,   868,    -1,   868,   415,   868,    -1,   868,   413,
     868,    -1,   868,   892,   868,    -1,   892,   868,    -1,   868,
     892,    -1,   868,   191,   116,   150,   868,    -1,   868,   191,
     238,   116,   150,   868,    -1,   868,   191,   248,   426,   898,
     427,    -1,   868,   191,   238,   248,   426,   898,   427,    -1,
     868,   191,   118,    -1,   868,   191,   238,   118,    -1,   916,
      -1,   936,    -1,    10,   919,    -1,   426,   867,   427,   919,
      -1,   911,    -1,   870,    -1,   793,    -1,   135,   793,    -1,
      30,   793,    -1,    30,   899,    -1,   888,    -1,   935,   426,
     427,   881,    -1,   935,   426,   896,   427,   881,    -1,   935,
     426,   383,   897,   427,   881,    -1,   935,   426,   896,   430,
     383,   897,   427,   881,    -1,   935,   426,   896,   806,   427,
     881,    -1,   935,   426,    22,   896,   805,   427,   881,    -1,
     935,   426,   116,   896,   805,   427,   881,    -1,   935,   426,
     419,   427,   881,    -1,    89,    -1,    92,    -1,    92,   426,
     937,   427,    -1,    93,    -1,    93,   426,   937,   427,    -1,
     211,    -1,   211,   426,   937,   427,    -1,   212,    -1,   212,
     426,   937,   427,    -1,    90,    -1,    94,    -1,   322,    -1,
     375,    -1,    88,    -1,    91,    -1,    53,   426,   867,    31,
     843,   427,    -1,   138,   426,   901,   427,    -1,   263,   426,
     903,   427,    -1,   272,   426,   905,   427,    -1,   341,   426,
     906,   427,    -1,   359,   426,   867,    31,   843,   427,    -1,
     361,   426,    46,   909,   427,    -1,   361,   426,   202,   909,
     427,    -1,   361,   426,   357,   909,   427,    -1,   361,   426,
     909,   427,    -1,   244,   426,   867,   430,   867,   427,    -1,
      64,   426,   895,   427,    -1,   157,   426,   895,   427,    -1,
     203,   426,   895,   427,    -1,   400,   426,   895,   427,    -1,
     401,   426,   224,   944,   427,    -1,   401,   426,   224,   944,
     430,   873,   427,    -1,   401,   426,   224,   944,   430,   895,
     427,    -1,   401,   426,   224,   944,   430,   873,   430,   895,
     427,    -1,   402,   426,   874,   427,    -1,   403,   426,   876,
     867,   877,   427,    -1,   404,   426,   224,   944,   427,    -1,
     404,   426,   224,   944,   430,   867,   427,    -1,   405,   426,
     867,   430,   871,   872,   427,    -1,   406,   426,   876,   867,
      31,   845,   427,    -1,   386,   867,    -1,   386,   230,   380,
      -1,   430,   332,   408,    -1,   430,   332,   230,    -1,   430,
     332,   230,   380,    -1,    -1,   399,   426,   874,   427,    -1,
     875,    -1,   874,   430,   875,    -1,   867,    31,   944,    -1,
     867,    -1,   118,    -1,    76,    -1,   275,   391,    -1,   340,
     391,    -1,    -1,   392,   879,    -1,    -1,   880,    -1,   879,
     430,   880,    -1,   942,    31,   882,    -1,   261,   882,    -1,
     261,   942,    -1,    -1,   426,   883,   884,   805,   885,   427,
      -1,   942,    -1,    -1,   268,    47,   895,    -1,    -1,   284,
     886,    -1,   308,   886,    -1,    -1,   887,    -1,    41,   887,
      28,   887,    -1,   366,   273,    -1,   366,   144,    -1,    87,
     307,    -1,   867,   273,    -1,   867,   144,    -1,   307,   426,
     895,   427,    -1,   307,   426,   427,    -1,   426,   895,   430,
     867,   427,    -1,    29,    -1,   330,    -1,    22,    -1,     8,
      -1,   891,    -1,   417,    -1,   418,    -1,   419,    -1,   420,
      -1,   421,    -1,   422,    -1,   414,    -1,   415,    -1,   413,
      -1,     8,    -1,   254,   426,   694,   427,    -1,   890,    -1,
     254,   426,   694,   427,    -1,   890,    -1,   254,   426,   694,
     427,    -1,   206,    -1,   238,   206,    -1,   166,    -1,   238,
     166,    -1,   867,    -1,   895,   430,   867,    -1,   897,    -1,
     896,   430,   897,    -1,   867,    -1,   867,    31,   676,    -1,
     843,    -1,   898,   430,   843,    -1,   424,   895,   425,    -1,
     424,   900,   425,    -1,   424,   425,    -1,   899,    -1,   900,
     430,   899,    -1,   902,   150,   867,    -1,    -1,     3,    -1,
     407,    -1,   222,    -1,    99,    -1,   163,    -1,   219,    -1,
     314,    -1,   938,    -1,   867,   904,   907,   908,    -1,   867,
     904,   907,    -1,   270,   867,    -1,   868,   170,   868,    -1,
      -1,   867,   907,   908,    -1,   867,   908,   907,    -1,   867,
     907,    -1,   867,   908,    -1,   895,    -1,    -1,   150,   867,
      -1,   145,   867,    -1,   867,   150,   895,    -1,   150,   895,
      -1,   895,    -1,   793,    -1,   426,   895,   427,    -1,    52,
     915,   912,   914,   127,    -1,   913,    -1,   912,   913,    -1,
     389,   867,   353,   867,    -1,   123,   867,    -1,    -1,   867,
      -1,    -1,   942,    -1,   942,   918,    -1,   428,   932,    -1,
     428,   419,    -1,   424,   867,   425,    -1,   424,   867,   431,
     867,   425,    -1,   917,    -1,   918,   917,    -1,    -1,   919,
     917,    -1,    35,    -1,    -1,   867,    -1,   104,    -1,   921,
      -1,   922,   430,   921,    -1,   426,   922,   427,    -1,   925,
      -1,   924,   430,   925,    -1,   867,    31,   944,    -1,   867,
       3,    -1,   867,    -1,   419,    -1,   927,    -1,   926,   430,
     927,    -1,   942,    -1,   942,   918,    -1,   929,    -1,   928,
     430,   929,    -1,   942,    -1,   942,    -1,   942,    -1,   944,
      -1,   942,    -1,   938,    -1,   943,    -1,   942,   918,    -1,
     937,    -1,     4,    -1,   938,    -1,     6,    -1,     7,    -1,
     935,   938,    -1,   935,   426,   896,   427,   938,    -1,   846,
     938,    -1,   863,   938,   865,    -1,   863,   426,   937,   427,
     938,   865,    -1,   362,    -1,   139,    -1,   243,    -1,     9,
      -1,     5,    -1,   942,    -1,   937,    -1,   417,   937,    -1,
     418,   937,    -1,   937,    -1,   941,   430,   937,    -1,     3,
      -1,   945,    -1,   946,    -1,     3,    -1,   945,    -1,   947,
      -1,     3,    -1,   945,    -1,   946,    -1,   947,    -1,   948,
      -1,    14,    -1,    15,    -1,    16,    -1,    17,    -1,    18,
      -1,    19,    -1,    20,    -1,    21,    -1,    23,    -1,    24,
      -1,    25,    -1,    33,    -1,    34,    -1,    36,    -1,    38,
      -1,    39,    -1,    40,    -1,    47,    -1,    48,    -1,    49,
      -1,    50,    -1,    51,    -1,    54,    -1,    55,    -1,    58,
      -1,    60,    -1,    61,    -1,    62,    -1,    63,    -1,    67,
      -1,    68,    -1,    69,    -1,    70,    -1,    72,    -1,    73,
      -1,    75,    -1,    76,    -1,    77,    -1,    78,    -1,    79,
      -1,    80,    -1,    82,    -1,    83,    -1,    84,    -1,    86,
      -1,    87,    -1,    95,    -1,    96,    -1,    97,    -1,    98,
      -1,    99,    -1,   100,    -1,   103,    -1,   105,    -1,   107,
      -1,   108,    -1,   109,    -1,   110,    -1,   111,    -1,   113,
      -1,   114,    -1,   115,    -1,   118,    -1,   119,    -1,   120,
      -1,   121,    -1,   122,    -1,   124,    -1,   125,    -1,   126,
      -1,   128,    -1,   129,    -1,   131,    -1,   132,    -1,   133,
      -1,   134,    -1,   136,    -1,   137,    -1,   140,    -1,   142,
      -1,   144,    -1,   146,    -1,   148,    -1,   152,    -1,   153,
      -1,   154,    -1,   156,    -1,   159,    -1,   161,    -1,   162,
      -1,   163,    -1,   164,    -1,   165,    -1,   167,    -1,   168,
      -1,   169,    -1,   171,    -1,   172,    -1,   173,    -1,   174,
      -1,   175,    -1,   176,    -1,   178,    -1,   181,    -1,   182,
      -1,   183,    -1,   184,    -1,   190,    -1,   193,    -1,   195,
      -1,   196,    -1,   197,    -1,   198,    -1,   199,    -1,   200,
      -1,   201,    -1,   205,    -1,   208,    -1,   209,    -1,   210,
      -1,   213,    -1,   214,    -1,   215,    -1,   216,    -1,   217,
      -1,   218,    -1,   219,    -1,   220,    -1,   221,    -1,   222,
      -1,   223,    -1,   224,    -1,   225,    -1,   229,    -1,   230,
      -1,   231,    -1,   232,    -1,   233,    -1,   234,    -1,   235,
      -1,   237,    -1,   239,    -1,   240,    -1,   242,    -1,   245,
      -1,   247,    -1,   248,    -1,   251,    -1,   254,    -1,   255,
      -1,   256,    -1,   264,    -1,   265,    -1,   266,    -1,   267,
      -1,   268,    -1,   269,    -1,   271,    -1,   273,    -1,   276,
      -1,   277,    -1,   275,    -1,   279,    -1,   280,    -1,   281,
      -1,   282,    -1,   283,    -1,   284,    -1,   285,    -1,   287,
      -1,   288,    -1,   289,    -1,   291,    -1,   292,    -1,   293,
      -1,   294,    -1,   295,    -1,   296,    -1,   297,    -1,   298,
      -1,   299,    -1,   300,    -1,   302,    -1,   303,    -1,   305,
      -1,   306,    -1,   308,    -1,   309,    -1,   310,    -1,   311,
      -1,   312,    -1,   313,    -1,   314,    -1,   315,    -1,   317,
      -1,   318,    -1,   319,    -1,   320,    -1,   321,    -1,   323,
      -1,   325,    -1,   326,    -1,   328,    -1,   331,    -1,   332,
      -1,   333,    -1,   334,    -1,   335,    -1,   336,    -1,   337,
      -1,   338,    -1,   339,    -1,   340,    -1,   342,    -1,   344,
      -1,   345,    -1,   347,    -1,   348,    -1,   349,    -1,   350,
      -1,   351,    -1,   352,    -1,   358,    -1,   360,    -1,   363,
      -1,   364,    -1,   365,    -1,   366,    -1,   367,    -1,   368,
      -1,   371,    -1,   372,    -1,   373,    -1,   374,    -1,   377,
      -1,   378,    -1,   379,    -1,   380,    -1,   384,    -1,   386,
      -1,   387,    -1,   388,    -1,   391,    -1,   394,    -1,   395,
      -1,   396,    -1,   397,    -1,   398,    -1,   407,    -1,   408,
      -1,   409,    -1,    41,    -1,    42,    -1,    44,    -1,    45,
      -1,    56,    -1,    57,    -1,    64,    -1,   101,    -1,   102,
      -1,   135,    -1,   138,    -1,   143,    -1,   157,    -1,   180,
      -1,   185,    -1,   186,    -1,   188,    -1,   203,    -1,   226,
      -1,   228,    -1,   236,    -1,   244,    -1,   246,    -1,   259,
      -1,   263,    -1,   272,    -1,   274,    -1,   286,    -1,   307,
      -1,   324,    -1,   329,    -1,   341,    -1,   354,    -1,   355,
      -1,   359,    -1,   361,    -1,   381,    -1,   382,    -1,   399,
      -1,   400,    -1,   401,    -1,   402,    -1,   403,    -1,   404,
      -1,   405,    -1,   406,    -1,    37,    -1,    43,    -1,    71,
      -1,    85,    -1,    91,    -1,   149,    -1,   151,    -1,   166,
      -1,   179,    -1,   191,    -1,   192,    -1,   194,    -1,   204,
      -1,   206,    -1,   227,    -1,   241,    -1,   260,    -1,   261,
      -1,   262,    -1,   304,    -1,   327,    -1,   385,    -1,    22,
      -1,    26,    -1,    27,    -1,    28,    -1,    29,    -1,    30,
      -1,    31,    -1,    32,    -1,    35,    -1,    46,    -1,    52,
      -1,    53,    -1,    59,    -1,    65,    -1,    66,    -1,    74,
      -1,    81,    -1,    88,    -1,    89,    -1,    90,    -1,    92,
      -1,    93,    -1,    94,    -1,   104,    -1,   106,    -1,   112,
      -1,   116,    -1,   117,    -1,   123,    -1,   127,    -1,   130,
      -1,   139,    -1,   141,    -1,   145,    -1,   147,    -1,   150,
      -1,   155,    -1,   158,    -1,   160,    -1,   170,    -1,   177,
      -1,   187,    -1,   189,    -1,   202,    -1,   207,    -1,   211,
      -1,   212,    -1,   238,    -1,   243,    -1,   249,    -1,   250,
      -1,   252,    -1,   253,    -1,   257,    -1,   258,    -1,   270,
      -1,   278,    -1,   290,    -1,   301,    -1,   316,    -1,   322,
      -1,   330,    -1,   343,    -1,   346,    -1,   353,    -1,   356,
      -1,   357,    -1,   362,    -1,   369,    -1,   370,    -1,   375,
      -1,   376,    -1,   383,    -1,   389,    -1,   390,    -1,   392,
      -1,   393,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   625,   625,   632,   639,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,   747,   748,   749,   750,   751,   753,   763,
     774,   775,   784,   785,   789,   790,   794,   799,   803,   808,
     813,   817,   821,   825,   829,   833,   837,   841,   845,   850,
     854,   858,   862,   866,   871,   878,   880,   884,   888,   892,
     896,   910,   928,   939,   940,   944,   962,   974,   995,  1002,
    1021,  1028,  1045,  1063,  1074,  1075,  1087,  1094,  1111,  1123,
    1135,  1136,  1140,  1141,  1149,  1150,  1151,  1152,  1153,  1154,
    1168,  1174,  1180,  1189,  1197,  1205,  1212,  1219,  1227,  1238,
    1246,  1254,  1262,  1270,  1281,  1289,  1297,  1304,  1314,  1315,
    1322,  1323,  1326,  1328,  1330,  1334,  1335,  1336,  1337,  1341,
    1342,  1343,  1344,  1356,  1360,  1364,  1379,  1402,  1403,  1404,
    1408,  1409,  1410,  1414,  1415,  1419,  1426,  1433,  1440,  1447,
    1457,  1458,  1463,  1469,  1475,  1481,  1487,  1497,  1507,  1508,
    1512,  1513,  1521,  1536,  1542,  1548,  1554,  1572,  1580,  1588,
    1596,  1607,  1608,  1613,  1621,  1629,  1638,  1646,  1654,  1663,
    1672,  1681,  1690,  1700,  1713,  1723,  1731,  1741,  1751,  1758,
    1765,  1772,  1779,  1787,  1795,  1803,  1811,  1819,  1826,  1833,
    1841,  1848,  1855,  1863,  1871,  1879,  1887,  1895,  1903,  1911,
    1919,  1927,  1937,  1938,  1942,  1943,  1944,  1948,  1949,  1953,
    1956,  1957,  1961,  1962,  1967,  1971,  1975,  1980,  1995,  2001,
    2028,  2050,  2064,  2065,  2074,  2075,  2076,  2079,  2080,  2085,
    2086,  2090,  2094,  2098,  2102,  2106,  2110,  2114,  2118,  2122,
    2126,  2130,  2139,  2143,  2147,  2151,  2155,  2159,  2163,  2164,
    2169,  2173,  2180,  2187,  2188,  2189,  2190,  2191,  2192,  2196,
    2200,  2208,  2209,  2220,  2234,  2258,  2259,  2260,  2261,  2262,
    2263,  2264,  2268,  2269,  2273,  2274,  2278,  2282,  2289,  2293,
    2300,  2301,  2302,  2306,  2307,  2310,  2321,  2332,  2333,  2337,
    2345,  2346,  2365,  2372,  2379,  2389,  2399,  2408,  2417,  2446,
    2453,  2460,  2467,  2486,  2496,  2497,  2498,  2502,  2503,  2504,
    2505,  2506,  2507,  2516,  2524,  2528,  2542,  2555,  2568,  2584,
    2604,  2605,  2609,  2610,  2613,  2619,  2623,  2631,  2636,  2642,
    2643,  2647,  2652,  2659,  2660,  2670,  2672,  2674,  2676,  2679,
    2682,  2685,  2689,  2690,  2691,  2692,  2693,  2696,  2697,  2702,
    2703,  2704,  2705,  2708,  2709,  2710,  2711,  2714,  2715,  2718,
    2719,  2729,  2754,  2766,  2767,  2771,  2772,  2776,  2792,  2793,
    2794,  2807,  2818,  2827,  2828,  2831,  2832,  2835,  2839,  2843,
    2847,  2851,  2855,  2859,  2863,  2867,  2871,  2875,  2879,  2885,
    2886,  2890,  2891,  2896,  2908,  2920,  2935,  2936,  2944,  2945,
    2949,  2950,  2954,  2955,  2959,  2960,  2964,  2972,  2983,  2984,
    2994,  3004,  3005,  3018,  3025,  3041,  3058,  3066,  3083,  3092,
    3100,  3111,  3112,  3116,  3120,  3128,  3132,  3136,  3143,  3147,
    3152,  3157,  3164,  3171,  3176,  3186,  3200,  3201,  3206,  3207,
    3211,  3212,  3222,  3230,  3247,  3256,  3264,  3280,  3292,  3293,
    3294,  3304,  3312,  3329,  3348,  3368,  3392,  3393,  3397,  3399,
    3421,  3423,  3425,  3427,  3429,  3434,  3439,  3449,  3450,  3454,
    3455,  3459,  3460,  3464,  3465,  3466,  3470,  3476,  3477,  3478,
    3479,  3480,  3484,  3485,  3489,  3491,  3500,  3507,  3517,  3521,
    3522,  3526,  3527,  3532,  3542,  3564,  3583,  3606,  3616,  3627,
    3637,  3647,  3658,  3694,  3701,  3710,  3719,  3728,  3739,  3742,
    3743,  3746,  3750,  3757,  3758,  3759,  3760,  3761,  3764,  3765,
    3768,  3771,  3772,  3780,  3787,  3788,  3791,  3793,  3810,  3825,
    3826,  3830,  3839,  3848,  3857,  3867,  3876,  3877,  3880,  3881,
    3884,  3898,  3903,  3913,  3922,  3934,  3935,  3939,  3947,  3959,
    3968,  3980,  3989,  4010,  4020,  4038,  4047,  4059,  4060,  4061,
    4062,  4063,  4064,  4065,  4066,  4067,  4068,  4069,  4070,  4074,
    4075,  4078,  4079,  4082,  4084,  4097,  4108,  4109,  4110,  4135,
    4144,  4153,  4162,  4171,  4180,  4189,  4199,  4208,  4217,  4226,
    4235,  4244,  4253,  4261,  4269,  4277,  4288,  4289,  4290,  4291,
    4292,  4293,  4294,  4295,  4296,  4297,  4298,  4299,  4303,  4304,
    4314,  4320,  4328,  4336,  4344,  4352,  4360,  4368,  4376,  4384,
    4392,  4400,  4408,  4416,  4424,  4432,  4440,  4448,  4458,  4459,
    4462,  4463,  4473,  4489,  4503,  4529,  4531,  4533,  4535,  4542,
    4551,  4552,  4555,  4562,  4569,  4576,  4590,  4598,  4606,  4614,
    4622,  4630,  4638,  4646,  4654,  4662,  4670,  4678,  4686,  4694,
    4706,  4707,  4710,  4720,  4734,  4735,  4739,  4740,  4745,  4761,
    4774,  4784,  4796,  4797,  4800,  4801,  4811,  4821,  4822,  4826,
    4830,  4834,  4845,  4858,  4872,  4889,  4890,  4891,  4903,  4922,
    4923,  4927,  4928,  4932,  4933,  4937,  4938,  4941,  4942,  4950,
    4960,  4970,  4982,  4983,  4984,  4987,  4988,  4989,  4992,  4993,
    4994,  5010,  5022,  5035,  5050,  5051,  5054,  5055,  5059,  5060,
    5068,  5069,  5073,  5074,  5089,  5098,  5107,  5116,  5125,  5137,
    5138,  5139,  5140,  5141,  5147,  5151,  5166,  5167,  5173,  5183,
    5187,  5192,  5202,  5203,  5210,  5214,  5218,  5222,  5226,  5230,
    5234,  5238,  5242,  5246,  5250,  5254,  5258,  5266,  5270,  5274,
    5278,  5284,  5285,  5292,  5293,  5296,  5308,  5312,  5327,  5338,
    5339,  5344,  5345,  5360,  5370,  5383,  5393,  5406,  5416,  5429,
    5437,  5439,  5441,  5446,  5448,  5461,  5470,  5471,  5475,  5479,
    5491,  5502,  5513,  5526,  5527,  5528,  5532,  5543,  5544,  5558,
    5566,  5576,  5589,  5590,  5593,  5594,  5604,  5613,  5621,  5629,
    5638,  5646,  5654,  5663,  5672,  5680,  5689,  5698,  5707,  5716,
    5725,  5734,  5742,  5750,  5758,  5767,  5776,  5784,  5792,  5800,
    5808,  5818,  5819,  5822,  5823,  5833,  5842,  5850,  5859,  5867,
    5875,  5883,  5899,  5908,  5916,  5924,  5932,  5941,  5949,  5957,
    5966,  5975,  5984,  5992,  6000,  6008,  6016,  6024,  6032,  6048,
    6056,  6064,  6072,  6081,  6089,  6097,  6106,  6115,  6123,  6133,
    6145,  6162,  6163,  6164,  6169,  6175,  6184,  6185,  6186,  6187,
    6188,  6192,  6193,  6196,  6197,  6198,  6199,  6203,  6204,  6205,
    6210,  6220,  6241,  6251,  6252,  6255,  6264,  6270,  6289,  6296,
    6303,  6310,  6317,  6324,  6331,  6339,  6347,  6355,  6363,  6371,
    6378,  6385,  6394,  6395,  6396,  6400,  6403,  6406,  6413,  6415,
    6417,  6422,  6424,  6436,  6447,  6461,  6467,  6473,  6479,  6489,
    6505,  6515,  6516,  6520,  6524,  6528,  6532,  6536,  6540,  6544,
    6548,  6552,  6556,  6560,  6564,  6568,  6572,  6576,  6580,  6590,
    6591,  6602,  6609,  6620,  6631,  6632,  6636,  6650,  6657,  6674,
    6686,  6695,  6703,  6711,  6720,  6731,  6732,  6743,  6753,  6763,
    6773,  6783,  6793,  6801,  6822,  6845,  6853,  6862,  6873,  6874,
    6886,  6900,  6914,  6926,  6938,  6955,  6956,  6960,  6961,  6962,
    6963,  6967,  6979,  6994,  6995,  6999,  7000,  7003,  7004,  7007,
    7008,  7012,  7013,  7026,  7033,  7043,  7050,  7060,  7061,  7062,
    7063,  7064,  7065,  7066,  7070,  7074,  7081,  7088,  7089,  7090,
    7094,  7095,  7096,  7097,  7107,  7117,  7118,  7122,  7123,  7124,
    7125,  7135,  7143,  7160,  7161,  7171,  7177,  7183,  7189,  7205,
    7214,  7220,  7226,  7235,  7237,  7242,  7253,  7254,  7265,  7278,
    7279,  7290,  7301,  7302,  7305,  7306,  7307,  7308,  7309,  7310,
    7311,  7312,  7315,  7316,  7327,  7344,  7345,  7349,  7350,  7354,
    7362,  7390,  7401,  7402,  7412,  7423,  7426,  7427,  7428,  7429,
    7430,  7433,  7434,  7435,  7483,  7484,  7488,  7489,  7503,  7504,
    7511,  7519,  7527,  7535,  7543,  7551,  7562,  7563,  7590,  7605,
    7606,  7625,  7629,  7633,  7648,  7655,  7665,  7666,  7669,  7681,
    7691,  7699,  7704,  7709,  7714,  7719,  7724,  7729,  7734,  7741,
    7742,  7745,  7746,  7747,  7754,  7755,  7756,  7757,  7761,  7762,
    7766,  7770,  7771,  7774,  7783,  7796,  7797,  7798,  7799,  7803,
    7804,  7808,  7810,  7820,  7825,  7828,  7833,  7834,  7842,  7852,
    7853,  7854,  7862,  7866,  7867,  7870,  7871,  7876,  7877,  7881,
    7882,  7886,  7887,  7891,  7892,  7896,  7897,  7901,  7909,  7920,
    7921,  7926,  7932,  7950,  7951,  7955,  7956,  7966,  7970,  7975,
    7982,  7990,  7997,  8007,  8017,  8045,  8052,  8056,  8082,  8086,
    8098,  8111,  8125,  8136,  8151,  8157,  8162,  8168,  8175,  8176,
    8177,  8178,  8182,  8183,  8195,  8196,  8201,  8208,  8215,  8222,
    8233,  8234,  8247,  8251,  8258,  8268,  8273,  8274,  8279,  8280,
    8288,  8293,  8297,  8303,  8324,  8329,  8336,  8341,  8347,  8352,
    8361,  8363,  8366,  8370,  8371,  8372,  8373,  8374,  8375,  8380,
    8410,  8411,  8412,  8413,  8424,  8430,  8438,  8439,  8445,  8450,
    8455,  8460,  8465,  8470,  8475,  8480,  8486,  8492,  8498,  8505,
    8527,  8536,  8540,  8548,  8552,  8560,  8572,  8593,  8597,  8603,
    8607,  8620,  8639,  8662,  8664,  8666,  8668,  8670,  8672,  8677,
    8678,  8682,  8683,  8690,  8699,  8707,  8716,  8727,  8735,  8736,
    8737,  8741,  8743,  8745,  8747,  8749,  8751,  8753,  8758,  8763,
    8769,  8777,  8782,  8789,  8796,  8800,  8804,  8834,  8835,  8837,
    8859,  8861,  8863,  8865,  8867,  8869,  8871,  8873,  8875,  8877,
    8879,  8882,  8884,  8886,  8889,  8891,  8893,  8896,  8898,  8911,
    8913,  8926,  8928,  8941,  8943,  8957,  8970,  8983,  8996,  9019,
    9026,  9033,  9040,  9047,  9051,  9058,  9065,  9072,  9079,  9086,
    9093,  9097,  9105,  9109,  9119,  9126,  9133,  9146,  9159,  9178,
    9199,  9209,  9216,  9232,  9237,  9255,  9257,  9259,  9261,  9263,
    9265,  9267,  9269,  9271,  9273,  9275,  9277,  9279,  9281,  9283,
    9285,  9287,  9291,  9296,  9300,  9304,  9309,  9326,  9327,  9328,
    9343,  9355,  9357,  9359,  9369,  9379,  9389,  9397,  9415,  9428,
    9441,  9454,  9467,  9480,  9497,  9510,  9533,  9554,  9564,  9577,
    9594,  9607,  9617,  9630,  9640,  9653,  9666,  9679,  9692,  9705,
    9718,  9731,  9733,  9746,  9764,  9778,  9794,  9816,  9832,  9845,
    9858,  9871,  9875,  9882,  9890,  9898,  9902,  9906,  9910,  9914,
    9918,  9922,  9931,  9935,  9939,  9944,  9958,  9960,  9964,  9966,
    9968,  9971,  9974,  9977,  9978,  9981,  9989,  9999, 10000, 10003,
   10004, 10005, 10012, 10013, 10017, 10018, 10023, 10031, 10033, 10047,
   10050, 10077, 10078, 10081, 10082, 10093, 10111, 10118, 10127, 10144,
   10189, 10197, 10205, 10213, 10221, 10242, 10243, 10244, 10247, 10248,
   10249, 10252, 10253, 10256, 10257, 10258, 10259, 10260, 10261, 10262,
   10263, 10264, 10267, 10269, 10274, 10276, 10281, 10283, 10285, 10287,
   10289, 10291, 10303, 10307, 10314, 10318, 10324, 10328, 10339, 10340,
   10343, 10347, 10351, 10357, 10358, 10363, 10367, 10374, 10375, 10376,
   10377, 10378, 10379, 10380, 10381, 10391, 10395, 10402, 10409, 10410,
   10426, 10430, 10435, 10439, 10454, 10459, 10463, 10466, 10469, 10470,
   10471, 10474, 10481, 10491, 10505, 10506, 10510, 10521, 10522, 10525,
   10526, 10529, 10533, 10540, 10544, 10548, 10555, 10565, 10566, 10570,
   10571, 10574, 10575, 10586, 10587, 10596, 10597, 10605, 10616, 10617,
   10620, 10636, 10644, 10652, 10674, 10675, 10686, 10694, 10722, 10724,
   10729, 10732, 10735, 10737, 10739, 10741, 10751, 10753, 10764, 10768,
   10772, 10776, 10780, 10789, 10796, 10821, 10825, 10831, 10848, 10852,
   10856, 10862, 10863, 10864, 10866, 10867, 10868, 10871, 10872, 10888,
   10889, 10890, 10895, 10896, 10897, 10903, 10904, 10905, 10906, 10907,
   10927, 10928, 10929, 10930, 10931, 10932, 10933, 10934, 10935, 10936,
   10937, 10938, 10939, 10940, 10941, 10942, 10943, 10944, 10945, 10946,
   10947, 10948, 10949, 10950, 10951, 10952, 10953, 10954, 10955, 10956,
   10957, 10958, 10959, 10960, 10961, 10962, 10963, 10964, 10965, 10966,
   10967, 10968, 10969, 10970, 10971, 10972, 10973, 10974, 10975, 10976,
   10977, 10978, 10979, 10980, 10981, 10982, 10983, 10984, 10985, 10986,
   10987, 10988, 10989, 10990, 10991, 10992, 10993, 10994, 10995, 10996,
   10997, 10998, 10999, 11000, 11001, 11002, 11003, 11004, 11005, 11006,
   11007, 11008, 11009, 11010, 11011, 11012, 11013, 11014, 11015, 11016,
   11017, 11018, 11019, 11020, 11021, 11022, 11023, 11024, 11025, 11026,
   11027, 11028, 11029, 11030, 11031, 11032, 11033, 11034, 11035, 11036,
   11037, 11038, 11039, 11040, 11041, 11042, 11043, 11044, 11045, 11046,
   11047, 11048, 11049, 11050, 11051, 11052, 11053, 11054, 11055, 11056,
   11057, 11058, 11059, 11060, 11061, 11062, 11063, 11064, 11065, 11066,
   11067, 11068, 11069, 11070, 11071, 11072, 11073, 11074, 11075, 11076,
   11077, 11078, 11079, 11080, 11081, 11082, 11083, 11084, 11085, 11086,
   11087, 11088, 11089, 11090, 11091, 11092, 11093, 11094, 11095, 11096,
   11097, 11098, 11099, 11100, 11101, 11102, 11103, 11104, 11105, 11106,
   11107, 11108, 11109, 11110, 11111, 11112, 11113, 11114, 11115, 11116,
   11117, 11118, 11119, 11120, 11121, 11122, 11123, 11124, 11125, 11126,
   11127, 11128, 11129, 11130, 11131, 11132, 11133, 11134, 11135, 11136,
   11137, 11138, 11139, 11140, 11141, 11142, 11143, 11144, 11145, 11146,
   11147, 11148, 11149, 11150, 11151, 11152, 11153, 11154, 11155, 11156,
   11157, 11158, 11159, 11160, 11161, 11162, 11163, 11164, 11165, 11166,
   11167, 11168, 11169, 11170, 11171, 11172, 11173, 11174, 11175, 11176,
   11177, 11191, 11192, 11193, 11194, 11195, 11196, 11197, 11198, 11199,
   11200, 11201, 11202, 11203, 11204, 11205, 11206, 11207, 11208, 11209,
   11210, 11211, 11212, 11213, 11214, 11215, 11216, 11217, 11218, 11219,
   11220, 11221, 11222, 11223, 11224, 11225, 11226, 11227, 11228, 11229,
   11230, 11231, 11232, 11233, 11234, 11235, 11236, 11250, 11251, 11252,
   11253, 11254, 11255, 11256, 11257, 11258, 11259, 11260, 11261, 11262,
   11263, 11264, 11265, 11266, 11267, 11268, 11269, 11270, 11271, 11281,
   11282, 11283, 11284, 11285, 11286, 11287, 11288, 11289, 11290, 11291,
   11292, 11293, 11294, 11295, 11296, 11297, 11298, 11299, 11300, 11301,
   11302, 11303, 11304, 11305, 11306, 11307, 11308, 11309, 11310, 11311,
   11312, 11313, 11314, 11315, 11316, 11317, 11318, 11319, 11320, 11321,
   11322, 11323, 11324, 11325, 11326, 11327, 11328, 11329, 11330, 11331,
   11332, 11333, 11334, 11335, 11336, 11337, 11338, 11339, 11340, 11341,
   11342, 11343, 11344, 11345, 11346, 11347, 11348, 11349, 11350, 11351,
   11352, 11353, 11354, 11355, 11356, 11357
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "FCONST", "SCONST", "BCONST",
  "XCONST", "Op", "ICONST", "PARAM", "TYPECAST", "DOT_DOT", "COLON_EQUALS",
  "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER",
  "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE",
  "AND", "ANY", "ARRAY", "AS", "ASC", "ASSERTION", "ASSIGNMENT",
  "ASYMMETRIC", "AT", "AUTHORIZATION", "BACKWARD", "BEFORE", "BEGIN_P",
  "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P", "BOTH", "BY", "CACHE",
  "CALLED", "CASCADE", "CASCADED", "CASE", "CAST", "CATALOG_P", "CHAIN",
  "CHAR_P", "CHARACTER", "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS",
  "CLOSE", "CLUSTER", "COALESCE", "COLLATE", "COLUMN", "COMMENT",
  "COMMENTS", "COMMIT", "COMMITTED", "CONCURRENTLY", "CONFIGURATION",
  "CONNECTION", "CONSTRAINT", "CONSTRAINTS", "CONTENT_P", "CONTINUE_P",
  "CONVERSION_P", "COPY", "COST", "CREATE", "CREATEDB", "CREATEROLE",
  "CREATEUSER", "CROSS", "CSV", "CURRENT_P", "CURRENT_CATALOG",
  "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME",
  "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P",
  "DATABASE", "DAY_P", "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE",
  "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P",
  "DELIMITER", "DELIMITERS", "DESC", "DICTIONARY", "DISABLE_P", "DISCARD",
  "DISTINCT", "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH",
  "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE",
  "EXCEPT", "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE", "EXISTS",
  "EXPLAIN", "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY", "FETCH",
  "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR", "FORCE", "FOREIGN", "FORWARD",
  "FREEZE", "FROM", "FULL", "FUNCTION", "FUNCTIONS", "GLOBAL", "GRANT",
  "GRANTED", "GREATEST", "GROUP_P", "HANDLER", "HAVING", "HEADER_P",
  "HOLD", "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE",
  "IMMUTABLE", "IMPLICIT_P", "IN_P", "INCLUDING", "INCREMENT", "INDEX",
  "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P", "INNER_P",
  "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD", "INT_P",
  "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL",
  "ISOLATION", "JOIN", "KEY", "LABEL", "LANGUAGE", "LARGE_P", "LAST_P",
  "LC_COLLATE_P", "LC_CTYPE_P", "LEADING", "LEAST", "LEFT", "LEVEL",
  "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOGIN_P", "MAPPING", "MATCH",
  "MAXVALUE", "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P",
  "NAMES", "NATIONAL", "NATURAL", "NCHAR", "NEXT", "NO", "NOCREATEDB",
  "NOCREATEROLE", "NOCREATEUSER", "NOINHERIT", "NOLOGIN_P", "NONE",
  "NOSUPERUSER", "NOT", "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P",
  "NULLIF", "NULLS_P", "NUMERIC", "OBJECT_P", "OF", "OFF", "OFFSET",
  "OIDS", "ON", "ONLY", "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER",
  "OUT_P", "OUTER_P", "OVER", "OVERLAPS", "OVERLAY", "OWNED", "OWNER",
  "PARSER", "PARTIAL", "PARTITION", "PASSWORD", "PLACING", "PLANS",
  "POSITION", "PRECEDING", "PRECISION", "PRESERVE", "PREPARE", "PREPARED",
  "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "QUOTE",
  "RANGE", "READ", "REAL", "REASSIGN", "RECHECK", "RECURSIVE",
  "REFERENCES", "REINDEX", "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE",
  "REPLACE", "REPLICA", "RESET", "RESTART", "RESTRICT", "RETURNING",
  "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROW", "ROWS", "RULE",
  "SAVEPOINT", "SCHEMA", "SCROLL", "SEARCH", "SECOND_P", "SECURITY",
  "SELECT", "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION",
  "SESSION_USER", "SET", "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE",
  "SMALLINT", "SOME", "STABLE", "STANDALONE_P", "START", "STATEMENT",
  "STATISTICS", "STDIN", "STDOUT", "STORAGE", "STRICT_P", "STRIP_P",
  "SUBSTRING", "SUPERUSER_P", "SYMMETRIC", "SYSID", "SYSTEM_P", "TABLE",
  "TABLES", "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY", "TEXT_P",
  "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING", "TRANSACTION", "TREAT",
  "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P",
  "UNBOUNDED", "UNCOMMITTED", "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN",
  "UNLISTEN", "UNTIL", "UPDATE", "USER", "USING", "VACUUM", "VALID",
  "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR", "VARIADIC", "VARYING",
  "VERBOSE", "VERSION_P", "VIEW", "VOLATILE", "WHEN", "WHERE",
  "WHITESPACE_P", "WINDOW", "WITH", "WITHOUT", "WORK", "WRAPPER", "WRITE",
  "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLFOREST",
  "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE", "YEAR_P", "YES_P",
  "ZONE", "NULLS_FIRST", "NULLS_LAST", "WITH_TIME", "'='", "'<'", "'>'",
  "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS", "'['",
  "']'", "'('", "')'", "'.'", "';'", "','", "':'", "$accept", "stmtblock",
  "stmtmulti", "stmt", "CreateRoleStmt", "opt_with", "OptRoleList",
  "AlterOptRoleList", "AlterOptRoleElem", "CreateOptRoleElem",
  "CreateUserStmt", "AlterRoleStmt", "opt_in_database", "AlterRoleSetStmt",
  "AlterUserStmt", "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt",
  "CreateGroupStmt", "AlterGroupStmt", "add_drop", "DropGroupStmt",
  "CreateSchemaStmt", "OptSchemaName", "OptSchemaEltList", "schema_stmt",
  "VariableSetStmt", "set_rest", "var_name", "var_list", "var_value",
  "iso_level", "opt_boolean", "zone_value", "opt_encoding",
  "ColId_or_Sconst", "VariableResetStmt", "SetResetClause",
  "VariableShowStmt", "ConstraintsSetStmt", "constraints_set_list",
  "constraints_set_mode", "CheckPointStmt", "DiscardStmt",
  "AlterTableStmt", "alter_table_cmds", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "alter_using", "reloptions",
  "opt_reloptions", "reloption_list", "reloption_elem", "ClosePortalStmt",
  "CopyStmt", "copy_from", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "opt_oids",
  "copy_delimiter", "opt_using", "copy_generic_opt_list",
  "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_column_list", "columnList",
  "columnElem", "key_match", "ExclusionConstraintList",
  "ExclusionConstraintElem", "ExclusionWhereClause", "key_actions",
  "key_update", "key_delete", "key_action", "OptInherit", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "CreateAsStmt",
  "create_as_target", "OptCreateAs", "CreateAsList", "CreateAsElement",
  "opt_with_data", "CreateSeqStmt", "AlterSeqStmt", "OptSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "CreatePLangStmt",
  "opt_trusted", "handler_name", "opt_inline_handler", "validator_clause",
  "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateFdwStmt", "DropFdwStmt", "AlterFdwStmt", "create_generic_options",
  "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateUserMappingStmt", "auth_ident",
  "DropUserMappingStmt", "AlterUserMappingStmt", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerForSpec", "TriggerForOpt", "TriggerForType", "TriggerWhen",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintDeferrabilitySpec",
  "ConstraintTimeSpec", "DropTrigStmt", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "definition", "def_list", "def_elem",
  "def_arg", "aggr_args", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list",
  "CreateOpClassStmt", "opclass_item_list", "opclass_item", "opt_default",
  "opt_opfamily", "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type", "any_name_list", "any_name", "attrs", "TruncateStmt",
  "opt_restart_seqs", "CommentStmt", "comment_type", "comment_text",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "function_with_argtypes_list", "function_with_argtypes", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "AlterDefaultPrivilegesStmt", "DefACLOptionList", "DefACLOption",
  "DefACLAction", "defacl_privilege_target", "IndexStmt", "opt_unique",
  "opt_concurrently", "opt_index_name", "access_method_clause",
  "index_params", "index_elem", "opt_class", "opt_asc_desc",
  "opt_nulls_order", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "func_args_with_defaults",
  "func_args_with_defaults_list", "func_arg", "arg_class", "param_name",
  "func_return", "func_type", "func_arg_with_default",
  "createfunc_opt_list", "common_func_opt_item", "createfunc_opt_item",
  "func_as", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "DoStmt", "dostmt_opt_list",
  "dostmt_opt_item", "CreateCastStmt", "cast_context", "DropCastStmt",
  "opt_if_exists", "ReindexStmt", "reindex_type", "opt_force",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectSchemaStmt",
  "AlterOwnerStmt", "AlterSecLabelStmt", "SecLabelItem", "RuleStmt",
  "RuleActionList", "RuleActionMulti", "RuleActionStmt",
  "RuleActionStmtOrEmpty", "event", "opt_instead", "DropRuleStmt",
  "NotifyStmt", "notify_payload", "ListenStmt", "UnlistenStmt",
  "TransactionStmt", "opt_transaction", "transaction_mode_item",
  "transaction_mode_list", "transaction_mode_list_or_empty", "ViewStmt",
  "opt_check_option", "LoadStmt", "CreatedbStmt", "createdb_opt_list",
  "createdb_opt_item", "opt_equal", "AlterDatabaseStmt",
  "AlterDatabaseSetStmt", "alterdb_opt_list", "alterdb_opt_item",
  "DropdbStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "vacuum_option_list", "vacuum_option_elem", "AnalyzeStmt",
  "analyze_keyword", "opt_verbose", "opt_full", "opt_freeze",
  "opt_name_list", "ExplainStmt", "ExplainableStmt", "explain_option_list",
  "explain_option_elem", "explain_option_name", "explain_option_arg",
  "PrepareStmt", "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "InsertStmt", "insert_rest",
  "insert_column_list", "insert_column_item", "returning_clause",
  "DeleteStmt", "using_clause", "LockStmt", "opt_lock", "lock_type",
  "opt_nowait", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "into_clause", "OptTempTableName", "opt_table",
  "opt_all", "opt_distinct", "opt_sort_clause", "sort_clause",
  "sortby_list", "sortby", "select_limit", "opt_select_limit",
  "limit_clause", "offset_clause", "select_limit_value",
  "select_offset_value", "opt_select_fetch_first_value",
  "select_offset_value2", "row_or_rows", "first_or_next", "group_clause",
  "having_clause", "for_locking_clause", "opt_for_locking_clause",
  "for_locking_items", "for_locking_item", "locked_rels_list",
  "values_clause", "from_clause", "from_list", "table_ref", "joined_table",
  "alias_clause", "join_type", "join_outer", "join_qual", "relation_expr",
  "relation_expr_list", "relation_expr_opt_alias", "func_table",
  "where_clause", "where_or_current_clause", "TableFuncElementList",
  "TableFuncElement", "Typename", "opt_array_bounds", "SimpleTypename",
  "ConstTypename", "GenericType", "opt_type_modifiers", "Numeric",
  "opt_float", "Bit", "ConstBit", "BitWithLength", "BitWithoutLength",
  "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "opt_charset",
  "ConstDatetime", "ConstInterval", "opt_timezone", "opt_interval",
  "interval_second", "a_expr", "b_expr", "c_expr", "func_expr",
  "xml_root_version", "opt_xml_root_standalone", "xml_attributes",
  "xml_attribute_list", "xml_attribute_el", "document_or_content",
  "xml_whitespace_option", "window_clause", "window_definition_list",
  "window_definition", "over_clause", "window_specification",
  "opt_existing_window_name", "opt_partition_clause", "opt_frame_clause",
  "frame_extent", "frame_bound", "row", "sub_type", "all_Op", "MathOp",
  "qual_Op", "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "overlay_list", "overlay_placing",
  "position_list", "substr_list", "substr_from", "substr_for", "trim_list",
  "in_expr", "case_expr", "when_clause_list", "when_clause",
  "case_default", "case_arg", "columnref", "indirection_el", "indirection",
  "opt_indirection", "opt_asymmetric", "ctext_expr", "ctext_expr_list",
  "ctext_row", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "database_name", "access_method",
  "attr_name", "index_name", "file_name", "func_name", "AexprConst",
  "Iconst", "Sconst", "RoleId", "SignedIconst", "Iconst_list", "ColId",
  "type_function_name", "ColLabel", "unreserved_keyword",
  "col_name_keyword", "type_func_name_keyword", "reserved_keyword", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,    61,    60,    62,   668,    43,    45,    42,
      47,    37,    94,   669,    91,    93,    40,    41,    46,    59,
      44,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   432,   433,   434,   434,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   436,
     437,   437,   438,   438,   439,   439,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   441,   441,   441,   441,   441,
     441,   442,   443,   444,   444,   445,   446,   447,   448,   448,
     449,   449,   450,   451,   452,   452,   453,   453,   454,   454,
     455,   455,   456,   456,   457,   457,   457,   457,   457,   457,
     458,   458,   458,   459,   459,   459,   459,   459,   459,   459,
     459,   459,   459,   459,   459,   459,   459,   459,   460,   460,
     461,   461,   462,   462,   462,   463,   463,   463,   463,   464,
     464,   464,   464,   465,   465,   465,   465,   465,   465,   465,
     466,   466,   466,   467,   467,   468,   468,   468,   468,   468,
     469,   469,   470,   470,   470,   470,   470,   471,   472,   472,
     473,   473,   474,   475,   475,   475,   475,   476,   476,   476,
     476,   477,   477,   478,   478,   478,   478,   478,   478,   478,
     478,   478,   478,   478,   478,   478,   478,   478,   478,   478,
     478,   478,   478,   478,   478,   478,   478,   478,   478,   478,
     478,   478,   478,   478,   478,   478,   478,   478,   478,   478,
     478,   478,   479,   479,   480,   480,   480,   481,   481,   482,
     483,   483,   484,   484,   485,   485,   485,   485,   486,   486,
     487,   487,   488,   488,   489,   489,   489,   490,   490,   491,
     491,   492,   492,   492,   492,   492,   492,   492,   492,   492,
     492,   492,   493,   493,   494,   494,   495,   495,   496,   496,
     497,   497,   498,   499,   499,   499,   499,   499,   499,   500,
     500,   501,   501,   502,   502,   503,   503,   503,   503,   503,
     503,   503,   504,   504,   505,   505,   506,   506,   507,   507,
     508,   508,   508,   509,   509,   510,   511,   512,   512,   513,
     513,   513,   514,   514,   514,   514,   514,   514,   514,   515,
     515,   515,   515,   516,   517,   517,   517,   518,   518,   518,
     518,   518,   518,   519,   519,   520,   520,   520,   520,   520,
     521,   521,   522,   522,   523,   524,   524,   524,   524,   525,
     525,   526,   526,   527,   527,   528,   528,   528,   528,   528,
     529,   530,   531,   531,   531,   531,   531,   532,   532,   533,
     533,   533,   533,   534,   534,   534,   534,   535,   535,   536,
     536,   537,   538,   539,   539,   540,   540,   541,   542,   542,
     542,   543,   544,   545,   545,   546,   546,   547,   547,   547,
     547,   547,   547,   547,   547,   547,   547,   547,   547,   548,
     548,   549,   549,   549,   550,   550,   551,   551,   552,   552,
     553,   553,   554,   554,   555,   555,   556,   556,   557,   557,
     558,   559,   559,   560,   560,   561,   562,   562,   563,   563,
     563,   564,   564,   565,   565,   566,   567,   567,   568,   568,
     568,   568,   569,   570,   571,   572,   573,   573,   574,   574,
     575,   575,   576,   576,   577,   577,   577,   578,   579,   579,
     579,   580,   580,   581,   582,   582,   583,   583,   584,   584,
     585,   585,   585,   585,   585,   586,   586,   587,   587,   588,
     588,   589,   589,   590,   590,   590,   591,   591,   591,   591,
     591,   591,   592,   592,   593,   593,   593,   593,   593,   594,
     594,   595,   595,   596,   596,   597,   598,   599,   599,   599,
     599,   599,   599,   599,   599,   599,   599,   599,   600,   601,
     601,   602,   602,   603,   603,   603,   603,   603,   604,   604,
     605,   606,   606,   607,   608,   608,   609,   609,   610,   611,
     611,   612,   612,   612,   612,   612,   613,   613,   614,   614,
     615,   615,   616,   617,   617,   618,   618,   619,   619,   620,
     620,   621,   621,   622,   623,   624,   624,   625,   625,   625,
     625,   625,   625,   625,   625,   625,   625,   625,   625,   626,
     626,   627,   627,   628,   628,   629,   630,   630,   630,   631,
     631,   631,   631,   631,   631,   631,   631,   631,   631,   631,
     631,   631,   631,   631,   631,   631,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   633,   633,
     634,   634,   635,   635,   635,   635,   635,   635,   635,   635,
     635,   635,   635,   635,   635,   635,   635,   635,   636,   636,
     637,   637,   638,   639,   639,   640,   640,   640,   640,   640,
     641,   641,   642,   642,   642,   642,   643,   643,   643,   643,
     643,   643,   643,   643,   643,   643,   643,   643,   643,   643,
     644,   644,   645,   645,   646,   646,   647,   647,   648,   649,
     650,   650,   651,   651,   652,   652,   653,   654,   654,   655,
     655,   655,   656,   656,   656,   657,   657,   657,   658,   659,
     659,   660,   660,   661,   661,   662,   662,   663,   663,   664,
     664,   664,   665,   665,   665,   666,   666,   666,   667,   667,
     667,   668,   668,   668,   669,   669,   670,   670,   671,   671,
     672,   672,   673,   673,   674,   674,   674,   674,   674,   675,
     675,   675,   675,   675,   676,   677,   678,   678,   678,   679,
     679,   679,   680,   680,   681,   681,   681,   681,   681,   681,
     681,   681,   681,   681,   681,   681,   681,   682,   682,   682,
     682,   683,   683,   684,   684,   685,   686,   686,   687,   688,
     688,   689,   689,   690,   690,   691,   691,   692,   692,   693,
     693,   693,   693,   694,   694,   695,   696,   696,   697,   697,
     698,   698,   698,   699,   699,   699,   700,   701,   701,   702,
     702,   702,   703,   703,   704,   704,   705,   705,   705,   705,
     705,   705,   705,   705,   705,   705,   705,   705,   705,   705,
     705,   705,   705,   705,   705,   705,   705,   705,   705,   705,
     705,   706,   706,   707,   707,   708,   708,   708,   708,   708,
     708,   708,   709,   709,   709,   709,   709,   709,   709,   709,
     709,   709,   709,   709,   709,   709,   709,   709,   709,   710,
     710,   710,   710,   710,   710,   710,   710,   710,   710,   711,
     712,   713,   713,   713,   714,   714,   715,   715,   715,   715,
     715,   716,   716,   717,   717,   717,   717,   718,   718,   718,
     719,   719,   720,   721,   721,   722,   723,   723,   724,   724,
     724,   724,   724,   724,   724,   724,   724,   724,   724,   724,
     724,   724,   725,   725,   725,   726,   726,   726,   727,   727,
     727,   728,   728,   729,   729,   730,   730,   730,   730,   731,
     732,   733,   733,   734,   734,   734,   734,   734,   734,   734,
     734,   734,   734,   734,   734,   734,   734,   734,   734,   735,
     735,   736,   736,   737,   738,   738,   739,   740,   740,   741,
     742,   742,   742,   742,   742,   743,   743,   744,   745,   745,
     745,   745,   745,   745,   746,   747,   747,   747,   748,   748,
     749,   749,   749,   749,   749,   750,   750,   751,   751,   751,
     751,   752,   752,   753,   753,   754,   754,   755,   755,   756,
     756,   757,   757,   758,   758,   758,   758,   759,   759,   759,
     759,   759,   759,   759,   760,   760,   761,   762,   762,   762,
     763,   763,   763,   763,   764,   765,   765,   766,   766,   766,
     766,   767,   767,   768,   768,   769,   769,   769,   769,   770,
     771,   771,   771,   772,   772,   773,   774,   774,   775,   776,
     776,   777,   778,   778,   779,   779,   779,   779,   779,   779,
     779,   779,   780,   780,   781,   782,   782,   783,   783,   784,
     785,   786,   787,   787,   788,   789,   790,   790,   790,   790,
     790,   791,   791,   791,   792,   792,   793,   793,   794,   794,
     794,   794,   794,   794,   794,   794,   795,   795,   796,   796,
     796,   796,   796,   796,   797,   797,   798,   798,   799,   800,
     800,   801,   801,   801,   801,   801,   801,   801,   801,   802,
     802,   803,   803,   803,   804,   804,   804,   804,   805,   805,
     806,   807,   807,   808,   808,   809,   809,   809,   809,   810,
     810,   811,   811,   811,   812,   812,   813,   813,   814,   815,
     815,   815,   816,   817,   817,   818,   818,   819,   819,   820,
     820,   821,   821,   822,   822,   823,   823,   824,   824,   825,
     825,   826,   826,   827,   827,   828,   828,   829,   829,   829,
     829,   829,   829,   829,   829,   829,   829,   829,   830,   830,
     830,   830,   830,   830,   831,   831,   831,   831,   832,   832,
     832,   832,   833,   833,   834,   834,   835,   835,   835,   835,
     836,   836,   837,   837,   837,   838,   839,   839,   840,   840,
     840,   841,   841,   842,   843,   843,   843,   843,   843,   843,
     844,   844,   844,   845,   845,   845,   845,   845,   845,   845,
     846,   846,   846,   846,   847,   847,   848,   848,   849,   849,
     849,   849,   849,   849,   849,   849,   849,   849,   849,   850,
     850,   851,   851,   852,   852,   853,   854,   855,   855,   856,
     856,   857,   858,   859,   859,   859,   859,   859,   859,   860,
     860,   861,   861,   862,   862,   862,   862,   863,   864,   864,
     864,   865,   865,   865,   865,   865,   865,   865,   865,   865,
     865,   865,   865,   865,   865,   866,   866,   867,   867,   867,
     867,   867,   867,   867,   867,   867,   867,   867,   867,   867,
     867,   867,   867,   867,   867,   867,   867,   867,   867,   867,
     867,   867,   867,   867,   867,   867,   867,   867,   867,   867,
     867,   867,   867,   867,   867,   867,   867,   867,   867,   867,
     867,   867,   867,   867,   867,   867,   867,   867,   867,   867,
     867,   867,   867,   867,   867,   868,   868,   868,   868,   868,
     868,   868,   868,   868,   868,   868,   868,   868,   868,   868,
     868,   868,   868,   868,   868,   868,   868,   869,   869,   869,
     869,   869,   869,   869,   869,   869,   869,   869,   870,   870,
     870,   870,   870,   870,   870,   870,   870,   870,   870,   870,
     870,   870,   870,   870,   870,   870,   870,   870,   870,   870,
     870,   870,   870,   870,   870,   870,   870,   870,   870,   870,
     870,   870,   870,   870,   870,   870,   870,   870,   870,   870,
     870,   870,   870,   870,   870,   870,   871,   871,   872,   872,
     872,   872,   873,   874,   874,   875,   875,   876,   876,   877,
     877,   877,   878,   878,   879,   879,   880,   881,   881,   881,
     882,   883,   883,   884,   884,   885,   885,   885,   886,   886,
     887,   887,   887,   887,   887,   888,   888,   888,   889,   889,
     889,   890,   890,   891,   891,   891,   891,   891,   891,   891,
     891,   891,   892,   892,   893,   893,   894,   894,   894,   894,
     894,   894,   895,   895,   896,   896,   897,   897,   898,   898,
     899,   899,   899,   900,   900,   901,   901,   902,   902,   902,
     902,   902,   902,   902,   902,   903,   903,   904,   905,   905,
     906,   906,   906,   906,   906,   906,   907,   908,   909,   909,
     909,   910,   910,   911,   912,   912,   913,   914,   914,   915,
     915,   916,   916,   917,   917,   917,   917,   918,   918,   919,
     919,   920,   920,   921,   921,   922,   922,   923,   924,   924,
     925,   925,   925,   925,   926,   926,   927,   927,   928,   928,
     929,   930,   931,   932,   933,   934,   935,   935,   936,   936,
     936,   936,   936,   936,   936,   936,   936,   936,   936,   936,
     936,   937,   938,   939,   940,   940,   940,   941,   941,   942,
     942,   942,   943,   943,   943,   944,   944,   944,   944,   944,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   946,   946,   946,   946,   946,   946,   946,   946,   946,
     946,   946,   946,   946,   946,   946,   946,   946,   946,   946,
     946,   946,   946,   946,   946,   946,   946,   946,   946,   946,
     946,   946,   946,   946,   946,   946,   946,   946,   946,   946,
     946,   946,   946,   946,   946,   946,   946,   947,   947,   947,
     947,   947,   947,   947,   947,   947,   947,   947,   947,   947,
     947,   947,   947,   947,   947,   947,   947,   947,   947,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     5,
       1,     0,     2,     0,     2,     0,     2,     2,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     2,     1,     2,     2,     2,     3,
       3,     5,     5,     0,     3,     5,     5,     4,     3,     5,
       3,     5,     5,     6,     1,     1,     3,     5,     6,     4,
       1,     0,     2,     0,     1,     1,     1,     1,     1,     1,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       5,     2,     2,     2,     2,     3,     3,     3,     1,     3,
       1,     3,     1,     1,     1,     2,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     3,     6,     1,     1,     1,
       1,     1,     0,     1,     1,     2,     3,     4,     3,     2,
       2,     1,     2,     3,     4,     3,     2,     4,     1,     1,
       1,     1,     1,     2,     2,     2,     2,     4,     4,     4,
       4,     1,     3,     2,     3,     4,     6,     6,     6,     5,
       5,     6,     6,     4,     7,     2,     6,     4,     3,     3,
       4,     4,     3,     3,     3,     4,     4,     3,     3,     3,
       3,     3,     3,     4,     4,     3,     2,     3,     3,     3,
       2,     2,     3,     2,     1,     1,     0,     2,     0,     3,
       2,     0,     1,     3,     3,     1,     5,     3,     2,     2,
      10,     6,     1,     1,     1,     1,     1,     1,     3,     2,
       0,     1,     1,     3,     3,     1,     1,     3,     3,     3,
       3,     4,     1,     0,     2,     0,     3,     0,     1,     0,
       1,     3,     2,     1,     1,     1,     1,     3,     0,     1,
       3,     1,     1,    11,    10,     1,     1,     2,     2,     2,
       2,     0,     1,     0,     3,     0,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     3,     4,     2,     0,     3,
       1,     1,     2,     1,     3,     4,     4,     2,     5,     1,
       2,     2,     2,     3,     3,     3,     0,     1,     1,     1,
       1,     1,     1,     3,     1,     5,     7,     8,     9,    11,
       3,     0,     1,     3,     1,     2,     2,     2,     0,     1,
       3,     3,     6,     4,     0,     1,     1,     2,     2,     0,
       3,     3,     2,     1,     1,     2,     2,     4,     0,     2,
       2,     2,     0,     3,     4,     4,     0,     2,     0,     4,
       0,     7,     5,     3,     0,     1,     3,     1,     2,     3,
       0,     5,     4,     1,     0,     1,     2,     2,     1,     2,
       3,     2,     2,     2,     2,     3,     3,     1,     3,     1,
       0,     1,     2,     1,     6,    10,     1,     0,     1,     2,
       2,     0,     2,     2,     1,     0,     5,     7,     1,     0,
       6,     2,     0,     3,     5,     7,     6,     8,     7,     6,
       6,     4,     0,     1,     3,     4,     1,     3,     1,     2,
       2,     2,     2,     1,     1,    10,     2,     0,     2,     2,
       1,     0,     4,     6,     5,     4,     4,     8,     1,     1,
       1,     7,     9,     8,    15,    20,     1,     1,     1,     3,
       1,     1,     1,     3,     1,     3,     0,     1,     0,     1,
       1,     4,     0,     1,     3,     0,     1,     1,     1,     1,
       1,     1,     2,     0,     1,     2,     1,     2,     0,     2,
       1,     2,     2,     6,     8,     8,     4,     5,     4,     4,
       4,     3,     7,     8,     6,     6,     6,     6,     3,     1,
       3,     3,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     1,     3,     3,     1,     0,     1,     3,    13,     1,
       3,     4,     5,     4,     7,     2,     1,     0,     2,     0,
       1,     0,     6,     8,     8,     1,     3,     5,     5,     7,
       9,     7,     9,     5,     6,     6,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     3,     3,     1,
       3,     1,     2,     2,     3,     5,     2,     2,     0,     6,
       7,     7,     7,     8,     8,     6,     8,     9,     9,     7,
      10,     7,     8,     8,     8,     8,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     1,     2,     3,     3,     3,     3,     4,     4,
       3,     3,     3,     4,     4,     3,     4,     4,     1,     1,
       1,     0,     7,     7,    10,     1,     1,     2,     4,     5,
       1,     3,     2,     2,     2,     2,     1,     2,     2,     4,
       3,     2,     2,     2,     3,     2,     2,     5,     5,     5,
       1,     3,     1,     2,     3,     0,     1,     3,     2,     6,
       6,     9,     3,     0,     3,     0,     5,     2,     0,     3,
       3,     3,     7,     7,    10,     1,     1,     1,    14,     1,
       0,     1,     0,     1,     0,     2,     0,     1,     3,     4,
       4,     6,     1,     2,     0,     1,     1,     0,     1,     1,
       0,     9,    12,     7,     2,     0,     3,     2,     1,     3,
       3,     2,     1,     3,     3,     3,     2,     2,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     4,     5,     1,
       3,     3,     1,     2,     4,     5,     1,     1,     1,     1,
       3,     3,     2,     2,     2,     2,     1,     2,     2,     1,
       1,     1,     3,     2,     0,     2,     1,     3,     5,     1,
       2,     1,     0,     5,     7,     5,     7,     5,     7,     3,
       5,     5,     5,     1,     3,     2,     1,     2,     1,     2,
      11,    10,    10,     2,     2,     0,     9,     2,     0,     4,
       4,     4,     1,     1,     1,     0,     7,     6,     6,     6,
       6,     7,     9,     9,     6,     6,     6,     6,     6,     8,
       8,     6,     6,     6,     5,     5,     8,     8,     8,     8,
       6,     1,     0,     2,     0,     7,     6,     6,     6,     6,
       6,     6,     7,     6,     6,     6,     6,     7,     7,     7,
       9,     9,     6,     6,     6,     8,     8,     8,     6,     4,
       4,     4,     7,     4,     4,     4,     5,     5,     4,     4,
      13,     1,     1,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     0,     1,     1,     1,     1,     1,     1,     0,
       6,     8,     3,     2,     0,     2,     2,     2,     2,     3,
       3,     2,     2,     2,     2,     3,     2,     5,     4,     3,
       3,     3,     1,     1,     0,     3,     2,     2,     1,     3,
       2,     1,     0,     8,    10,     3,     4,     4,     0,     2,
       5,     2,     0,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     4,     3,     3,     1,
       0,     5,     6,     4,     2,     0,     4,     3,     5,     6,
       4,     6,     6,     5,     7,     1,     0,     6,    11,    11,
      11,    13,     9,    11,    10,     4,     2,     5,     2,     0,
       4,     5,     5,     4,     6,     1,     3,     1,     1,     1,
       1,     2,     4,     1,     1,     1,     0,     1,     0,     1,
       0,     3,     0,     2,     4,     3,     5,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     2,     1,     1,     1,
       1,     1,     1,     0,     5,     3,     0,     1,     1,     1,
       1,     3,     8,     3,     0,     2,     3,     2,     3,     5,
       1,     4,     2,     1,     3,     2,     2,     0,     6,     2,
       0,     5,     3,     0,     2,     2,     2,     3,     1,     3,
       1,     2,     1,     0,     7,     1,     3,     1,     1,     3,
       5,     2,     1,     3,     7,     1,     0,     3,     2,     2,
       2,     0,     2,     2,     1,     1,     3,     3,     1,     2,
       4,     4,     2,     3,     5,     5,     1,     1,     9,     1,
       2,     4,     4,     4,     2,     3,     1,     3,     4,     2,
       0,     3,     3,     4,     4,     4,     4,     2,     1,     1,
       0,     1,     1,     0,     1,     5,     1,     0,     1,     0,
       3,     1,     3,     4,     3,     2,     2,     1,     1,     1,
       0,     2,     4,     5,     2,     3,     1,     1,     1,     1,
       3,     0,     1,     1,     1,     1,     1,     3,     0,     2,
       0,     1,     3,     1,     0,     1,     2,     4,     4,     2,
       0,     2,     3,     2,     0,     1,     3,     1,     2,     1,
       2,     5,     6,     5,     1,     2,     1,     4,     3,     4,
       5,     4,     5,     4,     5,     2,     4,     1,     2,     2,
       2,     1,     1,     0,     4,     2,     1,     2,     2,     4,
       1,     3,     1,     2,     3,     1,     2,     0,     2,     4,
       0,     1,     3,     2,     2,     3,     5,     6,     2,     3,
       3,     4,     0,     1,     1,     1,     1,     1,     2,     5,
       1,     1,     1,     1,     2,     3,     3,     0,     1,     1,
       1,     1,     1,     2,     2,     2,     2,     2,     1,     3,
       0,     1,     1,     1,     1,     5,     2,     1,     1,     1,
       1,     5,     2,     2,     2,     1,     3,     3,     2,     1,
       0,     3,     0,     5,     2,     5,     2,     1,     2,     3,
       0,     1,     1,     1,     1,     1,     1,     3,     3,     3,
       3,     3,     3,     3,     0,     1,     4,     1,     3,     5,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     2,     3,     3,     2,     3,     5,     4,
       6,     3,     5,     4,     6,     4,     6,     5,     7,     3,
       2,     4,     2,     3,     3,     4,     3,     4,     3,     4,
       5,     6,     6,     7,     6,     7,     6,     7,     3,     4,
       4,     6,     2,     3,     4,     1,     3,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       2,     5,     6,     6,     7,     3,     4,     1,     1,     2,
       4,     1,     1,     1,     2,     2,     2,     1,     4,     5,
       6,     8,     6,     7,     7,     5,     1,     1,     4,     1,
       4,     1,     4,     1,     4,     1,     1,     1,     1,     1,
       1,     6,     4,     4,     4,     4,     6,     5,     5,     5,
       4,     6,     4,     4,     4,     4,     5,     7,     7,     9,
       4,     6,     5,     7,     7,     7,     2,     3,     3,     3,
       4,     0,     4,     1,     3,     3,     1,     1,     1,     2,
       2,     0,     2,     0,     1,     3,     3,     2,     2,     0,
       6,     1,     0,     3,     0,     2,     2,     0,     1,     4,
       2,     2,     2,     2,     2,     4,     3,     5,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     1,     4,     1,     4,     1,     2,
       1,     2,     1,     3,     1,     3,     1,     3,     1,     3,
       3,     3,     2,     1,     3,     3,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     4,     3,     2,     3,     0,
       3,     3,     2,     2,     1,     0,     2,     2,     3,     2,
       1,     1,     3,     5,     1,     2,     4,     2,     0,     1,
       0,     1,     2,     2,     2,     3,     5,     1,     2,     0,
       2,     1,     0,     1,     1,     1,     3,     3,     1,     3,
       3,     2,     1,     1,     1,     3,     1,     2,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     2,     1,     1,
       1,     1,     1,     2,     5,     2,     3,     6,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
     108,   994,   489,  1074,  1073,   994,   232,     0,  1076,     0,
     994,   323,   795,     0,     0,     0,     0,     0,   489,   994,
       0,     0,     0,     0,     0,     0,     0,  1200,     0,     0,
       0,     0,     0,     0,     0,     0,   994,     0,  1207,     0,
       0,     0,     0,  1200,     0,     0,  1078,     0,     0,     0,
       0,     2,     4,    50,    51,    19,    18,    24,    23,    73,
      74,    40,    12,    64,    45,   105,   104,   106,    30,    26,
      58,    17,    27,    31,    47,    32,    46,    16,    44,    68,
      48,    71,    37,    62,     9,    38,    63,    10,    52,    75,
      22,    49,    72,    33,    60,    56,    41,    42,    43,    65,
      66,    67,    89,    70,   100,    29,    79,    80,    95,    81,
      96,     7,    82,    39,    11,    92,    91,    93,    59,    34,
      61,    90,    94,    13,    14,    15,    97,    69,    87,    84,
     101,    99,   107,    85,    53,     5,     6,    76,    36,     8,
      21,    20,    35,    28,   103,    25,  1076,    78,    88,    77,
      54,    83,    57,    86,   102,    55,    98,  1177,  1164,  1209,
    1176,     0,  1179,   993,   992,   978,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   488,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1002,  1699,  1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,
     299,  1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,  1726,
    1961,  1962,  1963,  1964,  1727,  1728,  1729,  1730,  1731,  1732,
    1733,  1965,  1966,  1734,  1735,  1736,  1737,  1738,  1967,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1968,  1969,  1762,  1763,  1764,  1765,  1766,  1767,
    1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,
    1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,  1970,  1786,
    1787,  1971,  1788,  1789,  1972,  1790,  1791,  1792,  1793,  1794,
    1795,  1796,  1973,  1797,  1798,  1799,  1800,  1801,  1802,  1803,
    1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,  1812,  1974,
    1813,  1814,  1815,  1816,  1975,  1976,  1977,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1978,  1826,  1827,  1828,
    1829,  1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,
    1839,  1840,  1841,  1842,  1979,  1980,  1843,  1844,  1845,  1846,
    1847,  1848,  1849,  1981,  1850,  1851,  1852,  1853,  1982,  1854,
    1983,  1855,  1856,  1857,  1858,  1859,  1860,  1984,  1985,  1861,
    1862,  1863,  1864,  1865,  1866,  1867,  1986,  1868,  1987,  1871,
    1869,  1870,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1988,
    1879,  1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,
    1889,  1890,  1891,  1892,  1893,  1894,  1895,  1989,  1896,  1897,
    1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,
    1908,  1909,  1990,  1910,  1911,  1912,  1991,  1913,  1914,  1915,
    1916,  1917,  1918,  1919,  1920,  1921,  1922,  1992,  1923,  1924,
    1925,  1926,  1927,  1928,  1929,  1930,  1931,  1993,  1994,  1932,
    1995,  1933,  1996,  1934,  1935,  1936,  1937,  1938,  1939,  1940,
    1941,  1942,  1943,  1944,  1945,  1946,  1947,  1997,  1998,  1948,
    1949,  1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  1958,  1959,  1960,
     298,  1155,  1670,  1700,  1701,  1075,  1056,   489,     0,   981,
     322,     0,     0,     0,     0,     0,     0,     0,   616,     0,
       0,     0,     0,     0,     0,     0,     0,   161,     0,     0,
     346,   345,     0,     0,     0,   769,     0,     0,     0,     0,
     477,  1117,  1869,  1115,  1156,     0,   233,   236,   234,   235,
    1692,     0,   865,   866,   868,     0,     0,   878,   643,     0,
     642,     0,     0,     0,   640,     0,     0,     0,     0,   644,
     638,     0,   637,     0,     0,     0,   641,     0,   639,     0,
       0,   982,  1114,   351,     0,     0,  1092,  1076,  1083,  1093,
    1088,  1090,  1089,  1091,  1087,  1691,  1711,   711,   711,   711,
     711,   708,   709,   711,   711,   711,  1883,     0,     0,   690,
       0,   692,  1694,   711,   716,   401,   401,   401,     0,   715,
     720,   401,     0,   975,  1009,  1675,  1199,     0,   691,   974,
    1932,  1106,     0,     0,   882,     0,   883,     0,  1898,   986,
     219,  1908,  1993,  1932,   215,   188,  1715,     0,     0,   715,
       0,   983,   984,  1206,  1204,     0,  1732,  1745,  1829,   212,
    1894,  1899,  1908,  1993,  1932,  1957,   170,     0,   226,  1908,
    1993,  1932,   222,  1002,     0,  1180,  1286,  1666,     0,   977,
     976,  1292,     0,  1077,     0,  1080,     0,  1251,  1881,  1184,
    1186,  1082,  1177,     0,     1,   108,  1071,  1203,  1203,     0,
    1203,     0,  1169,  1177,  1172,  1176,     0,  1699,  2007,  2008,
    2009,  2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,
    2019,  2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,
       0,     0,  1676,  1700,  1704,     0,   651,   111,  1671,   758,
       0,     0,     0,     0,     0,  1693,     0,     0,  1571,  1736,
    1788,  1581,  1579,  1580,  1573,  1574,  1575,  1576,  1577,  1578,
       0,   863,  1572,     0,   111,     0,     0,     0,     0,     0,
       0,     0,     0,  1833,   111,     0,     0,     0,     0,   998,
    1001,   979,  1059,     0,  1666,     0,     0,   676,     0,   685,
     677,   682,     0,   679,     0,     0,   687,     0,   678,   680,
     681,   686,     0,     0,   683,   684,     0,     0,   990,   401,
       0,     0,     0,     0,     0,   111,  1046,     0,   350,   349,
     111,   348,   347,  1736,  1788,     0,   794,   111,     0,   163,
     517,   492,     0,     0,   581,  1833,   111,     0,     0,     0,
       0,   772,     0,     0,   476,   489,  1118,  1116,     0,  1130,
     869,   214,   213,   867,  1802,     0,   286,     0,     0,  1802,
    1037,     0,  1802,     0,  1802,   156,  1668,  1736,  1788,  1802,
       0,     0,  1802,   148,  1802,     0,  1802,   286,  1802,   493,
       0,  1802,     0,  1802,  1833,   150,     0,  1802,   286,   649,
       0,  1111,     0,  1085,  1997,  1099,  1098,     0,  1094,  1103,
    1097,     0,   711,   710,     0,   711,     0,   711,     0,   711,
       0,   711,     0,     0,     0,   711,  1695,  1696,   693,     0,
     717,     0,     0,   724,   723,   722,     0,     0,     0,   725,
       0,  1290,  1133,     0,   972,   989,     0,     0,     0,   885,
     885,   885,   985,   218,   216,     0,     0,     0,     0,     0,
       0,   991,     0,     0,  1679,  1681,  1682,  1582,  1649,     0,
    1962,  1963,  1964,  1640,     0,  1965,  1966,  1967,  1499,  1486,
    1495,  1500,  1487,  1489,  1496,  1968,  1969,  1774,  1970,  1971,
    1689,  1972,  1973,  1975,  1976,  1977,  1978,  1491,  1493,  1979,
    1980,     0,  1690,  1982,  1983,  1858,  1985,  1986,  1988,  1989,
    1497,  1991,  1992,  1993,  1994,  1995,  1996,  1688,     0,  1498,
    1998,  2000,  2001,  2002,  2003,  2004,  2005,  2006,     0,     0,
    1663,     0,  1473,     0,  1320,  1321,  1343,  1344,  1322,  1349,
    1350,  1362,  1323,     0,  1662,  1387,  1472,  1477,     0,  1471,
    1467,  1190,  1658,     0,  1468,  1678,  1680,  1641,   181,   228,
       0,   229,  1664,  1908,   171,   211,   183,   210,   184,   182,
       0,  1734,   172,     0,   179,     0,     0,     0,     0,   225,
     223,     0,   980,     0,  1288,  1287,     0,     0,  1647,  1667,
     658,     0,  1293,     0,  1069,  1070,  1068,     0,  1065,  1067,
    1079,  1076,  1654,  1653,  1655,     0,  1185,     0,     0,     0,
    1167,  1166,     3,  1082,  1201,  1202,     0,     0,     0,     0,
       0,     0,     0,     0,  1244,  1217,  1218,  1220,  1241,  1245,
       0,  1173,  1252,     0,     0,  1677,     0,     0,     0,   652,
       0,     0,     0,     0,   110,  1035,   221,  1033,   939,     0,
       0,     0,     0,     0,  1040,     0,     0,     0,     0,   827,
       0,     0,     0,     0,     0,     0,   828,   826,   829,   836,
     849,   852,   945,     0,   748,   154,   155,     0,     0,     0,
     912,     0,     0,   912,     0,     0,     0,     0,     0,     0,
       0,   238,   241,     0,     0,     0,     0,     0,     0,     0,
       0,   115,     0,     0,     0,   940,     0,   458,   470,     0,
       0,     0,     0,     0,   467,     0,   111,   239,   452,   455,
     943,     0,     0,     0,   526,   525,   912,   912,     0,   237,
     941,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   948,     0,     0,     0,   115,   147,     0,
       0,   240,   944,     0,     0,   996,   997,     0,  1000,     0,
    1055,     0,     0,     0,     0,     0,     0,  1736,  1788,     0,
       0,     0,     0,     0,     0,   325,   305,   306,   111,   304,
       0,     0,   578,     0,  1702,  1331,  1360,  1338,  1360,  1360,
    1327,  1327,  1340,  1328,  1329,  1367,     0,  1360,  1327,  1332,
       0,  1330,  1370,  1370,  1355,     0,  1312,  1313,  1314,  1315,
    1341,  1342,  1316,  1347,  1348,  1317,  1384,  1327,  1703,     0,
    1012,  1045,     0,     0,   113,   617,     0,     0,   579,     0,
     113,     0,   159,     0,   521,     0,     0,     0,     0,     0,
       0,   537,   536,     0,     0,   580,     0,   113,   454,     0,
     444,   401,     0,   771,   774,     0,     0,     0,  1159,  1161,
    1160,     0,  1158,     0,  1300,     0,   286,   284,   285,   576,
     877,     0,     0,     0,     0,   286,     0,     0,  1802,     0,
    1802,     0,     0,   286,   286,     0,     0,     0,     0,   522,
       0,   648,   646,   645,   647,     0,     0,     0,     0,     0,
    1802,   286,     0,     0,   636,  1592,     0,     0,     0,     0,
     471,   200,   202,   201,   199,     0,  1100,  1101,  1102,  1096,
     473,  1084,     0,   701,     0,   705,     0,   696,     0,   702,
       0,   697,   694,   695,     0,   700,     0,     0,   402,   404,
       0,     0,  1759,     0,  1793,  1821,  1822,  1899,  1904,     0,
    1927,     0,   726,   753,   721,     0,     0,  1127,  1120,     0,
       0,  1143,   973,  1598,     0,     0,     0,   884,   881,   880,
     879,   217,   189,     0,     0,     0,   755,  1898,   988,     0,
    1469,     0,  1475,  1476,  1359,  1346,  1639,     0,     0,  1354,
    1353,     0,     0,     0,     0,  1336,  1335,  1334,  1474,  1606,
       0,  1333,     0,     0,     0,     0,  1360,  1360,  1358,  1406,
       0,  1337,     0,     0,  1619,     0,  1625,     0,     0,     0,
    1366,     0,  1364,     0,     0,  1442,     0,     0,     0,     0,
       0,     0,     0,  1390,  1391,  1473,  1592,     0,  1685,     0,
       0,  1352,     0,  1384,  1661,  1582,     0,     0,     0,     0,
    1652,  1590,     0,     0,  1420,  1588,     0,  1422,     0,     0,
       0,  1581,  1579,  1580,  1573,  1574,  1575,  1576,  1577,  1578,
    1586,  1403,     0,     0,  1402,     0,     0,  1254,     0,  1683,
    1642,   230,   231,   227,     0,     0,   186,   185,     0,   204,
     208,   209,   178,   207,     0,   203,  1538,  1537,   187,   177,
     175,   173,   190,   192,   193,   194,   176,   174,   224,     0,
       0,  1705,  2029,  2030,  2031,  2032,  2033,  2034,  2035,  2036,
    2037,  2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,  2046,
    2047,  2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,  2056,
    2057,  2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,  2066,
    2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,  2076,
    2077,  2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,  2086,
    2087,  2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,  2096,
    2097,  2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,  1644,
    1643,  1673,  1706,  1707,  1708,  1709,  1648,     0,     0,   286,
    1294,     0,  1254,  1145,  1147,  1148,     0,  1649,  1063,     0,
    1060,  1657,     0,  1187,     0,     0,  1072,  1183,  1182,  1210,
    1211,   787,  1181,  1235,  1236,  1231,     0,  1250,  1250,  1227,
    1221,  1226,  1224,     0,  1228,  1387,  1243,  1171,  1215,  1216,
    1219,  1170,     0,  1246,  1244,  1220,     0,     0,     0,     0,
       0,   946,     0,     0,   653,     0,     0,     0,     0,  1927,
     220,  1031,     0,     0,     0,     0,   757,   756,     0,     0,
     776,     0,     0,     0,  1043,   394,     0,   283,     0,     0,
       0,     0,     0,     0,     0,   834,     0,     0,     0,     0,
     835,   832,   833,  1899,   851,     0,   850,   848,   809,   811,
     810,     0,   813,   797,     0,   798,     0,     0,   808,   816,
     814,     0,     0,     0,  1782,   243,   255,     0,   911,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   276,
       0,     0,     0,     0,   281,     0,     0,     0,   280,     0,
       0,   947,     0,     0,     0,     0,     0,   864,     0,     0,
     142,   145,     0,     0,   457,   469,     0,   461,   462,   459,
     463,   464,     0,     0,     0,     0,     0,     0,   456,     0,
       0,   519,   518,   524,     0,     0,     0,     0,     0,     0,
     905,   904,     0,     0,     0,     0,     0,     0,     0,     0,
     528,   529,     0,   530,     0,   146,     0,     0,     0,     0,
       0,     0,   198,   995,   999,  1058,  1674,  1057,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   310,  1702,     0,
     601,   577,     0,  1312,     0,  1308,  1304,  1373,  1374,  1375,
    1372,  1385,  1371,     0,  1318,  1376,  1327,  1324,     0,  1010,
     368,   485,   152,     0,     0,     0,   589,   592,     0,   109,
     163,   351,     0,   162,   164,   166,   167,   168,   165,   169,
     516,   520,     0,   491,     0,     0,     0,     0,     0,   541,
     540,   544,   542,     0,   538,     0,     0,     0,   141,   451,
     453,     0,     0,   353,   432,     0,     0,     0,   773,     0,
       0,     0,     0,     0,     0,     0,  1157,     0,  1264,  1129,
    1255,  1266,  1257,  1259,  1295,     0,  1666,     0,  1127,     0,
     855,     0,  1038,  1802,   286,     0,   853,   157,  1669,     0,
       0,     0,     0,     0,   857,   633,   149,     0,   286,   286,
     494,     0,   286,   151,     0,     0,     0,   486,   286,   650,
    1113,     0,   444,  1086,  1095,   472,   698,   707,   706,   704,
     703,   699,     0,   718,     0,   400,     0,     0,     0,   732,
       0,     0,   731,   746,   733,     0,   735,   728,   727,   736,
       0,     0,   755,  1122,     0,  1123,  1649,     0,  1119,     0,
    1140,     0,  1138,     0,  1291,  1142,  1131,  1105,     0,  1104,
    1108,  1110,  1109,  1107,     0,     0,     0,   715,     0,     0,
     286,   987,     0,  1650,  1602,     0,  1603,     0,     0,     0,
    1638,  1634,     0,     0,     0,     0,     0,  1607,  1610,  1611,
    1612,  1609,  1613,  1608,     0,     0,  1614,     0,     0,     0,
       0,     0,  1357,  1356,     0,     0,     0,     0,     0,     0,
       0,  1445,  1477,     0,     0,  1566,     0,  1592,  1624,     0,
       0,  1368,     0,     0,     0,     0,     0,     0,     0,  1592,
    1630,     0,     0,     0,  1536,     0,  1533,     0,     0,     0,
       0,  1649,     0,     0,     0,     0,  1686,  1388,  1404,  1660,
       0,  1651,     0,     0,  1411,     0,  1631,  1438,     0,  1443,
    1426,     0,  1419,     0,  1424,  1428,  1407,  1652,  1591,     0,
    1589,     0,     0,  1405,     0,  1400,  1398,  1399,  1392,  1393,
    1394,  1395,  1396,  1397,  1401,  1570,  1568,  1569,     0,     0,
       0,  1423,  1795,  1829,     0,  1200,  1200,  1189,  1198,  1659,
       0,  1297,     0,     0,     0,     0,  1549,  1596,     0,  1594,
    1665,     0,     0,  1384,     0,  1289,  1645,     0,   656,   657,
     655,  1152,     0,     0,  1300,     0,  1151,  1082,  1066,  1062,
    1061,  1656,  1081,  1188,     0,   785,   786,     0,   790,     0,
       0,  1229,  1242,     0,  1143,  1143,     0,  1233,  1234,  1225,
    1175,  1174,   599,   598,     0,     0,     0,   923,   887,   654,
     924,   888,     0,  1032,     0,  1034,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   286,
    1041,   925,   282,  1042,   916,     0,     0,     0,   499,   500,
       0,   830,   831,   926,   889,     0,   917,   812,  1327,   796,
       0,     0,   807,     0,   806,  1327,  1327,   890,   153,   244,
     368,   914,   262,   275,   270,   271,   269,  1802,   286,  1802,
     286,     0,     0,     0,     0,   272,   267,   268,   264,   277,
     278,   898,     0,   292,   295,   279,   258,     0,   263,   259,
       0,   242,     0,     0,  1672,     0,     0,   859,     0,     0,
     144,   901,     0,   124,   126,   128,     0,   122,   130,   125,
     127,   129,   123,   131,   121,     0,   120,     0,     0,     0,
     114,   932,   894,   460,   465,   896,   468,   919,   466,  1714,
    1775,  1909,     0,   506,   508,     0,   513,   938,   914,   895,
       0,   918,   934,   903,     0,     0,     0,     0,     0,     0,
       0,  1047,     0,     0,     0,   933,   910,   921,     0,   902,
     897,   920,     0,     0,   196,   195,   197,     0,     0,     0,
       0,     0,     0,     0,     0,   689,   665,   688,     0,     0,
       0,     0,     0,     0,     0,   659,   324,   302,   303,     0,
       0,   301,   307,     0,   600,     0,     0,  1309,  1305,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1325,     0,
       0,  1030,  1030,  1030,  1030,  1030,  1030,  1030,  1011,  1039,
     484,   502,     0,     0,     0,     0,   135,   112,     0,   622,
     588,     0,     0,   401,   158,     0,     0,     0,   490,   587,
     585,   584,   586,     0,     0,     0,   605,     0,  1301,     0,
       0,     0,   450,   355,     0,     0,   352,   356,   360,   361,
     362,     0,   445,   447,     0,     0,   436,     0,     0,     0,
     801,     0,   819,   802,     0,     0,     0,   839,   844,   840,
     822,     0,   474,  1162,  1163,     0,  1177,     0,  1266,     0,
    1265,  1277,     0,     0,  1283,  1281,     0,  1283,     0,  1283,
       0,  1258,     0,  1260,  1277,     0,  1667,  1755,  1298,  1128,
     286,     0,     0,   496,   286,     0,   286,     0,   286,   286,
       0,   970,   523,     0,   573,     0,     0,   286,   635,  1593,
       0,   719,   403,     0,     0,     0,     0,   730,     0,  1697,
     734,     0,   745,   740,   742,     0,   749,     0,     0,  1125,
    1126,  1141,  1134,  1136,  1135,     0,     0,  1132,  1599,   634,
       0,     0,   286,     0,   750,  1205,  1600,  1601,     0,     0,
       0,     0,  1635,     0,     0,  1512,  1488,  1490,  1326,  1502,
       0,  1339,  1513,  1514,  1492,  1494,     0,  1583,     0,     0,
    1503,  1447,  1448,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1460,  1459,  1504,  1565,
       0,     0,  1622,  1623,  1505,  1369,  1370,  1370,     0,     0,
    1629,     0,     0,     0,  1510,  1515,     0,     0,  1520,     0,
    1541,     0,     0,     0,  1470,  1593,  1361,  1362,     0,     0,
       0,     0,     0,     0,     0,     0,  1444,  1427,  1421,     0,
    1425,  1429,     0,     0,     0,     0,  1413,  1439,  1409,     0,
       0,  1415,     0,  1440,  1200,  1200,  1200,  1200,  1197,     0,
       0,  1253,     0,  1238,  1209,  1209,     0,  1549,     0,  1478,
       0,  1549,     0,     0,   180,     0,   205,   191,     0,     0,
       0,  1146,  1127,  1149,  1064,  1212,     0,  1584,   790,   788,
     789,  1214,     0,     0,  1249,  1248,  1247,  1222,   922,   886,
     915,   949,  1030,   760,   761,     0,   759,     0,     0,     0,
     393,   775,     0,     0,     0,     0,  1044,   483,     0,   482,
     478,   498,   824,     0,  1327,   799,   804,   805,     0,   365,
       0,     0,     0,   245,     0,     0,   257,     0,   253,   273,
     265,   274,   266,   289,     0,     0,     0,   260,   261,   928,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   929,
       0,     0,   117,   116,     0,   134,     0,   510,   511,   509,
     505,     0,   512,   514,   942,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   927,   891,   660,
       0,     0,   661,   669,     0,     0,   662,     0,     0,     0,
       0,     0,     0,   671,   327,     0,   330,   338,   311,   315,
    1046,  1046,     0,   316,  1046,   312,  1046,   309,  1858,  1573,
    1574,   596,   603,   593,   595,   597,   594,     0,   602,   568,
       0,     0,     0,  1310,     0,  1378,  1379,  1380,  1381,  1382,
    1383,     0,  1377,  1384,     0,  1030,  1029,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   379,     0,     0,
     373,     0,     0,   844,   367,   370,   371,     0,   495,   137,
       0,     0,   138,   136,     0,   590,   591,     0,   351,     0,
       0,   543,   546,   539,     0,   604,   606,   582,     0,  1303,
     502,  1114,     0,   441,     0,   432,   386,   428,     0,   443,
       0,   430,   429,   431,     0,   438,  1008,     0,   776,   800,
       0,     0,     0,   837,   841,   838,     0,     0,   815,     0,
     823,   793,   965,   966,   963,   964,     0,     0,  1154,  1268,
    1275,     0,  1256,     0,  1282,  1278,     0,  1279,     0,     0,
    1280,     0,     0,  1275,     0,     0,     0,   856,     0,   286,
     854,     0,   629,     0,   631,   858,   286,   286,   531,     0,
     487,   447,     0,     0,     0,   729,   747,     0,   743,     0,
       0,   712,   752,  1121,  1124,  1139,  1137,   755,     0,   713,
     754,  1604,  1345,     0,  1637,  1633,     0,  1605,     0,  1617,
    1616,  1446,  1618,     0,  1465,     0,     0,  1457,  1455,  1456,
    1449,  1450,  1451,  1452,  1453,  1454,  1458,  1627,  1626,  1620,
    1621,  1365,  1363,     0,  1507,  1508,  1509,  1628,  1516,     0,
    1535,  1534,     0,     0,     0,  1522,     0,     0,  1531,     0,
    1567,  1351,  1384,  1389,     0,     0,  1412,  1632,  1430,     0,
       0,     0,  1408,     0,     0,     0,     0,  1417,  1583,     0,
       0,     0,     0,     0,     0,  1192,  1191,  1296,     0,  1240,
       0,     0,  1208,     0,  1549,  1485,  1552,  1547,  1548,  1597,
     814,  1479,  1684,     0,  1595,  1549,     0,  1646,     0,  1153,
    1144,     0,  1213,  1230,  1223,     0,   766,   767,   765,     0,
       0,     0,   568,     0,     0,   409,     0,   784,   784,     0,
       0,   844,   937,   479,   825,     0,   817,     0,   250,   913,
       0,     0,     0,   249,     0,   286,   286,   293,   294,   297,
       0,     0,     0,     0,     0,   623,   609,     0,     0,   624,
     625,     0,     0,   861,   862,   860,   132,   118,   119,   133,
     507,   899,     0,     0,     0,     0,     0,   936,   909,   935,
     907,   906,   908,   900,   533,     0,   663,     0,     0,   664,
     675,   673,   672,   674,   666,   328,   111,     0,   308,     0,
     336,     0,   333,   334,   332,   335,     0,     0,     0,     0,
       0,     0,   570,     0,     0,   575,   564,   566,     0,     0,
       0,  1306,  1311,  1386,  1319,   563,     0,  1021,  1020,  1019,
    1023,  1022,  1025,  1024,  1016,  1015,  1028,  1027,  1014,  1013,
    1018,  1017,     0,     0,   377,   381,   382,   380,   372,   844,
     401,   440,     0,   140,   139,     0,     0,     0,     0,   548,
     552,   583,     0,  1302,   527,  1112,   448,     0,     0,   358,
     363,   364,     0,   436,   383,     0,   432,   357,   446,     0,
       0,   442,     0,  1003,     0,     0,   803,   820,   821,     0,
       0,   844,   843,     0,   481,  1267,     0,     0,  1269,     0,
       0,  1271,  1273,     0,     0,     0,     0,     0,  1670,  1549,
    1299,   286,   497,   286,   286,   971,   574,     0,   739,   738,
     737,  1698,     0,   741,   286,     0,  1636,  1501,  1511,  1615,
       0,     0,  1466,     0,     0,  1506,  1999,     0,     0,  1539,
    1540,  1521,     0,  1844,  1526,     0,     0,     0,  1687,  1436,
    1434,  1431,     0,  1432,     0,     0,  1414,  1410,     0,  1416,
    1441,  1196,  1195,  1194,  1193,     0,     0,  1543,  1549,  1549,
    1480,  1554,  1551,     0,  1482,  1384,  1150,     0,  1036,     0,
       0,     0,   395,     0,   844,     0,     0,     0,   782,   787,
     787,     0,   844,   440,   818,   246,   247,   248,   251,   288,
     256,   252,     0,   930,   892,     0,     0,   615,     0,     0,
       0,     0,   931,   893,     0,     0,     0,  1052,     0,     0,
     667,   668,   310,     0,   331,   341,   342,     0,   339,   313,
     318,     0,   320,   319,   314,   317,   572,   571,   569,   565,
     567,  1307,     0,   875,   875,     0,   568,  1026,     0,     0,
     369,   440,   408,     0,   374,     0,   503,     0,  1008,   353,
     502,   547,     0,     0,     0,   607,   449,   354,     0,     0,
     438,     0,     0,     0,   436,     0,   433,     0,   437,     0,
       0,     0,     0,     0,   842,     0,   846,     0,   791,  1297,
       0,   485,     0,  1276,  1285,     0,  1272,  1270,  1261,     0,
    1263,   876,   630,   632,   532,   744,   751,   286,  1461,     0,
       0,     0,     0,  1517,     0,  1518,  1523,  1527,     0,  1524,
    1525,  1433,  1437,  1435,  1418,  1237,  1239,     0,  1178,  1483,
    1484,     0,  1209,  1549,   206,  1585,   745,     0,   286,   784,
     440,   410,  1858,   411,   783,   790,   790,     0,   440,   568,
       0,   254,   296,     0,     0,   621,   610,     0,     0,   626,
       0,     0,     0,     0,     0,   670,   300,   326,   337,     0,
     321,   875,     0,   872,   871,   562,     0,   376,   375,     0,
     419,     0,   501,     0,   619,  1004,   515,   549,   550,   545,
       0,     0,   359,   368,   344,   392,   391,   388,   387,   389,
     390,   385,   384,     0,   438,   434,   435,     0,  1005,     0,
    1054,     0,   777,   845,     0,     0,     0,   480,   475,  1274,
       0,  1262,   714,  1462,     0,  1463,     0,     0,  1529,  1528,
    1542,  1544,     0,     0,  1557,  1481,   762,     0,   763,   787,
     414,     0,   780,   779,   401,   568,   396,   287,     0,   613,
     620,   611,   621,     0,     0,  1048,     0,  1049,  1050,  1053,
     340,   870,   874,   873,     0,   405,   406,   407,     0,   378,
     415,   416,     0,   504,     0,     0,     0,     0,   366,   427,
     343,  1006,  1007,   291,     0,   844,   847,   969,  1284,  1464,
    1532,  1519,  1530,     0,     0,  1553,     0,     0,     0,     0,
     790,     0,   568,     0,   408,   397,     0,   612,   628,   627,
       0,     0,     0,     0,     0,   417,     0,   418,   439,   618,
       0,   551,     0,     0,   438,   778,   792,   968,   967,     0,
    1545,  1546,  1961,  1755,  1937,     0,  1555,  1558,  1556,  1550,
     286,   781,     0,   398,   412,   419,     0,  1051,   552,   424,
       0,   423,     0,   421,   420,   608,   555,   290,  1297,   951,
     962,   950,   952,   960,   957,   959,   958,   956,     0,  1562,
    1561,  1560,  1564,  1563,   764,     0,   568,   614,     0,   422,
     426,   425,   557,   559,   560,     0,   553,   556,   558,   561,
     768,     0,   961,   955,  1177,  1164,     0,   413,   399,     0,
     534,     0,   953,   962,  1559,     0,   554,   954,     0,   555,
       0,   535
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    50,    51,    52,    53,  1125,  1932,  1830,  2496,  2497,
      54,    55,  1182,    56,    57,    58,    59,    60,    61,    62,
    1158,    63,    64,   818,  1312,  1943,    65,  1740,   657,  1581,
    1582,  1883,  1583,  1572,  1046,  1584,  1126,  1149,    67,    68,
    1040,  1563,    69,    70,    71,  1171,  1172,  2813,  1349,  3601,
    1818,  3774,  2352,  2353,    72,    73,  2459,  1258,  2461,  2462,
    2897,   501,  1906,  3246,  3247,  2885,  2886,  3254,  3477,  3478,
      74,  1309,  2525,  2975,  2526,  3318,  2527,  3319,  2528,  3320,
    2489,  2944,  2945,  2946,  2529,  3324,  3651,  2530,  1755,   913,
    1417,  1418,  3630,  3174,  3175,  3752,  3719,  3720,  3721,  3803,
    3326,  2536,  2985,  3331,  3504,   576,  1329,  1974,  2531,  2532,
    2973,    76,    77,  1969,  1198,  1199,  1836,  2901,    78,   835,
    2799,  3541,  2490,  2491,    79,   189,    80,  1316,    81,    82,
      83,    84,  2948,  3505,  1204,  2402,  2403,  2404,  2405,  2852,
      85,  1314,  1205,  1952,    86,    87,    88,  1872,    89,    90,
      91,  1323,  1963,  1964,  3310,  3512,  3639,  3514,  3835,  3836,
    3496,  3265,  3266,  3267,    92,    93,    94,    95,  1308,  1935,
    1936,  2902,  1114,  1262,  1909,  1910,  2964,  2965,    96,  3205,
    3206,   528,  3725,  3701,    97,    98,  3209,  3210,    99,   100,
     101,   102,   103,   570,   878,   879,  2326,   104,  1679,   105,
     797,  2446,   106,   599,   893,   894,   107,   108,   608,  2087,
     610,  1431,  2612,  2613,  3051,  2052,   732,   109,   110,  2062,
    2090,   111,  1129,  1746,  1747,  3169,   112,   529,  1334,  1977,
    2295,  3661,  3176,  3439,  2258,  2771,   113,   530,  1154,  1784,
    1980,  2541,  2542,  1786,  1787,  2997,  1788,  2543,  2548,  2549,
    2550,  2993,  3001,  3536,  3537,   114,  1151,  1777,   115,   116,
     117,  1177,   750,   118,   542,   543,   119,  3623,   120,   848,
     121,   627,  1448,   122,  1799,  2814,   123,   124,   125,  1128,
     126,  3811,  3841,  3842,  3843,  3006,  3779,   127,  3813,   924,
     129,   130,   131,   165,   769,   770,   771,   132,  3333,   133,
     134,  1929,  2488,  2927,   135,   136,  1741,  2285,   137,   138,
     139,  1302,   140,   141,   142,   143,  1240,   144,  1077,  1078,
     145,   146,   496,   675,  1081,  1089,   147,   578,   887,   888,
     889,  1399,   148,   927,  2079,   579,   881,   150,   580,  1437,
    2064,  2065,  2068,   581,  1344,   153,  1441,  2073,  2076,   582,
    1682,  1683,  1684,  1685,  1686,  2242,   583,   601,   838,  1985,
     584,  1012,   158,   159,   160,   161,   679,   680,  1557,  2217,
     617,  1096,   645,   691,  3142,  1699,  1700,  1720,  1721,  1105,
    1106,  1710,  1712,  2260,  1713,  2269,  1705,  3139,  3417,  1716,
    1717,  1108,  1109,  2264,   162,  2221,  1989,  1990,  1991,  2560,
    2570,  3015,  3351,  1992,   922,   672,  1993,  2743,  1998,  2517,
    2518,  1789,  1916,  1286,  1013,  1287,  1927,  1014,  1481,  1289,
    1015,  1016,  1017,  1292,  1018,  1019,  1020,  1021,  1465,  1521,
    1022,  1023,  1500,  1924,  1925,  1385,  2130,  1025,  1026,  3108,
    3396,  3387,  2155,  2156,  1578,  3104,  3578,  3680,  3681,  3151,
    3147,  3421,  3582,  3748,  3786,  3787,  1027,  2208,  1550,   752,
    1028,  2904,  1552,  2150,  2228,  2229,  1727,  1463,  2097,  2114,
    2115,  2127,  2659,  2134,  2139,  2682,  2683,  2151,  2177,  1029,
    2100,  2101,  2643,  1467,  1030,  1068,  1069,  1460,  2173,  1084,
    1085,   677,  1031,  1032,  1432,   666,  3347,   856,   727,  2363,
    1670,   773,   614,  1033,  1034,  1035,  1036,  2614,  1400,  2610,
     492,   722,  2406,   493,   494,   724,  1675
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -3453
static const int yypact[] =
{
   10396,  1096, 10282, -3453, -3453,  1096, -3453, 42209,    -4,   118,
      20,   127, 10097, 42616, 49535,   260,   460,   274, 10238,  1096,
   49535,  1452, 33255, 38546,   532, 49535,   386,   489, 33255, 49535,
   49942,   762,   700, 50349, 43023, 36511,   884, 49535,   307, 50756,
   43430,   791, 43837,   489, 30426, 43837,    46,   758, 51163,  1149,
    1233,   881, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453,    -4, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453,   162, -3453,   669,
     169,   -15,   890, -3453, -3453, -3453, 34476, 49535, 49535,  1070,
   49535,  1240, 34476, 49535, 49535,  1203, 27510, -3453, 49535, 49535,
   49535, 49535, 43837, 49535,  1150, 49535, 49535, 51570, 49535,  1276,
     908, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, 49535,  3896,   386, -3453,
   -3453, 49535,  1143, 34476, 49535,  1059,  1151, 49535, -3453, 49535,
    1449,  1053, 49535,  1409, 27930,  1262, 49535, 49535, 49535, 49535,
   -3453, -3453,  1268, 49535, 49535, -3453, 51977,    18,  1525,  1473,
      87, -3453, 44244, -3453, -3453, 43837, -3453, -3453, -3453, -3453,
   -3453, 44651,   274, -3453, -3453, 34883, 49535,  1490, -3453, 52384,
   -3453,  1583, 35290, 52791, -3453, 28350,  1644, 53198, 53605, -3453,
   -3453, 54012, -3453, 54419,  1417, 54826, -3453, 55233, -3453,  1539,
   55640, -3453,  1319,   807,  1849, 24612, -3453,    -4, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453,   297,  1387,   233,   149,
     276, -3453, -3453,   152,   157,   158,   297,  1731,  1731, -3453,
   49535, -3453, -3453,  1387,   528,  1392,  1392,  1392,  1526,   739,
   -3453,  1392, 49535, -3453, -3453, -3453, -3453, 43837, -3453,  1405,
     386,  1396,  1802, 49535, -3453, 49535, -3453, 49535, 49535, -3453,
   -3453,  1816,  1456,  1680,  1451, -3453,  1638,  1661,  1650,    68,
     386,  1571, -3453, -3453,  1689, 16198,   386, 45058, 56047,   143,
   44651,   386, 45465,  1523,   908,  1681, -3453,    36, -3453,  1911,
    1568,  1797,  1451,   908, 25438, -3453,  1580,  1242, 43837, -3453,
   -3453, 56454,  1683, -3453,   214,  1872, 16622, -3453, 49535,  1596,
   -3453,  1609,  1614,  1625, -3453, 10396, 49535,   772,   772,  2018,
     772,   180,  1025, -3453,  1773, -3453,   758,   184, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
    1654,  1242, -3453,   200, -3453,    92,  1642,  1129, -3453, -3453,
     212,  1703,  2375,  1665,   211, -3453,  3226,  1731, -3453, 49535,
   49535, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
    1669, -3453, -3453,  1657,  1075,  1175,  3237,   666,  2630,    78,
     361,  1865,  1241,  1973,  1082,  3087, 49535,  1919,    27, -3453,
     553, -3453,  1752,  1880,   623, 34476,  1708, -3453, 49535, -3453,
   -3453, -3453, 34476, -3453,  1891, 28770, -3453, 49535, -3453, -3453,
   -3453, -3453,  1831, 49535, -3453, -3453,  1957, 49535, -3453,  1392,
     178,  1729,  2103, 62108, 49535,  1775,  2141,  1781, -3453, -3453,
    1775, -3453, -3453, 49535, 49535,  1758,   861,  1775,  2150,  2157,
    1833,  1931,   651,   360,   128,  2054,  1775, 49535, 49535, 49535,
   49535,  2129, 34476, 49535, -3453,  1920, -3453, -3453,   883,  1826,
   -3453, -3453, -3453, -3453,  2068,  1654,   390,  2070,  1783,  2072,
   -3453,  1814,  2076,  1665,  2083,  1789, -3453, 56861, 57268,  2087,
    1669, 49535,  2089,  1789,  2091,  1975,  2094,   390,  2096, -3453,
     827,  2097,  1981,  2099,  1435,  1789, 45872,  2101,   195, -3453,
   18318, -3453,  1895, -3453,   758, -3453, -3453,  1172, -3453, 32848,
   -3453,  1849,  1387, -3453, 49535,  1387, 49535,  1387, 49535,  1387,
   49535,  1387, 49535, 49535, 49535,  1387, -3453, -3453, -3453, 49535,
    1818, 49535, 49535, -3453, -3453, -3453, 38953, 49535, 39360, -3453,
     116, -3453,    83,   386, -3453, -3453, 62108,  2214, 49535,  2106,
    2106,  2106, -3453, -3453, -3453,  2042, 49535,  2104,  2109, 38953,
   49535, -3453, 57675,  1830, -3453, -3453, -3453, -3453, -3453,  1166,
    2252,   159,  2255, 18318,  1837,   209,   209,  1838, -3453, -3453,
   -3453,   202,  1840,  1843, -3453,   210,   210,  1996,  1845,  1846,
   -3453,   219,  1848,  2273,  2275,   221,  1857,  1860,  1861,  1710,
     209, 18318, -3453,  1863,   210,  1864,  1869,  1871,  2286,  1874,
   -3453,  2293,  1879,   298,   313,  1881,  1882, -3453,  1845, -3453,
     168,  1883,  1884,  1885,  1886,  1888,  1893,  1894, 18318, 18318,
   -3453, 15350, -3453,   386, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453,   166, -3453,   223,  3715, -3453, -3453,  2044, 18318, -3453,
   -3453,    73, -3453,   227, -3453, -3453, -3453,  1242, -3453, -3453,
    1034,  1896, -3453,  1418, -3453, -3453, -3453, -3453, -3453, -3453,
   40174,  2284, -3453,   797,   553,   280,  2234, 32034, 32441, -3453,
   -3453,  2118, -3453, 49535, -3453, -3453, 18318, 30019, -3453,  1242,
      90, 49535, -3453, 25851, -3453, -3453, -3453,  1295, -3453, -3453,
   -3453,    -4, -3453,  9486, -3453,  1297,  1596, 49535, 49535,  2294,
   -3453, -3453, -3453,  1609, -3453, -3453,   -15,   -15, 18318,   -15,
     925,  1085, 17046, 18318,  2182,  2078,   696,   741,  2184, -3453,
     180,  1025, -3453, 31240,  1245,  1242,  1974,  1977, 33662,  1903,
    1979,  1980,  2143, 58082, -3453, -3453, -3453, -3453, -3453,  1202,
     294,   201,  1984,   632, -3453, 49535,  2085,   291,  2032, -3453,
    1992,  1993,  2107,   291,  1122, 58489, -3453, -3453, -3453, -3453,
   -3453,  2730, -3453, 14134, -3453, -3453, -3453,  1995,  1978, 35697,
    2289,  2100,    17,  1160,   197, 49535,  2181,  2001,  2003,  1934,
    1221,  1935, -3453,    69,  1985,  1988, 60909,  2108, 29190,  2270,
    2013, -3453,  1298,  2015,  2016, -3453,   291, -3453,  2332,   291,
     291,  1200,  2333,  2025,   282,  1090,  1775,  1935,  1565, -3453,
   -3453,  1956,  2027,   249, -3453,  2128,  2289,   182,  1114,  1935,
   -3453,  2033,  2035,  1934,  1934, 49535, 49535, 49535, 49535, 49535,
    2041,  2045,  2092, -3453, 40581,  2046, 56047, -3453, -3453,  2048,
    1271,  1935, -3453,  1294,  1259, -3453, -3453,   908, -3453, 49535,
   -3453, 49535,  1654, 62108,  2146,  1665,   291, 49535, 49535,  1669,
     985,   914,  2148, 49535,  2216,  2012, -3453, -3453,  1775, -3453,
   31637,  1758, -3453,  1982, -3453, -3453,  2026, -3453,  2026,  2026,
    1983,  1983,  1989, -3453, -3453, -3453,  1710,  2026,  1983, -3453,
   62900, -3453,   482,  1158, -3453,  2380,  2384, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453,   120,  1415, -3453,  2399,
   -3453, -3453, 62108, 49535, -3453,  2316,  2053, 33662, -3453,  2034,
   -3453, 49535,  1119,   386,  2036, 49535,  2210, 49535, 49535, 49535,
   49535, -3453, -3453,   853,   141, -3453, 40581, -3453,  1565,  2402,
      30,  1392,  2291, -3453, 49535,  2014,  2407,  2242, -3453,  1394,
   -3453,  2130, -3453, 22960,  2057, 34476,   390, -3453, -3453, -3453,
   -3453, 62108, 49535, 58896, 34476,   390, 49535, 49535,  2306,  2073,
    2313,  2075, 29190,   390,   208, 49535, 49535, 49535, 49535, -3453,
   49535, -3453, -3453, -3453, -3453, 49535, 49535, 49535, 40581,  2318,
    2321,   390, 49535, 49535, -3453,  9486,  1302, 49535,  1849, 39767,
   -3453, -3453, -3453, -3453, -3453,   870, -3453, -3453, -3453, -3453,
   -3453, -3453, 49535, -3453, 49535, -3453, 49535, -3453, 49535, -3453,
   49535, -3453, -3453, -3453, 49535, -3453, 49535,  1308, -3453, -3453,
    1317,   635, 49535,   176, 34476, 49535,  2211, 49535, 49535, 49535,
   49535,  2114,  1896,  1050, -3453,  2082, 25025,  2158, -3453,   205,
   43837,  2229, -3453, -3453,  1323,  1326,   915, -3453, -3453, -3453,
   -3453, -3453, -3453, 39360, 38546,  2323,    81, 49535, -3453, 18318,
    1242, 15774, -3453, -3453, -3453,  2049,  9486,  2093, 18318, -3453,
   -3453, 18318,  1731,  1731, 18318, -3453, -3453, -3453, -3453,   784,
    1731, -3453, 18318, 18318,  1731,  1731,  2026,  2026, -3453,  5036,
   18318, -3453, 29190, 18318, 20862, 13304, 18318,  2120,  2069,  1731,
   -3453,  1731, -3453, 18318, 14926, -3453, 18318,  2256, 18318,   280,
    2257, 18318,   280,  2465,  2465,  1254,  3858,  2055, -3453,  2165,
    1731, -3453,  1731,   801, -3453,   172, 62108, 18318, 33662,  2140,
     164, 18318,  2071,  1658, -3453, 18318,   675, -3453,  2074, 18318,
    2139, 18318, 18318, 18318, 18318, 18318, 18318, 18318, 18318, 18318,
   -3453, 21710,   230,     5,   552, 46279, 16198,  2346, 12879, -3453,
     142, -3453, -3453, -3453, 49535,  2284, -3453, -3453,  2144, -3453,
   -3453, -3453, -3453, -3453,   231, -3453, -3453, -3453, -3453, -3453,
   -3453,  2080, -3453, -3453, -3453, -3453, -3453,  2080, -3453,  2081,
    3514, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453,  2337,  2339,   390,
   -3453, 49535,    88, -3453, -3453, -3453,  2102, -3453, 49535,   214,
   40988, -3453, 16622, -3453,  1329,  1845, -3453,  2326, -3453,  2084,
   -3453,  6801,  2326, -3453, -3453,   242,  2266,  2272,  2272, -3453,
    2098,  9486, -3453,  1492,  9486,  1506, -3453, -3453, -3453, -3453,
   -3453, -3453,   714, -3453,  2182,   741,  2095,  1335,  2168,  2183,
    2230, -3453, 49535, 49535, -3453, 33662, 49535, 49535,  2186, 49535,
   -3453,  2448,  1012, 38546,  2239, 36918, -3453, -3453,  2125, 49535,
    2176,  2358,  2359,  2131, -3453, -3453, 49535, -3453,  2315, 49535,
   18318,  2317, 49535,   824,  2320, -3453,   942, 49535, 49535,  2307,
   -3453, -3453, -3453, 44651, -3453,   947, -3453, -3453,  2302, -3453,
   -3453, 62900, -3453, -3453,  1350, -3453, 62504, 59303, -3453, -3453,
     928, 49535, 49535, 49535,   -31, -3453, -3453, 62108, -3453, 49535,
   49535, 49535, 41395, 59699, 60106,   769,  1037, 49535, 41802, -3453,
   49535, 49535, 49535, 33662, -3453, 49535,    58,   171, -3453,  3447,
    2208, -3453, 49535, 49535,  2135,  1352,  2212, -3453, 49535, 49535,
    2889, -3453, 49535, 49535, -3453, -3453,   291, -3453, -3453, -3453,
   -3453, -3453, 49535, 49535,   291, 49535,   291,  1189, -3453, 34069,
   49535, -3453, -3453, -3453, 49535, 49535, 49535, 49535, 49535, 49535,
   -3453, -3453,   727,   503,  2281,  2285,  2292, 49535, 49535, 49535,
   -3453, -3453,  2247, -3453, 49535,  2889, 49535, 49535,  2231,  2232,
     241,  2304, -3453, -3453, -3453, -3453, -3453, -3453,  2400,  2559,
   49535,  2403,  2404,  2220,  2221,  2408,   747, 49535, 49535, 49535,
   49535, 49535, 49535,  2409,   747,  2347,   111,  2175,  2189,  1359,
   -3453, -3453, 18318,  2573, 62108,  2185,  2187,  2249,  2250,  2251,
   -3453,  2188,  2254,  1731, -3453, -3453,  1433, -3453,   853,   711,
   -3453,   518,  3369,  2463, 49535,  1366, -3453,  2202, 49535,  3369,
   -3453,  2067, 38546, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453,  2469, -3453,   386,  1758,  1758,  1758,  1758, -3453,
   -3453, -3453,  2371,  1134, -3453,  2194, 49535,  2303,  3369, -3453,
    1565,   897, 49535, 36104,  1434,  2591,   386,  2372, -3453, 14530,
    1517,  2373, 44651,  2464,  2475,  2486, -3453, 22547, 46686,  2213,
    1112, -3453, 46686, 47093, -3453,  2215,  1242, 18742,  2158,  1654,
   -3453,  2607, -3453,  2509,   390,  1665, -3453,  1789, -3453, 49535,
   49535, 49535, 49535,  1669, -3453, -3453,  1789,  2393,   390,   390,
   -3453,  2394,   390,  1789,  2327,  2504, 44651, -3453,   195, -3453,
   -3453, 18318,  2225, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453,  1380, -3453, 49535, -3453,  2482,  2483,  2489,  1789,
    2264, 49535,  2235, -3453,  1789,  1731,  1789,  1896,  1896,  1789,
   47500,  2642,  2506, -3453,  1381, -3453, -3453, 16198, -3453,   593,
   -3453,   650,   940,  2445, -3453, -3453, -3453, -3453, 62108, -3453,
   -3453, -3453, -3453, -3453, 49535,   114,  2415,  2240, 47500,  2624,
     390, -3453,  1382, -3453, -3453,  1047, -3453,  1186, 18318, 18318,
     112, -3453,  7453,  1390,  2248,  2253,  1404, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453,  2259,  2524, -3453,  2265,  1412,  1428,
    2267,  2268, -3453, -3453,  2047,  2269,  7133,  2274, 20862, 20862,
     768, -3453, -3453, 20862,  2276, -3453,  1436,  6774,  2246,  2277,
    2288, -3453,  2278,  2282,  7550, 17470, 18318, 17470, 17470,  7656,
    2246,  2290,  1440, 33662,  8389,  1442, -3453, 18318, 33662,  3067,
   18318, -3453, 18318, 49535,  2297,  2298, -3453, -3453,  5036, -3453,
    2299, -3453, 20862, 20862,  3238, 15350, -3453, -3453,  2528, -3453,
   -3453,  1057, -3453,  2301, -3453, -3453,  6357,   167, 18318,  2071,
   18318,  2325, 29190,  9640, 18318,  5168,  4161,  4161,   335,   335,
     155,   155,   155,  1401,   552, -3453, -3453, -3453,  2305,  1874,
   18318, -3453,  1591,  1604, 49535,  1889,  2942, -3453, -3453, -3453,
   22960,  2310, 18318, 18318, 18318,  2311,  2418,  8665,   582, -3453,
   -3453,   908,  1731,   801, 32848, -3453, -3453, 18318, -3453, -3453,
   -3453, -3453,  1444, 25851,  2057, 16622,  1242,  1609, -3453, -3453,
   -3453, -3453, -3453, -3453, 18318, -3453, -3453,   725,  1511, 18318,
    1492, -3453, -3453, 49535,  2229,  2229, 18318, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, 49535, 49535, 49535, -3453, -3453, -3453,
   -3453, -3453,   386, -3453,  2495, -3453, 49535, 49535,  2430, 49535,
    2473,  2466, 18318,   834, 49535,  2314,  2319,  2322, 49535,   390,
   -3453, -3453,  9486, -3453, -3453,  2340,  2364, 49535,  2128, -3453,
    2548, -3453, -3453, -3453, -3453,  2487, -3453, -3453,  1415, -3453,
   59303, 62504, -3453, 62504, -3453,  1415,  1258, -3453,  1789, -3453,
   -3453,   150, -3453, -3453, -3453, -3453, -3453,  2602,   390,  2604,
     390, 49535, 49535, 49535, 49535, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453,  1450, -3453,  1228, -3453, -3453,  2545, -3453, -3453,
    2547, -3453, 49535,  1314, -3453,   748, 62108, -3453, 61305, 49535,
   -3453, -3453,  2539, -3453, -3453, -3453,  2478, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453,   773, -3453,  2480, 49535,  2377,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, 33662,
   33662, 33662,  1454, -3453, -3453,   386, -3453, -3453,   913, -3453,
    2396, -3453, -3453, -3453,  2537,  2541,  2542,  2405,  2406,  2410,
    2411, -3453,  2412,  2416,  2417, -3453, -3453, -3453, 49535, -3453,
   -3453, -3453, 49535, 49535, -3453, -3453, -3453,   747, 62108,  2564,
     747,   747, 49535, 49535,   747, -3453, -3453, -3453,  2568,  2569,
    2583,  2585,  2587,  2589,   747, -3453, -3453, -3453, -3453,   178,
   33662, -3453,  2051, 27090, -3453,  2761,  4195,  2357,  2187,  2360,
    1731,   154,   133,   857,  2470,  1731,  2563,  2361, -3453,  1393,
    2579,  2376,  2376,  2376,  2376,  2376,  2376,  2376, -3453,  1892,
   -3453,  2535, 49535,   131, 49535,  1731, -3453, -3453,  2427, -3453,
   -3453, 33662, 27090,  1392,  1119,  2497,   992,  2697, -3453, -3453,
   -3453, -3453, -3453, 49535, 49535,   853,   386,  1455, -3453, 62108,
   49535, 49535,  2414,  2370, 49535,  2374,  2367, -3453, -3453, -3453,
   -3453,  1461, -3453, 62108,    12,  2549,  2550,  1149,  2443, 49535,
   -3453,  1470,    70, -3453,   386, 44651, 60513, -3453,  1953, -3453,
   -3453,   175,  2644, -3453, -3453,  1149, 13720,  1112,  2382, 49535,
   -3453,  2378, 22960,  2617,  2553, -3453, 22960,  2553,  1227,  2553,
    2621, -3453, 26264, -3453,  2391, 12879,  1292,  2571,  9486, -3453,
     390, 62108, 49535, -3453,   390,  2444,   390,  2446,   390,   390,
   49535, -3453, -3453, 49535, -3453, 49535, 40581,   390, -3453,  9486,
   49535, -3453, -3453,  2510,  2513,  2514, 49535,  1789, 34476, -3453,
    2397, 49535,  1088, -3453, -3453,  2574, -3453,  1149, 49535,  1242,
    2398, -3453, -3453, -3453, -3453,  2693,  2698, -3453, -3453, -3453,
   49535, 38953,   222, 49535, -3453, -3453, -3453, -3453,  2419,  1477,
    9171, 18318, -3453,  2703, 62108, -3453, -3453, -3453, -3453, -3453,
   18318, -3453, -3453, -3453, -3453, -3453, 18318, -3453, 18318,  2683,
   -3453,  2825,  2825, 62108, 20862,  1226,  1864, 20862, 20862, 20862,
   20862, 20862, 20862, 20862, 20862, 20862, 22134,   442, -3453, -3453,
   18318, 18318,  2699,  2683, -3453, -3453,   805,   805, 62108,  2420,
    2246,  2421,  2422, 18318, -3453, -3453,  1496, 33662, -3453, 18318,
    6819,  1501,  2456,  9455,  1242,  4364, -3453,  2788,   386, 18318,
    1291,  1590, 18318,  1520, 18318,  2696, -3453, -3453, -3453,  2424,
   -3453, -3453, 62108, 18318, 20862, 20862,  6843, -3453,  9027, 18318,
    2425,  9879, 15350, -3453,   489,   489,   489,   489, -3453, 49535,
   49535,  2213, 18318,  2695,     7,     7,  2431,  2418, 26677, -3453,
   63296,   255, 17894,  2434,   553,  2436, -3453, -3453,  6532,  2438,
   49535, -3453,  2158, -3453, -3453, -3453,  2428, -3453,  1511, -3453,
   -3453, -3453,  4637,  2611,  1896, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453,  2376,  1789,  1789,   642,  1789,  2712,   642,  4691,
   -3453, -3453, 23373, 49535, 49535,  1534, -3453, -3453, 49535, -3453,
    1642, -3453, -3453,  2685,  1275, -3453, -3453, -3453,  2511,  1892,
     170,  1934,   323, -3453,  2515, 49535, -3453, 49535, -3453, -3453,
   -3453, -3453, -3453, -3453, 33662, 27090, 33662, -3453, -3453, -3453,
    2518,  2519,   105,   163,  2523,  2525,  2460,  2461,  2462, -3453,
     297,   386, -3453, -3453,   386,  1789,   386, -3453, -3453, -3453,
   -3453, 34069, -3453, -3453, -3453, 49535,  2738,   165,  1475, 49535,
   49535, 49535, 49535, 49535, 49535, 49535,  2128, -3453, -3453, -3453,
    2474,   747, -3453, -3453,  2700,  2701, -3453,   747,   747,   747,
     747,   747,   747, -3453,   296,  1548, -3453, 24199, -3453, -3453,
    2141,  2141,   987, -3453,  2141, -3453,  2141, -3453,  2428,  1731,
     870, -3453, -3453, -3453, -3453, -3453, -3453,  2189, -3453,  1073,
    1731,  1518,  2468, -3453,  2477, -3453, -3453, -3453, -3453, -3453,
   -3453,  2484, -3453,   801, 49535,  2376, -3453,  1230,   798,   821,
    1020, 47907, 48314, 48721,  2479, 49535, 20862, -3453,  1182,   667,
   -3453,  2705, 49535,  2501, -3453, -3453, -3453,  2481, -3453,  1789,
   49535, 49535,  1789, -3453, 62108, -3453, -3453,  2873,   807, 49535,
    2521,  2492,  2764, -3453,  2496,  2499, -3453, -3453, 49535, -3453,
    2535,  1319,   780, -3453, 37325,  1434, -3453,  2734, 36104, -3453,
   49535, -3453, -3453, -3453,  2845,  2577,  2534,   386,  2176, -3453,
   59303, 18318, 18318, -3453,  2500, -3453,  2507,  2467, -3453,  1758,
   -3453, -3453, -3453, -3453, -3453, -3453,  2590, 49535, -3453, 46686,
    2522, 49535,  1112, 22960, -3453, -3453,   692, -3453, 22960,  2741,
   -3453, 22960, 49535,  2529, 49535,   698, 49535, -3453,  2512,   390,
   -3453, 49535, -3453, 49535, -3453, -3453,   390,   390, -3453,  2627,
   -3453, -3453, 49535, 49535, 49535,  1789, -3453,  1731, -3453,  2786,
   47500, -3453, -3453, -3453, -3453, -3453, -3453,    81,  2799, -3453,
   -3453, -3453, -3453, 18318,  9486, -3453,  2527,  9486,  5087,  9486,
    2699, -3453,  1106,  2800, -3453,   919,  2530,  1106,   838,   838,
     395,   395,   173,   173,   173,  2825,   442,  9486,  9486, -3453,
   -3453, -3453, -3453,  2531, -3453, -3453, -3453,  2246, -3453, 19166,
   -3453, -3453,  2560,  2566,  2533, -3453, 18318, 19590,  2536, 62900,
   -3453, -3453,   801,  2465, 20862, 20862,  2152, -3453,   433, 18318,
   62108,  1552,  2152,  2112,  2163, 18318, 18318,  9902,   333, 18318,
    5116, 49535, 49535, 49535, 49535, -3453, -3453,  9486,  2914,  2804,
   18318,  2538, -3453,  2540,  2418, -3453, 61701, -3453, -3453, -3453,
   -3453, -3453, -3453, 18318, -3453,  2418,   386, -3453,   758, -3453,
   -3453, 29190, -3453, -3453, -3453,   297, -3453, -3453, -3453,  2612,
   38546,  2819,  1073, 18318,  1559, -3453,  2581, 49128, 12453,  1561,
    1570,  2501, -3453,  1903, -3453,  2605, -3453,  2732, -3453, -3453,
    2733,   297, 49535, -3453, 62108,   390,   390, -3453, -3453,  2567,
   49535, 49535,  1731,  1731, 62108,  2551, -3453,  1731,  1731,  2552,
   -3453, 49535, 49535, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, 49535, 49535, 49535, 49535,  2842, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453,  2792, -3453,   747,   747, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453,  1775,  2868, -3453, 33662,
   -3453, 37732, -3453, -3453, -3453, -3453,   386,   386,  2745, 30833,
     386,   386, -3453,  1289,  2883, -3453,  2813,   719,  2570,  1424,
    2840, -3453, -3453, -3453, -3453,  2844,   297, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, 18318,  1023,  1106, -3453, -3453, -3453, -3453,  2501,
    1392,  2620, 33662,  1789,  1789,  2622,  1149,    34, 49535,  2875,
    2610, -3453,   386, -3453, -3453, -3453, -3453,  2903,  1588, -3453,
   -3453, -3453,  2608,  2550,   701,  2576,  1434, -3453, -3453,   620,
   49535, -3453,   783, -3453,  2853,  2578, -3453,  9486,  9486,   386,
   63296,  1953, -3453, 49535,  2827, -3453, 49535,  1598, -3453, 18318,
    2580, -3453, -3453, 22960,   692,  1613, 49535,  1615, 62108,  2418,
   -3453,   390, -3453,   390,   390, -3453, -3453, 49535,  1789,  1789,
    1789, -3453,  2753, -3453,   390, 47500,  9486, -3453, -3453, -3453,
   20862,  2859, -3453,  2584, 62108, -3453,  2586,  1626,  1627, -3453,
   -3453, -3453,  5583,  2631,  9486,  2682,  2592,  2593, -3453,   944,
     944,   433,  1647, -3453, 20862, 20862,  2152,  2152, 18318,  2152,
   -3453, -3453, -3453, -3453, -3453, 18318, 18318,  2625,  2418,  2418,
   -3453,  2748, -3453,  2595, -3453,   801, -3453,  2597, -3453, 47500,
    2774, 47500, -3453,  5771,  2501, 23373, 29610, 49535, -3453,   833,
     833,  2739,  2501,  2620, -3453, -3453, -3453, -3453, -3453,  2657,
   -3453, -3453, 27090, -3453, -3453, 23786, 29190, -3453,   105,  2614,
    2623,   163, -3453, -3453,  1141,   516,  2641,  1789,  2898,   747,
   -3453, -3453,  2175,   386, -3453, -3453, -3453,  1651, -3453, -3453,
   -3453, 49535, -3453,  2492, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, 34476,  3017,  3017, 49535,  1073, -3453,  5912,  2807,
   -3453,  2620,  2834,  2879, -3453,  1652, -3453, 49535,  2534, 36104,
    2535, -3453,    54,  2628,  2921, -3453, -3453, -3453, 37325,  2801,
    2577,   245,   245, 49535,  2550,  2750, -3453,  2751, -3453,  2997,
    2805,  3003, 49535, 23373, -3453, 62504, -3453,  1659, -3453,  2310,
   49535,   518,  1670, -3453,  9486, 49535, -3453, -3453, -3453,  1684,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453,   222,   515, 20862,
   62108,  1695, 18318, -3453, 18318, -3453, -3453, -3453,   424, -3453,
   -3453, -3453,   944,   944,  2152,  2246,  9486, 49535, -3453, -3453,
   -3453,  3018,  2808,  2418, -3453, -3453,  1088,   642,   222, 49128,
    2620, -3453,  2645, -3453, -3453,  1511,  1511, 49535,  2620,  1073,
   18318, -3453, -3453, 62108,  1665,   452, -3453, 62108, 62108, -3453,
   49535, 49535, 49535, 49535, 49535, -3453, -3453, -3453, -3453, 37732,
    2492,  3017,   746, -3453, -3453, -3453,  2922, -3453, -3453,   126,
    2816,  2722, -3453, 33662,  2933, -3453, -3453, -3453, -3453, -3453,
   18318,  2795, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453,  1699,  2577, -3453, -3453,  2824, -3453,  2829,
   -3453,  1706, -3453, -3453,  2467, 63296,  2957, -3453, -3453, -3453,
    1716, -3453, -3453,   515,  1721, -3453,  1722,  1726,  2706, -3453,
    2650, -3453,  3054, 18318,   560, -3453, -3453,  2938, -3453,   833,
    2704, 29190, -3453, -3453,  1392,  1073, -3453,  9486,  1737, -3453,
   -3453, -3453,  2803,  1739,  1749,  2659,  2713,  2659, -3453,  1789,
   -3453, -3453, -3453, -3453,  2971, -3453, -3453, -3453,   346, -3453,
    2846,  2847, 49535, -3453, 49535,  3065,  6008, 34476,  1892, -3453,
   -3453, -3453, -3453,  2714, 23373,  1953, -3453,   796, -3453, -3453,
   -3453, -3453, -3453, 49535,  2684,  2246, 20014, 20014,  2686, 47500,
    1511,  2688,  1073,  2689,  2834, -3453, 34476, -3453, -3453, -3453,
   49535,  2802,   677,   677,  3006, -3453,  2743, -3453, -3453, -3453,
     105, -3453,  2707,  1934,  2577, -3453, -3453, -3453, -3453,  1811,
   -3453, -3453, 21286,  2812,   148,  6875, -3453, -3453, -3453, -3453,
     222, -3453, 18318, -3453, -3453,  2816,  1665, -3453,  2610, -3453,
    3095, -3453,   186, -3453, -3453,  2551, 38139, -3453,  2310, -3453,
    1231, -3453, -3453, -3453, -3453, -3453, -3453, -3453,  3097, -3453,
   -3453, -3453, -3453, -3453, -3453,  6051,  1073, -3453,  2993, -3453,
   -3453, -3453, -3453, -3453, -3453,  1751, -3453, -3453, -3453, -3453,
   -3453,  1530, -3453, -3453,  1536,  1625, 20438, -3453, -3453,  2848,
   -3453, 38139, -3453,  1231, -3453, 34476, -3453, -3453,  2708, 38139,
    1756, -3453
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -3453, -3453, -3453,  2447, -3453,  -706,  -194,  1904,  -388, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -3453, -3453, -3453,  1195, -3453, -3453,   115,  1619,  2079,
     904, -3453,  -863, -3453, -3453,  -529,   135,  -577, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453,   902,  1321,  2413,  -651, -3453,
   -1134, -3453, -3453,   312, -3453, -3453, -3453,   682,  -328, -3453,
   -3453, -3453, -3453, -3453, -3453, -3453,  -104, -3453, -3453,  -473,
   -1221,    44, -3453, -3453, -3453, -3453,   174,  -370, -1018, -3453,
   -2253, -3453,  -140, -3453, -3453, -3453,  -368, -1084,   862,  -593,
    -869,  1116,  -592, -3453,  -274, -3453,  -632,  -557,  -555,  -597,
   -3453, -2762, -3074, -3250, -2166,   136, -3453, -3453, -3453,   191,
   -3453, -1218, -3453, -3453,  1851, -1066, -3453,  -849, -3453, -3453,
   -2861, -3453,  1410,  -364, -3453,   106, -3453, -3453, -3453, -3453,
   -3453, -3453, -2826, -3453, -1140, -3453,   332, -2318,   786, -3453,
   -3453, -3453,  1877, -3453, -3453, -3453, -3453, -1248, -3453, -3453,
   -1212, -3453,  1265,   679, -3453, -3453, -3453,  -603,  -662,  -653,
   -3453, -3030,   -68,   -64, -3453, -3453, -3453, -3453,  -793, -3453,
     702, -2390,  -719, -3453, -3453,   740, -3453, -3453, -3453,  -564,
    -254,  1905, -3453,  -493, -3453, -3453, -3453,  -249, -3453, -3453,
   -3453, -3453, -3453, -3453, -1345,   -96,  -681, -3453, -3453, -3453,
   -3453, -1771, -3453,  3185,  1640,  2039, -1211, -3453,   -28,    50,
    2296,  -889, -2016,   177,  -371, -3453, -1377, -3453, -3453, -3453,
   -1953, -3453, -3453, -3453, -3453, -2659, -1210, -3453, -3453, -3453,
     228, -3453, -2768, -3013, -2961, -2645, -3453, -3453,  -833, -3453,
   -3453, -3453, -1047,  1439, -1731, -3453, -1689,   232, -2857,  -551,
   -2494, -3453, -2812,  -445, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453,  -835,  -504, -3453, -3453,  2679, -3453, -2461, -3453, -3453,
   -3453, -3453,  1083, -3453,   366, -3453, -3453, -3453, -3453,  -669,
   -3453, -3453, -3453,  -549,  -621, -3453, -3453, -3453,   137, -3453,
   -3453, -3453, -3453,  1633,  -718,  -595,  2572, -1209,  -270, -3453,
   -3453, -3453, -3453, -2307, -3453, -3453, -3453, -3453, -3453, -3453,
   -3453, -1121, -3453, -3453, -3453, -3453, -3453, -3453, -3453,  1545,
    1549,    45,   -41, -3453, -3453, -1009, -3453,  -449, -3453,  1852,
   -3453, -3453, -3453, -3453, -3453,   138,   269, -3453,     2, -3453,
   -3453,   627, -1864,     3, -3453, -3453, -3453, -3453,  -152,     4,
   -3453,  1010, -3453, -3453, -1586, -3453,   139,   181, -3453, -3453,
       1,     0,   -44,   -39,   -33, -3453,  2582,  2167, -3453, -3453,
      -1,  1358, -3453,  -685,  -135, -3453,  1002,  -509,  1538,  2159,
    2164, -3453,  1005, -3453, -3453,  1008, -3453, -3453, -3453,  -491,
    1551, -3453,  2169,  1564, -3453,  1594,  1058, -1895,  1293, -1875,
     713,  -503,   -71,    74,  2619,  2755, -3453, -3349,  1049, -2708,
     326,  -695,  1378, -1241, -3453, -3453,  -896,  6332, -3453, -3453,
   -3453,  6931,  7378, -3453, -3453,  7488,  7845, -3453,  -784,   588,
    8174,  5563,  -932, -1463,  -798,  5893,  -566, -1042, -1290, -3453,
   -3453, -3453,  -266,   598,   483, -3453, -3453, -3453,  -442, -2150,
    -446, -3453, -3453, -3453,  -443, -3452, -1343, -3453,  -170, -3453,
    8815,  1045, -3453,  -724, -2030, -2097,  -892, -1354, -3453, -3453,
   -3453, -3453, -3453, -3453, -3453, -1793, -2497,  -455,  1120, -3453,
   -3453,  1210, -3453, -3453, -3453, -1002,  -689, -1532,  1125, -1547,
   -3453,  -668,  1246,  1759,  -624,  -147,  -538,  5307,  -439, -1766,
    -975,  -186, -3453,  -136, -3453,    16,    -9,    25,    -6, -3453,
    3002,  1370, -1003,  6219,  -907,  -850, -2349
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -2012
static const yytype_int16 yytable[] =
{
     157,   156,   151,   152,   154,   683,   751,   638,   544,  1110,
     815,   502,   840,   914,   915,   855,   603,   615,   919,   863,
    1355,   157,   603,  1041,   692,  1363,  1396,   736,  1112,   875,
     720,  1325,  1115,   756,  1444,  1814,   733,  2028,   602,  1913,
    1398,   765,   668,  1420,   602,  1119,  1754,  2053,  1181,   682,
    1455,   860,  1238,  1994,  3000,  2321,   527,  2365,  1227,  1054,
    2166,  1715,  1502,  1152,  1671,  1853,   577,  1676,   805,  1475,
    1476,   725,  2632,   609,   730,  1796,  2749,  2809,  1967,  1860,
    1861,  2847,  1261,  2849,  1696,   639,  1185,  1200,  1491,  1210,
     762,  1944,  2557,  1223,  1945,  2241,  1232,  2322,  2324,  1300,
    1946,  1947,  1948,  1949,  1304,   686,  1785,  2096,  1285,  2616,
     850,  1310,  2956,  1676,  2906,  1671,   665,  2571,  2573,   671,
    1327,  1048,   694,  3162,   569,   883,  1346,  2746,   695,  3171,
    2024,  3301,  1848,  2455,  2579,    66,    75,   128,   149,   155,
    3341,  1795,  3432,  1734,  3314,  2251,  3344, -1677,   540, -1789,
    1127,  2132, -1823,  2906,   656,  2246,  1386, -1843, -1872,  1324,
    1673,   693, -1165,   585, -1360,  3440,  1526,  1677,  2499, -1168,
     500,  1469,  1470, -1355,  2991,  2928,  2929,  2930,  2931,  2932,
    2933,  1150,  1104,   540,  2663,  3089,  1056,  1228,   490, -1702,
    3666,  1529,  2744,  2745, -1571,   534,  1488,   673,   734,  2171,
    1107, -1571,  2171,   754,  1573, -1703,  1255, -2011,  1585,  1585,
    2211,  1673,   764,  3323, -1360, -1327,  1369,  1674,   940,  1917,
    1435,  2069,  1805,  1519, -1340, -1355, -1367,  1384,   540,  1155,
    1130,  1443,   540, -1724,  2358,  2641,   540,  2089,  2220,   832,
       3,     4,   585, -1165,  2586,  1347,  2588,  1045,  1798,  3520,
   -1168,   585,  2205,  1439,   540,   895,   758,  3202,  1347,  2206,
     540,  2457,  1555,  2981,  2630,   689, -1360,  3645,  1674,  1965,
    3644,  2810,  1347,  2050,  1757,  1756, -1792,  3715,  1972,   540,
    1235,  1249,  1972,  1918,  3002,   585,  -111,  1517,  1765,  2950,
    3830,  -111,  3820, -1842,  1770,  1390,  2915,   498,   899,   591,
     585,    38,   591, -1370,  1937,  1757,   585,   591,   591,  2356,
    3223,  2434,  2209,  3646,  3355,  3207,  3357, -1165, -1370,   592,
    3647,  1100,   592,  1364, -1168,  1101,  1801,   592,   592,   643,
    3818,    42,  1156,  1131,  1820,   827,  1238,  1834,  2070,  1919,
    1837,  1838,  1920,  1211,   751,  2294,  1526,  1381,  1560,   772,
    3648,  1502,  2916,  1748,   799, -1587,  1576,  1116,  3003,  3203,
    1397,  3637, -1587,  1074,   828,  1075,    47,   801,  1749,  3443,
     497,  1529,  1212,  2357,  1475,  1476,  1213,  1802,   163,  1433,
    1321,   495,  1491,   591,  1122,   751,  1117,  1102,  3638,  1678,
    1446,   540,  1057,  3716,  3854,  -776,   833,  1892,  1577,  1322,
    1673,  1214,  1456,   592,  3730,   829,  2663,  -329,  3187,   845,
     535,    49,  1891,   806,  1895,   164,   853,  3208,  1443,  3649,
    3189,  3821,  2359,   644,  1236,  1750,   591,  1760,   824,  3831,
    1103,  2210,    38,  1215,  1921,  3198,  2951,  3140,  1813,  1758,
    1347,  1751,  1401,  3204,  1526,  1731,   592,  1921,  2811,  1058,
    3654,   834,  2131,  2663,  3717,  3762,  1973,  1674,  2093,  3840,
    3509,  3224,    42, -1165,   936,   920,  3626,  2458,  1911,  1529,
   -1168,   541,   674,  2812,  1216,  3165,  2906,  1132,  3595,  3596,
     931,  1825,   536,  2992,  1469,  1470,  2360,  3501,  1844,   798,
    1846,  3004,  1851,  1488,  1806,  1348,  2051,    47,   918, -1842,
    1042,  2099, -1571,  1556,  1821,  1157,  1807,  2172,  1348,    48,
    2724,  1357,  2071,  1440,  1256,  1257,  2748,  1064,  2243,  1884,
    1440,  1567,  1348,  1888,  3808,  2169,  2663,  1922,  2791,  3538,
    2072,   683,   841,   544,  2619,  1133,   891,   810,  1855,  1093,
    1913,   817,  1436,  1464,   918,  3025,  1923,  2042,  1889,  3005,
    1694,   826,  1907,    49,  1307, -1165, -1842,  1808,  1676,  1111,
    2207,  3190, -1168,  1526,  3524,  1443,  1066,  1966, -1677,  3696,
    1067, -1842,  1752,  3379,   157,   682,  3689,  1549, -1789,  2913,
     892, -1823,   897,  3650,   901, -1360, -1843, -1872,  1529, -1165,
     905, -1165,  1520,  1464, -1355,  2675, -1168,  3145, -1168,  1076,
    1776,  1724,   602,   796,   602,  1831,   602,  1930,  2435,   671,
   -1702,   925,   602,   906,   907,   751,  1926,   882,  3276,  1725,
     886,  1673,  3590,  2309, -2012,  1383, -1703,  1217, -2011,  2704,
    3598,   941,  2806,  2665,  2807, -1360,  1474,  1038,  1357,  1242,
    1047,   841,  1049,  1174,  1175,  1480,  1245, -1367,  3549,  1522,
     597,   598,  3050,  1558,  3678,  3154,  2001,  2232,  3191,   597,
     598,  3192, -1724, -1587,  1753,  3755,  2869,  3012,  2259,  2872,
    2873,  3016,  3245,  2876,  1827,  1124,  2874,  2875,  1674,  3667,
    1328,  1330,  1331,  2883,  3636,   157,   156,   151,   152,   154,
    1348,   921,  1497,   597,   598,  2000,  1335,  1994,  2763,  -111,
    -111,  1254,  2122,  2123,  2006, -1792, -2012,  1497,   597,  1395,
    1498,  1218,  2014,  2015,   597,   598,  2187,  1305,  1306,  1079,
    3763,   612,  3793,  1317,  1499,  1498,  2621,  3799,  3750,  3525,
    2027,   537,  1671,   738,  1332,  2092,  1760,  2095,  1975,  1501,
    3700,  3526,   921,  1533,  1534,  2414,   767,  2103,  2305,  1813,
    2106,  2415,   540,  1173,  1546,  1547,  1548,  1549,  2118,  2119,
    2279,  1359,  1361,  1044,  1318,  3662,  2832,  1052,  2419,  1042,
    2756,  2136,  2138,  3297,  2903,  2329,   947,  2563,   540,  2663,
    3712,   908,  2152,  2623,  2480,  2132,  2132,  2107,  2046,   540,
    2132,  1259,  1042,  1537,  1094,  3166,  3848,  2420,   623,   687,
    1569,  1390,   540,   540,  2057,  2058,   585,  3735,   910,   538,
    2354,   539,  3611,  2903,  2672,  2673,  2674,  2675,  2007,  3777,
      66,    75,   128,   149,   155,  3262,   540,  2016,  1673,  2132,
    2132,  2167,  3679,  3521,  3529,   616,  2481,  1100,   768,  2023,
     689,  2188,  3530,  2564,  3746,  2189,   947,  3000,  2416,  2663,
    1544,  1545,  1546,  1547,  1548,  1549,   688,  2998,  2013,  2670,
    2671,  2672,  2673,  2674,  2675,  2255,  3070,   841,  3747,  2833,
    1761,  2565,  3522,   624,  2035, -1674,  1497,  3316,  1176,   585,
     841,  2190,  1100,  2108,  2049,  1674,  2566,  2054,  1095,  2056,
    3090,   157,  2059,  1748,  1498,  3527,  2567,  2307,  3160,  1371,
    1917,  1570,  3280,  1102,  1848,   602,  1673,  3800,  1499,  3612,
    3298,  2482,  2483,  2002,  1442,  3713,  1589,  1319,  2622,  2568,
     157,  1438,  1201,  3776,  2484,  3282,  1338,   689,  3687,  1307,
    1994,  1202,  2670,  2671,  2672,  2673,  2674,  2675,  2664,  2033,
    1372,  1337,  1673,  1762,  3349,  2256,  1357,  2109,  1102,  1462,
    3692,  3693,   947,  2047,   911,  2663,   689,  3264, -1327,  2665,
    3167,   511,  1959,  1674,  1918,  1750,  3775,   683,  1478,  1544,
    1545,  1546,  1547,  1548,  1549,  2624,  2485,  3801,  1339,  2766,
    3778,  1751,  2048,  1237,  3506,  1275,  1898,  2393,  2125,  3168,
    2445,  1103,  2417,  3531,  3420,  2396,  2569,  2398,  1505,  1674,
    3802,  1320,  2191,  2110,  1518,  3424,  2111,  1571,   751,  2751,
    3317,  1515,  2752,  2834,  1523,   511,  2842,   513,  1809,  3149,
    1919,  2418,  2666,  1920,  1559,   540,   622,  1899,  2240,  2665,
    2478,  2521, -1327,  3624,  2810,  3381,  1960,  3382,   690,  1707,
    1690,   841,  2835,  3154,  1575,   625,   626,  1066,   841,   841,
    2311,  1067,  1203,  1885,  2305,  1771,  3423,  1697,  1698,  2486,
    1702,  2487,  3602,   695,   695,  1340,   695,  1703,  3350,   602,
    2421,   513,  1866,   602,   602,  1403,  2918,  1405,  2341,  1407,
    1201,  1409,  2934,  1411,  1412,  1413,  2131,  2131,  1708,  2306,
    1415,  2131,  2666,  1373,  1887,   917,   693,   693,  2112,   693,
    3236,   767,  2330,  2906,  3374,  3791,  3239,  3240,  3241,  3242,
    3243,  3244,  1752,  1341,   947,  1921,  1939,  2663,  3348,  1862,
    1863,  1864,  1865,  3352,  3284,  3359,  3354,  2936,  2752,  2342,
    2131,  2131,  2312,  1968,  3345,  2665,  2903,  1772,   741,   742,
     743,  1561,   744,   745,   746,   747,   748,   749,  1978,   663,
    2696,  1893,  1894,   602,  1704,  2701,   520,  1903,   521,   602,
    3711,   640,  2509,  2510,  2511,  2512, -1208,  3383,  2801,   918,
   -1208,  1921,  2584,  2715,  3159,  2716,  1896,  1374,  2589,  3262,
    1900,  2667,  2668,  2669,   676,  2670,  2671,  2672,  2673,  2674,
    2675,  2113,   751,   768,  1852,  1342,  2717,  2563,  2666,  1497,
    1941,  1562,   602,  2307,  1753,   602,   602,  1995,  1922,  1999,
     520,  2811,   521,    38,   597,  1395,  1961,  1498,  2005,  2469,
    2018,  1955,  1956,  1957,  1958,  3258,  1798,  1962,  1122,  2022,
    1771,  3046, -1208,   684,  1803,   540,  2812,  1897,  2764,   585,
    2032,  3000,   163,    42,  2093,  1179,  1673,  2625,  -351,  1873,
    3263,  1673, -2012, -2012,  2328,  2670,  2671,  2672,  2673,  2674,
    2675,  3499,   602,  2564,  1901,  3363,  2940,  3364,  3579,  3580,
    3259,  2084,  1994,  2805,  1942, -1208,  1994,  3599,    47,   164,
    2580,  1042,  1042,  1944,  3061,  1839,  1945,  2029,   733,  3295,
      48,  2565,  1946,  1947,  1948,  1949,  1839,  2665,  2281,   947,
    2718,  2941,  2663,  1674,  1950,  2719,  2566,  2576,  1674,   827,
     685,  3264,  1772,  2942,  2626,  3723,  2567,  2286,  1738,  3114,
     696,  2132,   751,    49,  2132,  2132,  2132,  2132,  2132,  2132,
    2132,  2132,  2132,  2132,  3277,  3628,  1940,   731,  2959,  2568,
      15, -1327,  3073,  1988,  3074,  1357,  2343,  1742,  3039,  3296,
     729,  1873, -1327,  2583,  1474, -1327,  1118,  1743, -1327,  3557,
    2666,  2670,  2671,  2672,  2673,  2674,  2675,  2591,  2592,  1180,
    1706,  2594,  1744,  -143,  2639,  1810,  1225,  2598,  2564,   829,
      34,  2132,  2132,  2628, -1177,  1585,  2514,  2287,   157,  2370,
    3728,  2515,   683,  2943,  1120, -1177,  3486,  2344,  -143, -1177,
    2982,  1845,   808,  1873,   809,  1226,  2565,  1840,  2218,  1841,
    1707,   907,  1526,  3586,    24,  3588,  2569,  2230,  1840,  2720,
    1841,  3018,  2690,  1121,  3690,  1857,  2086,    34,  2721,  2795,
    2478,  2567,  3695,  3685,   886,    15,   682,  1529,  1815,  2634,
    1183, -1177,  2390,  2061,  1122,   157,  2083,  2080,  2081,  2082,
     737,  2713,  1123,  2552,   163,  1050,  3487,  2887,  3546,  1708,
    3274, -1177,  1815,   760,  3075,    38,  3470,  3471,  1124,  1184,
    2116,    29,  2636,   766,  3076,  1124,  1565,  2031,     3,     4,
    1357,  3049,  2665,  1816,  1817,   803,  1517,  2390,  2104,  2105,
    1122,   164,  1673,  1673,  1673,    42,  2117,  2597,  1937,   800,
    2120,  2121,  3177,  2085, -1177,  1745,  1220,  1816,  1817,    24,
    1728,   804, -1177,  2607,  2074,  2142,  1813,  2143,  3050,  2667,
    2668,  2669,  1124,  2670,  2671,  2672,  2673,  2674,  2675,  1804,
      47,  2569,  2176,   573,  3610,  1221,  2164,   591,  2165,  1729,
    1813,  2247,    48,  2250,  1880,  2666,   807,    38,  2544,  1674,
    1674,  1674,  1497,  1673,  1881,    14,  1122,   592,   816,  1878,
    1122,    15,  2661,  2662,  1222,  2233,  1136,  2677,  1730,  1815,
    1498,  1357,  1854,  1856,  1676,    49,  3492,    42,  1882,  2830,
    1378,   822,  1877,  2036,  1501,  2037,    20,  2038,  1879,  2039,
    1461,  2040,    49,  2132,  1673,  2041,    34,  1137,   947,  1388,
    1379,  2663,  1389,   830,  3493,    45,  2710,  2711,  2831,  3535,
    1674,  2637,    47,  1186,  1816,  1817,  2638,  2093,  3115,  1815,
    3225,  1226,  2131, -1177,    48,  2131,  2131,  2131,  2131,  2131,
    2131,  2131,  2131,  2131,  2131,    24,  2754,  2804,   190,  2774,
    3226,  2825,    38,   499,  2961,  2924,   831,  1813,  2796,  3398,
    2515,  1674,   571,   634,  1138,   847,  2826,    49,  1197,   662,
    1209,  1187,   600,  2349,  1816,  1817,  1066,  1231,   600,   641,
    1067,  2836,    42,  2838,  2917,  2919,  2920,  3188,  3193,  2808,
     851,  1090,  2131,  2131,  1474,  1139,  1735,  2816,  2730,  2818,
    2689,   861,  2691,  2692,  3100,  2253,  3185,  1813,  3615,  2261,
      45,  1474,  2093,  1735,  2667,  2668,  2669,    47,  2670,  2671,
    2672,  2673,  2674,  2675,  2545,  2288,  1066,  2291, -1677,    48,
    1067,   602,  1688,  1994,  1691,  1689,  3234,  1692,  1994,  2030,
     870,  1994,  2031,  3790,  1079,  2043,   876,  1188,  2044,  2854,
     585,  3634,  3058,  2870,  2045,   880,  2394,  2044,  2783,  2784,
    2077,  2786,    49,  2078,  3091,  3092,  2252,  2277,   811,  1357,
     812,  2280,  2273,  2903,  1049,  2078,  1486,  1487,    38,  3256,
    3257,  2132,  2132,  3260,  2178,  3261,  2179,  2319,   916,  2367,
    2320,  2665,  2368,  1189,  2301,  1190,  2464,  1983,  1984,  2465,
    1673,  2503,  2313,  2500,  2439,  1847,  2501,  2180,    42,  2267,
    2268,  2448,  2449,  2450,  2451,  2452,  2453,  2601,  2617,  2635,
    2044,  2618,  2031, -1232, -1232,    34,  2327,  2645,   912,  2546,
    2031,  2354,   926,  3199,  2969,  1143,    45,  2534,  2535,  1192,
    3121,  2648,  1775,    47,  2031,   923,  2350,   574,  2330,  2652,
    1226,  1474,  2031,  1118,  2666,    48,  3663,  1674,  1146,   928,
    2845,  1995,   602,   933,  2371,  2653,  1147,  2391,  2031,  1474,
     602,  1735,   602,  2679,  1194,   934,  2031,  2695,  3397,  2698,
    2031,  2759,  2699,   935,  2760,  2407,  2523,  2823,   575,   936,
    2824,  2850,  2967,  2412,  2851,  2968,  3028,  2447,  2979, -1928,
    3321,  2980,  2425,   937,  2131,  2447,  2181,  2989,  1196,  2429,
    2990,  2182,   939,   687,  3062,  1148,  2183,  2031,  2478,  2547,
    2957,  3269,  3270,  2585, -1209,  2587,   938,  1673, -1209,  1673,
      15,  2769,  2770,  3098,  3179,  3180,  3099,   942,  3105,  3027,
     573,  3106,  1053,  3030,  3535,  3032,  1055,  3034,  3035,  2477,
    2734,   943,  2735,   683,  1673,  2508,  3040,  3117,  1059,  3066,
    2031,  2934,    14,  2736,  2949,  2737,  2952,  3852,    15,  3853,
     688,  3181,  3584,  1090,  2044, -1165,  2935,  2538,  3071,  3097,
   -1928,   157,  2522,   841,  1674,  3248,  1674,  1060,  3249,  3403,
   -1209,  3059,  2078,    20,  2544,  2506,  3434,  2556,  3441,  3435,
    1061,  2044,  2157,  3093,    24,  2160,  2936,  3442,  2937,  1065,
    2044,  1674,  1136,  2667,  2668,  2669,  1073,  2670,  2671,  2672,
    2673,  2674,  2675,  1449,  1450,  3517,  2995,   841,  3518, -1928,
    2184,  1080,   751, -1209,  3252,  3543,  1087,  1443,  1357,  2185,
   -1928,   689,    24,  1137, -1928,  1088,  1238,  2132,  3255, -1928,
    3548,  1090,  3550,  2968, -1928,  2968,  1097, -1928,  1099, -1928,
    3809,    29,  1091,  3563,  3565,  1525,  3564,  2031,  1526,  3141,
    3143,  2132,  2132,  1994,  3017,  1098,  3020,  2738,  3045,  2938,
    1118,  2609,  2131,  2131,  3571,  1527, -1928,  2078,  3618,  3632,
    1113,  3619,  3633,  1529,  1995,  1178,  3664,  2767,  1530,  3665,
    1138,  1153,  3057,  2753,  2888,  1176, -1928,  3669,  3072,  1135,
    1357,  3077,  3078,  3079,  3080,  3081,  3082,  3083,  3084,  3085,
    3086,  3671,  2775,  2776,  2968,  3621,  1042,  1219,  1224,  3183,
     947,  1139,  3675,  2663,  1234,  2078,  3729,    38,  1239,  1564,
    2939,   683,  1241,  3733,  1243,  2940,  3734,  2889,  1246, -1928,
    3404,   506,   690,  3738,  1251,  3177,  1357, -1928,  3739,  3740,
    2545,  2078,  2699,  3741,  1253,  1260,  2031,    42,  3123,  3124,
    1525,  2890,  1263,  1526,  3756,    38,  3758,  2078,  1124,  2078,
    2941,   947,  1301,  1297,  2663,  1515,  3759,  1303,  3850,  2078,
    2891,  3851,  2942,  3861,  1307,    45,  3851,  1311,  1529,  2176,
   -1928,  3405,    47,  1530,  -160,    42,  1315,  2892,  1313,  1326,
    1333,   177,  1343,  1345,    48,  1350,  3342,  1352,  2733,  1351,
    1353,  1354,  2893,  1531,  2739,  2740,  2132,  1532,  1356,  1357,
    1988,   511,  1362,    45,  1365,   841,  1366,  1367,  3402,  1368,
      47,  1370,  1375,  1376,  1377,   616,  1382,  3810,  1533,  1534,
    -770,  1387,    48,  3177,  1416,  1445,  2887,  1451,  2755,  1453,
     602,    34,  1447,  1535,  1454,  1142,  1459, -1331, -1928,  3305,
   -1338,  1143,  2943,  1468,  1471,  3705,  1472,  3707,  1775,  1473,
    1477,    49,  1479,  2781,  1482,    49,  1226,   513, -1328, -1928,
   -1329, -1928, -1928,  1483,  1146,  1536,  1484,  1485,  1537,  1490,
    1492, -1332,  1147,  2767,  2894,  1493,  1297,  1494, -1330,  2778,
    1495,  1538,  2895,  2665,  1539,  1496,  1553,  1503,  1504,  1506,
    1507,  1508,  1509, -1928,  1510,  1568, -1928, -1928, -1928,  1511,
    1512,  1579,  1532,  1588,  2505,  1695,  1564,  1101,  1103,  1722,
    1732,  1735,  2767,  1733,  2896,  1736,  1737,  1764,  2131,  1738,
    1759,  1148,  1673,  1533,  1534,  2547,  2999,  1766,  1767,  1768,
    1769,  1791,  1800,  1792,  2665,  1798,  1810,  1811,  3253,  1812,
    1813,  1822,  2131,  2131,  1823,  1819,  2666,  2962,  1828,  1829,
    3294,  1832,  1833,  1826,  1540,  3388,  2843,  2976,  3362,  1835,
    1842,  1843,  1849,  1850,  1201,  3365,  3366,  2829,  3475,  1858,
    3483,  1859,  2988,  1537,  2839,  1673,  2853,  1867,  1890,  1674,
    1902,  1868,  1874,  1869,  1876,  1905,  1538,  1904,  1912,  1474,
    1464,  1914,  3303,  3304,  1915,  1480,   520,  2666,   521,  1928,
     508,  1938,  1203,  1954,  1136,  1443,  1995,   523,  2447,  1934,
    1995,  2447,  2447,  1971,  3321,  2447,  1976,   525,  1981,  1982,
    1979,  2009,  1986,  3036,  3177,  2447,  3037,  1997,  2011,  2010,
    1259,  2012,  1674,  2025,  2905,  1137,  2026,  2867,  2055,  2067,
    1541,  1542,  1543,  2063,  1544,  1545,  1546,  1547,  1548,  1549,
    2060,  2075,   733,  2088,  2140,  2098,  1526,  2656,  2141,   602,
    2153,  2158,  2099,  1297,  1042,  2162,  2912,  2914,  2163,  1115,
    3426,  2921,  3561,  2905,  2170,  2194,  2220,  2175,  2544,  3449,
    2192,  2238,  2231,  2239,  3368,  3369,  3370,  2966,  2235,  3457,
    2234,  2953,  1138,   688,  2254,  2245,  1136,  2131,   602,  2262,
    2263,  2284,  2272,  1790,  2274,  2667,  2668,  2669,  2266,  2670,
    2671,  2672,  2673,  2674,  2675,  2994,   841,   157,  2986,  2275,
    3472,  2276,  2282,  1139,  3450,  3451,  1297,  1137,  3399,  3400,
    2289,  2292,  2294,  2296,  2297,   157,  3008,  2298,  2300,  2315,
    2303,  2317,  1988,  2310,  2362,  2366,  1988,  2428,  2369,  1544,
    1545,  1546,  1547,  1548,  1549,  2422,  2667,  2668,  2669,  2423,
    2670,  2671,  2672,  2673,  2674,  2675,  2424,  2432,  2433,  2436,
    2438,  2437,  3135,  3136,  2440,  2441,  2442,  2443,  2456,  2444,
    2454,  2460,  2463,  2467,  1138,  2472,  2473,  2474,  2498,  2470,
    2476,  2471,  3620,  1297,  2475,  2502,  2507,   157,  3053,  2513,
    2516,  1873,  2537,  2520,  2539,  2551,  2553,   896,   898,   900,
    1297,  2555,   902,   903,   904,  1139,  3048,  2554,  2581,  3807,
    1140,  2575,   909,  2562,  2582,  2590,  2593,  2595,  1159,  2596,
    1297,  2600,  2603,  2604,  1206,  2767,  1995,  3427,  3060,  2605,
    2606,  2615,  2089,  2969,  2545,  2608,  2627,  2631,  3674,  1141,
     918,  2633,  1297,    34,  2650,  2646,  2031,  1142,  2714,  2748,
    2647,  2729,  2785,  1143,  3464,  3465,  2649,  3467,   683,  1443,
    1144,  3575,  2651,  1161,  2654,  2655,  2657,  2685,  1145,  3112,
    2742,  2660,  2782,  2678,  2684,  2686,  1146,  3502,  2709,  2687,
    3551,  3698,  3552,  3553,  1147,  3703,  3704,  2694,  2788,  2797,
    2798,  1297,  3476,  3556,  2707,  2708,  1673,  2722,  2787,  2802,
    2803,  2732,  1515,  3131,  3132,  3133,  3134,  2815,  2747,  2817,
    2792,  2827,  3152,  2828,  1162,  2793,  2840,  2841,  2794,  2844,
    2846,  1163,  2855,  2856,  1164,  2871,  3475,  2857,  2858,  2877,
    2878,  2859,  2860,  1148,  2907,    34,  2861,  2862,  2863,  1142,
    3702,  3699,  2864,  2865,  2879,  1143,  2880,  3275,  2881,  1136,
    2882,  2910,  1775,  1674,  1921,  2922,  2925,  2911,  2923,  2926,
    1226,  2947,  2954,  2958,  2960,  3300,  2974,  2978,  1146,  2987,
    2983,  2977,  2984,  3007,  3011,  1165,  1147,  2972,  3542,  3009,
    1137,  3013,  3307,  3014,  3558,  3021,  2905,  3024,  3542,  3026,
    3031,  3042,  3033,  3182,  3043,  3044,  3055,  3047,  1556,  3052,
    3065,  3056,  3217,  2681,  3216,  3218,  2663,  3219,  3572,  3573,
    3677,   602,  3107,  1461,  2680,  1519,  3119,  3094,  3095,  3096,
    3120,  3158,  3128,  3138,  3161,  1148,   602,  3170,  3144,  2547,
    1166,  3155,  2447,  3156,  3164,  1443,  3184,  1138,  2447,  2447,
    2447,  2447,  2447,  2447,  3200,  3201,  3186,  1995,   841,  3211,
    3194,  3212,  1995,  3222,  3227,  1995,  3229,  3213,  3214,  3215,
    2753,  3237,  3238,  3271,  2999,  1167,  1297,  3684,  1139,  3653,
    3299,  3235,  3272,   602,  3306,  3292,  3672,  3302,  1443,  3309,
    3325,  3273,  1443,  1443,  3329,   906,   907,  3308,  3279,  3281,
    3283,  3285,  2044,  3311,  1207,  3330,  3268,  3332,  1169,  3312,
    3339,  1402,  3593,  3340,  1404,  3353,  1406,  3688,  1408,  3361,
    1410,  3372, -1930,  3278,  1414,  1122,  3343,  3367,  3346,  3375,
    3380,  3389,  3605,  1208,  3377,  3356,  3384,  3390,  3385,  3745,
    3391,  3415,  2372,  3827,  3416,  3418,  3395,  3419,  3429,  3431,
    3444,  2373,  2374,  2375,  3436,  3445,  3446,  3468,  3334,  3473,
    3452,  3458,  3461,  3469,  3411,  3412,  3413,  3414,  3481,  3488,
    3263,   751,  3494,  3673,  3495,  3491,  3503,  3511,  3507,  3513,
    3516,  3519,  3523,  3532,  3533,  3540,  3545,  3670,  3555,  3559,
    3560,  3567,  3562,  1988,  3568,  2376,  3581,  3577,  1988,  3569,
    3570,  1988,  3583, -1930,  3585,   611,  3587,   613,    34,  3597,
    1774,   619,  1142,  3600,  3613,   629,   635,   611,  1143,   642,
    3607,   635,   635,  3614,   667,  1775,   670,   667,  3622,  3608,
    3298,  3629,  3631,  1226,  3640,  3641,  3657,  3643,  3655,  3656,
    3658,  1146,  3659,  3371,  2377,  3683,   689,  3714,  3718,  1147,
    3722,  3691, -1930,  3724,  3737,  1525,  3709,  3727,  1526,  3731,
    3743,  3438,  3438, -1930,  3732,  3744,  3742, -1930,  3749,  1383,
    3476,  3700, -1930,  3761,  3751,  1527,  3770, -1930,  3764,  3766,
   -1930,  3754, -1930,  1529,  2378,  1159,  3760,  3773,  1530,  3798,
    3146,  1160,  3829,  3789,  3792,  3762,  3794,  3763,  1148,  3819,
    2379,  2380,  2381,  2382,  2383,  3846,  2384,  3849,  3466, -1930,
    3855,  1875,  1092,  3806,  3859,  2504,  3197,  1587,  2757,  3824,
    2361,  2884,  3430,  1134,  3616,  3474,  3710,  3425,  3642, -1930,
    1161,  2318,  3327,  3500,  3652,  2790,  1790,  2325,  2385,  3428,
    2602,  3591,  3795,  3826,  3767,  3765,  3804,  1297,   721,   726,
     728,  3328,   726,  2308,   721,   735,   667,  3668,   753,  1970,
     735,   602,   667,  3220,   667,  3447,  2848,  3753,   726,   735,
     667,  1951, -1930,  2479,  2963,  3828,  3539,  3860,  3856,  3490,
   -1930,  1162,  3489,  2955,  3606,  2908,  3805,   602,  1163,  3757,
    1933,  1164,  3609,   618,  1434,  3686,  3335,  1995,  3455,  3456,
    3736,   843,  3336,  3459,  3460,  3453,  2323,  3373,  2447,  2447,
    3812,  2386,  3857,  1531,  2248,  1062,  3462,  1532,  3635,  2249,
    3315,  2034,   841, -1930,  1159,  3054,  1525,  3479,  3480,  1526,
    1160,  3484,  3485,  2761,  1693,  1159,  2765,  2387,  1533,  1534,
    1086,  1160,  1165,  2271,  2388,  1719,   751,  2389,  2773,  1718,
    3497,  2777,  2265,  1535,  1529,  2270,  2244,  1723,  2741,  1530,
    2558,  3019,  2767,  3547,  1297,  1186,   751,  1070,   616,  1161,
     839,  2468,   602,  2762,  3313,  3111,  3676,  3101,  3781,  1995,
    1161,  3780,  2768,  3515,  3788,  1536,   157,  3508,  1537,  2727,
    2642, -1930,  2725,  2620,     0,  2219,     0,  1166,     0,  3604,
       0,  1538,     0,     0,  1539,     0,     0,     0,     0,     0,
    3534,     0, -1930,  1187, -1930, -1930,     0,     0,     0,     0,
    1162,  3594,     0,     0,     0,     0,     0,  1163,  3625,  1790,
    1164,  1162,  1167,  1988,     0,     0,   733,     0,  1163,     0,
       0,  1164,     0,     0,     0,     0, -1930,  2712,     0, -1930,
   -1930, -1930,     0,     0,     0,     0,  1042,     0,     0,     0,
       0,  1229,     0,     0,     0,  1169,     0,     0,  2492,     0,
       0,     0,     0,     0,  1540,     0,     0,  1995,     0,     0,
       0,  1165,  1122,     0, -2012,     0,     0,     0,  1532,  1188,
    1230,     0,  1165,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1533,
    1534,     0,     0,     0,     0,     0,  3660,     0,     0,     0,
       0,     0,  2372,  2905, -2012,     0,     0,     0,  1297,     0,
    3694,  2373,  2374,  2375,     0,  1189,  1166,  1190,     0,     0,
    2447,     0,     0,     0,  3617,  1159,     0,  1191,   602,     0,
       0,  1160,     0,     0,     0,     0,     0,     0,     0,  1537,
    1541,  1542,  1543,     0,  1544,  1545,  1546,  1547,  1548,  1549,
       0,  1167,  1538,  3438,     0,  2376,     0,  2702,   774,     0,
       0,  1192,  1167,   667,     0,   721,     0,     0,     0,   728,
    1161,   726,     0,     0,   735,  3706,   753,  3708,   735,   819,
    1168,   751,  1525,     0,  1169,  1526,   726,     0,   735,     0,
       0,  1193,     0,     0,     0,  1169,  1194,   667,     0,  2493,
       0,     0,  1527,   842,  2377,     0,     0,   721,     0,  1170,
    1529,   728,  1122,     0,   721,  1530,     0,   753,     0,     0,
    1195,  1162,     0,     0,     0, -2012,     0,     0,  1163,     0,
    1196,  1164,   726,     0,     0,     0,     0,   890,     0,     0,
       0,     0,     0,     0,  2378,     0,     0,     0,     0,     0,
       0,  3772,     0,     0,     0,     0,     0,     0,  1995,     0,
    2379,  2380,  2381,  2382,  2383,     0,  2384,     0,     0,     0,
     841,     0,     0,     0,   667,     0,     0,     0,     0,   667,
    3796,     0,  1165,     0,     0,     0,     0,     0,  3769,   667,
     932,     0,     0,     0,     0,     0,     0,     0,  2385,     0,
       0,     0,     0,     0,     0,     0,     0,  1037,     0,   667,
     635,     0,   842,     0,   635,  1544,  1545,  1546,  1547,  1548,
    1549,     0,     0,     0,  3797,     0,   667,     0,     0,     0,
     667,     0,     0,  1072,  2494,     0,     0,  1166,  1037,     0,
    1531,     0,     0,     0,  1532,     0,     0,     0,   667,     0,
    1790,  2325,     0,  2325,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1533,  1534,     0,     0,     0,
       0,  2386,  1167,  2495,     0,     0,     0,     0,  1524,  3858,
    1535,     0,     0,  1525,     0,     0,  1526,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1297,  2387,  1297,     0,
       0,   726,   726,  1527,  2388,  1169,  1528,  2389,     0,     0,
       0,  1529,  1536,     0,     0,  1537,  1530,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3845,     0,  1538,     0,
    1170,  1539,     0,     0,     0,     0,     0,   721,     0,   157,
    3817,  3814,  3815,  3816,   721,     0,     0,   753,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3838,     0,   726,
       0,     0,     0,     0,     0,     0,     0,     0,  1297,     0,
    3844,  3817,  3814,  3815,  3816,   726,   726,     0,     0,     0,
       0,     0,  3837,     0,     0,     0,     0,     0,     0,   667,
     667,   667,   726,  2325,   721,     0,     0,     0,     0,     0,
       0,  1540,  3838,     0,     0,     0,     0,     0,     0,     0,
    3838,     0,     0,   157,  3817,  3814,  3815,  3816,     0,   726,
     726,     0,     0,     0,     0,     0,  1525,  3837,     0,  1526,
       0,     0,  2325,     0,     0,  3837,     0,     0,   842,     0,
       0,  1531,  1037,     0,     0,  1532,  1527,     0,     0,  1297,
       0,   842,     0,     0,  1529,     0,     0,     0,     0,  1530,
       0,     0,     0,  1297,     0,     0,  1533,  1534,     0,     0,
       0,     0,     0,  1419,  1419,     0,  2325,   775,   667,     0,
     611,  1535,     0,     0,     0,     0,     0,  1541,  1542,  1543,
       0,  1544,  1545,  1546,  1547,  1548,  1549,     0,  1452,  2236,
       0,   667,     0,     0,  1458,  2237,     0,     0,     0,   776,
       0,  1297,     0,  1536,     0,  1037,  1537,     0,     0,     0,
       0,     0,   777,     0,     0,     0,     0,     0,     0,  1538,
     778,     0,  1539,     0,   779,     0,     0,     0,     0,     0,
       0,     0,     0,  1037,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   780,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1037,  1037,     0,  1037,  1297,   781,     0,     0,     0,     0,
       0,     0,     0,     0,  1531,     0,     0,     0,  1532,     0,
    1037,     0,     0,  1297,     0,     0,     0,     0,     0,     0,
       0,     0,  1540,     0,     0,     0,     0,     0,   782,  1533,
    1534,     0,   842,     0,     0,     0,     0,     0,  1297,   842,
     842,     0,     0,     0,  1535,   667,     0,     0,  1037,   783,
       0,     0,     0,  1680,     0,  1687,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1297,     0,   784,     0,  1536,     0,     0,  1537,
    1037,     0,     0,     0,  1037,  1037,     0,     0,     0,     0,
       0,     0,  1538,     0,     0,  1539,     0,     0,     0,     0,
    3150,     0,     0,     0,     0,   635,     0,     0,  1541,  1542,
    1543,     0,  1544,  1545,  1546,  1547,  1548,  1549,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   635,     0,     0,
     785,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1797,     0,     0,     0,     0,     0,   667,     0,  1525,
       0,     0,  1526,     0,     0,     0,     0,   177,     0,     0,
     753,     0,     0,     0,     0,  1540,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2325,     0,  1529,     0,     0,
       0,   786,  1530,  1525,     0,   787,  1526,   788,     0,     0,
       0,     0,     0,   789,     0,     0,     0,   726,   726,   726,
     726,   667,     0,  1527,     0,     0,   735,     0,   635,     0,
       0,  1529,     0,     0,     0,     0,  1530,     0,     0,     0,
       0,  1886,   790,   667,   791,     0,     0,     0,   792,   726,
     726,     0,     0,     0,     0,   726,   793,     0,     0,     0,
       0,   794,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1541,  1542,  1543,     0,  1544,  1545,  1546,  1547,  1548,
    1549,     0,     0,   795,     0,  2161,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   735,     0,     0,     0,     0,     0,   726,
     726,   726,   726,     0,  1297,     0,     0,  1531,   735,     0,
       0,  1532,     0,     0,     0,     0,  1886,     0,     0,     0,
       0,     0,     0,     0,     0,  1996,     0,   721,     0,     0,
       0,     0,  1533,  1534,   728,     0,   721,     0,     0,     0,
    1790,  1531,     0,     0,   753,  1532,     0,  1535,     0,   667,
       0,     0,  1525,     0,     0,  1526,     0,     0,   667,     0,
     735,     0,     0,     0,   726,   726,  1533,  1534,     0,   667,
       0,   890,  1527,     0,     0,     0,     0,     0,     0,     0,
    1529,  1535,  1537,     0,     0,  1530,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1538,     0,     0,  1419,     0,
       0,     0,     0,     0,     0,     0,   721,     0,     0,     0,
     667,   667,     0,  1536,     0,     0,  1537,     0,  2066,     0,
       0,     0,   667,     0,     0,     0,     0,     0,     0,  1538,
       0,     0,  1539,     0,     0,   611,   611,     0,     0,  2091,
       0,  1037,     0,  1037,     0,     0,     0,     0,     0,     0,
    1037,     0,     0,  1037,     0,     0,  1037,     0,     0,  1297,
       0,     0,     0,     0,  1037,  1037,     0,     0,  1540,     0,
    1297,     0,  1037,     0,   753,  1037,  1037,  1037,  1037,     0,
       0,     0,     0,     0,     0,  1037,  1037,     0,  1037,     0,
    1037,     0,     0,  1037,     0,     0,     0,     0,     0,     0,
       0,     0,  1540,     0,     0,     0,     0,     0,     0,  1037,
    1531,     0,     0,  1037,  1532,     0,     0,  1037,     0,     0,
       0,  1037,     0,  1037,  1037,  1037,  1037,  1037,  1037,  1037,
    1037,  1037,     0,  1037,     0,  1533,  1534,   667,  1037,     0,
    1037,     0,     0,     0,  1297,     0,   667,     0,     0,     0,
    1535,     0,     0,     0,  1297, -2012, -2012,     0,  1544,  1545,
    1546,  1547,  1548,  1549,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1536,     0,     0,  1537,     0,     0,  1541,  1542,
    1543,     0,  1544,  1545,  1546,  1547,  1548,  1549,  1538,     0,
       0,  1539,  2909,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1525,     0,     0,  1526,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1527,     0,     0,     0,     0,
       0,     0,     0,  1529,     0,     0,     0,     0,  1530,     0,
       0,     0,     0,  1687,     0,     0,     0,     0,     0,     0,
     667,  1540,   667,     0,  1037,     0,     0,     0,     0,  1525,
       0,     0,  1526,     0,     0,     0,     0,     0,     0,     0,
    3150,     0,     0,     0,     0,     0,     0,     0,     0,  1527,
       0,     0,     0,     0,     0,     0,     0,  1529,  1297,     0,
       0,     0,  1530,     0,   735,     0,     0,     0,   735,   728,
       0,     0,     0,     0,     0,   611,     0,   611,     0,     0,
       0,     0,     0,     0,  1297,     0,     0,     0,     0,     0,
       0,   735,  1037,     0,     0,     0,     0,     0,     0,   735,
       0,     0,     0,     0,     0,     0,     0,  1541,  1542,  1543,
       0,  1544,  1545,  1546,  1547,  1548,  1549,     0,     0,     0,
       0,  3110,     0,   735,     0,  1797,     0,     0,     0,     0,
       0,  2331,     0,  1531,     0,     0,  2340,  1532,     0,     0,
       0,     0,   667,   735,     0,     0,     0,     0,     0,     0,
       0,     0,  2325,     0,  2364,  2364,     0,     0,  1533,  1534,
     728,   735,     0,     0,   735,     0,     0,     0,     0,     0,
       0,     0,     0,  1535,   726,     0,     0,     0,     0,     0,
       0,     0,   735,     0,     0,     0,  2408,  1531,     0,     0,
     735,  1532,     0,     0,     0,     0,     0,     0,     0,   735,
       0,     0,     0,     0,     0,  1536,   735,     0,  1537,     0,
       0,     0,  1533,  1534,     0,     0,     0,     0,     0,     0,
       0,  1538,   726,     0,  1539,     0,     0,  1535,     0,   726,
     726,   726,   726,   726,   726,  2325,     0,     0,     0,     0,
       0,     0,     0,     0,  1037,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1536,
    1297,     0,  1537,     0,     0,     0,  2364,     0,     0,     0,
     667,     0,     0,     0,   611,  1538,     0,     0,  1539,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1540,     0,     0,     0,  2519,     0,
       0,     0,     0,  1297,   726,  2533,     0,  1297,  1297,     0,
       0,     0,     0,     0,   842,     0,     0,     0,     0,  1996,
    2561,     0,     0,     0,  2561,  2574,     0,     0,     0,  1037,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   726,  2364,   726,  2364,     0,     0,     0,  1540,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   842,     0,
       0,     0,     0,  1037,     0,  3150,     0,     0,     0,     0,
       0,     0,     0,     0,  1525,     0,  1419,  1526,     0,     0,
    1541,  1542,  1543,     0,  1544,  1545,  1546,  1547,  1548,  1549,
       0,     0,   735,     0,  3163,     0,     0,     0,     0,  1037,
       0,     0,  1529,     0,     0,     0,     0,  1530,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     735,     0,     0,     0,     0,  1525,     0,     0,  1526,     0,
    1037,  1037,     0,     0,  1541,  1542,  1543,     0,  1544,  1545,
    1546,  1547,  1548,  1549,     0,  1527,     0,     0,  3172,     0,
       0,     0,     0,  1529,  1525,     0,     0,  1526,  1530,     0,
    1037,  1037,     0,     0,     0,  1037,     0,     0,     0,     0,
       0,     0,     0,     0,  1527,     0,     0,  1037,  1037,  1037,
    1037,     0,  1529,     0,     0,     0,     0,  1530,     0,  1037,
       0,     0,  1037,     0,  1037,  2706,     0,     0,     0,     0,
       0,     0,     0,     0,  1037,  1037,  1525,  1037,     0,  1526,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1037,     0,  1037,     0,   753,     0,  1037,     0,     0,     0,
       0,     0,  1531,     0,  1529,     0,  1532,     0,     0,  1530,
       0,     0,  1037,     0,     0,     0,   667,     0,     0,     0,
       0,     0,  1996,     0,  1037,  1037,  1037,  1533,  1534,     0,
       0,     0,     0,     0,     0,     0,   842,     0,     0,  1037,
       0,     0,  1535,     0,     0,  1687,     0,  1037,     0,     0,
       0,     0,     0,  1531,     0,     0,  1037,  1532,     0,     0,
       0,  1037,     0,     0,     0,   667,     0,     0,  1037,     0,
       0,     0,     0,     0,  1536,     0,   735,  1537,  1533,  1534,
       0,     0,  1531,     0,     0,     0,  1532,     0,     0,     0,
    1538,     0,     0,  1535,  1037,     0,  2364,     0,     0,     0,
    1419,     0,     0,     0,     0,     0,     0,  1533,  1534,     0,
       0,     0,     0,     0,   491,     0,     0,     0,     0,     0,
     533,   491,  1535,     0,     0,  1536,     0,   572,  1537,   491,
       0,     0,     0,     0,  1531,   491,     0,   621,  1532,     0,
       0,  1538,     0,     0,  1539,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1536,   681,     0,  1537,     0,  1533,
    1534,     0,     0,  1540,   735,     0,     0,     0,     0,     0,
    1538,   735,     0,  1539,  1535,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1537,
       0,     0,     0,     0,  1540,     0,     0,     0,     0,     0,
       0,     0,  1538,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   735,     0,     0,     0,     0,     0,
       0,     0,     0,  1540,  2364,  2364,     0,     0,     0,  1541,
    1542,  1543,     0,  1544,  1545,  1546,  1547,  1548,  1549,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   755,     0,   757,     0,
     759,     0,   761,     0,     0,  1540,     0,     0,     0,     0,
    1541,  1542,  1543,     0,  1544,  1545,  1546,  1547,  1548,  1549,
       0,     0,     0,     0,  3378,  1419,   667,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   667,     0,     0,  1541,
    1542,  1543,     0,  1544,  1545,  1546,  1547,  1548,  1549,     0,
       0,   667,     0,  3410,     0,     0,     0,   842,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2561,     0,
       0,  3010,     0,     0,  1996,     0,     0,     0,  1996,     0,
       0,     0,     0,     0,  3023,     0,     0,  1037,     0,     0,
       0,  1541,  1542,  1543,     0,  1544,  1545,  1546,  1547,  1548,
    1549,  1525,   667,     0,  1526,   667,     0,     0,   735,     0,
       0,     0,  3041,     0,     0,     0,     0,     0,     0,     0,
     721,  1527,     0,   735,     0,     0,     0,     0,     0,  1529,
    2066,     0,     0,     0,  1530,     0,     0,     0,     0,     0,
       0,     0,     0,   667,     0,   735,     0,     0,     0,     0,
       0,     0,     0,  1037,     0,     0,     0,     0,     0,     0,
       0,     0,  1037,     0,     0,     0,     0,     0,  1037,     0,
    1037,     0,     0,     0,     0,     0,  1037,     0,     0,  1037,
    1037,  1037,  1037,  1037,  1037,  1037,  1037,  1037,  1037,     0,
       0,     0,  1037,  1037,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1037,     0,     0,     0,     0,
       0,  1037,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1037,     0,     0,  1037,     0,  1037,     0,     0,     0,
       0,     0,     0,     0,     0,  1037,  1037,  1037,     0,     0,
       0,  1037,     0,     0,  1037,     0,     0,     0,     0,     0,
       0,   667,   667,     0,  1037,     0,     0,     0,     0,  1531,
    3148,     0,     0,  1532,  1037,     0,     0,     0,     0,     0,
       0,     0,  1687,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1533,  1534,     0,     0,     0,  1525,
       0,     0,  1526,     0,     0,     0,     0,     0,     0,  1535,
       0,     0,     0,     0,  3178,  1419,  1419,     0,     0,  1527,
     735,     0,     0,     0,     0,     0,     0,  1529,     0,     0,
       0,   802,  1530,     0,     0,     0,     0,     0,     0,  3196,
       0,  1536,     0,     0,  1537,   820,   821,     0,     0,     0,
     823,     0,     0,     0,     0,     0,     0,  1538,     0,   837,
    1539,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   846,     0,     0,     0,     0,     0,     0,
       0,   735,     0,   735,     0,   865,     0,     0,   867,     0,
     869,     0,   872,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   842,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   491,     0,     0,
    1540,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1525,     0,     0,  1526,     0,     0,   667,     0,     0,     0,
     929,     0,   930,     0,     0,     0,     0,  1531,  1037,     0,
    1527,  1532,     0,     0,   667,     0,     0,     0,  1529,     0,
       0,     0,     0,  1530,     0,     0,     0,     0,     0,     0,
       0,   667,  1533,  1534,     0,     0,     0,     0,     0,     0,
    2519,     0,     0,     0,     0,     0,  3322,  1535,     0,     0,
    1797,     0,  3041,     0,     0,   681,     0,     0,     0,     0,
       0,     0,     0,  1037,  1037,     0,  1541,  1542,  1543,     0,
    1544,  1545,  1546,  1547,  1548,  1549,     0,     0,     0,  1536,
    3566,  2561,  1537,     0,     0,  1996,  1525,     0,     0,  1526,
    1996,     0,     0,  1996,  2519,  1538,  3358,     0,  1539,     0,
       0,     0,     0,  2364,     0,  2364,  1527,     0,     0,     0,
       0,     0,     0,     0,  1529,     0,     0,     0,     0,  1530,
       0,     0,   735,     0,     0,     0,     0,     0,     0,  1525,
       0,     0,  1526,     0,     0,  1037,     0,     0,     0,     0,
       0,     0,     0,  1233,     0,     0,     0,     0,  1531,  1527,
       0,     0,  1532,     0,     0,  1244,     0,  1529,     0,     0,
       0,     0,  1530,     0,  1250,     0,     0,     0,  1540,     0,
    1252,  1037,     0,  1533,  1534,     0,     0,     0,  1037,  1037,
       0,  1299,     0,     0,     0,     0,  1037,  1037,  1535,     0,
       0,  1037,     0,     0,     0,     0,     0,  1037,  1037,     0,
       0,  1037,     0,   667,   667,   667,   667,     0,     0,     0,
    1336,     0,  1037,     0,     0,     0,     0,     0,  3422,     0,
    1536,     0,     0,  1537,     0,  1037,     0,     0,     0,     0,
       0,     0,     0,   753,     0,     0,  1538,     0,     0,  1539,
       0,     0,   611,     0,  1531,  1037,     0,     0,  1532,   726,
     726,     0,     0,     0,  1541,  1542,  1543,     0,  1544,  1545,
    1546,  1547,  1548,  1549,  3448,     0,     0,     0,  3589,  1533,
    1534,   491,   735,   491,     0,   491,     0,   491,     0,   491,
     491,   491,     0,   735,  1535,     0,   491,  1531,     0,     0,
       0,  1532,     0,     0,     0,     0,   726,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1540,
       0,     0,  1533,  1534,     0,     0,  1536,     0,     0,  1537,
       0,     0,     0,   842,     0,     0,     0,  1535,     0,     0,
       0,  1419,  1538,     0,     0,  1539,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1536,
       0,     0,  1537,     0,  1037,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1538,     0,     0,  1539,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1541,  1542,  1543,     0,  1544,
    1545,  1546,  1547,  1548,  1549,  1540,     0,     0,     0,  3627,
       0,     0,     0,     0,     0,   667,     0,     0,     0,     0,
       0,  1037,     0,     0,     0,  1996,     0,     0,  3358,     0,
       0,     0,     0,     0,     0,  1525,  1296,     0,  1526,     0,
       0,     0,     0,     0,     0,     0,     0,   735,  1540,     0,
       0,     0,  1037,     0,     0,   723,     0,     0,     0,     0,
       0,   723,     0,  1529,   681,     0,     0,     0,  1530,     0,
       0,     0,     0,     0,     0,     0,  1037,  1037,     0,     0,
    1037,     0,     0,     0,     0,     0,     0,  1037,  1037,     0,
       0,  1541,  1542,  1543,     0,  1544,  1545,  1546,  1547,  1548,
    1549,   735,     0,   735,     0,  3771,     0,  3178,   753,   726,
       0,     0,  1763,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   721,   753,     0,
       0,     0,     0,     0,  1541,  1542,  1543,     0,  1544,  1545,
    1546,  1547,  1548,  1549,     0,     0,     0,     0,  3847,     0,
       0,     0,     0,  1419,     0,     0,  2723,     0,     0,  1296,
       0,     0,     0,     0,   721,     0,     0,   667,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2364,
       0,  1797,     0,     0,     0,     0,     0,     0,     0,     0,
    3322,     0,     0, -2012,     0,   667,     0,  1532,     0,     0,
       0,     0,     0,     0,   726,  3178,     0,     0,  1024,     0,
    1525,     0,     0,  1526,     0,     0,     0,     0,  1533,  1534,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1527,  1037,     0, -2012,  1037,     0,  1037,     0,  1529,  1083,
       0,     0,     0,  1530,     0,     0,     0,     0,     0,  3682,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   726,     0,     0,     0,     0,     0,     0,  1537,   667,
       0,     0,  1037,     0,     0,     0,     0,     0,     0,     0,
    1931,  1538,   726,   726,   726,   726,  1574,     0,     0,     0,
       0,   842,  1953,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1037,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2004,     0,     0,     0,  2008,     0,     0,     0,     0,     0,
       0,     0,     0,  2017,     0,  2019,  1296,  2020,     0,     0,
       0,     0,  2021,     0, -2012,  1037,     0,     0,     0,     0,
       0,     0,     0,   753,     0,     0,     0,     0,  1531,     0,
       0,     0,  1532,     0,     0,     0,     0,     0,     0,   491,
       0,   491,     0,   491,     0,   491,  1296,   491,     0,     0,
       0,   491,   723,  1533,  1534,     0,   726,     0,     0,   721,
       0,     0,     0,     0,     0,     0,  3178,     0,  1535,  1296,
       0,     0,     0,     0,     0,  3682,     0,     0,  1037,  1037,
       0,   735,     0,     0,     0,     0,     0,     0,   721,     0,
       0,     0,   726,     0,   723,     0,     0,     0,     0,     0,
    1536,   723,     0,  1537,  1544,  1545,  1546,  1547,  1548,  1549,
       0,     0,  1525,     0,  1037,  1526,  1538,     0,     0,  1539,
       0,     0,     0,     0,  1037,     0,     0,     0,     0,     0,
       0,     0,  1527,     0,     0,     0,  1296,     0,  3839,  1525,
    1529,     0,  1526,     0,     0,  1530,     0,     0,     0,     0,
       0,     0,     0,  1296,     0,     0,     0,  1525,     0,  1527,
    1526,     0,     0,  2255,     0,     0,     0,  1529,     0,     0,
       0,     0,  1530,  1296,     0,     0,  1466,  1527,  1037,     0,
       0,  1525,     0,  3839,  1526,  1529,     0,   721,     0,  1540,
    1530,  3839,     0,     0,   723,  1296,     0,     0,     0,     0,
       0,     0,     0,     0,  1489,     0,     0,     0,     0,  1529,
       0,     0,     0,  1525,  1530,     0,  1526,     0,     0,     0,
       0,     0,     0,     0,     0,   723,     0,     0,     0,     0,
       0,  1513,  1514,  1527,  1516,     0,     0,     0,     0,     0,
       0,  1529,     0,  2256,  1296,     0,  1530,     0,     0,  2680,
       0,  1554,     0,     0,  2681,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1531,     0,     0,     0,  1532,  1541,  1542,  1543,     0,  1544,
    1545,  1546,  1547,  1548,  1549,     0,     0,  3157,     0,  1590,
       0,     0,     0,     0,     0,  1533,  1534,  1531,     0,     0,
       0,  1532,  3125,     0,     0,     0,     0,     0,     0,     0,
    1535,     0,     0,     0,     0,  1531,     0,     0,     0,  1532,
       0,  1701,  1533,  1534,   723,  1711,  1714,     0,     0,     0,
       0,   723,     0,     0,     0,     0,     0,  1535,     0, -2012,
    1533,  1534,  1536,  1532,     0,  1537,     0,     0,     0,  3822,
       0,     0,  1298,     0,     0,  1535,     0,     0,  1538,     0,
       0,  1539,     0,     0,  1533,  1534,     0,     0,     0,  1536,
    2278,  1531,  1537,     0,     0,  1532,  2283,     0,     0, -2012,
       0,   723,     0,     0,     0,  1538,  2293,  1536,  1539,     0,
    1537,     0,     0,  2299,     0,     0,  1533,  1534,     0,  2304,
       0,     0,     0,  1538,     0,  2314,  1539,     0,     0,     0,
    2316,  1535,     0,     0,  1537,     0,     0,     0,     0,  1296,
       0,     0,     0,     0,  3102,     0,     0,  1538,     0,   723,
       0,  1540,     0,     0,     0,     0,     0,  2332,  2333,  2336,
    2338,     0,     0,  1536,  2345,  2348,  1537,     0,     0,  2351,
       0,     0,  2355,     0,     0,     0,     0,     0,  1540,  1538,
       0,     0,  1539,     0,     0,  1288,     0,     0,     0,     0,
    2392,  1525,     0,     0,  1526,  1298,  1540,     0,  3823,     0,
    2395,     0,  2397,     0,     0,     0,     0,     0,     0,  3103,
       0,  1527,  2409,  2410,  2411,     0,  2413,     0,     0,  1529,
   -2012,     0,   723,     0,  1530,  2426,  2427,  2257,     0,     0,
       0,     0,     0,  2430,  2431,     0,     0,  1541,  1542,  1543,
       0,  1544,  1545,  1546,  1547,  1548,  1549,     0,     0,     0,
     723,     0,  1540,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1541,  1542,  1543,     0,  1544,  1545,
    1546,  1547,  1548,  1549,     0,     0,     0,   723,   723,     0,
     723,     0,  1541,  1542,  1543,     0,  1544,  1545,  1546,  1547,
    1548,  1549,     0,     0,     0,     0,     0,   723,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1288,     0,
    1544,  1545,  1546,  1547,  1548,  1549,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   723,  1672,     0,  1541,  1542,
    1543,     0,  1544,  1545,  1546,  1547,  1548,  1549,     0,  1531,
       0,     0,     0,  1532,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   723,     0,     0,
       0,   723,   723,     0,  1533,  1534,     0,     0,     0,     0,
       0,     0,  1298,     0,     0,     0,     0,  1672,     0,  1535,
       0,     0,     0,     0,  1296,     0,     0,     0,     0,  1296,
    1296,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1296,  2102,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1536,  1298,     0,  1537,     0,     0,     0,     0,     0,
       0,     0,     0,  2124,     0,     0,  2126,  1538,     0,  2137,
    1539,  2629,     0,     0,     0,  1298,  2144,  2149,     0,     0,
       0,  2154,     0,  2658,  2159,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2168,     0,     0,     0,  2174,     0,     0,     0,  2186,     0,
       0,     0,  2193,     0,  2195,  2196,  2197,  2198,  2199,  2200,
    2201,  2202,  2203,     0,  2204,  1288,     0,     0,     0,  1024,
       0,  2227,     0,     0,     0,     0,     0,     0,     0,     0,
    1540,  1525,  1298,     0,  1526,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1296,     0,  1298,
       0,  1527,     0,     0,  2644,  1288,     0,     0,     0,  1529,
       0,     0,     0,     0,  1530,     0,     0,     0,     0,  1298,
       0,     0,     0,     0,     0,     0,     0,     0,  1288,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1298,     0,     0,     0,     0,  1672,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1296,     0,     0,     0,  1541,  1542,  1543,     0,
    1544,  1545,  1546,  1547,  1548,  1549,     0,     0,  1525,     0,
       0,  1526,   723,     0,   723,     0,     0,     0,     0,     0,
    1298,     0,     0,   723,     0,  1288,     0,     0,  1527,     0,
       0,  2688,  2779,  2780,     0,  1083,  1529,     0,     0,     0,
       0,  1530,  1288,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1288,     0,  2800,     0,     0,     0,     0,  1531,
       0,     0,     0,  1532,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1288,     0,     0,     0,     0,     0,
       0,  1296,     0,   723,  1533,  1534,     0,     0,  2819,  2820,
    2821,  2822,     0,  2302,     0,     0,     0,     0,     0,  1535,
       0,     0,     0,     0,  1525,     0,     0,  1526,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   723,     0,
     723,     0,     0,  1288,  1527,     0,     0,   723,     0,     0,
     723,  1536,  1529,   723,  1537,     0,     0,  1530,     0,     0,
       0,   723,   723,     0,     0,     0,     0,  1538,     0,   723,
    1539,     0,   723,   723,   723,   723,  1531,     0,     0,     0,
    1532,     0,   723,   723,     0,   723,     0,   723,     0,     0,
     723,     0,     0,     0,  1290,  2866,     0,     0,     0,     0,
    2868,  1533,  1534,     0,     0,  1298,   723,  1672,     0,     0,
     723,     0,     0,     0,   723,     0,  1535,     0,   723,     0,
     723,   723,   723,   723,   723,   723,   723,   723,   723,     0,
     723,     0,     0,     0,     0,   723,     0,   723,     0,     0,
    1540,     0,     0,     0,     0,     0,     0,     0,  1536,     0,
       0,  1537,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1538,  2466,  2693,  1539,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1531,     0,     0,     0,  1532,  2970,  2971,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1533,  1534,     0,
       0,     0,     0,     0,     0,     0,     0,  1290,  1288,     0,
       0,     0,  1535,     0,     0,     0,  1541,  1542,  1543,     0,
    1544,  1545,  1546,  1547,  1548,  1549,     0,  1540,     0,     0,
       0,     0,     0,  1296,  1296,     0,  1296,     0,     0,  3029,
    2578,     0,     0,     0,  1536,     0,     0,  1537,     0,     0,
       0,     0,  3038,     0,     0,     0,     0,     0,     0,     0,
    1538,   723,     0,  1539,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2599,     0,     0,     0,     0,  1296,
       0,  1296,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1672,     0,     0,     0,     0,     0,
    1024,     0,     0,  1541,  1542,  1543,     0,  1544,  1545,  1546,
    1547,  1548,  1549,     0,     0,     0,     0,     0,     0,   723,
       0,     0,     0,  1540,     0,     0,     0,     0,     0,     0,
       0,     0,  2640,     0,     0,     0,     0,     0,     0,     0,
    1298,  1296,     0,     0,     0,  1298,  1298,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1298,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1296,     0,     0,     0,
       0,     0,  1672,     0,     0,     0,     0,     0,  2149,     0,
    2149,  2149,     0,     0,  1290,     0,     0,     0,     0,     0,
    2700,     0,     0,  2703,     0,  2705,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1296,     0,     0,  1672,  1541,
    1542,  1543,     0,  1544,  1545,  1546,  1547,  1548,  1549,     0,
       0,  2726,  1296,  2728,  1290,     0,     0,  2731,     0,     0,
       0,     0,     0,     0,     0,     0,  1296,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1290,     0,  1296,
       0,     0,     0,  1288,     0,  2227,  2227,  2227,  1288,  1288,
       0,     0,  3195,     0,     0,     0,     0,     0,     0,  1288,
    2758,   723,     0,  1298,     0,     0,     0,     0,  1083,     0,
       0,     0,     0,     0,  1296,     0,     0,  1701,     0,     0,
       0,     0,  2772,     0,     0,     0,     0,     0,     0,  1714,
       0,     0,  3221,     0,     0,     0,     0,  3228,     0,  3230,
    3231,  3232,  3233,     0,  1290,     0,     0,     0,     0,     0,
       0,  1291,     0,     0,     0,  2789,     0,     0,     0,     0,
       0,  1290,     0,     0,     0,     0,     0,     0,  1298,     0,
       0,     0,     0,     0,     0,     0,   723,  1296,     0,     0,
       0,  1290,     0,     0,     0,     0,   723,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1296,     0,     0,     0,
       0,     0,     0,  1290,     0,     0,     0,     0,  3287,  3289,
    3291,     0,  3293,     0,     0,     0,  1288,     0,     0,     0,
     723,  1296,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1290,     0,     0,  1296,   723,     0,     0,     0,
       0,  1293,     0,     0,     0,     0,     0,  1298,     0,     0,
       0,     0,     0,     0,  1291,     0,     0,     0,     0,     0,
       0,  1288,     0,     0,  2800,     0,     0,   723,   723,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3360,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   723,   723,     0,
       0,     0,   723,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   723,   723,   723,   723,     0,     0,
       0,     0,  1672,     0,     0,     0,   723,  1672,     0,   723,
       0,   723,     0,     0,     0,     0,     0,     0,  1296,     0,
       0,   723,   723,     0,   723,     0,     0,  1525,     0,     0,
    1526,     0,     0,     0,     0,     0,     0,   723,     0,   723,
    1288,     0,     0,   723,  1293,     0,     0,  1527,     0,     0,
    2697,     0,     0,     0,     0,  1529,     0,     0,     0,   723,
    1530,     0,     0,     0,     0,     0,     0,     0,     0,   723,
       0,   723,   723,   723,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   723,  1290,     0,     0,
       0,     0,     0,     0,   723,     0,     0,     0,  2227,     0,
       0,     0,     0,   723,     0,     0,     0,     0,   723,     0,
       0,     0,     0,     0,     0,   723,     0,     0,     0,     0,
       0,  1291,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3454,     0,
       0,   723,     0,     0,     0,     0,     0,  1296,     0,  3463,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1291,     0,     0,  3064,     0,     0,     0,     0,  1298,
    1298,     0,  1298,  3067,     0,     0,     0,     0,     0,  3068,
       0,  3069,     0,  1296,  1291,  1531,     0,     0,     0,  1532,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3087,  3088,     0,     0,     0,     0,     0,
    1533,  1534,     0,     0,     0,  1298,     0,  1298,     0,     0,
       0,     0,  2154,     0,     0,  1535,     0,     0,     0,     0,
       0,  1293,  3113,     0,     0,  3116,     0,  3118,     0,     0,
       0,     0,     0,     0,     0,  3510,  3122,     0,  1672,  1672,
    1672,  1291,  3127,     0,     0,  3130,     0,  1536,     0,     0,
    1537,     0,     0,     0,     0,  3137,     0,  3528,  1291,     0,
       0,  1293,     0,  1538,     0,  2227,  1539,     0,  1294,     0,
       0,     0,  1288,  1288,     0,  1288,     0,  1298,  1291,     0,
       0,     0,     0,     0,  1293,     0,     0,     0,     0,     0,
       0,     0,  1296,  1525,  3554,     0,  1526,     0,     0,  1672,
    1291,     0,  1298,  1296,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1527,     0,     0,  2750,     0,  1288,     0,
    1288,  1529,     0,     0,     0,     0,  1530,     0,     0,     0,
       0,     0,  1290,     0,     0,     0,  1540,  1290,  1290,     0,
    1672,  1298,     0,     0,     0,     0,     0,     0,  1290,  1291,
       0,  1293,     0,     0,     0,     0,     0,     0,  1298,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1293,     0,
       0,     0,  1298,     0,     0,     0,     0,  1296,     0,     0,
       0,     0,     0,     0,     0,  1298,     0,  1296,  1293,     0,
    1288,  1294,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   723,     0,     0,     0,   723,     0,     0,     0,     0,
    1293,     0,     0,     0,   723,  1288,     0,     0,     0,     0,
    1298,     0,  1541,  1542,  1543,     0,  1544,  1545,  1546,  1547,
    1548,  1549,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   723,     0,     0,
       0,  1531,     0,     0,  1288,  1532,     0,     0,     0,  1293,
       0,     0,     0,     0,     0,  1290,     0,  2800,     0,     0,
       0,  1288,     0,     0,     0,     0,  1533,  1534,     0,     0,
     723,     0,     0,  1298,     0,  1288,     0,     0,     0,   723,
       0,  1535,     0,     0,     0,   723,     0,   723,  1288,     0,
       0,     0,  1298,   723,  3337,  3338,   723,   723,   723,   723,
     723,   723,   723,   723,   723,   723,     0,     0,     0,   723,
     723,     0,     0,  1536,  1291,     0,  1537,  1298,     0,     0,
    1290,     0,   723,  1288,     0,     0,  1672,     0,   723,  1538,
       0,  1296,  1539,     0,     0,     0,     0,     0,   723,     0,
       0,   723,     0,   723,     0,     0,     0,     0,     0,     0,
       0,  1298,   723,   723,   723,     0,     0,  1296,   723,     0,
       0,   723,     0,     0,     0,     0,  3376,     0,  1294,     0,
       0,   723,     0,     0,     0,     0,     0,     0,     0,  1298,
       0,   723,     0,     0,     0,     0,  1288,  1295,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1540,     0,     0,  1288,     0,     0,  1294,  3392,
    3394,     0,     0,     0,     0,     0,     0,     0,     0,  1290,
       0,   723,  3401,     0,  1293,  1296,     0,     0,  3406,  3407,
    1288,  1294,  3409,     0,     0,     0,     0,     0,     0,  3768,
       0,     0,     0,  2227,     0,  1525,     0,     0,  1526,     0,
       0,     0,     0,  1672,  1298,  1672,  2227,     0,     0,     0,
       0,     0,     0,     0,  1288,     0,     0,     0,     0,     0,
       0,     0,     0,  1529,     0,     0,  3433,     0,  1530,     0,
    1672,     0,     0,     0,     0,     0,     0,     0,  1541,  1542,
    1543,     0,  1544,  1545,  1546,  1547,  1548,  1549,  1294,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1296,     0,
    1295,     0,     0,     0,     0,  1294,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1296,     0,  1294,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1294,     0,     0,
       0,     0,     0,     0,     0,   723,  3126,  1288,     0,  1291,
       0,     0,     0,     0,  1291,  1291,  1296,     0,     0,     0,
    1296,  1296,     0,  1298,     0,  1291,     0,     0,     0,  1525,
       0,     0,  1526,     0,     0,  3498,     0,     0,     0,     0,
       0,     0,     0, -2012,     0,     0,  1294,  1532,     0,  1527,
       0,     0,     0,     0,     0,     0,     0,  1529,     0,  1298,
     723,   723,  1530,     0,     0,     0,     0,     0,  1533,  1534,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   723, -2012,     0,     0,     0,   723,     0,     0,
     723,     0,  3544,     0,     0,     0,     0,     0,     0,     0,
       0,  1290,  1290,     0,  1290,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1537,  1293,
       0,     0,     0,     0,  1293,  1293,     0,     0,     0,     0,
       0,  1538,   723,     0,     0,  1293,  1288,  1295,     0,     0,
       0,     0,  1291,     0,     0,     0,     0,  1290,     0,  1290,
       0,  3574,     0,     0,     0,     0,     0,     0,     0,  3576,
       0,     0,     0,     0,     0,     0,     0,     0,   723,     0,
       0,     0,  1288,     0,     0,   723,   723,  1295,  1298,     0,
       0,     0,     0,   723,   723,     0,     0,  1531,   723,  1298,
       0,  1532,     0,     0,   723,   723,     0,     0,   723,     0,
    1295,     0,     0,     0, -2012,     0,     0,  1291,     0,   723,
       0,     0,  1533,  1534,     0,     0,     0,     0,     0,  1290,
       0,  1294,   723,     0,     0,     0,     0,  1535,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   723,     0,  1290,     0,     0,     0,     0,     0,
       0,     0,  1293,     0,     0,     0,     0,     0,     0,  1536,
       0,     0,  1537,  1298,     0,     0,     0,  1295,     0,     0,
       0,     0,     0,  1298,     0,  1538,     0,     0,  1539,     0,
       0,     0,     0,  1290,  1295,     0,     0,     0,     0,     0,
       0,  1288,     0,     0,  1544,  1545,  1546,  1547,  1548,  1549,
    1290,     0,  1288,     0,  1295,  2154,  1291,     0,     0,     0,
       0,     0,     0,  1525,  1290,     0,  1526,  1293,  1672,     0,
       0,     0,     0,     0,     0,     0,  1295,  1290,     0,     0,
       0,     0,     0,  1527,     0,     0,  3109,     0,     0,     0,
       0,  1529,     0,  3697,  1525,     0,  1530,  1526,  1540,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   723,  1290,     0,  1527,     0,     0,     0,     0,     0,
       0,  1672,  1529,     0,  3063,  1295,  1288,  1530,     0,     0,
       0,     0,     0,  3726,     0,     0,  1288,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1298,
       0,     0,     0,     0,     0,     0,  1293,     0,   723,     0,
       0,     0,   723,     0,     0,  1290,     0,  1298,     0,     0,
       0,     0,     0,     0,  1541,  1542,  1543,     0,  1544,  1545,
    1546,  1547,  1548,  1549,  1290,     0,     0,     0,     0,   723,
       0,     0,     0,  1298,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1290,
       0,  1531,     0,   723,   723,  1532,  1294,   723,     0,     0,
       0,  1294,  1294,     0,   723,   723,     0,     0,     0,  3785,
    3785,     0,  1294,     0,     0,     0,  1533,  1534,  1525,     0,
       0,  1526,  1531,  1290,   723,     0,  1532,     0,     0,     0,
       0,  1535,     0,     0,     0,     0,     0,     0,  1527,     0,
       0,  1298,     0,     0,   723,  3785,  1529,  1533,  1534,     0,
       0,  1530,     0,     0,     0,  3825,     0,     0,     0,     0,
    1288,     0,  1535,  1536,     0,     0,  1537,     0,  1291,  1291,
    1295,  1291,     0,     0,     0,     0,     0,     0,     0,  1538,
       0,   723,  1539,     0,     0,     0,  1288,     0,     0,     0,
       0,     0,     0,     0,  1536,     0,     0,  1537,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3785,
    1538,     0,     0,  1539,  1291,     0,  1291,     0,     0,     0,
       0,     0,   723,     0,  1298,     0,  1290,     0,     0,  1294,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   723,  1298,
       0,   723,  1540,   723,  1288,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1531,     0,  1293,  1293,
    1532,  1293,     0,  1540,     0,     0,  1291,     0,     0,   723,
       0,     0,  1298,     0,  1294,     0,  1298,  1298,     0,     0,
       0,  1533,  1534,     0,     0,     0,     0,     0,     0,  1551,
       0,  1291,     0,     0,     0,     0,  1535,     0,     0,     0,
       0,     0,  1672,     0,  1293,     0,  1293,     0,     0,   723,
       0,     0,     0,     0,     0,     0,     0,  1288,  1541,  1542,
    1543,     0,  1544,  1545,  1546,  1547,  1548,  1549,  1536,     0,
    1291,  1537,     0,     0,  1298,  1290,     0,  1525,     0,     0,
    1526,     0,  1288,     0,  1538,     0,     0,  1291,  1551,  1541,
    1542,  1543,   723,  1544,  1545,  1546,  1547,  1548,  1549,     0,
    1525,  1291,     0,  1526,     0,  1529,     0,     0,     0,     0,
    1530,  1290,     0,  1294,  1291,     0,  1293,     0,     0,     0,
       0,     0,     0,     0,     0,  1288,     0,     0,  1529,  1288,
    1288,     0,     0,  1530,     0,     0,   723,     0,     0,     0,
       0,  1293,     0,   723,     0,  1295,     0,     0,     0,  1291,
    1295,  1295,     0,     0,     0,   723,   723,  1540,     0,     0,
       0,  1295,     0,     0,     0,   723,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1293,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   723,     0,     0,     0,     0,     0,  1293,  3129,     0,
       0,   723,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1293,  1291,     0,     0,     0,     0,     0,     0,     0,
       0,  3408,     0,     0,  1293,     0,     0,     0,     0,     0,
    1290,  1291,     0,     0,     0, -2012,     0,     0,     0,  1532,
       0,  1290,     0,  1541,  1542,  1543,     0,  1544,  1545,  1546,
    1547,  1548,  1549,     0,     0,   723,  1291,     0, -2012,  1293,
    1533,  1534,  1532,     0,   723,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0, -2012,     0,     0,  1295,     0,
       0,     0,     0,  1533,  1534,     0,     0,     0,     0,     0,
    1291,     0,     0,     0,     0,     0,     0,     0, -2012,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   503,     0,
    1537,     0,     0,     0,     0,  1290,     0,     0,     0,     0,
     504,     0,  1293,  1538,     0,  1290,     0,     0,     0,     0,
       0,     0,     0,  1537,     0,     0,     0,     0,     0,     0,
     505,  1293,     0,  1295,     0,     0,  1538,     0,     0,     0,
       0,     0,     0,     0,     0,  1294,  1294,     0,  1294,     0,
       0,   506,     0,     0,     0,  -617,  1293,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   507,     0,     0,     0,     0,
    1551,   508,     0,  1291,     0,     0, -2012,     0,     0,     0,
    1293,  1294,     0,  1294,     0,     0,   509,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -2012,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   510,     0,     0,     0,     0,     0,
       0,   511,  1295,     0,     0,   512,     0,     0,     0,   545,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -770,   546,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1551,     0,  1294,     0,     0,     0,     0,     0,  1290,
       0,   547,     0,     0,     0,     0,  1544,  1545,  1546,  1547,
    1548,  1549,     0,   166,  1551,     0,     0,   513,  1294,  2133,
       0,     0,     0,  1293,     0,  1290,   548,     0,     0,  1544,
    1545,  1546,  1547,  1548,  1549,     0,     0,     0,  1551,  1551,
       0,  1551,  1291,     0,     0,     0,   549,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1294,     0,     0,
       0,   514,     0,     0,   515,     0,     0,   550,     0,     0,
     167,     0,     0,     0,  1294,     0,     0,     0,  1291,  1551,
       0,     0,     0,     0,     0,     0,     0,     0,  1294,     0,
     168,     0,     0,  1290,     0,   551,   169,     0,     0,     0,
     552,  1294,     0,     0,     0,     0,   553,     0,     0,     0,
       0,   170,   516,     0,     0,  1551,     0,     0,   517,     0,
       1,   554,     0,     0,  -351,     0,     0,   518,     0,     0,
       2,     0,     3,     4,     0,     0,  1294,     0,     0,   171,
       0,     0,     0,     0,   172,     0,     5,     0,     0,     0,
     173,     0,  1293,  -351,     0,   519,   520,     0,   521,   522,
       0,     0,     0,     0,     0,   174,     6,   523,     7,     8,
       0,     0,   524,     9,     0,    10,  1290,   525,     0,     0,
       0,     0,   526,     0,     0,    11,     0,    12,  1293,     0,
     175,     0,     0,     0,  -351,     0,     0,  1291,     0,  1294,
       0,  1290,   555,     0,  1295,  1295,    13,  1295,  1291,    14,
       0,     0,   556,     0,     0,    15,     0,     0,  1294,     0,
       0,    16,     0,    17,     0,     0,  1551,    18,     0,   177,
       0,     0,     0,    19,     0,     0,  1551,     0,     0,  1551,
      20,     0,    21,  1294,  1290,     0,   176,    22,  1290,  1290,
    1295,     0,  1295,   557,     0,     0,     0,   558,     0,   559,
       0,    23,     0,     0,     0,   560,     0,     0,   561,     0,
       0,     0,     0,   177,     0,     0,     0,  1294,     0,     0,
       0,     0,  1291,     0,     0,     0,     0,     0,     0,    24,
       0,     0,  1291,     0,   562,     0,   563,   178,     0,     0,
     564,     0,     0,   179,     0,     0,     0,  1293,   565,   180,
       0,     0,   181,   566,    25,    26,     0,     0,  1293,     0,
      27,     0,  1295,   567,     0,     0,     0,     0,     0,    28,
       0,     0,     0,     0,     0,   568,     0,     0,   182,     0,
     183,     0,     0,     0,   184,     0,    29,  1295,     0,     0,
       0,     0,   185,     0,     0,     0,     0,   186,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   187,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   188,
    1294,     0,    30,     0,     0,     0,  1295,     0,     0,     0,
       0,     0,  1293,    31,     0,     0,     0,    32,     0,    33,
       0,     0,  1293,  1295,    34,     0,     0,     0,     0,    35,
       0,     0,    36,     0,     0,     0,    37,  1295,     0,     0,
       0,     0,    38,     0,     0,     0,     0,     0,     0,    39,
    1295,     0,    40,     0,     0,     0,     0,     0,     0,    41,
       0,     0,     0,     0,     0,     0,  1291,     0,     0,     0,
       0,     0,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1295,     0,     0,     0,    43,
       0,     0,  1291,     0,     0,     0,     0,     0,    44,     0,
      45,     0,     0,    46,     0,     0,     0,    47,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    48,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1294,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1295,     0,
       0,     0,    49,     0,     0,     0,     0,     0,     0,     0,
    1291,     0,     0,     0,     0,  1294,     0,  1295,     0,     0,
       0,     0,     0,     0,     0,     0,  1293,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1295,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1293,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1295,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1291,     0,     0,     0,  1551,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1291,  1551,
    1293,  1551,     0,  2133,  2133,  2676,     0,     0,  2133,     0,
       0,     0,  1551,     0,  1294,     0,     0,     0,     0,  1551,
       0,     0,     0,     0,  1551,  1294,     0,     0,     0,  1551,
       0,     0,     0,     0,  1551,     0,     0,     0,     0,     0,
       0,  1291,     0,  1551,     0,  1291,  1291,  2133,  2133,  1551,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1295,
       0,  1551,     0,     0,     0,     0,     0,     0,  1551,     0,
    1551,  1551,  1551,  1551,  1551,  1551,  1551,  1551,  1551,  1551,
       0,     0,     0,  1293,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1294,
       0,     0,  1551,     0,     0,     0,     0,     0,  1293,  1294,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1293,     0,     0,     0,  1293,  1293,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1551,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1295,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1295,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1294,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1294,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1551,     0,  1295,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1295,     0,     0,  1294,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1295,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1295,     0,
    1294,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1551,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1294,     0,     0,     0,     0,
       0,     0,     0,     0,  1551,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1294,     0,
       0,     0,  1294,  1294,     0,  1551,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2676,  2676,     0,  2133,
       0,     0,  2133,  2133,  2133,  2133,  2133,  2133,  2133,  2133,
    2133,  2133,  2676,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1551,     0,     0,  1551,     0,
    1551,     0,     0,     0,     0,  2676,  2676,     0,     0,     0,
       0,     0,  1295,     0,     0,     0,     0,     0,     0,  2133,
    2133,  1551,     0,  1551,     0,     0,  1551,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1295,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1551,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1551,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1551,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1295,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1295,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1295,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2133,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1295,     0,     0,
       0,  1295,  1295,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1551,
       0,     0,  1551,  1551,  1551,     0,     0,  2676,     0,     0,
       0,     0,  2676,  2676,  2676,  2676,  2676,  2676,  2676,  2676,
    2676,  2676,  1551,  1551,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1551,  2133,
    2133,  1551,     0,  1551,     0,     0,     0,  1551,  2676,  2676,
       0,     0,  1551,     0,     0,  1551,     0,     0,     0,     0,
       0,     0,  1551,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2676,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1551,  1551,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1551,     0,     0,     0,  2133,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1551,     0,  1551,
       0,     0,     0,     0,  2676,  2676,  1551,     0,     0,  2133,
    2133,  1551,  1551,     0,  1551,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1551,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1551,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1551,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2676,  2133,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2676,  2676,  1551,
       0,  1551,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,  2676,   206,
       0,   207,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,  1551,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,  1551,     0,     0,     0,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
    1551,   287,     0,     0,     0,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   298,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
    1551,   316,     0,   317,     0,     0,   318,     0,   319,   320,
     321,   322,   323,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,     0,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,     0,     0,     0,   368,   369,   370,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,     0,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
       0,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,     0,   459,   460,   461,   462,     0,  3437,
     463,   464,   465,   466,   467,   468,     0,   469,     0,   470,
     471,   472,     0,     0,   473,     0,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1066,     0,     0,
       0,  1067,   697,   944,   540,   945,   946,   947,   585,   948,
       0,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,  2222,   201,   202,   203,     0,     0,     0,     0,   949,
       0,     0,   204,   205,     0,   206,   698,   207,   208,   209,
     210,   950,   699,   951,   952,     0,   214,   215,   216,   217,
     218,   953,   954,   219,   220,   955,   956,   223,     0,   224,
     225,   226,   227,   957,     0,     0,   229,   230,   231,   232,
     700,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,   701,   244,   245,   958,   959,   960,
     961,   962,   963,   964,   246,   247,   248,   249,   250,   251,
     965,   966,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,  2223,     0,   264,   265,   967,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   968,   279,   280,   969,   970,   282,
       0,   283,   971,   285,     0,   286,     0,   287,   703,     0,
     704,   288,   289,   290,     0,   291,   972,     0,   293,     0,
     294,   295,   296,   297,   298,   705,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   706,   309,
     310,   311,   312,   313,   973,   974,     0,   975,     0,   317,
     707,   708,   318,   709,   319,   320,   321,   322,   323,   324,
     325,     0,   976,   710,   327,   711,     0,   328,   329,   330,
     977,   978,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   979,   712,   980,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   981,   355,   356,
     713,   357,   982,   983,   359,   984,   361,   362,     0,     0,
     363,     0,     0,   985,   365,   366,     0,     0,   367,   714,
     715,   716,   986,   369,   370,   371,   372,   373,   374,     0,
     375,   987,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   988,   390,   391,   392,     0,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
       0,   403,   404,   717,   405,   406,   989,   408,   409,   410,
     411,   412,   413,   414,   415,     0,   416,   417,   418,   419,
     420,   990,   421,   422,   423,   424,   718,   425,   991,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     992,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,   993,   994,     0,     0,   449,   995,   451,
     996,   997,   453,   454,   455,   456,   457,   458,     0,   998,
     459,   460,   461,   462,   999,     0,   463,   464,   465,   466,
     467,  1000,  2224,   469,   719,   470,   471,   472,     0,     0,
     473,     0,     0,   474,   475,   476,   477,   478,   479,  1001,
    1002,  1003,  1004,  1005,  1006,  1007,   487,   488,   489,     0,
       0,     0,     0,     0,     0,     0,  1008,  1009,  2225,     0,
       0,     0,     0,     0,     0,  1011,  2226,   697,   944,   540,
     945,   946,   947,   585,   948,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,   949,     0,     0,   204,   205,     0,
     206,   698,   207,   208,   209,   210,   950,   699,   951,   952,
       0,   214,   215,   216,   217,   218,   953,   954,   219,   220,
     955,   956,   223,     0,   224,   225,   226,   227,   957,     0,
       0,   229,   230,   231,   232,   700,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   701,
     244,   245,   958,   959,   960,   961,   962,   963,   964,   246,
     247,   248,   249,   250,   251,   965,   966,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   967,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   968,
     279,   280,   969,   970,   282,     0,   283,   971,   285,     0,
     286,     0,   287,   703,     0,   704,   288,   289,   290,     0,
     291,   972,     0,   293,     0,   294,   295,   296,   297,   298,
     705,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   706,   309,   310,   311,   312,   313,   973,
     974,     0,   975,     0,   317,   707,   708,   318,   709,   319,
     320,   321,   322,   323,   324,   325,     0,   976,   710,   327,
     711,     0,   328,   329,   330,   977,   978,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     979,   712,   980,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   981,   355,   356,   713,   357,   982,   983,   359,
     984,   361,   362,     0,     0,   363,     0,     0,   985,   365,
     366,     0,     0,   367,   714,   715,   716,   986,   369,   370,
     371,   372,   373,   374,     0,   375,   987,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     988,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,   717,   405,
     406,   989,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,   990,   421,   422,   423,
     424,   718,   425,   991,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   992,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   993,   994,
       0,     0,   449,   995,   451,   996,   997,   453,   454,   455,
     456,   457,   458,     0,   998,   459,   460,   461,   462,   999,
       0,   463,   464,   465,   466,   467,  1000,     0,   469,   719,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,   487,   488,   489,     0,     0,     0,     0,     0,     0,
       0,  1008,  1009,   191,     0,     0,     0,     0,     0,     0,
    1011,  2135,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,  2559,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243, -1264,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0, -1264,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   298,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308, -1264,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318, -1264,   319,   320,   321,   322,   323,
     324,   325,     0,   326, -1264,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344, -1264,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,     0,
       0,   363,     0,     0,   364,   365,   366,     0,     0,   367,
       0,     0,     0,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404, -1264,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   447,   448,     0,     0,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,     0,   469,     0,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
       0,     0,     0,     0,     0,     0,     0,  1264,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1090,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,   698,   207,   208,   209,     0,  1265,   699,  1266,  1267,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
    1268,  1269,   223,     0,   224,   225,   226,   227,     0,     0,
       0,   229,   230,   231,   232,   700,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   701,
     244,   245,     0,     0,     0,   702,     0,     0,     0,   246,
     247,   248,   249,   250,   251,  1270,  1271,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   967,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,     0,
     279,   280,     0,     0,   282,     0,   283,  1272,   285,     0,
     286,     0,   287,   703,     0,   704,   288,   289,   290,     0,
     291,     0,     0,   293,     0,   294,   295,   296,   297,   298,
     705,   299,   300,   301,  1778,   302,   303,   304,   305,   306,
     307,     0,   308,   706,  1779,   310,   311,   312,   313,  1273,
    1274,     0,  1275,     0,   317,   707,   708,   318,   709,   319,
     320,   321,   322,   323,   324,   325,     0,     0,   710,   327,
     711,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
    1276,   712,  1277,   346,   347,   348,   349,   350,   351,   352,
       0,   354,     0,   355,   356,   713,   357,     0,     0,   359,
    1278,   361,   362,     0,     0,   363,     0,     0,   364,   365,
     366,     0,     0,  1780,   714,   715,   716,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,   377,     0,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
    1279,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,   717,   405,
     406,     0,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,     0,   421,  1781,   423,
     424,   718,   425,  1281,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     0,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,  1282,  1283,
       0,     0,   449,     0,   451,     0,     0,   453,   454,   455,
     456,   457,   458,     0,     0,   459,   460,   461,   462,     0,
       0,   463,   464,   465,   466,     0,  1284,  1782,   469,   719,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,  1264,     0,     0,     0,     0,     0,     0,
       0,   487,   488,   489,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,  1783,     0,   204,   205,     0,   206,   698,   207,   208,
     209,     0,  1265,   699,  1266,  1267,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,  1268,  1269,   223,     0,
     224,   225,   226,   227,     0,     0,     0,   229,   230,   231,
     232,   700,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   701,   244,   245,     0,     0,
       0,   702,     0,     0,     0,   246,   247,   248,   249,   250,
     251,  1270,  1271,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     967,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,     0,   279,   280,     0,     0,
     282,     0,   283,  1272,   285,     0,   286,     0,   287,   703,
       0,   704,   288,   289,   290,     0,   291,     0,     0,   293,
       0,   294,   295,   296,   297,   298,   705,   299,   300,   301,
    1778,   302,   303,   304,   305,   306,   307,     0,   308,   706,
    1779,   310,   311,   312,   313,  1273,  1274,     0,  1275,     0,
     317,   707,   708,   318,   709,   319,   320,   321,   322,   323,
     324,   325,     0,     0,   710,   327,   711,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,  1276,   712,  1277,   346,
     347,   348,   349,   350,   351,   352,     0,   354,     0,   355,
     356,   713,   357,     0,     0,   359,  1278,   361,   362,     0,
       0,   363,     0,     0,   364,   365,   366,     0,     0,  1780,
     714,   715,   716,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,   377,     0,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,  1279,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,   717,   405,   406,     0,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,     0,   421,  1781,   423,   424,   718,   425,  1281,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,  1282,  1283,     0,     0,   449,     0,
     451,     0,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,     0,     0,   463,   464,   465,
     466,     0,  1284,  1782,   469,   719,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   697,
     944,   540,   945,   946,   947,   585,   948,   487,   488,   489,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,   949,  2540,     0,   204,
     205,     0,   206,   698,   207,   208,   209,   210,   950,   699,
     951,   952,  2145,   214,   215,   216,   217,   218,   953,   954,
     219,   220,   955,   956,   223,     0,   224,   225,   226,   227,
     957,     0,     0,   229,   230,   231,   232,   700,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   701,   244,   245,   958,   959,   960,   961,   962,   963,
     964,   246,   247,   248,   249,   250,   251,   965,   966,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   967,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   968,   279,   280,   969,   970,   282,     0,   283,   971,
     285,     0,   286,     0,   287,   703,  2146,   704,   288,   289,
     290,     0,   291,   972,     0,   293,     0,   294,   295,   296,
     297,   298,   705,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   706,   309,   310,   311,   312,
     313,   973,   974,     0,   975,     0,   317,   707,   708,   318,
     709,   319,   320,   321,   322,   323,   324,   325,  2147,   976,
     710,   327,   711,     0,   328,   329,   330,   977,   978,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   979,   712,   980,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   981,   355,   356,   713,   357,   982,
     983,   359,   984,   361,   362,     0,     0,   363,     0,     0,
     985,   365,   366,     0,     0,   367,   714,   715,   716,   986,
     369,   370,   371,   372,   373,   374,     0,   375,   987,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   988,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
     717,   405,   406,   989,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,   990,   421,
     422,   423,   424,   718,   425,   991,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   992,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     993,   994,     0,  2148,   449,   995,   451,   996,   997,   453,
     454,   455,   456,   457,   458,     0,   998,   459,   460,   461,
     462,   999,     0,   463,   464,   465,   466,   467,  1000,     0,
     469,   719,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,   487,   488,   489,     0,     0,     0,     0,
       0,     0,     0,  1008,  1009,     0,     0,     0,     0,     0,
       0,     0,  1011,   697,   944,   540,   945,   946,   947,   585,
     948,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
     949,     0,     0,   204,   205,     0,   206,   698,   207,   208,
     209,   210,   950,   699,   951,   952,     0,   214,   215,   216,
     217,   218,   953,   954,   219,   220,   955,   956,   223,     0,
     224,   225,   226,   227,   957,     0,     0,   229,   230,   231,
     232,   700,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   701,   244,   245,   958,   959,
     960,   961,   962,   963,   964,   246,   247,   248,   249,   250,
     251,   965,   966,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     967,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   968,   279,   280,   969,   970,
     282,     0,   283,   971,   285,     0,   286,     0,   287,   703,
       0,   704,   288,   289,   290,     0,   291,   972,     0,   293,
       0,   294,   295,   296,   297,   298,   705,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   706,
     309,   310,   311,   312,   313,   973,   974,     0,   975,     0,
     317,   707,   708,   318,   709,   319,   320,   321,   322,   323,
     324,   325,     0,   976,   710,   327,   711,     0,   328,   329,
     330,   977,   978,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   979,   712,   980,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   981,   355,
     356,   713,   357,   982,   983,   359,   984,   361,   362,     0,
       0,   363,     0,     0,   985,   365,   366,     0,     0,   367,
     714,   715,   716,   986,   369,   370,   371,   372,   373,   374,
       0,   375,   987,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   988,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,   717,   405,   406,   989,   408,   409,
     410,   411,   412,   413,   414,   415,    38,   416,   417,   418,
     419,   420,   990,   421,   422,   423,   424,   718,   425,   991,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   992,   438,     0,   439,   440,    42,   441,   442,   443,
     444,   445,   446,     0,   993,   994,     0,     0,   449,   995,
     451,   996,   997,   453,   454,   455,   456,   457,   458,     0,
     998,   459,   460,   461,   462,   999,     0,   463,   464,   465,
     466,   884,  1000,     0,   469,   719,   470,   471,   472,     0,
       0,   473,     0,    48,   474,   475,   476,   477,   478,   479,
    1001,  1002,  1003,  1004,  1005,  1006,  1007,   487,   488,   489,
       0,     0,     0,     0,     0,     0,     0,  1008,  1009,     0,
       0,     0,     0,     0,     0,     0,  1011,   697,   944,   540,
     945,   946,   947,   585,   948,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,   949,     0,     0,   204,   205,     0,
     206,   698,   207,   208,   209,   210,   950,   699,   951,   952,
       0,   214,   215,   216,   217,   218,   953,   954,   219,   220,
     955,   956,   223,     0,   224,   225,   226,   227,   957,     0,
       0,   229,   230,   231,   232,   700,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   701,
     244,   245,   958,   959,   960,   961,   962,   963,   964,   246,
     247,   248,   249,   250,   251,   965,   966,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   967,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   968,
     279,   280,   969,   970,   282,     0,   283,   971,   285,     0,
     286,     0,   287,   703,     0,   704,   288,   289,   290,     0,
     291,   972,     0,   293,     0,   294,   295,   296,   297,   298,
     705,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   706,   309,   310,   311,   312,   313,   973,
     974,     0,   975,     0,   317,   707,   708,   318,   709,   319,
     320,   321,   322,   323,   324,   325,     0,   976,   710,   327,
     711,     0,   328,   329,   330,   977,   978,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     979,   712,   980,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   981,   355,   356,   713,   357,   982,   983,   359,
     984,   361,   362,     0,     0,   363,     0,     0,   985,   365,
     366,     0,     0,   367,   714,   715,   716,   986,   369,   370,
     371,   372,   373,   374,     0,   375,   987,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     988,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,   717,   405,
     406,   989,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,   990,   421,   422,   423,
     424,   718,   425,   991,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   992,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   993,   994,
       0,     0,   449,   995,   451,   996,   997,   453,   454,   455,
     456,   457,   458,     0,   998,   459,   460,   461,   462,   999,
       0,   463,   464,   465,   466,   467,  1000,     0,   469,   719,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,   487,   488,   489,     0,     0,     0,     0,     0,     0,
       0,  1008,  1009,     0,     0,     0,     0,     0,  1461,  2094,
    1011,   697,   944,   540,   945,   946,   947,   585,   948,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,   949,     0,
       0,   204,   205,     0,   206,   698,   207,   208,   209,   210,
     950,   699,   951,   952,     0,   214,   215,   216,   217,   218,
     953,   954,   219,   220,   955,   956,   223,     0,   224,   225,
     226,   227,   957,     0,     0,   229,   230,   231,   232,   700,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   701,   244,   245,   958,   959,   960,   961,
     962,   963,   964,   246,   247,   248,   249,   250,   251,   965,
     966,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   967,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   968,   279,   280,   969,   970,   282,     0,
     283,   971,   285,     0,   286,     0,   287,   703,     0,   704,
     288,   289,   290,     0,   291,   972,     0,   293,     0,   294,
     295,   296,   297,   298,   705,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   706,   309,   310,
     311,   312,   313,   973,   974,     0,   975,     0,   317,   707,
     708,   318,   709,   319,   320,   321,   322,   323,   324,   325,
       0,   976,   710,   327,   711,     0,   328,   329,   330,   977,
     978,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   979,   712,   980,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   981,   355,   356,   713,
     357,   982,   983,   359,   984,   361,   362,     0,     0,   363,
       0,     0,   985,   365,   366,     0,     0,   367,   714,   715,
     716,   986,   369,   370,   371,   372,   373,   374,     0,   375,
     987,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   988,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,   717,   405,   406,   989,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
     990,   421,   422,   423,   424,   718,   425,   991,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   992,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   993,   994,     0,     0,   449,   995,   451,   996,
     997,   453,   454,   455,   456,   457,   458,     0,   998,   459,
     460,   461,   462,   999,     0,   463,   464,   465,   466,   467,
    1000,     0,   469,   719,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,   487,   488,   489,     0,     0,
       0,     0,     0,     0,     0,  1008,  1009,  1010,     0,     0,
       0,     0,     0,     0,  1011,   697,   944,   540,   945,   946,
     947,   585,   948,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,   949,     0,     0,   204,   205,     0,   206,   698,
     207,   208,   209,   210,   950,   699,   951,   952,     0,   214,
     215,   216,   217,   218,   953,   954,   219,   220,   955,   956,
     223,     0,   224,   225,   226,   227,   957,     0,     0,   229,
     230,   231,   232,   700,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   701,   244,   245,
     958,   959,   960,   961,   962,   963,   964,   246,   247,   248,
     249,   250,   251,   965,   966,   254,  1082,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   967,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   968,   279,   280,
     969,   970,   282,     0,   283,   971,   285,     0,   286,     0,
     287,   703,     0,   704,   288,   289,   290,     0,   291,   972,
       0,   293,     0,   294,   295,   296,   297,   298,   705,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   706,   309,   310,   311,   312,   313,   973,   974,     0,
     975,     0,   317,   707,   708,   318,   709,   319,   320,   321,
     322,   323,   324,   325,     0,   976,   710,   327,   711,     0,
     328,   329,   330,   977,   978,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   979,   712,
     980,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     981,   355,   356,   713,   357,   982,   983,   359,   984,   361,
     362,     0,     0,   363,     0,     0,   985,   365,   366,     0,
       0,   367,   714,   715,   716,   986,   369,   370,   371,   372,
     373,   374,     0,   375,   987,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   988,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,   717,   405,   406,   989,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,   990,   421,   422,   423,   424,   718,
     425,   991,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   992,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,   993,   994,     0,     0,
     449,   995,   451,   996,   997,   453,   454,   455,   456,   457,
     458,     0,   998,   459,   460,   461,   462,   999,     0,   463,
     464,   465,   466,   467,  1000,     0,   469,   719,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,   479,  1001,  1002,  1003,  1004,  1005,  1006,  1007,   487,
     488,   489,     0,     0,     0,     0,     0,     0,     0,  1008,
    1009,     0,     0,     0,     0,     0,     0,     0,  1011,   697,
     944,   540,   945,   946,   947,   585,   948,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,  1709,   201,
     202,   203,     0,     0,     0,     0,   949,     0,     0,   204,
     205,     0,   206,   698,   207,   208,   209,   210,   950,   699,
     951,   952,     0,   214,   215,   216,   217,   218,   953,   954,
     219,   220,   955,   956,   223,     0,   224,   225,   226,   227,
     957,     0,     0,   229,   230,   231,   232,   700,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   701,   244,   245,   958,   959,   960,   961,   962,   963,
     964,   246,   247,   248,   249,   250,   251,   965,   966,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   967,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   968,   279,   280,   969,   970,   282,     0,   283,   971,
     285,     0,   286,     0,   287,   703,     0,   704,   288,   289,
     290,     0,   291,   972,     0,   293,     0,   294,   295,   296,
     297,   298,   705,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   706,   309,   310,   311,   312,
     313,   973,   974,     0,   975,     0,   317,   707,   708,   318,
     709,   319,   320,   321,   322,   323,   324,   325,     0,   976,
     710,   327,   711,     0,   328,   329,   330,   977,   978,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   979,   712,   980,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   981,   355,   356,   713,   357,   982,
     983,   359,   984,   361,   362,     0,     0,   363,     0,     0,
     985,   365,   366,     0,     0,   367,   714,   715,   716,   986,
     369,   370,   371,   372,   373,   374,     0,   375,   987,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   988,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
     717,   405,   406,   989,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,   990,   421,
     422,   423,   424,   718,   425,   991,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   992,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     993,   994,     0,     0,   449,   995,   451,   996,   997,   453,
     454,   455,   456,   457,   458,     0,   998,   459,   460,   461,
     462,   999,     0,   463,   464,   465,   466,   467,  1000,     0,
     469,   719,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,   487,   488,   489,     0,     0,     0,     0,
       0,     0,     0,  1008,  1009,     0,     0,     0,     0,     0,
       0,     0,  1011,   697,   944,   540,   945,   946,   947,   585,
     948,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
     949,     0,     0,   204,   205,     0,   206,   698,   207,   208,
     209,   210,   950,   699,   951,   952,     0,   214,   215,   216,
     217,   218,   953,   954,   219,   220,   955,   956,   223,     0,
     224,   225,   226,   227,   957,     0,     0,   229,   230,   231,
     232,   700,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   701,   244,   245,   958,   959,
     960,   961,   962,   963,   964,   246,   247,   248,   249,   250,
     251,   965,   966,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     967,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   968,   279,   280,   969,   970,
     282,     0,   283,   971,   285,     0,   286,     0,   287,   703,
    2146,   704,   288,   289,   290,     0,   291,   972,     0,   293,
       0,   294,   295,   296,   297,   298,   705,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   706,
     309,   310,   311,   312,   313,   973,   974,     0,   975,     0,
     317,   707,   708,   318,   709,   319,   320,   321,   322,   323,
     324,   325,     0,   976,   710,   327,   711,     0,   328,   329,
     330,   977,   978,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   979,   712,   980,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   981,   355,
     356,   713,   357,   982,   983,   359,   984,   361,   362,     0,
       0,   363,     0,     0,   985,   365,   366,     0,     0,   367,
     714,   715,   716,   986,   369,   370,   371,   372,   373,   374,
       0,   375,   987,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   988,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,   717,   405,   406,   989,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,   990,   421,   422,   423,   424,   718,   425,   991,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   992,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   993,   994,     0,     0,   449,   995,
     451,   996,   997,   453,   454,   455,   456,   457,   458,     0,
     998,   459,   460,   461,   462,   999,     0,   463,   464,   465,
     466,   467,  1000,     0,   469,   719,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
    1001,  1002,  1003,  1004,  1005,  1006,  1007,   487,   488,   489,
       0,     0,     0,     0,     0,     0,     0,  1008,  1009,     0,
       0,     0,     0,     0,     0,     0,  1011,   697,   944,   540,
     945,   946,   947,   585,   948,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,   949,     0,     0,   204,   205,     0,
     206,   698,   207,   208,   209,   210,   950,   699,   951,   952,
       0,   214,   215,   216,   217,   218,   953,   954,   219,   220,
     955,   956,   223,     0,   224,   225,   226,   227,   957,     0,
       0,   229,   230,   231,   232,   700,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   701,
     244,   245,   958,   959,   960,   961,   962,   963,   964,   246,
     247,   248,   249,   250,   251,   965,   966,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   967,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   968,
     279,   280,   969,   970,   282,     0,   283,   971,   285,     0,
     286,     0,   287,   703,     0,   704,   288,   289,   290,     0,
     291,   972,     0,   293,     0,   294,   295,   296,   297,   298,
     705,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   706,   309,   310,   311,   312,   313,   973,
     974,     0,   975,     0,   317,   707,   708,   318,   709,   319,
     320,   321,   322,   323,   324,   325,     0,   976,   710,   327,
     711,     0,   328,   329,   330,   977,   978,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     979,   712,   980,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   981,   355,   356,   713,   357,   982,   983,   359,
     984,   361,   362,     0,     0,   363,     0,     0,   985,   365,
     366,     0,     0,   367,   714,   715,   716,   986,   369,   370,
     371,   372,   373,   374,     0,   375,   987,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     988,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,   717,   405,
     406,   989,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,   990,   421,   422,   423,
     424,   718,   425,   991,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   992,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   993,   994,
       0,     0,   449,   995,   451,   996,   997,   453,   454,   455,
     456,   457,   458,     0,   998,   459,   460,   461,   462,   999,
       0,   463,   464,   465,   466,   467,  1000,  3153,   469,   719,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,   487,   488,   489,     0,     0,     0,     0,     0,     0,
       0,  1008,  1009,     0,     0,     0,     0,     0,     0,     0,
    1011,   697,   944,   540,   945,   946,   947,   585,   948,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,   949,     0,
       0,   204,   205,     0,   206,   698,   207,   208,   209,   210,
     950,   699,   951,   952,     0,   214,   215,   216,   217,   218,
     953,   954,   219,   220,   955,   956,   223,     0,   224,   225,
     226,   227,   957,     0,     0,   229,   230,   231,   232,   700,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   701,   244,   245,   958,   959,   960,   961,
     962,   963,   964,   246,   247,   248,   249,   250,   251,   965,
     966,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   967,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   968,   279,   280,   969,   970,   282,     0,
     283,   971,   285,     0,   286,     0,   287,   703,     0,   704,
     288,   289,   290,     0,   291,   972,     0,   293,     0,   294,
     295,   296,   297,   298,   705,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   706,   309,   310,
     311,   312,   313,   973,   974,     0,   975,     0,   317,   707,
     708,   318,   709,   319,   320,   321,   322,   323,   324,   325,
       0,   976,   710,   327,   711,     0,   328,   329,   330,   977,
     978,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   979,   712,   980,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   981,   355,   356,   713,
     357,   982,   983,   359,   984,   361,   362,     0,     0,   363,
       0,     0,   985,   365,   366,     0,     0,   367,   714,   715,
     716,   986,   369,   370,   371,   372,   373,   374,     0,   375,
     987,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   988,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,   717,   405,   406,   989,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
     990,   421,   422,   423,   424,   718,   425,   991,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   992,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   993,   994,     0,     0,   449,   995,   451,   996,
     997,   453,   454,   455,   456,   457,   458,     0,   998,   459,
     460,   461,   462,   999,     0,   463,   464,   465,   466,   467,
    1000,     0,   469,   719,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,   487,   488,   489,     0,     0,
       0,     0,     0,     0,     0,  1008,  1009,     0,     0,     0,
       0,     0,     0,     0,  1011,   697,   944,   540,   945,   946,
     947,   585,   948,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,   949,     0,     0,   204,   205,     0,   206,   698,
     207,   208,   209,   210,   950,   699,   951,   952,     0,   214,
     215,   216,   217,   218,   953,   954,   219,   220,   955,   956,
     223,     0,   224,   225,   226,   227,   957,     0,     0,   229,
     230,   231,   232,   700,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   701,   244,  2577,
     958,   959,   960,   961,   962,   963,   964,   246,   247,   248,
     249,   250,   251,   965,   966,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   967,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   968,   279,   280,
     969,   970,   282,     0,   283,   971,   285,     0,   286,     0,
     287,   703,     0,   704,   288,   289,   290,     0,   291,   972,
       0,   293,     0,   294,   295,   296,   297,   298,   705,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   706,   309,   310,   311,   312,   313,   973,   974,     0,
     975,     0,   317,   707,   708,   318,   709,   319,   320,   321,
     322,   323,   324,   325,     0,   976,   710,   327,   711,     0,
     328,   329,   330,   977,   978,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   979,   712,
     980,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     981,   355,   356,   713,   357,   982,   983,   359,   984,   361,
     362,     0,     0,   363,     0,     0,   985,   365,   366,     0,
       0,   367,   714,   715,   716,   986,   369,   370,   371,   372,
     373,   374,     0,   375,   987,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   988,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,   717,   405,   406,   989,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,   990,   421,   422,   423,   424,   718,
     425,   991,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   992,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,   993,   994,     0,     0,
     449,   995,   451,   996,   997,   453,   454,   455,   456,   457,
     458,     0,   998,   459,   460,   461,   462,   999,     0,   463,
     464,   465,   466,   467,  1000,     0,   469,   719,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,   479,  1001,  1002,  1003,  1004,  1005,  1006,  1007,   487,
     488,   489,     0,     0,     0,     0,     0,     0,     0,  1008,
    1009,     0,     0,     0,     0,     0,     0,     0,  1011,   697,
     944,   540,   945,   946,   947,   585,   948,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,   949,     0,     0,   204,
     205,     0,   206,   698,   207,   208,   209,   210,   950,   699,
     951,   952,     0,   214,   215,   216,   217,   218,   953,   954,
     219,   220,   955,   956,   223,     0,   224,   225,   226,   227,
     957,     0,     0,   229,   230,   231,   232,   700,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   701,   244,   245,   958,   959,   960,   961,   962,   963,
     964,   246,   247,   248,   249,   250,   251,   965,   966,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   967,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   968,   279,   280,   969,   970,   282,     0,   283,   971,
     285,     0,   286,     0,   287,   703,     0,   704,   288,   289,
     290,     0,   291,   972,     0,   293,     0,   294,   295,   296,
     297,   298,   705,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   706,   309,   310,   311,   312,
     313,   973,   974,     0,   975,     0,   317,   707,   708,   318,
     709,   319,   320,   321,   322,   323,   324,   325,     0,   976,
     710,   327,   711,     0,   328,   329,   330,   977,   978,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   979,   712,   980,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   981,   355,   356,   713,   357,   982,
     983,   359,   984,   361,   362,     0,     0,   363,     0,     0,
     985,   365,   366,     0,     0,   367,   714,   715,   716,   986,
     369,   370,   371,   372,   373,   374,     0,   375,   987,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   988,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
     717,   405,   406,   989,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,   990,   421,
     422,   423,   424,   718,   425,   991,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   992,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     993,   994,     0,     0,   449,   995,   451,   996,   997,   453,
     454,   455,   456,   457,   458,     0,   998,   459,   460,   461,
     462,   999,     0,   463,   464,   465,   466,   467,  1000,     0,
     469,   719,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,  3386,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,   487,   488,   489,     0,     0,     0,     0,
       0,     0,     0,  1008,  1009,     0,     0,     0,     0,     0,
       0,     0,  1011,   697,   944,   540,   945,   946,   947,   585,
     948,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
     949,     0,     0,   204,   205,     0,   206,   698,   207,   208,
     209,   210,   950,   699,   951,   952,     0,   214,   215,   216,
     217,   218,   953,   954,   219,   220,   955,   956,   223,     0,
     224,   225,   226,   227,   957,     0,     0,   229,   230,   231,
     232,   700,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   701,   244,   245,   958,   959,
     960,   961,   962,   963,   964,   246,   247,   248,   249,   250,
     251,   965,   966,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     967,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   968,   279,   280,   969,   970,
     282,     0,   283,   971,   285,     0,   286,     0,   287,   703,
       0,   704,   288,   289,   290,     0,   291,   972,     0,   293,
       0,   294,   295,   296,   297,   298,   705,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   706,
     309,   310,   311,   312,   313,   973,   974,     0,   975,     0,
     317,   707,   708,   318,   709,   319,   320,   321,   322,   323,
     324,   325,     0,   976,   710,   327,   711,     0,   328,   329,
     330,   977,   978,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   979,   712,   980,   346,
    3393,   348,   349,   350,   351,   352,   353,   354,   981,   355,
     356,   713,   357,   982,   983,   359,   984,   361,   362,     0,
       0,   363,     0,     0,   985,   365,   366,     0,     0,   367,
     714,   715,   716,   986,   369,   370,   371,   372,   373,   374,
       0,   375,   987,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   988,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,   717,   405,   406,   989,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,   990,   421,   422,   423,   424,   718,   425,   991,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   992,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   993,   994,     0,     0,   449,   995,
     451,   996,   997,   453,   454,   455,   456,   457,   458,     0,
     998,   459,   460,   461,   462,   999,     0,   463,   464,   465,
     466,   467,  1000,     0,   469,   719,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
    1001,  1002,  1003,  1004,  1005,  1006,  1007,   487,   488,   489,
       0,     0,     0,     0,     0,     0,     0,  1008,  1009,     0,
       0,     0,     0,     0,     0,     0,  1011,   697,   944,   540,
     945,   946,   947,   585,   948,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,   949,     0,     0,   204,   205,     0,
     206,   698,   207,   208,   209,  3782,   950,   699,   951,   952,
       0,   214,   215,   216,   217,   218,   953,   954,   219,   220,
     955,   956,   223,     0,   224,   225,   226,   227,   957,     0,
       0,   229,   230,   231,   232,   700,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   701,
     244,  3783,   958,   959,   960,   961,   962,   963,   964,   246,
     247,   248,   249,   250,   251,   965,   966,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   967,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   968,
     279,   280,   969,   970,   282,     0,   283,   971,   285,     0,
     286,     0,   287,   703,     0,   704,   288,   289,   290,     0,
     291,   972,     0,   293,     0,   294,   295,   296,   297,   298,
     705,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   706,   309,   310,   311,   312,   313,   973,
     974,     0,   975,     0,   317,   707,   708,   318,   709,   319,
     320,   321,   322,   323,   324,   325,     0,   976,   710,   327,
     711,     0,   328,   329,   330,   977,   978,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     979,   712,   980,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   981,   355,   356,   713,   357,   982,   983,   359,
     984,   361,   362,     0,     0,   363,     0,     0,   985,   365,
     366,     0,     0,   367,   714,   715,   716,   986,   369,   370,
     371,   372,   373,   374,     0,   375,   987,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     988,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,   717,   405,
     406,   989,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,   990,   421,   422,   423,
     424,   718,   425,   991,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   992,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   993,   994,
       0,     0,   449,   995,   451,   996,   997,   453,   454,   455,
    3784,   457,   458,     0,   998,   459,   460,   461,   462,   999,
       0,   463,   464,   465,   466,   467,  1000,     0,   469,   719,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,   487,   488,   489,     0,     0,     0,     0,     0,     0,
       0,  1008,  1009,     0,     0,     0,     0,     0,     0,     0,
    1011,   697,   944,   540,   945,   946,   947,   585,   948,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,   949,     0,
       0,   204,   205,     0,   206,   698,   207,   208,   209,   210,
     950,   699,   951,   952,     0,   214,   215,   216,   217,   218,
     953,   954,   219,   220,   955,   956,   223,     0,   224,   225,
     226,   227,   957,     0,     0,   229,   230,   231,   232,   700,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   701,   244,  3783,   958,   959,   960,   961,
     962,   963,   964,   246,   247,   248,   249,   250,   251,   965,
     966,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   967,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   968,   279,   280,   969,   970,   282,     0,
     283,   971,   285,     0,   286,     0,   287,   703,     0,   704,
     288,   289,   290,     0,   291,   972,     0,   293,     0,   294,
     295,   296,   297,   298,   705,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   706,   309,   310,
     311,   312,   313,   973,   974,     0,   975,     0,   317,   707,
     708,   318,   709,   319,   320,   321,   322,   323,   324,   325,
       0,   976,   710,   327,   711,     0,   328,   329,   330,   977,
     978,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   979,   712,   980,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   981,   355,   356,   713,
     357,   982,   983,   359,   984,   361,   362,     0,     0,   363,
       0,     0,   985,   365,   366,     0,     0,   367,   714,   715,
     716,   986,   369,   370,   371,   372,   373,   374,     0,   375,
     987,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   988,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,   717,   405,   406,   989,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
     990,   421,   422,   423,   424,   718,   425,   991,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   992,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   993,   994,     0,     0,   449,   995,   451,   996,
     997,   453,   454,   455,  3784,   457,   458,     0,   998,   459,
     460,   461,   462,   999,     0,   463,   464,   465,   466,   467,
    1000,     0,   469,   719,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,   487,   488,   489,     0,     0,
       0,     0,     0,     0,     0,  1008,  1009,     0,     0,     0,
       0,     0,     0,     0,  1011,   697,   944,   540,   945,   946,
     947,   585,   948,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,   949,     0,     0,   204,   205,     0,   206,   698,
     207,   208,   209,   210,   950,   699,   951,   952,     0,   214,
     215,   216,   217,   218,   953,   954,   219,   220,   955,   956,
     223,     0,   224,   225,   226,   227,   957,     0,     0,   229,
     230,   231,   232,   700,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   701,   244,   245,
     958,   959,   960,   961,   962,   963,   964,   246,   247,   248,
     249,   250,   251,   965,   966,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   967,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   968,   279,   280,
     969,   970,   282,     0,   283,   971,   285,     0,   286,     0,
     287,   703,     0,   704,   288,   289,   290,     0,   291,   972,
       0,   293,     0,   294,   295,   296,   297,   298,   705,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   706,   309,   310,   311,   312,   313,   973,   974,     0,
     975,     0,   317,   707,   708,   318,   709,   319,   320,   321,
     322,   323,   324,   325,     0,   976,   710,   327,   711,     0,
     328,   329,   330,   977,   978,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   979,   712,
     980,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,   713,   357,   982,   983,   359,   984,   361,
     362,     0,     0,   363,     0,     0,   985,   365,   366,     0,
       0,   367,   714,   715,   716,   986,   369,   370,   371,   372,
     373,   374,     0,   375,   987,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   988,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,   717,   405,   406,   989,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,   990,   421,   422,   423,   424,   718,
     425,   991,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   992,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,   993,   994,     0,     0,
     449,   995,   451,   996,   997,   453,   454,   455,   456,   457,
     458,     0,     0,   459,   460,   461,   462,   999,     0,   463,
     464,   465,   466,   467,  1000,     0,   469,   719,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,   479,  1001,  1002,  1003,  1004,  1005,  1006,  1007,   487,
     488,   489,     0,     0,     0,     0,     0,     0,     0,  2128,
    2129,     0,     0,     0,     0,     0,     0,     0,  1011,   697,
     944,   540,   945,   946,   947,   585,   948,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,   949,     0,     0,   204,
     205,     0,   206,   698,   207,   208,   209, -2012,   950,   699,
     951,   952,     0,   214,   215,   216,   217,   218,   953,   954,
     219,   220,   955,   956,   223,     0,   224,   225,   226,   227,
     957,     0,     0,   229,   230,   231,   232,   700,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   701,   244,  3783,   958,   959,   960,   961,   962,   963,
     964,   246,   247,   248,   249,   250,   251,   965,   966,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   967,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   968,   279,   280,   969,   970,   282,     0,   283,   971,
     285,     0,   286,     0,   287,   703,     0,   704,   288,   289,
     290,     0,   291,   972,     0,   293,     0,   294,   295,   296,
     297,   298,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   706,   309,   310,   311,   312,
     313,   973,   974,     0,   975,     0,   317,   707,   708,   318,
     709,   319,   320,   321,   322,   323,   324,   325,     0,   976,
     710,   327,     0,     0,   328,   329,   330,   977,   978,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   979,   712,   980,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,   713,   357,   982,
     983,   359,   984,   361,   362,     0,     0,   363,     0,     0,
     985,   365,   366,     0,     0,   367,   714,   715,   716,   986,
     369,   370,   371,   372,   373,   374,     0,   375,   987,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   988,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
     717,   405,   406,   989,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,   990,   421,
     422,   423,   424,     0,   425,   991,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   992,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     993,   994,     0,     0,   449,   995,   451,   996,   997,   453,
     454,   455,  3784,   457,   458,     0,   998,   459,   460,   461,
     462,   999,     0,   463,   464,   465,   466,   467,  1000,     0,
     469,   719,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,   487,   488,   489,     0,     0,     0,     0,
       0,     0,     0,  1008,  1009,     0,     0,     0,     0,     0,
       0,     0,  1011,   697,   944,   540,   945,   946,   947,   585,
     948,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
     949,     0,     0,   204,   205,     0,   206,   698,   207,   208,
     209,     0,   950,   699,   951,   952,     0,   214,   215,   216,
     217,   218,   953,   954,   219,   220,   955,   956,   223,     0,
     224,   225,   226,   227,   957,     0,     0,   229,   230,   231,
     232,   700,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   701,   244,   245,   958,   959,
     960,   961,   962,   963,   964,   246,   247,   248,   249,   250,
     251,   965,   966,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     967,   267,   268,     0,   269,   270,   271,     0,   272,     0,
       0,   274,   275,   276,   277,   968,   279,   280,   969,   970,
     282,     0,   283,   971,   285,     0,   286,     0,   287,   703,
       0,   704,   288,   289,   290,     0,   291,   972,     0,   293,
       0,   294,   295,   296,   297,   298,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   706,
     309,   310,   311,   312,   313,   973,   974,     0,   975,     0,
     317,   707,   708,   318,   709,   319,   320,   321,   322,   323,
     324,   325,     0,   976,   710,   327,     0,     0,   328,   329,
     330,   977,   978,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   979,   712,   980,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,   713,   357,   982,   983,   359,   984,   361,   362,     0,
       0,   363,     0,     0,   985,   365,   366,     0,     0,   367,
     714,   715,   716,   986,   369,   370,   371,   372,   373,   374,
       0,   375,   987,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   988,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,   717,   405,   406,   989,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,   990,   421,   422,   423,   424,     0,   425,   991,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   992,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   993,   994,     0,     0,   449,   995,
     451,   996,   997,   453,   454,   455,   456,   457,   458,     0,
     998,   459,   460,   461,   462,   999,     0,   463,   464,   465,
     466,   467,  1000,     0,   469,   719,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
    1001,  1002,  1003,  1004,  1005,  1006,  1007,   487,   488,   489,
       0,     0,     0,     0,     0,     0,     0,  1008,  1009,     0,
       0,     0,     0,     0,     0,     0,  1011,   697,   944,   540,
     945,   946,   947,   585,   948,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,   949,     0,     0,   204,   205,     0,
     206,   698,   207,   208,   209,     0,   950,   699,   951,   952,
       0,   214,   215,   216,   217,   218,   953,   954,   219,   220,
     955,   956,   223,     0,   224,   225,   226,   227,   957,     0,
       0,   229,   230,   231,   232,   700,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   701,
     244,   245,   958,   959,   960,   961,   962,   963,   964,   246,
     247,   248,   249,   250,   251,   965,   966,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   967,   267,   268,     0,   269,   270,
     271,     0,   272,     0,     0,   274,   275,   276,   277,   968,
     279,   280,   969,   970,   282,     0,   283,   971,   285,     0,
     286,     0,   287,   703,     0,   704,   288,   289,   290,     0,
     291,   972,     0,   293,     0,   294,   295,   296,   297,   298,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   706,   309,   310,   311,   312,   313,   973,
     974,     0,   975,     0,   317,   707,   708,   318,   709,   319,
     320,   321,   322,   323,   324,   325,     0,   976,   710,   327,
       0,     0,   328,   329,   330,   977,   978,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     979,   712,   980,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,   713,   357,   982,   983,   359,
     984,   361,   362,     0,     0,   363,     0,     0,   985,   365,
     366,     0,     0,   367,   714,   715,   716,   986,   369,   370,
     371,   372,   373,   374,     0,   375,   987,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     988,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,   717,   405,
     406,   989,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,   990,   421,   422,   423,
     424,     0,   425,   991,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   992,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   993,   994,
       0,     0,   449,   995,   451,   996,   997,   453,   454,   455,
     456,   457,   458,     0,     0,   459,   460,   461,   462,   999,
       0,   463,   464,   465,   466,   467,  1000,     0,   469,   719,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,   487,   488,   489,     0,     0,     0,     0,     0,     0,
     697,  2128,  2129,     0,     0,     0,     0,     0,     0,     0,
    1011,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,   698,   207,   208,   209,   210,   211,
     699,   212,   213,     0,   214,   215,   216,   217,   218,     0,
     954,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   957,     0,     0,   229,   230,   231,   232,   700,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,   701,   244,   245,   958,   959,   960,   961,   962,
     963,   964,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   969,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,   703,     0,   704,   288,
     289,   290,     0,   291,   972,     0,   293,     0,   294,   295,
     296,   297,   298,   705,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   706,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   707,   708,
     318,   709,   319,   320,   321,   322,   323,   324,   325,     0,
     976,   710,   327,   711,     0,   328,   329,   330,   977,   978,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   712,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,   713,   357,
       0,   983,   359,   360,   361,   362,     0,     0,   363,     0,
     664,   364,   365,   366,     0,     0,   367,   714,   715,   716,
     986,   369,   370,   371,   372,   373,   374,     0,   375,   987,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,     0,   403,
     404,   717,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    38,   416,   417,   418,   419,   420,   990,
     421,   422,   423,   424,   718,   425,   426,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   992,   438,
       0,   439,   440,    42,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,     0,   449,   995,   451,   996,     0,
     453,   454,   455,   456,   457,   458,     0,     0,   459,   460,
     461,   462,   999,     0,   463,   464,   465,   466,   884,   468,
       0,   469,   719,   470,   471,   472,     0,     0,   473,     0,
      48,   474,   475,   476,   477,   478,   479,  1001,  1002,  1003,
    1004,  1005,  1006,  1007,   487,   488,   489,     0,     0,     0,
       0,     0,     0,   697,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1987,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,   698,   207,   208,
     209,   210,   211,   699,   212,   213,     0,   214,   215,   216,
     217,   218,     0,   954,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   957,     0,     0,   229,   230,   231,
     232,   700,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   701,   244,   245,   958,   959,
     960,   961,   962,   963,   964,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   969,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,   703,
       0,   704,   288,   289,   290,     0,   291,   972,     0,   293,
       0,   294,   295,   296,   297,   298,   705,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   706,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   707,   708,   318,   709,   319,   320,   321,   322,   323,
     324,   325,     0,   976,   710,   327,   711,     0,   328,   329,
     330,   977,   978,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   712,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,   713,   357,     0,   983,   359,   360,   361,   362,     0,
       0,   363,     0,   664,   364,   365,   366,     0,     0,   367,
     714,   715,   716,   986,   369,   370,   371,   372,   373,   374,
       0,   375,   987,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,   717,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,   990,   421,   422,   423,   424,   718,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   992,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   447,   448,     0,     0,   449,   995,
     451,   996,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,   999,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   719,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
    1001,  1002,  1003,  1004,  1005,  1006,  1007,   487,   488,   489,
       0,     0,     0,     0,     0,     0,   697,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1987,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
     698,   207,   208,   209,   210,   211,   699,   212,   213,     0,
     214,   215,   216,   217,   218,     0,   954,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   957,     0,     0,
     229,   230,   231,   232,   700,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,   701,   244,
     245,   958,   959,   960,   961,   962,   963,   964,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   969,     0,   282,     0,   283,   284,   285,     0,   286,
       0,   287,   703,     0,   704,   288,   289,   290,     0,   291,
     972,     0,   293,     0,   294,   295,   296,   297,   298,   705,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   706,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   707,   708,   318,   709,   319,   320,
     321,   322,   323,   324,   325,     0,   976,   710,   327,   711,
       0,   328,   329,   330,   977,   978,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     712,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,   713,   357,     0,   983,   359,   360,
     361,   362,     0,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   714,   715,   716,   986,   369,   370,   371,
     372,   373,   374,     0,   375,   987,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,     0,   403,   404,   717,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,     0,
     416,   417,   418,   419,   420,   990,   421,   422,   423,   424,
     718,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   992,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
       0,   449,   995,   451,   996,     0,   453,   454,   455,   456,
     457,   458,     0,     0,   459,   460,   461,   462,   999,     0,
     463,   464,   465,   466,   467,   468,     0,   469,   719,   470,
     471,   472,     0,     0,   473,     0,     0,   474,   475,   476,
     477,   478,   479,  1001,  1002,  1003,  1004,  1005,  1006,  1007,
     487,   488,   489,     0,     0,     0,     0,     0,     0,   697,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3173,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,   698,   207,   208,   209,   210,   211,   699,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,   700,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   701,   244,   245,     0,     0,     0,   702,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,   703,     0,   704,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,   298,   705,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   706,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   707,   708,   318,
     709,   319,   320,   321,   322,   323,   324,   325,     0,   326,
     710,   327,   711,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   712,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,   713,   357,     0,
     358,   359,   360,   361,   362,     0,     0,   363,     0,     0,
     364,   365,   366,     0,     0,   367,   714,   715,   716,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
     717,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   718,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     447,   448,     0,     0,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,     0,   459,   460,   461,
     462,     0,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   719,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,     0,     0,     0,     0,
       0,     0,   191,  1390,   540,     0,     0,     0,   585,     0,
       0,     0,  3603,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,  1391,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,   298,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,  1392,     0,
     363,  1393,     0,   364,   365,   366,     0,     0,   367,     0,
       0,     0,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,     0,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,     0,   449,   450,   451,
     452,  1394,   453,   454,   455,   456,   457,   458,     0,     0,
     459,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,     0,   469,     0,   470,   471,   472,     0,     0,
     473,     0,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,     0,
       0,     0,     0,     0,     0,   191,   597,  1395,  3250,     0,
       0,     0,     0,     0,     0,  3251,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     3,     4,
       0,     0,     0,     0,     0,   204,   205,     0,   206,     0,
     207,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,   221,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   278,   279,   280,
     281,     0,   282,     0,   283,   284,   285,     0,   286,     0,
     287,     0,     0,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,   298,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   323,   324,   325,     0,   326,     0,   327,     0,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,     0,     0,   363,     0,     0,   364,   365,   366,     0,
       0,   367,     0,     0,     0,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    38,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,    42,   441,
     442,   443,   444,   445,   446,     0,   447,   448,     0,     0,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,     0,   459,   460,   461,   462,     0,     0,   463,
     464,   465,   466,   884,   468,     0,   469,   885,   470,   471,
     472,     0,     0,   473,     0,    48,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,     0,     0,     0,     0,     0,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    49,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,     0,   207,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,   221,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     278,   279,   280,   281,     0,   282,     0,   283,   284,   285,
       0,   286,     0,   287,     0,     0,     0,   288,   289,   290,
       0,   291,   292,     0,   293,     0,   294,   295,   296,   297,
     298,     0,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   323,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,     0,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,     0,     0,     0,   368,   369,
     370,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    38,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,     0,   425,   426,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,    42,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,     0,   459,   460,   461,   462,
       0,     0,   463,   464,   465,   466,   884,   468,     0,   469,
       0,   470,   471,   472,     0,     0,   473,     0,    48,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,     0,     0,     0,     0,     0,
       0,   191,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    49,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,   367,     0,     0,
       0,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   447,   448,     0,     0,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,     0,   469,     0,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,     0,
       0,     0,     0,     0,   191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1063,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,     0,   287,
       0,     0,     0,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   298,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
       0,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,     0,     0,     0,   368,   369,   370,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,     0,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,     0,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,     0,   425,
     426,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,     0,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,     0,   459,   460,   461,   462,     0,     0,   463,   464,
     465,   466,   467,   468,     0,   469,     0,   470,   471,   472,
       0,     0,   473,     0,     0,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,     0,     0,     0,     0,     0,     0,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1681,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   298,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
       0,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,     0,     0,   363,     0,     0,   364,   365,
     366,     0,     0,   367,     0,     0,     0,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   447,   448,
       0,     0,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,     0,   459,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,     0,   469,     0,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,     0,     0,     0,     0,     0,     0,
     191,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3022,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,     0,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,     0,     0,     0,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,     0,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,     0,   425,   426,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,     0,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,     0,   459,   460,
     461,   462,     0,     0,   463,   464,   465,   466,   467,   468,
       0,   469,     0,   470,   471,   472,     0,     0,   473,     0,
       0,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,     0,     0,
       0,     0,     0,  1264,  1390,   540,     0,     0,   738,   585,
       0,     0,     0,  3146,   192,   193,   194,   195,   196,   197,
     198,   199,  1592,   201,   202,   203,  1593,  1594,  1595,  1596,
    1597,  1598,  1599,   204,   205,  1600,   206,   698,   207,   208,
     209,     0,  1265,   699,  1266,  1267,  1601,   214,   215,   216,
     217,   218,  1602,  1603,   219,   220,  1268,  1269,   223,  1604,
     224,   225,   226,   227,     0,  1605,  1606,   229,   230,   231,
     232,   700,   233,   234,  1607,   235,   236,   237,   238,   239,
     240,  1608,   241,   242,   243,   701,   244,   245,  1609,  1610,
    1611,   702,  1612,  1613,  1614,   246,   247,   248,   249,   250,
     251,  1270,  1271,   254,  1615,   255,  1616,   256,   257,   258,
     259,   260,  1617,   261,   262,   263,  1618,  1619,   264,   265,
     967,   267,   268,  1620,   269,   270,   271,  1621,   272,   273,
    1622,   274,   275,   276,   277,     0,   279,   280,     0,  1623,
     282,  1624,   283,  1272,   285,  1625,   286,  1626,   287,   703,
    1627,   704,   288,   289,   290,  1628,   291,     0,  1629,   293,
    1630,   294,   295,   296,   297,   298,   705,   299,   300,   301,
    1631,   302,   303,   304,   305,   306,   307,  1632,   308,   706,
       0,   310,   311,   312,   313,  1273,  1274,  1633,  1275,  1634,
     317,   707,   708,   318,   709,   319,   320,   321,   322,   323,
     324,   325,  1635,     0,   710,   327,   711,  1636,   328,   329,
     330,  1637,  1638,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,  1276,   712,  1277,   346,
     347,   348,   349,   350,   351,   352,     0,   354,  1639,   355,
     356,   713,   357,  1640,     0,   359,  1278,   361,   362,  1641,
    1642,   363,  1643,  1644,  2898,   365,   366,  1645,  1646,     0,
     714,   715,   716,     0,   369,   370,   371,   372,   373,   374,
    1647,   375,     0,   377,     0,   379,   380,   381,  1648,   382,
     383,   384,   385,   386,   387,   388,  1279,   390,   391,   392,
    1649,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,  1650,   403,   404,   717,   405,   406,     0,   408,   409,
     410,   411,   412,   413,   414,   415,  1651,   416,   417,   418,
     419,   420,  1652,   421,  1781,   423,   424,   718,   425,  1281,
    1653,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   438,  1654,   439,   440,  1655,   441,   442,   443,
     444,   445,   446,  1656,  1282,  1283,  1657,  1658,   449,     0,
     451,     0,  1659,   453,   454,   455,   456,   457,   458,  1660,
    1661,   459,   460,   461,   462,  1662,  1663,   463,   464,   465,
     466,     0,  1284,  1664,   469,   719,   470,   471,   472,  1665,
    1666,   473,  1667,  1668,   474,   475,   476,   477,   478,     0,
       0,     0,     0,     0,     0,     0,     0,   487,   488,   489,
       0,     0,     0,   741,   742,   743,     0,  2899,  2900,   746,
     747,   748,   749,   191,     0,     0,     0,     0,   738,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   739,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     740,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   298,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,     0,
       0,   363,     0,     0,   364,   365,   366,     0,     0,   367,
       0,     0,     0,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   447,   448,     0,     0,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,     0,   469,     0,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
       0,     0,     0,   741,   742,   743,     0,   744,   745,   746,
     747,   748,   749,   191,     0,     0,     0,     0,   738,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   813,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     814,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   298,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,     0,
       0,   363,     0,     0,   364,   365,   366,     0,     0,   367,
       0,     0,     0,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   447,   448,     0,     0,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,     0,   469,     0,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
       0,     0,     0,   741,   742,   743,     0,   744,   745,   746,
     747,   748,   749,   191,     0,     0,     0,     0,   738,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   857,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     858,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   859,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,     0,
       0,   363,     0,     0,   364,   365,   366,     0,     0,   367,
       0,     0,     0,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   447,   448,     0,     0,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,     0,   469,     0,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
       0,     0,     0,   741,   742,   743,     0,   744,   745,   746,
     747,   748,   749,   191,     0,     0,     0,     0,   738,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,  1247,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
    1248,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   298,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,     0,
       0,   363,     0,     0,   364,   365,   366,     0,     0,   367,
       0,     0,     0,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   447,   448,     0,     0,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,     0,   469,     0,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
       0,     0,     0,   741,   742,   743,     0,   744,   745,   746,
     747,   748,   749,   191,     0,     0,     0,     0,   738,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   298,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,     0,
       0,   363,     0,     0,   364,   365,   366,     0,     0,   367,
       0,     0,     0,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   447,   448,     0,     0,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,     0,   469,     0,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
       0,     0,     0,   741,   742,   743,     0,   744,   745,   746,
     747,   748,   749,   191,     0,     0,     0,     0,   738,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   298,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,     0,
       0,   363,     0,     0,  3592,   365,   366,     0,     0,   367,
       0,     0,     0,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   447,   448,     0,     0,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,     0,   469,     0,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
       0,     0,  1591,   741,   742,   743,     0,   744,   745,   746,
     747,   748,   749,   192,   193,   194,   195,   196,   197,   198,
     199,  1592,   201,   202,   203,  1593,  1594,  1595,  1596,  1597,
    1598,  1599,   204,   205,  1600,   206,   698,   207,   208,   209,
     210,   211,   699,   212,   213,  1601,   214,   215,   216,   217,
     218,  1602,  1603,   219,   220,   221,   222,   223,  1604,   224,
     225,   226,   227,   228,  1605,  1606,   229,   230,   231,   232,
     700,   233,   234,  1607,   235,   236,   237,   238,   239,   240,
    1608,   241,   242,   243,   701,   244,   245,  1609,  1610,  1611,
     702,  1612,  1613,  1614,   246,   247,   248,   249,   250,   251,
     252,   253,   254,  1615,   255,  1616,   256,   257,   258,   259,
     260,  1617,   261,   262,   263,  1618,  1619,   264,   265,   266,
     267,   268,  1620,   269,   270,   271,  1621,   272,   273,  1622,
     274,   275,   276,   277,   278,   279,   280,   281,  1623,   282,
    1624,   283,   284,   285,  1625,   286,  1626,   287,   703,  1627,
     704,   288,   289,   290,  1628,   291,   292,  1629,   293,  1630,
     294,   295,   296,   297,   298,   705,   299,   300,   301,  1631,
     302,   303,   304,   305,   306,   307,  1632,   308,   706,   309,
     310,   311,   312,   313,   314,   315,  1633,   316,  1634,   317,
     707,   708,   318,   709,   319,   320,   321,   322,   323,   324,
     325,  1635,   326,   710,   327,   711,  1636,   328,   329,   330,
    1637,  1638,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   712,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,  1639,   355,   356,
     713,   357,  1640,   358,   359,   360,   361,   362,  1641,  1642,
     363,  1643,  1644,   364,   365,   366,  1645,  1646,   367,   714,
     715,   716,   368,   369,   370,   371,   372,   373,   374,  1647,
     375,   376,   377,   378,   379,   380,   381,  1648,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,  1649,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
    1650,   403,   404,   717,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,  1651,   416,   417,   418,   419,
     420,  1652,   421,   422,   423,   424,   718,   425,   426,  1653,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,  1654,   439,   440,  1655,   441,   442,   443,   444,
     445,   446,  1656,   447,   448,  1657,  1658,   449,   450,   451,
     452,  1659,   453,   454,   455,   456,   457,   458,  1660,  1661,
     459,   460,   461,   462,  1662,  1663,   463,   464,   465,   466,
     467,   468,  1664,   469,   719,   470,   471,   472,  1665,  1666,
     473,  1667,  1668,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   191,
       0,     0,     0,     0,     0,     0,     0,     0,  1669,     0,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,   298,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,     0,     0,   363,     0,     0,
     364,   365,   366,     0,     0,   367,     0,     0,     0,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     447,   448,     0,     0,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,     0,   459,   460,   461,
     462,     0,     0,   463,   464,   465,   466,   467,   468,     0,
     469,     0,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   191,     0,     0,     0,
       0,     0,     0,     0,     0,   669,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
       0,   207,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
       0,   287,     0,     0,     0,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   298,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,     0,   319,   320,
     321,   322,   323,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,     0,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,     0,     0,     0,   368,   369,   370,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,     0,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
       0,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,     0,   459,   460,   461,   462,     0,     0,
     463,   464,   465,   466,   467,   468,     0,   469,     0,   470,
     471,   472,     0,     0,   473,     0,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,  1264,     0,     0,     0,     0,     0,     0,
       0,     0,  3482,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,   698,   207,   208,
     209,     0,  1265,   699,  1266,  1267,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,  1268,  1269,   223,     0,
     224,   225,   226,   227,     0,     0,     0,   229,   230,   231,
     232,   700,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   701,   244,   245,     0,     0,
       0,   702,     0,     0,     0,   246,   247,   248,   249,   250,
     251,  1270,  1271,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     967,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,     0,   279,   280,     0,     0,
     282,     0,   283,  1272,   285,     0,   286,     0,   287,   703,
       0,   704,   288,   289,   290,     0,   291,     0,     0,   293,
       0,   294,   295,   296,   297,   298,   705,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   706,
       0,   310,   311,   312,   313,  1273,  1274,     0,  1275,     0,
     317,   707,   708,   318,   709,   319,   320,   321,   322,   323,
     324,   325,     0,     0,   710,   327,   711,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,  1276,   712,  1277,   346,
     347,   348,   349,   350,   351,   352,     0,   354,     0,   355,
     356,   713,   357,     0,     0,   359,  1278,   361,   362,     0,
       0,   363,     0,     0,   364,   365,   366,     0,     0,     0,
     714,   715,   716,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,   377,     0,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,  1279,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,   717,   405,   406,     0,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,     0,   421,  1280,   423,   424,   718,   425,  1281,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,  1282,  1283,     0,     0,   449,     0,
     451,     0,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,     0,     0,   463,   464,   465,
     466,     0,  1284,     0,   469,   719,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,     0,
    1908,     0,     0,     0,     0,     0,     0,   487,   488,   489,
       0,   192,   193,   194,   195,   196,   197,   198,   199,  1726,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,   698,   207,   208,   209,     0,  1265,
     699,  1266,  1267,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,  1268,  1269,   223,     0,   224,   225,   226,
     227,     0,     0,     0,   229,   230,   231,   232,   700,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,   701,   244,   245,     0,     0,     0,   702,     0,
       0,     0,   246,   247,   248,   249,   250,   251,  1270,  1271,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   967,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,     0,   279,   280,     0,     0,   282,     0,   283,
    1272,   285,     0,   286,     0,   287,   703,     0,   704,   288,
     289,   290,     0,   291,     0,     0,   293,     0,   294,   295,
     296,   297,   298,   705,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   706,     0,   310,   311,
     312,   313,  1273,  1274,     0,  1275,     0,   317,   707,   708,
     318,   709,   319,   320,   321,   322,   323,   324,   325,     0,
       0,   710,   327,   711,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,  1276,   712,  1277,   346,   347,   348,   349,
     350,   351,   352,     0,   354,     0,   355,   356,   713,   357,
       0,     0,   359,  1278,   361,   362,     0,     0,   363,     0,
       0,   364,   365,   366,     0,     0,     0,   714,   715,   716,
       0,   369,   370,   371,   372,   373,   374,     0,   375,     0,
     377,     0,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,  1279,   390,   391,   392,     0,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,     0,   403,
     404,   717,   405,   406,     0,   408,   409,   410,   411,   412,
     413,   414,   415,     0,   416,   417,   418,   419,   420,     0,
     421,  1280,   423,   424,   718,   425,  1281,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,  1282,  1283,     0,     0,   449,     0,   451,     0,     0,
     453,   454,   455,   456,   457,   458,     0,     0,   459,   460,
     461,   462,     0,     0,   463,   464,   465,   466,     0,  1284,
       0,   469,   719,   470,   471,   472,     0,     0,   473,     0,
       0,   474,   475,   476,   477,   478,     0,   191,  1390,   540,
       0,     0,     0,   585,   487,   488,   489,     0,   192,   193,
     194,   195,   196,   197,   198,   199,  1726,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,  1580,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,  1391,   282,     0,   283,   284,   285,     0,
     286,     0,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   298,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
       0,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,  1392,     0,   363,  1393,     0,   364,   365,
     366,     0,     0,   367,     0,     0,     0,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   447,   448,
       0,     0,   449,   450,   451,   452,  1394,   453,   454,   455,
     456,   457,   458,     0,     0,   459,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,     0,   469,     0,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   191,  1390,   540,     0,     0,     0,
     585,   597,  1395,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,  1586,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
    1391,   282,     0,   283,   284,   285,     0,   286,     0,   287,
       0,     0,     0,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   298,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
    1392,     0,   363,  1393,     0,   364,   365,   366,     0,     0,
     367,     0,     0,     0,   368,   369,   370,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,     0,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,     0,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,     0,   425,
     426,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,     0,   449,
     450,   451,   452,  1394,   453,   454,   455,   456,   457,   458,
       0,     0,   459,   460,   461,   462,     0,     0,   463,   464,
     465,   466,   467,   468,     0,   469,     0,   470,   471,   472,
       0,     0,   473,     0,     0,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   191,  1390,   540,     0,     0,     0,   585,   597,  1395,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,  1391,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,  1392,     0,   363,
    1393,     0,   364,   365,   366,     0,     0,   367,     0,     0,
       0,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   447,   448,     0,     0,   449,   450,   451,   452,
    1394,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,     0,   469,     0,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   191,     0,
       0,     0,     0,     0,   585,   597,  1395,     0,     0,   192,
     586,   194,   195,   196,   197,   198,   199,   587,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,     0,   588,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,   221,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     278,   279,   280,   281,     0,   282,     0,   589,   284,   285,
       0,   286,     0,   590,     0,   591,     0,   288,   289,   290,
       0,   291,   292,     0,   293,     0,   294,   295,   296,   297,
     298,     0,   299,   300,   301,   592,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   593,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   594,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,     0,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,     0,     0,     0,   368,   369,
     370,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,     0,   595,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,   596,   395,   396,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,     0,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,     0,   425,   426,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,     0,   459,   460,   461,   462,
       0,     0,   463,   464,   465,   466,   467,   468,     0,   469,
       0,   470,   471,   472,     0,     0,   473,     0,     0,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,  1591,     0,     0,     0,     0,
       0,     0,   597,   598,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,  1592,   201,   202,   203,  1593,  1594,
    1595,  1596,  1597,  1598,  1599,   204,   205,  1600,   206,   698,
     207,   208,   209,   210,   211,   699,   212,   213,  1601,   214,
     215,   216,   217,   218,  1602,  1603,   219,   220,   221,   222,
     223,  1604,   224,   225,   226,   227,   228,  1605,  1606,   229,
     230,   231,   232,   700,   233,   234,  1607,   235,   236,   237,
     238,   239,   240,  1608,   241,   242,   243,   701,   244,   245,
    1609,  1610,  1611,   702,  1612,  1613,  1614,   246,   247,   248,
     249,   250,   251,   252,   253,   254,  1615,   255,  1616,   256,
     257,   258,   259,   260,  1617,   261,   262,   263,  1618,  1619,
     264,   265,   266,   267,   268,  1620,   269,   270,   271,  1621,
     272,   273,  1622,   274,   275,   276,   277,   278,   279,   280,
     281,  1623,   282,  1624,   283,   284,   285,  1625,   286,  1626,
     287,   703,  1627,   704,   288,   289,   290,  1628,   291,   292,
    1629,   293,  1630,   294,   295,   296,   297,   298,   705,   299,
     300,   301,  1631,   302,   303,   304,   305,   306,   307,  1632,
     308,   706,   309,   310,   311,   312,   313,   314,   315,  1633,
     316,  1634,   317,   707,   708,   318,   709,   319,   320,   321,
     322,   323,   324,   325,  1635,   326,   710,   327,   711,  1636,
     328,   329,   330,  1637,  1638,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   712,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
    1639,   355,   356,   713,   357,  1640,   358,   359,   360,   361,
     362,  1641,  1642,   363,  1643,  1644,   364,   365,   366,  1645,
    1646,   367,   714,   715,   716,   368,   369,   370,   371,   372,
     373,   374,  1647,   375,   376,   377,   378,   379,   380,   381,
    1648,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,  1649,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,  1650,   403,   404,   717,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,  1651,   416,
     417,   418,   419,   420,  1652,   421,   422,   423,   424,   718,
     425,   426,  1653,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,  1654,   439,   440,  1655,   441,
     442,   443,   444,   445,   446,  1656,   447,   448,  1657,  1658,
     449,   450,   451,   452,  1659,   453,   454,   455,   456,   457,
     458,  1660,  1661,   459,   460,   461,   462,  1662,  1663,   463,
     464,   465,   466,   467,   468,  1664,   469,   719,   470,   471,
     472,  1665,  1666,   473,  1667,  1668,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,  1591,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   192,   193,   194,   195,  2399,   197,   198,
     199,  1592,   201,   202,   203,  1593,  1594,  1595,  1596,  1597,
    1598,  1599,   204,   205,  1600,   206,   698,   207,   208,   209,
     210,   211,   699,   212,   213,  1601,   214,   215,   216,   217,
     218,  1602,  1603,   219,   220,   221,   222,   223,  1604,   224,
     225,   226,   227,   228,  1605,  1606,   229,   230,   231,   232,
     700,   233,   234,  1607,   235,   236,   237,   238,   239,   240,
    1608,   241,   242,   243,   701,   244,   245,  1609,  1610,  1611,
     702,  1612,  1613,  1614,   246,   247,   248,   249,   250,   251,
     252,   253,   254,  1615,   255,  1616,   256,   257,   258,   259,
     260,  1617,   261,   262,   263,  1618,  1619,   264,   265,   266,
    2400,   268,  1620,   269,   270,   271,  1621,   272,   273,  1622,
     274,   275,   276,   277,   278,   279,   280,   281,  1623,   282,
    1624,   283,   284,   285,  1625,   286,  1626,   287,   703,  1627,
     704,   288,   289,   290,  1628,   291,   292,  1629,   293,  1630,
     294,   295,   296,   297,   298,   705,   299,   300,   301,  1631,
     302,   303,   304,   305,   306,   307,  1632,   308,   706,   309,
     310,   311,   312,   313,   314,   315,  1633,   316,  1634,   317,
     707,   708,   318,   709,   319,   320,   321,   322,   323,   324,
     325,  1635,   326,   710,   327,   711,  1636,   328,   329,   330,
    1637,  1638,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   712,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,  1639,   355,   356,
     713,   357,  1640,   358,   359,   360,   361,   362,  1641,  1642,
     363,  1643,  1644,   364,   365,   366,  1645,  1646,   367,   714,
     715,   716,   368,   369,   370,   371,   372,   373,   374,  1647,
     375,   376,   377,   378,   379,   380,   381,  1648,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,  1649,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
    1650,   403,   404,   717,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,  1651,   416,   417,   418,   419,
     420,  1652,  2401,   422,   423,   424,   718,   425,   426,  1653,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,  1654,   439,   440,  1655,   441,   442,   443,   444,
     445,   446,  1656,   447,   448,  1657,  1658,   449,   450,   451,
     452,  1659,   453,   454,   455,   456,   457,   458,  1660,  1661,
     459,   460,   461,   462,  1662,  1663,   463,   464,   465,   466,
     467,   468,  1664,   469,   719,   470,   471,   472,  1665,  1666,
     473,  1667,  1668,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   697,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,   698,   207,   208,   209,   210,   211,   699,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,   700,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   701,   244,   245,     0,     0,     0,   702,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,   703,     0,   704,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,   298,   705,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   706,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   707,   708,   318,
     709,   319,   320,   321,   322,   323,   324,   325,     0,   326,
     710,   327,   711,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   712,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,   713,   357,     0,
     358,   359,   360,   361,   362,     0,     0,   363,     0,     0,
     364,   365,   366,     0,     0,   367,   714,   715,   716,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
     717,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   718,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     447,   448,     0,     0,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,     0,   459,   460,   461,
     462,     0,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   719,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   697,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
     698,   207,   208,   209,   210,   211,   699,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,   700,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,   701,   244,
     245,     0,     0,     0,   702,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
       0,   287,   703,     0,   704,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   844,   705,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   706,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   707,   708,   318,   709,   319,   320,
     321,   322,   323,   324,   325,     0,   326,   710,   327,   711,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     712,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,   713,   357,     0,   358,   359,   360,
     361,   362,     0,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   714,   715,   716,   368,   369,   370,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,     0,   403,   404,   717,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,     0,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     718,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
       0,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,     0,   459,   460,   461,   462,     0,     0,
     463,   464,   465,   466,   467,   468,     0,   469,   719,   470,
     471,   472,     0,     0,   473,     0,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   697,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,   698,   207,   208,
     209,   210,   211,   699,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,   700,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   701,   244,   245,     0,     0,
       0,   702,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,   703,
       0,   704,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   852,   705,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   706,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   707,   708,   318,   709,   319,   320,   321,   322,   323,
     324,   325,     0,   326,   710,   327,   711,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   712,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,   713,   357,     0,   358,   359,   360,   361,   362,     0,
       0,   363,     0,     0,   364,   365,   366,     0,     0,   367,
     714,   715,   716,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,   717,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   718,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   447,   448,     0,     0,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   719,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     191,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,  1748,   224,   225,   226,
     227,   228,     0,  1793,   229,   230,   231,   232,     0,   233,
     234,  1749,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,  1794,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,  1751,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,     0,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,     0,     0,     0,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,  1752,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,     0,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,     0,   425,   426,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,     0,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,  1753,   459,   460,
     461,   462,     0,     0,   463,   464,   465,   466,   467,   468,
       0,   469,     0,   470,   471,   472,     0,     0,   473,     0,
       0,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,  1748,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,     0,   233,   234,  1749,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,  1794,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,  1751,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   298,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
    2524,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,     0,     0,   363,     0,     0,   364,   365,
     366,     0,     0,   367,     0,     0,     0,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,  1752,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   447,   448,
       0,     0,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,  1753,   459,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,     0,   469,     0,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   194,   195,   196,
     636,   198,   199,   604,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,   605,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,     0,   287,
       0,     0,     0,   288,   289,   290,   637,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   298,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
       0,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,     0,     0,     0,   368,   369,   370,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   606,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   607,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,     0,   425,
     426,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,     0,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,     0,   459,   460,   461,   462,     0,     0,   463,   464,
     465,   466,   467,   468,     0,   469,     0,   470,   471,   472,
       0,     0,   473,     0,     0,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   191,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
     604,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,   605,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,  2290,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,   367,     0,     0,
       0,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   606,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   607,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   447,   448,     0,     0,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,     0,   469,     0,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,     0,   207,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,   221,   222,   223,  1748,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,     0,   233,   234,  1749,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,  1794,   275,   276,   277,
     278,   279,   280,   281,     0,   282,     0,   283,   284,   285,
       0,   286,  1751,   287,     0,     0,     0,   288,   289,   290,
       0,   291,   292,     0,   293,     0,   294,   295,   296,   297,
     298,     0,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   323,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,     0,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,     0,     0,     0,   368,   369,
     370,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,  1752,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,     0,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,     0,   425,   426,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,  1753,   459,   460,   461,   462,
       0,     0,   463,   464,   465,   466,   467,   468,     0,   469,
       0,   470,   471,   472,     0,     0,   473,     0,     0,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   191,     0,   540,     0,     0,
       0,     0,     0,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,     0,
     207,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,   221,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   278,   279,   280,
     281,  1391,   282,     0,   283,   284,   285,     0,   286,     0,
     287,     0,     0,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,   298,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   323,   324,   325,     0,   326,     0,   327,     0,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,  1392,     0,   363,  1393,     0,   364,   365,   366,     0,
       0,   367,     0,     0,     0,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,   447,   448,     0,     0,
     449,   450,   451,   452,  1394,   453,   454,   455,   456,   457,
     458,     0,     0,   459,   460,   461,   462,     0,     0,   463,
     464,   465,   466,   467,   468,     0,   469,     0,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   191,  3832,   540,  3833,  3834,     0,   585,     0,
       0,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,     0,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,   298,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,     0,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,     0,
       0,     0,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,     0,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,     0,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,     0,
     459,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,     0,   469,     0,   470,   471,   472,     0,     0,
     473,     0,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,   604,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,   605,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,   298,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,     0,     0,   363,     0,     0,
     364,   365,   366,     0,     0,   367,     0,     0,     0,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   606,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   607,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     447,   448,     0,     0,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,     0,   459,   460,   461,
     462,     0,     0,   463,   464,   465,   466,   467,   468,     0,
     469,     0,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,  1421,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
       0,   207,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,  1422,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
    1423,   287,     0,     0,     0,  1424,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   298,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,     0,   319,   320,
    1425,  1426,   323,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,     0,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,     0,     0,     0,   368,   369,   370,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,   405,   406,
     407,   408,   409,   410,  1427,   412,   413,   414,   415,     0,
    1428,   417,   418,   419,   420,     0,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,  1429,
     441,  1430,   443,   444,   445,   446,     0,   447,   448,     0,
       0,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,     0,   459,   460,   461,   462,     0,     0,
     463,   464,   465,   466,   467,   468,     0,   469,     0,   470,
     471,   472,     0,     0,   473,     0,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   191,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,   605,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   298,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,     0,
       0,   363,     0,     0,   364,   365,   366,     0,     0,   367,
       0,     0,     0,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     606,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   607,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   447,   448,     0,     0,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,     0,   469,     0,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     191,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     3,     4,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,     0,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,     0,     0,     0,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,     0,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,     0,   425,   426,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,     0,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,     0,   459,   460,
     461,   462,     0,     0,   463,   464,   465,   466,   467,   468,
       0,   469,   885,   470,   471,   472,     0,     0,   473,     0,
       0,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   191,     0,   540,
       0,     0,     0,     0,     0,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,  1566,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   298,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
       0,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,     0,     0,   363,     0,     0,   364,   365,
     366,     0,     0,   367,     0,     0,     0,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   447,   448,
       0,     0,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,     0,   459,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,     0,   469,     0,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,  1870,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,     0,   287,
       0,     0,     0,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   298,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
       0,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,     0,     0,     0,   368,   369,   370,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,     0,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,     0,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,     0,   425,
     426,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,     0,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,     0,   459,   460,   461,   462,  1871,     0,   463,   464,
     465,   466,   467,   468,     0,   469,     0,   470,   471,   472,
       0,     0,   473,     0,     0,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   191,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     3,     4,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,   367,     0,     0,
       0,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   447,   448,     0,     0,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,     0,   469,     0,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,  2334,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,     0,   207,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,   221,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     278,   279,   280,   281,     0,   282,     0,   283,   284,   285,
       0,   286,     0,   287,     0,     0,     0,   288,   289,   290,
       0,   291,   292,     0,   293,     0,   294,   295,   296,   297,
     298,     0,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   323,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,     0,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,     0,     0,     0,   368,   369,
     370,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,     0,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,     0,   425,   426,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,     0,   459,   460,   461,   462,
    2335,     0,   463,   464,   465,   466,   467,   468,     0,   469,
       0,   470,   471,   472,     0,     0,   473,     0,     0,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,  2346,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,     0,
     207,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,   221,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   278,   279,   280,
     281,     0,   282,     0,   283,   284,   285,     0,   286,     0,
     287,     0,     0,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,   298,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   323,   324,   325,     0,   326,     0,   327,     0,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,     0,     0,   363,     0,     0,   364,   365,   366,     0,
       0,   367,     0,     0,     0,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,   447,   448,     0,     0,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,     0,   459,   460,   461,   462,  2347,     0,   463,
     464,   465,   466,   467,   468,     0,   469,     0,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   191,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,     0,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,   298,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,     0,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,     0,
       0,     0,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,     0,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,     0,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,     0,
     459,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,     0,   469,     0,   470,   471,   472,     0,     0,
     473,     0,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,   531,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,   298,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,     0,     0,   363,     0,     0,
     364,   365,   366,     0,     0,   367,     0,     0,     0,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   532,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     447,   448,     0,     0,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,     0,   459,   460,   461,
     462,     0,     0,   463,   464,   465,   466,   467,   468,     0,
     469,     0,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,   630,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
       0,   207,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
       0,   287,     0,     0,     0,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   298,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,     0,   319,   320,
     321,   322,   323,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,     0,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,     0,     0,     0,   368,   369,   370,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,     0,
     416,   417,   418,   419,   631,     0,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,   632,   448,     0,
       0,   633,   450,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,     0,   459,   460,   461,   462,     0,     0,
     463,   464,   465,   466,   467,   468,     0,   469,     0,   470,
     471,   472,     0,     0,   473,     0,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   191,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,   658,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   298,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,     0,
       0,   363,     0,     0,   364,   365,   366,     0,     0,   367,
       0,     0,     0,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   659,     0,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   660,   448,     0,     0,   661,   450,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,     0,   469,     0,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     191,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,     0,     0,   363,     0,
     664,   364,   365,   366,     0,     0,   367,     0,     0,     0,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,     0,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,     0,   425,   426,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,     0,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,     0,   459,   460,
     461,   462,     0,     0,   463,   464,   465,   466,   467,   468,
       0,   469,     0,   470,   471,   472,     0,     0,   473,     0,
       0,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,   836,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   298,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
       0,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,     0,     0,   363,     0,     0,   364,   365,
     366,     0,     0,   367,     0,     0,     0,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   447,   448,
       0,     0,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,     0,   459,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,     0,   469,     0,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   191,     0,   540,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,     0,   287,
       0,     0,     0,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   298,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
       0,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,     0,     0,     0,   368,   369,   370,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,     0,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,     0,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,     0,   425,
     426,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,     0,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,     0,   459,   460,   461,   462,     0,     0,   463,   464,
     465,   466,   467,   468,     0,   469,     0,   470,   471,   472,
       0,     0,   473,     0,     0,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   191,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
    1039,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,   367,     0,     0,
       0,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   447,   448,     0,     0,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,     0,   469,     0,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,  1050,   207,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   646,
     220,   221,   222,  1051,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     278,   279,   280,   281,     0,   282,     0,   283,   284,   285,
       0,   286,     0,   287,     0,     0,     0,   288,   289,   290,
       0,   291,   292,     0,   293,     0,   294,   295,   296,   297,
     298,     0,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   323,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     649,   344,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,     0,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,     0,     0,     0,   368,   369,
     370,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
     650,   406,   407,   408,   409,   410,   651,   412,   413,   414,
     415,     0,   416,   417,   418,   419,  1043,     0,   421,   422,
     423,   424,     0,   425,   426,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,   653,
     448,     0,     0,   654,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,     0,   459,   460,   461,   462,
       0,     0,   463,   464,   465,   466,   467,   468,     0,   469,
       0,   470,   471,   472,     0,     0,   473,     0,     0,   474,
     475,   476,   477,   655,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   191,     0,   540,     0,     0,
       0,     0,     0,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,     0,
     207,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,   221,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   278,   279,   280,
     281,     0,   282,     0,   283,   284,   285,     0,   286,     0,
     287,     0,     0,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,  1380,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   323,   324,   325,     0,   326,     0,   327,     0,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,     0,     0,   363,     0,     0,   364,   365,   366,     0,
       0,   367,     0,     0,     0,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,   447,   448,     0,     0,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,     0,   459,   460,   461,   462,     0,     0,   463,
     464,   465,   466,   467,   468,     0,   469,     0,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   191,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,     0,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,  2212,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,   298,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,  2213,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,     0,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,     0,
       0,     0,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,     0,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,  2214,   441,   442,  2215,   444,
    2216,   446,     0,   447,   448,     0,     0,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,     0,
     459,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,     0,   469,     0,   470,   471,   472,     0,     0,
     473,     0,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,     0,  2559,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,   298,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,     0,     0,   363,     0,     0,
     364,   365,   366,     0,     0,   367,     0,     0,     0,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     447,   448,     0,     0,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,     0,   459,   460,   461,
     462,     0,     0,   463,   464,   465,   466,   467,   468,     0,
     469,     0,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,  2572,     0,   204,   205,     0,   206,
       0,   207,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
       0,   287,     0,     0,     0,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   298,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,     0,   319,   320,
     321,   322,   323,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,     0,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,     0,     0,     0,   368,   369,   370,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,     0,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
       0,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,     0,   459,   460,   461,   462,     0,     0,
     463,   464,   465,   466,   467,   468,     0,   469,     0,   470,
     471,   472,     0,     0,   473,     0,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   191,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,  2611,   293,
       0,   294,   295,   296,   297,   298,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,     0,
       0,   363,     0,     0,   364,   365,   366,     0,     0,   367,
       0,     0,     0,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   447,   448,     0,     0,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,     0,   469,     0,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     191,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,  3286,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,     0,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,     0,     0,     0,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,     0,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,     0,   425,   426,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,     0,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,     0,   459,   460,
     461,   462,     0,     0,   463,   464,   465,   466,   467,   468,
       0,   469,     0,   470,   471,   472,     0,     0,   473,     0,
       0,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,  3288,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   298,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
       0,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,     0,     0,   363,     0,     0,   364,   365,
     366,     0,     0,   367,     0,     0,     0,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   447,   448,
       0,     0,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,     0,   459,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,     0,   469,     0,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,  3290,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,     0,   287,
       0,     0,     0,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   298,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
       0,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,     0,     0,     0,   368,   369,   370,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,     0,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,     0,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,     0,   425,
     426,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,     0,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,     0,   459,   460,   461,   462,     0,     0,   463,   464,
     465,   466,   467,   468,     0,   469,     0,   470,   471,   472,
       0,     0,   473,     0,     0,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   191,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,   367,     0,     0,
       0,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   447,   448,     0,     0,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,  3437,   463,   464,   465,   466,   467,
     468,     0,   469,     0,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,     0,   207,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,   221,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     278,   279,   280,   281,     0,   282,     0,   283,   284,   285,
       0,   286,     0,   287,     0,     0,     0,   288,   289,   290,
       0,   291,   292,     0,   293,     0,   294,   295,   296,   297,
     298,     0,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   323,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,     0,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,     0,     0,     0,   368,   369,
     370,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,     0,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,     0,   425,   426,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,     0,   459,   460,   461,   462,
       0,     0,   463,   464,   465,   466,   467,   468,     0,   469,
       0,   470,   471,   472,     0,     0,   473,     0,     0,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,     0,
     207,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,   221,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   278,   279,   280,
     281,     0,   282,     0,   283,   284,   285,     0,   286,     0,
     287,     0,     0,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,   298,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   323,   324,   325,     0,   326,     0,   327,     0,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,     0,     0,   363,     0,     0,   364,   365,   366,     0,
       0,   367,     0,     0,     0,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,   447,   448,     0,     0,
     620,   450,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,     0,   459,   460,   461,   462,     0,     0,   463,
     464,   465,   466,   467,   468,     0,   469,     0,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   191,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,     0,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,   298,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,     0,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,     0,
       0,     0,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,   405,   406,   407,   408,   409,   628,
     411,   412,   413,   414,   415,     0,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,     0,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,     0,
     459,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,     0,   469,     0,   470,   471,   472,     0,     0,
     473,     0,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     646,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   647,   236,   237,   238,   239,   240,     0,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,   298,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   648,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   649,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,     0,     0,   363,     0,     0,
     364,   365,   366,     0,     0,   367,     0,     0,     0,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,   650,   406,   407,   408,   409,   410,   651,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   652,     0,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     653,   448,     0,     0,   654,   450,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,     0,   459,   460,   461,
     462,     0,     0,   463,   464,   465,   466,   467,   468,     0,
     469,     0,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   655,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
       0,   207,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
       0,   287,     0,     0,     0,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   298,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,     0,   319,   320,
     321,   322,   323,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,     0,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,     0,     0,     0,   368,   369,   370,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   678,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,     0,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
       0,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,     0,   459,   460,   461,   462,     0,     0,
     463,   464,   465,   466,   467,   468,     0,   469,     0,   470,
     471,   472,     0,     0,   473,     0,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   191,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   298,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   763,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,     0,
       0,   363,     0,     0,   364,   365,   366,     0,     0,   367,
       0,     0,     0,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   447,   448,     0,     0,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,     0,   469,     0,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     191,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   825,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,     0,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,     0,     0,     0,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,     0,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,     0,   425,   426,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,     0,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,     0,   459,   460,
     461,   462,     0,     0,   463,   464,   465,   466,   467,   468,
       0,   469,     0,   470,   471,   472,     0,     0,   473,     0,
       0,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   849,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
       0,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,     0,     0,   363,     0,     0,   364,   365,
     366,     0,     0,   367,     0,     0,     0,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   447,   448,
       0,     0,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,     0,   459,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,     0,   469,     0,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,     0,   287,
       0,     0,     0,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   854,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
       0,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,     0,     0,     0,   368,   369,   370,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,     0,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,     0,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,     0,   425,
     426,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,     0,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,     0,   459,   460,   461,   462,     0,     0,   463,   464,
     465,   466,   467,   468,     0,   469,     0,   470,   471,   472,
       0,     0,   473,     0,     0,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   191,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   862,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,   367,     0,     0,
       0,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   447,   448,     0,     0,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,     0,   469,     0,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,     0,   207,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,   221,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     278,   279,   280,   281,     0,   282,     0,   283,   284,   285,
       0,   286,     0,   287,     0,     0,     0,   288,   289,   290,
       0,   291,   292,     0,   293,     0,   294,   295,   296,   297,
     864,     0,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   323,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,     0,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,     0,     0,     0,   368,   369,
     370,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,     0,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,     0,   425,   426,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,     0,   459,   460,   461,   462,
       0,     0,   463,   464,   465,   466,   467,   468,     0,   469,
       0,   470,   471,   472,     0,     0,   473,     0,     0,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,     0,
     207,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,   221,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   278,   279,   280,
     281,     0,   282,     0,   283,   284,   285,     0,   286,     0,
     287,     0,     0,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,   866,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   323,   324,   325,     0,   326,     0,   327,     0,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,     0,     0,   363,     0,     0,   364,   365,   366,     0,
       0,   367,     0,     0,     0,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,   447,   448,     0,     0,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,     0,   459,   460,   461,   462,     0,     0,   463,
     464,   465,   466,   467,   468,     0,   469,     0,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   191,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,     0,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,   868,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,     0,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,     0,
       0,     0,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,     0,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,     0,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,     0,
     459,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,     0,   469,     0,   470,   471,   472,     0,     0,
     473,     0,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,   871,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,     0,     0,   363,     0,     0,
     364,   365,   366,     0,     0,   367,     0,     0,     0,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     447,   448,     0,     0,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,     0,   459,   460,   461,
     462,     0,     0,   463,   464,   465,   466,   467,   468,     0,
     469,     0,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
       0,   207,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
       0,   287,     0,     0,     0,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   873,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,     0,   319,   320,
     321,   322,   323,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   874,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,     0,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,     0,     0,     0,   368,   369,   370,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,     0,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
       0,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,     0,   459,   460,   461,   462,     0,     0,
     463,   464,   465,   466,   467,   468,     0,   469,     0,   470,
     471,   472,     0,     0,   473,     0,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   191,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   877,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,     0,
       0,   363,     0,     0,   364,   365,   366,     0,     0,   367,
       0,     0,     0,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   447,   448,     0,     0,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,     0,   469,     0,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     191,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   646,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   649,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,     0,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,     0,     0,     0,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,   650,   406,   407,   408,   409,   410,   651,   412,
     413,   414,   415,     0,   416,   417,   418,   419,  1043,     0,
     421,   422,   423,   424,     0,   425,   426,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,   653,   448,     0,     0,   654,   450,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,     0,   459,   460,
     461,   462,     0,     0,   463,   464,   465,   466,   467,   468,
       0,   469,     0,   470,   471,   472,     0,     0,   473,     0,
       0,   474,   475,   476,   477,   655,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,  1071,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   298,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
       0,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,     0,     0,   363,     0,     0,   364,   365,
     366,     0,     0,   367,     0,     0,     0,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,     0,     0,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   447,   448,
       0,     0,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,     0,   459,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,     0,   469,     0,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,     0,   287,
       0,     0,     0,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,  1358,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
       0,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,     0,     0,     0,   368,   369,   370,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,     0,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,     0,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,     0,   425,
     426,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,     0,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,     0,   459,   460,   461,   462,     0,     0,   463,   464,
     465,   466,   467,   468,     0,   469,     0,   470,   471,   472,
       0,     0,   473,     0,     0,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   191,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,  1360,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,   367,     0,     0,
       0,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   447,   448,     0,     0,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,     0,   469,     0,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,     0,   207,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,   221,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     278,   279,   280,   281,     0,   282,     0,   283,   284,   285,
       0,   286,     0,   287,     0,     0,     0,   288,   289,   290,
       0,   291,   292,     0,   293,     0,   294,   295,   296,   297,
     298,     0,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   323,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,     0,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,     0,     0,     0,   368,   369,
     370,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
     405,   406,   407,   408,   409,  1457,   411,   412,   413,   414,
     415,     0,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,     0,   425,   426,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,     0,   459,   460,   461,   462,
       0,     0,   463,   464,   465,   466,   467,   468,     0,   469,
       0,   470,   471,   472,     0,     0,   473,     0,     0,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,     0,
     207,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   646,   220,   221,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   278,   279,   280,
     281,     0,   282,     0,   283,   284,   285,     0,   286,     0,
     287,     0,     0,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,   298,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   323,   324,   325,     0,   326,     0,   327,     0,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   649,   344,     0,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,     0,     0,   363,     0,     0,   364,   365,   366,     0,
       0,   367,     0,     0,     0,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,   650,   406,   407,
     408,   409,   410,   651,   412,   413,   414,   415,     0,   416,
     417,   418,   419,  1043,     0,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   441,
    1739,   443,   444,   445,   446,     0,   653,   448,     0,     0,
     654,   450,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,     0,   459,   460,   461,   462,     0,     0,   463,
     464,   465,   466,   467,   468,     0,   469,     0,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     655,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   191,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   646,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,     0,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,   298,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   649,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,     0,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,     0,
       0,     0,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,   650,   406,   407,   408,   409,   410,
    1773,   412,   413,   414,   415,     0,   416,   417,   418,   419,
    1043,     0,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,   653,   448,     0,     0,   654,   450,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,     0,
     459,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,     0,   469,     0,   470,   471,   472,     0,     0,
     473,     0,     0,   474,   475,   476,   477,   655,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,  2003,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,     0,     0,   363,     0,     0,
     364,   365,   366,     0,     0,   367,     0,     0,     0,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     447,   448,     0,     0,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,     0,   459,   460,   461,
     462,     0,     0,   463,   464,   465,   466,   467,   468,     0,
     469,     0,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,  1264,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
     698,   207,   208,   209,     0,  1265,   699,  1266,  1267,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,  1268,
    1269,   223,     0,   224,   225,   226,   227,     0,     0,     0,
     229,   230,   231,   232,   700,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,   701,   244,
     245,     0,     0,     0,   702,     0,     0,     0,   246,   247,
     248,   249,   250,   251,  1270,  1271,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   967,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,     0,   279,
     280,     0,     0,   282,     0,   283,  1272,   285,     0,   286,
       0,   287,   703,     0,   704,   288,   289,   290,     0,   291,
       0,     0,   293,     0,   294,   295,   296,   297,   298,   705,
     299,   300,   301,  1778,   302,   303,   304,   305,   306,   307,
       0,   308,   706,  1779,   310,   311,   312,   313,  1273,  1274,
       0,  1275,     0,   317,   707,   708,   318,   709,   319,   320,
     321,   322,   323,   324,   325,     0,     0,   710,   327,   711,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,  1276,
     712,  1277,   346,   347,   348,   349,   350,   351,   352,     0,
     354,     0,   355,   356,   713,   357,     0,     0,   359,  1278,
     361,   362,     0,     0,   363,     0,     0,   364,   365,   366,
       0,     0,  1780,   714,   715,   716,     0,   369,   370,   371,
     372,   373,   374,     0,   375,     0,   377,     0,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,  1279,
     390,   391,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,     0,   403,   404,   717,   405,   406,
       0,   408,   409,   410,   411,   412,   413,   414,   415,     0,
     416,   417,   418,   419,   420,     0,   421,  1781,   423,   424,
     718,   425,  1281,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,  1282,  1283,     0,
       0,   449,     0,   451,     0,     0,   453,   454,   455,   456,
     457,   458,     0,     0,   459,   460,   461,   462,     0,     0,
     463,   464,   465,   466,     0,  1284,  1782,   469,   719,   470,
     471,   472,     0,     0,   473,     0,     0,   474,   475,   476,
     477,   478,   191,     0,     0,     0,     0,     0,     0,     0,
     487,   488,   489,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,     0,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,  2337,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,     0,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,     0,
       0,     0,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,     0,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,     0,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,     0,
     459,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,     0,   469,     0,   470,   471,   472,     0,     0,
     473,     0,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,  2339,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,     0,     0,   363,     0,     0,
     364,   365,   366,     0,     0,   367,     0,     0,     0,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     447,   448,     0,     0,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,     0,   459,   460,   461,
     462,     0,     0,   463,   464,   465,   466,   467,   468,     0,
     469,     0,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,  1264,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
     698,   207,   208,   209,     0,  1265,   699,  1266,  1267,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,  1268,
    1269,   223,     0,   224,   225,   226,   227,     0,     0,     0,
     229,   230,   231,   232,   700,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,   701,   244,
     245,     0,     0,     0,   702,     0,     0,     0,   246,   247,
     248,   249,   250,   251,  1270,  1271,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   967,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,     0,   279,
     280,     0,     0,   282,     0,   283,  1272,   285,     0,   286,
       0,   287,   703,     0,   704,   288,   289,   290,     0,   291,
       0,     0,   293,     0,   294,   295,   296,   297,   298,   705,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   706,     0,   310,   311,   312,   313,  1273,  1274,
       0,  1275,     0,   317,   707,   708,   318,   709,   319,   320,
     321,   322,   323,   324,   325,     0,     0,   710,   327,   711,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,  1276,
     712,  1277,   346,   347,   348,   349,   350,   351,   352,     0,
     354,     0,   355,   356,   713,   357,  1769,     0,   359,  1278,
     361,   362,     0,     0,   363,     0,     0,   364,   365,   366,
       0,     0,     0,   714,   715,   716,     0,   369,   370,   371,
     372,   373,   374,     0,   375,     0,   377,     0,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,  1279,
     390,   391,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,     0,   403,   404,   717,   405,   406,
       0,   408,   409,   410,   411,   412,   413,   414,   415,     0,
     416,   417,   418,   419,   420,     0,   421,  1781,   423,   424,
     718,   425,  1281,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   438,     0,   439,   440,  2996,
     441,   442,   443,   444,   445,   446,     0,  1282,  1283,     0,
       0,   449,     0,   451,     0,     0,   453,   454,   455,   456,
     457,   458,     0,     0,   459,   460,   461,   462,     0,     0,
     463,   464,   465,   466,     0,  1284,     0,   469,   719,   470,
     471,   472,     0,     0,   473,     0,     0,   474,   475,   476,
     477,   478,  1264,     0,     0,     0,     0,     0,     0,     0,
     487,   488,   489,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,   698,   207,   208,   209,
       0,  1265,   699,  1266,  1267,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,  1268,  1269,   223,     0,   224,
     225,   226,   227,     0,     0,     0,   229,   230,   231,   232,
     700,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,   701,   244,   245,     0,     0,     0,
     702,     0,     0,     0,   246,   247,   248,   249,   250,   251,
    1270,  1271,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   967,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,     0,   279,   280,     0,     0,   282,
       0,   283,  1272,   285,     0,   286,     0,   287,   703,     0,
     704,   288,   289,   290,     0,   291,     0,     0,   293,     0,
     294,   295,   296,   297,   298,   705,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   706,     0,
     310,   311,   312,   313,  1273,  1274,     0,  1275,     0,   317,
     707,   708,   318,   709,   319,   320,   321,   322,   323,   324,
     325,     0,     0,   710,   327,   711,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,  1276,   712,  1277,   346,   347,
     348,   349,   350,   351,   352,  1824,   354,     0,   355,   356,
     713,   357,     0,     0,   359,  1278,   361,   362,     0,     0,
     363,     0,     0,   364,   365,   366,     0,     0,     0,   714,
     715,   716,     0,   369,   370,   371,   372,   373,   374,     0,
     375,     0,   377,     0,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,  1279,   390,   391,   392,     0,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
       0,   403,   404,   717,   405,   406,     0,   408,   409,   410,
     411,   412,   413,   414,   415,     0,   416,   417,   418,   419,
     420,     0,   421,  1280,   423,   424,   718,   425,  1281,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,  1282,  1283,     0,     0,   449,     0,   451,
       0,     0,   453,   454,   455,   456,   457,   458,     0,     0,
     459,   460,   461,   462,     0,     0,   463,   464,   465,   466,
       0,  1284,     0,   469,   719,   470,   471,   472,     0,     0,
     473,     0,     0,   474,   475,   476,   477,   478,  1264,     0,
       0,     0,     0,     0,     0,     0,   487,   488,   489,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,   698,   207,   208,   209,     0,  1265,   699,  1266,
    1267,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,  1268,  1269,   223,     0,   224,   225,   226,   227,     0,
       0,     0,   229,   230,   231,   232,   700,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
     701,   244,   245,     0,     0,     0,   702,     0,     0,     0,
     246,   247,   248,   249,   250,   251,  1270,  1271,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   967,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
       0,   279,   280,     0,     0,   282,     0,   283,  1272,   285,
       0,   286,     0,   287,   703,     0,   704,   288,   289,   290,
       0,   291,     0,     0,   293,     0,   294,   295,   296,   297,
     298,   705,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   706,     0,   310,   311,   312,   313,
    1273,  1274,     0,  1275,     0,   317,   707,   708,   318,   709,
     319,   320,   321,   322,   323,   324,   325,     0,     0,   710,
     327,   711,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,  1276,   712,  1277,   346,   347,   348,   349,   350,   351,
     352,  2837,   354,     0,   355,   356,   713,   357,     0,     0,
     359,  1278,   361,   362,     0,     0,   363,     0,     0,   364,
     365,   366,     0,     0,     0,   714,   715,   716,     0,   369,
     370,   371,   372,   373,   374,     0,   375,     0,   377,     0,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,  1279,   390,   391,   392,     0,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,     0,   403,   404,   717,
     405,   406,     0,   408,   409,   410,   411,   412,   413,   414,
     415,     0,   416,   417,   418,   419,   420,     0,   421,  1280,
     423,   424,   718,   425,  1281,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,  1282,
    1283,     0,     0,   449,     0,   451,     0,     0,   453,   454,
     455,   456,   457,   458,     0,     0,   459,   460,   461,   462,
       0,     0,   463,   464,   465,   466,     0,  1284,     0,   469,
     719,   470,   471,   472,     0,     0,   473,     0,     0,   474,
     475,   476,   477,   478,   191,     0,     0,     0,     0,     0,
       0,     0,   487,   488,   489,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,     0,   287,
       0,     0,     0,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   298,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
       0,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,     0,     0,     0,   368,   369,   370,   371,   372,     0,
     374,     0,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,     0,   388,   389,   390,   391,
     392,     0,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,   405,   406,   407,     0,
     409,   410,   411,   412,   413,   414,   415,     0,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,     0,   425,
     426,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,     0,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,     0,   459,   460,   461,   462,     0,     0,   463,   464,
     465,   466,   467,   468,     0,   469,     0,   470,   471,   472,
       0,     0,   473,     0,     0,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,  1264,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,   698,   207,   208,   209,     0,
    1265,   699,  1266,  1267,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,  1268,  1269,   223,     0,   224,   225,
     226,   227,     0,     0,     0,   229,   230,   231,   232,   700,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   701,   244,   245,     0,     0,     0,   702,
       0,     0,     0,   246,   247,   248,   249,   250,   251,  1270,
    1271,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   967,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,     0,   279,   280,     0,     0,   282,     0,
     283,  1272,   285,     0,   286,     0,   287,   703,     0,   704,
     288,   289,   290,     0,   291,     0,     0,   293,     0,   294,
     295,   296,   297,   298,   705,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   706,     0,   310,
     311,   312,   313,  1273,  1274,     0,  1275,     0,   317,   707,
     708,   318,   709,   319,   320,   321,   322,   323,   324,   325,
       0,     0,   710,   327,   711,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,  1276,   712,  1277,   346,   347,   348,
     349,   350,   351,   352,     0,   354,     0,   355,   356,   713,
     357,     0,     0,   359,  1278,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,     0,   714,   715,
     716,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,   377,     0,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,  1279,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,   717,   405,   406,     0,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
       0,   421,  1280,   423,   424,   718,   425,  1281,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     0,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,  1282,  1283,     0,     0,   449,     0,   451,     0,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,     0,
    1284,     0,   469,   719,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,  1264,     0,     0,
       0,     0,     0,     0,     0,   487,   488,   489,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,   698,   207,   208,   209,     0,  1265,   699,  1266,  1267,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
    1268,  1269,   223,     0,   224,   225,   226,   227,     0,     0,
       0,   229,   230,   231,   232,   700,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   701,
     244,   245,     0,     0,     0,   702,     0,     0,     0,   246,
     247,   248,   249,   250,   251,  1270,  1271,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   967,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,     0,
     279,   280,     0,     0,   282,     0,   283,  1272,   285,     0,
     286,     0,   287,   703,     0,   704,   288,   289,   290,     0,
     291,     0,     0,   293,     0,   294,   295,   296,   297,   298,
     705,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   706,     0,   310,   311,   312,   313,  1273,
    1274,     0,  1275,     0,   317,   707,   708,   318,   709,   319,
     320,   321,   322,   323,   324,   325,     0,     0,   710,   327,
     711,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
    1276,   712,  1277,   346,   347,   348,   349,   350,   351,   352,
       0,   354,     0,   355,   356,   713,   357,     0,     0,   359,
    1278,   361,   362,     0,     0,   363,     0,     0,   364,   365,
     366,     0,     0,     0,   714,   715,   716,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,   377,     0,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
    1279,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,   717,   405,
     406,     0,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,     0,   421,  1781,   423,
     424,   718,   425,  1281,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     0,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,  1282,  1283,
       0,     0,   449,     0,   451,     0,     0,   453,   454,   455,
     456,   457,   458,     0,     0,   459,   460,   461,   462,     0,
       0,   463,   464,   465,   466,     0,  1284,     0,   469,   719,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,  1264,     0,     0,     0,     0,     0,     0,
       0,   487,   488,   489,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,   698,   207,   208,
     209,     0,  1265,   699,  1266,  1267,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,  1268,  1269,   223,     0,
     224,   225,   226,   227,     0,     0,     0,   229,   230,   231,
     232,   700,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   701,   244,   245,     0,     0,
       0,   702,     0,     0,     0,   246,   247,   248,   249,   250,
     251,  1270,  1271,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     967,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,     0,   279,   280,     0,     0,
     282,     0,   283,  1272,   285,     0,   286,     0,   287,   703,
       0,   704,   288,   289,   290,     0,   291,     0,     0,   293,
       0,   294,   295,   296,   297,   298,   705,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   706,
       0,   310,   311,   312,   313,  1273,  1274,     0,  1275,     0,
     317,   707,   708,   318,   709,   319,   320,   321,   322,   323,
     324,   325,     0,     0,   710,   327,   711,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,  1276,   712,  1277,   346,
     347,   348,   349,   350,   351,   352,     0,   354,     0,   355,
     356,   713,   357,     0,     0,   359,  1278,   361,   362,     0,
       0,   363,     0,     0,   364,   365,   366,     0,     0,     0,
     714,   715,   716,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,   377,     0,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,  1279,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,   717,   405,   406,     0,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,     0,   421,     0,   423,   424,   718,   425,  1281,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,  1282,  1283,     0,     0,   449,     0,
     451,     0,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,     0,     0,   463,   464,   465,
     466,     0,  1284,     0,   469,   719,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,  1264,
       0,     0,     0,     0,     0,     0,     0,   487,   488,   489,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,   698,   207,   208,   209,     0,     0,   699,
       0,     0,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,     0,     0,   223,     0,   224,   225,   226,   227,
       0,     0,     0,   229,   230,   231,   232,   700,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   701,   244,   245,     0,     0,     0,   702,     0,     0,
       0,   246,   247,   248,   249,   250,   251,     0,     0,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,     0,   279,   280,     0,     0,   282,     0,   283,     0,
     285,     0,   286,     0,   287,   703,     0,   704,   288,   289,
     290,     0,   291,     0,     0,   293,     0,   294,   295,   296,
     297,   298,   705,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   706,     0,   310,   311,   312,
     313,     0,     0,     0,     0,     0,   317,   707,   708,   318,
     709,   319,   320,   321,   322,   323,   324,   325,     0,     0,
     710,   327,   711,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   712,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   354,     0,   355,   356,   713,   357,     0,
       0,   359,     0,   361,   362,     0,     0,   363,     0,     0,
     364,   365,   366,     0,     0,     0,   714,   715,   716,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,   377,
       0,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
     717,   405,   406,     0,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,     0,   421,
       0,   423,   424,   718,   425,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     0,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
       0,     0,     0,     0,   449,     0,   451,     0,     0,   453,
     454,   455,   456,   457,   458,     0,     0,   459,   460,   461,
     462,     0,     0,   463,   464,   465,   466,     0,     0,     0,
     469,   719,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,     0,     0,     0,     0,     0,
       0,     0,     0,   487,   488,   489
};

static const yytype_int16 yycheck[] =
{
       0,     0,     0,     0,     0,    49,   176,    35,    17,   694,
     514,    11,   541,   606,   607,   553,    22,    26,   611,   557,
     853,    21,    28,   647,   159,   860,   889,   174,   696,   567,
     166,   824,   721,   180,   926,  1169,   172,  1382,    22,  1280,
     889,   188,    43,   912,    28,   726,  1130,  1424,   754,    49,
     939,   555,   770,  1343,  2548,  1786,    12,  1823,   764,   654,
    1523,  1103,   994,   732,  1067,  1205,    21,  1069,   507,   965,
     966,   167,  2088,    23,   170,  1159,  2226,  2330,  1326,  1213,
    1214,  2399,   801,  2401,  1093,    35,   755,   756,   984,   758,
     186,  1312,  1987,   762,  1312,  1681,   765,  1786,  1787,   805,
    1312,  1312,  1312,  1312,   810,   146,  1153,  1461,   803,  2062,
     549,   817,  2502,  1115,  2463,  1118,    42,  1992,  1993,    45,
     826,   650,   161,  2768,    18,   574,   845,  2224,   161,  2788,
    1378,  2943,  1198,  1904,  1998,     0,     0,     0,     0,     0,
    2997,  1159,  3172,  1118,  2970,  1692,  3007,     5,     5,     0,
     727,  1494,     0,  2502,    39,  1687,   880,     0,     0,    31,
    1067,   161,     0,     9,     5,  3178,    11,    77,  1934,     0,
      43,   955,   956,     5,   104,  2482,  2483,  2484,  2485,  2486,
    2487,   732,   691,     5,    11,  2682,   150,   764,     7,     5,
    3539,    36,  2222,  2223,    22,    14,   980,   151,   173,    35,
     691,    29,    35,   178,  1053,     5,   799,     5,  1057,  1058,
    1553,  1118,   187,  2975,     5,     5,   867,  1067,   150,    99,
     104,    16,    25,    57,     5,    57,     5,   878,     5,    18,
      18,   926,     5,     0,    63,   123,     5,   156,   150,   152,
      26,    27,     9,    81,  2010,    50,  2012,   104,    66,  3323,
      81,     9,    22,   170,     5,    22,   182,   152,    50,    29,
       5,   150,   189,   251,   150,   258,    57,    22,  1118,   128,
    3520,   121,    50,    97,   104,    74,     0,   151,   248,     5,
     253,   785,   248,   163,   109,     9,     4,  1011,  1137,   158,
     104,     9,   144,   150,  1143,     4,   163,   277,    22,   150,
       9,   316,   150,     5,  1307,   104,     9,   150,   150,   251,
     145,    70,   307,    68,  3022,   152,  3024,   155,     5,   170,
      75,   141,   170,   861,   155,   145,   309,   170,   170,    22,
    3782,   346,   121,   121,   265,   317,  1054,  1186,   133,   219,
    1189,  1190,   222,   265,   514,   376,    11,   876,  1037,   496,
     105,  1283,   219,    59,   501,    22,    76,   265,   183,   254,
     889,   307,    29,   149,   346,   151,   381,   503,    74,  3181,
     252,    36,   294,   315,  1270,  1271,   298,   360,   358,   917,
      20,   385,  1278,   150,   315,   555,   294,   207,   334,   299,
     928,     5,   356,   267,  3846,   426,   309,  1246,   118,    39,
    1307,   323,   940,   170,  3654,   387,    11,   111,   238,   545,
     150,   426,  1245,   509,  1249,   395,   552,   254,  1113,   174,
      97,   273,   251,   116,   397,   131,   150,   104,   524,   243,
     250,   426,   316,    72,   314,  2825,   305,   430,   426,   238,
      50,   147,   891,   338,    11,  1114,   170,   314,   298,   413,
    3524,   364,  1494,    11,   328,   109,   426,  1307,  1460,  3808,
     426,   296,   346,   301,   428,   612,  3496,   356,  1261,    36,
     301,   197,   426,   323,   113,  2782,  2825,   265,  3439,  3440,
     627,  1176,    22,   413,  1268,  1269,   315,  3299,  1194,   498,
    1196,   316,   243,  1277,   297,   300,   320,   381,   430,   356,
     647,   389,   330,   430,  1173,   294,   309,   343,   300,   393,
     343,   430,   307,   430,   336,   337,   261,   664,   430,  1237,
     430,  1050,   300,  1242,  3774,  1528,    11,   407,  2294,  3341,
     325,   575,   541,   542,  2066,   323,   577,   512,   356,   686,
    1781,   516,   426,   384,   430,  2575,   426,  1416,  1243,   374,
    1088,   526,  1258,   426,   426,   393,   413,   360,  1560,   694,
     330,   238,   393,    11,  3326,  1260,   424,   426,   426,  3599,
     428,   428,   278,  3070,   574,   575,  3589,   422,   429,   425,
     586,   429,   588,   338,   590,   426,   429,   429,    36,   427,
     596,   429,   426,   384,   426,   422,   427,  2747,   429,   385,
    1151,  1110,   586,   497,   588,  1182,   590,  1302,   367,   535,
     426,   620,   596,   597,   598,   785,  1297,   573,  2925,  1110,
     575,  1528,  3434,  1763,   191,   430,   426,   266,   426,  2161,
    3442,   640,  2321,   191,  2323,   426,   426,   646,   430,   775,
     649,   650,   651,   739,   740,   426,   782,   426,  3356,   426,
     417,   418,   430,   426,   230,  2752,  1351,   426,   335,   417,
     418,   338,   429,   330,   370,  3695,  2437,  2562,   426,  2440,
    2441,  2566,   376,  2444,  1178,   393,  2442,  2443,  1528,  3540,
     827,   828,   829,  2454,  3510,   685,   685,   685,   685,   685,
     300,   617,   394,   417,   418,  1346,   832,  1987,  2245,   417,
     418,   797,  1486,  1487,  1355,   429,   191,   394,   417,   418,
     412,   350,  1363,  1364,   417,   418,    41,   813,   814,   674,
     374,   189,  3752,    72,   426,   412,   133,    50,  3689,   109,
    1381,   271,  1735,     8,   830,  1459,   104,  1461,  1331,   426,
     288,   121,   668,   191,   192,    18,   193,  1471,   230,   426,
    1474,    24,     5,   737,   419,   420,   421,   422,  1482,  1483,
    1735,   857,   858,   648,   113,  3533,    18,   652,   265,   916,
    2233,  1495,  1496,   106,  2463,  1793,     8,    85,     5,    11,
      34,   600,  1506,   133,    73,  2128,  2129,     3,   153,     5,
    2133,   800,   939,   241,    22,   153,  3826,   294,    98,   130,
       3,     4,     5,     5,  1428,  1429,     9,  3664,   280,   349,
    1813,   351,   296,  2502,   419,   420,   421,   422,  1356,    23,
     685,   685,   685,   685,   685,   106,     5,  1365,  1735,  2172,
    2173,  1526,   408,   132,    51,   346,   125,   141,   285,  1377,
     258,   166,    59,   151,   284,   170,     8,  3341,   121,    11,
     417,   418,   419,   420,   421,   422,   187,  2546,  1362,   417,
     418,   419,   420,   421,   422,    32,  2659,   876,   308,   121,
     238,   179,   171,   173,     4,   252,   394,    97,   426,     9,
     889,   206,   141,    99,  1422,  1735,   194,  1425,   116,  1427,
    2683,   891,  1430,    59,   412,   275,   204,   379,  2762,    72,
      99,   104,   104,   207,  1970,   889,  1813,   230,   426,   393,
     243,   200,   201,  1352,   923,   169,  1063,   266,   325,   227,
     920,   920,   256,  3735,   213,   104,    43,   258,  3587,   426,
    2220,   265,   417,   418,   419,   420,   421,   422,   170,  1388,
     113,   835,  1849,   311,   252,   112,   430,   163,   207,   949,
    3595,  3596,     8,   318,   426,    11,   258,   238,    30,   191,
     318,   154,   109,  1813,   163,   131,  3734,  1011,   968,   417,
     418,   419,   420,   421,   422,   325,   265,   300,    95,   254,
     184,   147,   347,   430,  3302,   188,    72,  1836,  1492,   347,
     243,   250,   265,   210,  3144,  1844,   304,  1846,   998,  1849,
     323,   350,   327,   219,  1013,  3155,   222,   210,  1178,   427,
     230,  1011,   430,   265,  1023,   154,   243,   210,  1165,  2750,
     219,   294,   254,   222,  1033,     5,   264,   113,  1679,   191,
    1926,   134,   104,  3494,   121,   116,   183,   118,   369,   325,
    1081,  1050,   294,  3140,  1053,   345,   346,   424,  1057,  1058,
     108,   428,   386,  1239,   230,   108,  3153,  1096,  1097,   348,
    1099,   350,  3452,  1096,  1097,   182,  1099,   142,   376,  1053,
    1863,   210,  1219,  1057,  1058,   894,   219,   896,   309,   898,
     256,   900,    59,   902,   903,   904,  2128,  2129,   374,   265,
     909,  2133,   254,   266,  1241,   356,  1096,  1097,   314,  1099,
    2871,   193,  1797,  3452,  3057,  3750,  2877,  2878,  2879,  2880,
    2881,  2882,   278,   230,     8,   314,  1310,    11,  3013,  1215,
    1216,  1217,  1218,  3018,   104,   427,  3021,   104,   430,   360,
    2172,  2173,   190,  1327,  3009,   191,  2825,   190,   413,   414,
     415,   107,   417,   418,   419,   420,   421,   422,  1334,   358,
    2153,  1247,  1248,  1137,   229,  2158,   349,  1253,   351,  1143,
    3621,   277,  1955,  1956,  1957,  1958,   141,   248,  2308,   430,
     145,   314,  2005,   116,  2760,   118,   191,   350,  2013,   106,
     266,   413,   414,   415,   426,   417,   418,   419,   420,   421,
     422,   407,  1362,   285,  1203,   312,   139,    85,   254,   394,
      81,   167,  1186,   379,   370,  1189,  1190,  1343,   407,  1345,
     349,   298,   351,   316,   417,   418,   363,   412,  1354,  1914,
    1367,  1317,  1318,  1319,  1320,   238,    66,   374,   315,  1376,
     108,  2608,   207,     0,    74,     5,   323,   252,  2247,     9,
    1387,  3735,   358,   346,  2246,   170,  2153,   307,   387,  1224,
     177,  2158,   414,   415,  1792,   417,   418,   419,   420,   421,
     422,   238,  1246,   151,   350,  3031,   243,  3033,  3418,  3419,
     283,   356,  2562,  2320,   155,   250,  2566,  3443,   381,   395,
    1999,  1428,  1429,  2504,  2638,    96,  2504,  1383,  1424,   107,
     393,   179,  2504,  2504,  2504,  2504,    96,   191,  1737,     8,
     243,   278,    11,  2153,  1313,   248,   194,  1996,  2158,   317,
     429,   238,   190,   290,   374,  3633,   204,   305,   196,    28,
     430,  2664,  1492,   426,  2667,  2668,  2669,  2670,  2671,  2672,
    2673,  2674,  2675,  2676,   104,  3501,  1311,    97,   346,   227,
     109,   413,   116,  1343,   118,   430,   309,   145,  2596,   167,
     280,  1326,   424,  2004,   426,   427,   428,   155,   430,  3375,
     254,   417,   418,   419,   420,   421,   422,  2018,  2019,   294,
     285,  2022,   170,   298,  2098,   175,   294,  2028,   151,   387,
     298,  2724,  2725,  2078,   130,  2234,   252,   375,  1388,  1828,
    3643,   257,  1436,   370,   265,   141,   107,   360,   323,   145,
    2534,   311,   349,  1378,   351,   323,   179,   218,  1555,   220,
     325,  1395,    11,  3429,   183,  3431,   304,  1564,   218,   362,
     220,   194,  2146,   294,  3590,   311,  1454,   298,   371,  2298,
    2326,   204,  3598,  3583,  1389,   109,  1436,    36,   348,  2090,
     265,   187,  1830,   393,   315,  1445,  1445,  1445,  1445,  1445,
     247,  2175,   323,  1982,   358,    37,   167,  2460,  3353,   374,
    2923,   207,   348,   313,   238,   316,  3237,  3238,   393,   294,
    1479,   240,   425,   197,   248,   393,    58,   430,    26,    27,
     430,   393,   191,   393,   394,   426,  2210,  1875,  1472,  1473,
     315,   395,  2399,  2400,  2401,   346,  1480,  2026,  2501,   356,
    1484,  1485,  2792,  1453,   250,   303,   265,   393,   394,   183,
     265,   360,   258,  2051,  1440,  1499,   426,  1501,   430,   413,
     414,   415,   393,   417,   418,   419,   420,   421,   422,  1163,
     381,   304,  1532,    81,   393,   294,  1520,   150,  1522,   294,
     426,  1688,   393,  1690,   285,   254,    97,   316,    31,  2399,
    2400,  2401,   394,  2460,   295,   103,   315,   170,   296,   265,
     315,   109,  2128,  2129,   323,  1574,    49,  2133,   323,   348,
     412,   430,  1206,  1207,  2576,   426,   152,   346,   319,   265,
     145,   313,   311,  1402,   426,  1404,   134,  1406,   294,  1408,
     424,  1410,   426,  2936,  2501,  1414,   298,    80,     8,   427,
     165,    11,   430,    78,   180,   374,  2172,  2173,   294,  3340,
    2460,   425,   381,    48,   393,   394,   430,  2619,    28,   348,
     145,   323,  2664,   369,   393,  2667,  2668,  2669,  2670,  2671,
    2672,  2673,  2674,  2675,  2676,   183,  2231,  2318,     5,  2263,
     165,   413,   316,    10,  2513,   252,   173,   426,  2299,  3112,
     257,  2501,    19,    34,   137,   165,   428,   426,   756,    40,
     758,    96,    22,  1810,   393,   394,   424,   765,    28,    36,
     428,  2366,   346,  2368,  2472,  2473,  2474,  2811,  2812,   421,
      97,   427,  2724,  2725,   426,   168,   428,  2338,  2192,  2340,
    2145,    47,  2147,  2148,  2697,  1695,   421,   426,  3469,  1705,
     374,   426,  2704,   428,   413,   414,   415,   381,   417,   418,
     419,   420,   421,   422,   197,  1743,   424,  1745,   426,   393,
     428,  1705,   427,  3013,   427,   430,  2866,   430,  3018,   427,
     313,  3021,   430,  3749,  1689,   427,   197,   172,   430,  2408,
       9,  3507,  2631,  2438,   427,   426,  1842,   430,  2286,  2287,
     427,  2289,   426,   430,  2686,  2687,   427,  1732,   349,   430,
     351,  1736,   427,  3452,  1773,   430,    56,    57,   316,  2890,
    2891,  3114,  3115,  2894,   116,  2896,   118,   427,   252,   427,
     430,   191,   430,   218,  1759,   220,   427,   393,   394,   430,
    2697,  1938,  1767,   427,  1890,   230,   430,   139,   346,   307,
     308,  1897,  1898,  1899,  1900,  1901,  1902,   427,   427,   427,
     430,   430,   430,   307,   308,   298,  1791,   427,   426,   302,
     430,  2824,   426,  2826,  2519,   308,   374,   393,   394,   264,
    2722,   427,   315,   381,   430,   430,  1811,   385,  2533,   427,
     323,   426,   430,   428,   254,   393,  3535,  2697,   331,    47,
    2388,  1987,  1836,    37,  1829,   427,   339,  1832,   430,   426,
    1844,   428,  1846,   427,   299,   409,   430,   427,  3109,   427,
     430,   427,   430,   193,   430,  1850,  1972,   427,   426,   428,
     430,   427,   427,  1858,   430,   430,  2581,  1896,   427,     0,
    2974,   430,  1867,   255,  2936,  1904,   238,   427,   333,  1874,
     430,   243,   252,   130,   427,   388,   248,   430,  2804,   392,
    2503,   393,   394,  2009,   141,  2011,   255,  2824,   145,  2826,
     109,   410,   411,   427,  2793,  2794,   430,   356,   427,  2580,
      81,   430,   409,  2584,  3665,  2586,   255,  2588,  2589,  1923,
     349,   252,   351,  1987,  2851,  1954,  2597,   427,    37,  2644,
     430,    59,   103,   349,  2492,   351,  2494,   427,   109,   429,
     187,   427,  3425,   427,   430,   429,    74,  1976,  2663,  2693,
      81,  1971,  1971,  1982,  2824,   427,  2826,   409,   430,   427,
     207,  2632,   430,   134,    31,  1941,   427,  1987,   427,   430,
     193,   430,  1509,  2688,   183,  1512,   104,   427,   106,   419,
     430,  2851,    49,   413,   414,   415,   323,   417,   418,   419,
     420,   421,   422,   930,   931,   427,  2545,  2026,   430,   130,
     362,   149,  2192,   250,  2887,   427,   430,  2722,   430,   371,
     141,   258,   183,    80,   145,   426,  2754,  3380,  2887,   150,
     427,   427,   427,   430,   155,   430,   688,   158,   690,   160,
     239,   240,   427,   427,   427,     8,   430,   430,    11,  2744,
    2745,  3404,  3405,  3353,  2567,    47,  2569,  2214,  2606,   177,
     428,  2055,  3114,  3115,   427,    28,   187,   430,   427,   427,
     426,   430,   430,    36,  2220,   428,   427,  2257,    41,   430,
     137,   426,  2630,  2228,    43,   426,   207,   427,  2664,   396,
     430,  2667,  2668,  2669,  2670,  2671,  2672,  2673,  2674,  2675,
    2676,   427,  2264,  2265,   430,  3492,  2263,   252,   145,  2800,
       8,   168,   427,    11,   205,   430,   427,   316,   376,   430,
     238,  2175,   252,   427,   426,   243,   430,    86,   247,   250,
      28,    74,   369,   427,   313,  3435,   430,   258,   427,   427,
     197,   430,   430,   427,   197,   426,   430,   346,  2724,  2725,
       8,   110,    59,    11,   427,   316,   427,   430,   393,   430,
     278,     8,    31,   803,    11,  2175,   427,   396,   427,   430,
     129,   430,   290,   427,   426,   374,   430,    37,    36,  2189,
     301,    28,   381,    41,    37,   346,   265,   146,   365,   145,
      71,   281,   376,   135,   393,   135,  2999,   135,  2208,   426,
     396,   135,   161,   166,  2215,  2216,  3559,   170,   135,   430,
    2220,   154,   135,   374,   135,  2234,   135,   252,  3120,   135,
     381,   135,   135,   252,   135,   346,   135,   426,   191,   192,
     173,   346,   393,  3533,   426,    31,  3249,   205,  2232,   145,
    2234,   298,   146,   206,   145,   302,   426,     5,   369,  2954,
       5,   308,   370,   426,   426,  3610,   426,  3612,   315,   426,
     274,   426,   426,  2282,   426,   426,   323,   210,     5,   390,
       5,   392,   393,   426,   331,   238,   426,   426,   241,   426,
     426,     5,   339,  2463,   243,   426,   926,   426,     5,  2274,
     426,   254,   251,   191,   257,   426,   262,   426,   426,   426,
     426,   426,   426,   424,   426,    31,   427,   428,   429,   426,
     426,    87,   170,   205,   257,    31,   430,   145,   250,   145,
     356,   428,  2502,   356,   283,   356,   356,   252,  3380,   196,
     356,   388,  3249,   191,   192,   392,   393,   315,   356,   356,
     243,   356,   252,   375,   191,    66,   175,   356,  2887,   356,
     426,   376,  3404,  3405,   376,   430,   254,  2514,    98,   356,
    2936,   356,   356,   265,   327,  3099,  2385,  2524,  3029,    47,
      47,   356,   426,   356,   256,  3036,  3037,  2362,  3251,   356,
    3259,   356,  2539,   241,  2369,  3302,  2405,   356,   252,  3249,
     252,   356,   356,   311,   356,   393,   254,   191,   426,   426,
     384,    31,  2950,  2951,    30,   426,   349,   254,   351,    20,
     104,   387,   386,   213,    49,  3120,  2562,   360,  2437,   376,
    2566,  2440,  2441,    31,  3518,  2444,   145,   370,    31,   197,
     426,   135,   312,  2590,  3734,  2454,  2593,   390,   135,   376,
    2459,   376,  3302,   135,  2463,    80,   135,  2432,   247,   301,
     413,   414,   415,   381,   417,   418,   419,   420,   421,   422,
     356,   242,  2608,   150,   354,   426,    11,   430,   409,  2463,
     224,   224,   389,  1113,  2631,   430,  2470,  2471,   323,  3178,
    3158,  2475,  3384,  2502,   354,   356,   150,   426,    31,  3194,
     426,   164,   358,   164,  3042,  3043,  3044,  2516,   427,  3204,
     430,  2495,   137,   187,   430,   413,    49,  3559,  2502,   253,
     248,    73,   427,  1153,   356,   413,   414,   415,   430,   417,
     418,   419,   420,   421,   422,  2544,  2545,  2537,  2537,   356,
    3246,   311,   356,   168,  3195,  3196,  1176,    80,  3114,  3115,
     311,   426,   376,   195,   195,  2555,  2555,   426,   243,   252,
     243,   259,  2562,   243,   356,   430,  2566,   320,   356,   417,
     418,   419,   420,   421,   422,   294,   413,   414,   415,   294,
     417,   418,   419,   420,   421,   422,   294,   356,   356,   285,
      31,   191,  2739,  2740,   191,   191,   376,   376,   251,   191,
     191,   426,   413,    30,   137,   356,   356,   356,   145,   424,
     356,   424,  3481,  1243,   426,   413,   147,  2617,  2617,   248,
     426,  2596,    31,   320,   252,   252,   162,   588,   589,   590,
    1260,   145,   593,   594,   595,   168,  2611,   162,    31,  3773,
     265,   426,   603,   430,   135,   252,   252,   320,    18,   145,
    1280,   426,   170,   170,    24,  2825,  2792,  3161,  2633,   170,
     396,    19,   156,  3358,   197,   430,   221,   252,  3560,   294,
     430,    47,  1302,   298,   150,   427,   430,   302,   150,   261,
     427,   356,   252,   308,  3222,  3223,   427,  3225,  2732,  3384,
     315,  3415,   427,    63,   427,   427,   427,   409,   323,  2708,
     390,   427,   207,   427,   427,   427,   331,  3300,   409,   427,
    3361,  3603,  3363,  3364,   339,  3607,  3608,   427,   252,   379,
     356,  1351,  3251,  3374,   427,   427,  3633,   426,   255,   181,
     243,   426,  2732,  2734,  2735,  2736,  2737,   135,   427,   135,
     426,   196,  2751,   196,   114,   426,   207,   269,   426,   269,
     373,   121,   356,   216,   124,   191,  3619,   216,   216,   191,
     191,   356,   356,   388,     3,   298,   356,   356,   356,   302,
    3605,  3604,   356,   356,   191,   308,   191,  2924,   191,    49,
     191,   424,   315,  3633,   314,   222,   207,   427,   427,   413,
     323,   256,   365,   296,    97,  2942,   426,   430,   331,   356,
     251,   427,   252,   159,   426,   175,   339,   393,  3346,   427,
      80,   194,  2959,   260,  3380,   194,  2825,   426,  3356,   248,
     376,   311,   376,  2798,   311,   311,   133,   430,   430,   255,
     127,   133,  2841,   150,  2840,  2844,    11,  2846,  3404,  3405,
    3564,  2825,   386,   424,   145,    57,   150,   427,   427,   427,
     426,   413,   427,   158,   426,   388,  2840,   145,   427,   392,
     230,   427,  2871,   427,   253,  3560,   181,   137,  2877,  2878,
    2879,  2880,  2881,  2882,   356,   356,   365,  3013,  2887,   356,
     365,   356,  3018,   145,  2859,  3021,  2861,   427,   427,   427,
    3025,   191,   191,   425,   393,   265,  1526,  3582,   168,  3523,
     195,   427,   425,  2887,    31,   426,  3557,   426,  3603,   145,
     176,   427,  3607,  3608,    69,  2899,  2900,   396,  2927,  2928,
    2929,  2930,   430,   427,   294,   348,  2910,   393,   298,   430,
     430,   892,  3436,   426,   895,   194,   897,  3588,   899,   427,
     901,   155,     0,  2927,   905,   315,   356,   320,   426,   150,
     150,   391,  3456,   323,   427,   426,   426,   391,   427,  3683,
     427,    47,    73,  3796,   160,   427,   430,   427,   356,   150,
     365,    82,    83,    84,   393,   243,   243,   135,  2987,   111,
     413,   430,   430,   191,  3131,  3132,  3133,  3134,   243,   106,
     177,  3161,   152,  3559,   150,   425,   376,   122,   376,   389,
      97,   393,   426,   150,   426,   178,   426,  3545,   255,   150,
     426,   380,   426,  3013,   332,   126,   268,   392,  3018,   427,
     427,  3021,   427,    81,   427,    23,   252,    25,   298,   290,
     300,    29,   302,   376,   393,    33,    34,    35,   308,    37,
     426,    39,    40,   145,    42,   315,    44,    45,    31,   426,
     243,   217,   173,   323,   426,   134,    59,   256,   308,   308,
     255,   331,    59,  3047,   175,    47,   258,   145,   252,   339,
     348,   426,   130,   140,   117,     8,  3614,   282,    11,   255,
     430,  3177,  3178,   141,   255,    31,   380,   145,   150,   430,
    3619,   288,   150,   122,   390,    28,    31,   155,   252,   252,
     158,  3694,   160,    36,   215,    18,   393,   393,    41,   307,
     426,    24,    17,   427,   426,   109,   427,   374,   388,   307,
     231,   232,   233,   234,   235,    28,   237,   134,  3224,   187,
     282,  1227,   685,   426,   426,  1940,  2824,  1058,  2234,  3790,
    1819,  2459,  3170,   730,  3472,  3249,  3619,  3156,  3518,   207,
      63,  1781,  2978,  3293,  3522,  2293,  1786,  1787,   269,  3165,
    2044,  3435,  3754,  3795,  3721,  3720,  3763,  1797,   166,   167,
     168,  2980,   170,  1763,   172,   173,   174,  3541,   176,  1328,
     178,  3165,   180,  2851,   182,  3191,  2400,  3691,   186,   187,
     188,  1314,   250,  1928,  2515,  3798,  3343,  3859,  3851,  3267,
     258,   114,  3266,  2501,  3458,  2465,  3770,  3191,   121,  3702,
    1305,   124,  3461,    28,   918,  3586,  2988,  3353,  3202,  3203,
    3665,   542,  2990,  3207,  3208,  3200,  1787,  3050,  3237,  3238,
    3779,   342,  3853,   166,  1689,   663,  3211,   170,  3508,  1690,
    2971,  1389,  3251,   301,    18,  2618,     8,  3256,  3257,    11,
      24,  3260,  3261,  2243,  1087,    18,  2254,   368,   191,   192,
     678,    24,   175,  1725,   375,  1106,  3436,   378,  2260,  1105,
    3276,  2266,  1708,   206,    36,  1724,  1682,  1108,  2220,    41,
    1987,  2568,  3452,  3354,  1914,    48,  3456,   668,   346,    63,
     535,  1913,  3276,  2244,  2968,  2707,  3562,  2699,  3744,  3435,
      63,  3743,  2257,  3312,  3747,   238,  3306,  3306,   241,  2189,
    2100,   369,  2187,  2067,    -1,  1556,    -1,   230,    -1,  3455,
      -1,   254,    -1,    -1,   257,    -1,    -1,    -1,    -1,    -1,
    3339,    -1,   390,    96,   392,   393,    -1,    -1,    -1,    -1,
     114,  3437,    -1,    -1,    -1,    -1,    -1,   121,  3495,  1979,
     124,   114,   265,  3353,    -1,    -1,  3492,    -1,   121,    -1,
      -1,   124,    -1,    -1,    -1,    -1,   424,   129,    -1,   427,
     428,   429,    -1,    -1,    -1,    -1,  3523,    -1,    -1,    -1,
      -1,   294,    -1,    -1,    -1,   298,    -1,    -1,    19,    -1,
      -1,    -1,    -1,    -1,   327,    -1,    -1,  3533,    -1,    -1,
      -1,   175,   315,    -1,   166,    -1,    -1,    -1,   170,   172,
     323,    -1,   175,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,
     192,    -1,    -1,    -1,    -1,    -1,  3532,    -1,    -1,    -1,
      -1,    -1,    73,  3452,   206,    -1,    -1,    -1,  2078,    -1,
    3597,    82,    83,    84,    -1,   218,   230,   220,    -1,    -1,
    3469,    -1,    -1,    -1,  3473,    18,    -1,   230,  3452,    -1,
      -1,    24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
      -1,   265,   254,  3589,    -1,   126,    -1,   430,   496,    -1,
      -1,   264,   265,   501,    -1,   503,    -1,    -1,    -1,   507,
      63,   509,    -1,    -1,   512,  3611,   514,  3613,   516,   517,
     294,  3691,     8,    -1,   298,    11,   524,    -1,   526,    -1,
      -1,   294,    -1,    -1,    -1,   298,   299,   535,    -1,   170,
      -1,    -1,    28,   541,   175,    -1,    -1,   545,    -1,   323,
      36,   549,   315,    -1,   552,    41,    -1,   555,    -1,    -1,
     323,   114,    -1,    -1,    -1,   327,    -1,    -1,   121,    -1,
     333,   124,   570,    -1,    -1,    -1,    -1,   575,    -1,    -1,
      -1,    -1,    -1,    -1,   215,    -1,    -1,    -1,    -1,    -1,
      -1,  3727,    -1,    -1,    -1,    -1,    -1,    -1,  3734,    -1,
     231,   232,   233,   234,   235,    -1,   237,    -1,    -1,    -1,
    3619,    -1,    -1,    -1,   612,    -1,    -1,    -1,    -1,   617,
    3756,    -1,   175,    -1,    -1,    -1,    -1,    -1,  3724,   627,
     628,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   269,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   645,    -1,   647,
     648,    -1,   650,    -1,   652,   417,   418,   419,   420,   421,
     422,    -1,    -1,    -1,  3760,    -1,   664,    -1,    -1,    -1,
     668,    -1,    -1,   671,   305,    -1,    -1,   230,   676,    -1,
     166,    -1,    -1,    -1,   170,    -1,    -1,    -1,   686,    -1,
    2320,  2321,    -1,  2323,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   191,   192,    -1,    -1,    -1,
      -1,   342,   265,   344,    -1,    -1,    -1,    -1,     3,  3855,
     206,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2366,   368,  2368,    -1,
      -1,   739,   740,    28,   375,   298,    31,   378,    -1,    -1,
      -1,    36,   238,    -1,    -1,   241,    41,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3810,    -1,   254,    -1,
     323,   257,    -1,    -1,    -1,    -1,    -1,   775,    -1,  3779,
    3779,  3779,  3779,  3779,   782,    -1,    -1,   785,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3806,    -1,   797,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2438,    -1,
    3810,  3810,  3810,  3810,  3810,   813,   814,    -1,    -1,    -1,
      -1,    -1,  3806,    -1,    -1,    -1,    -1,    -1,    -1,   827,
     828,   829,   830,  2463,   832,    -1,    -1,    -1,    -1,    -1,
      -1,   327,  3851,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3859,    -1,    -1,  3853,  3853,  3853,  3853,  3853,    -1,   857,
     858,    -1,    -1,    -1,    -1,    -1,     8,  3851,    -1,    11,
      -1,    -1,  2502,    -1,    -1,  3859,    -1,    -1,   876,    -1,
      -1,   166,   880,    -1,    -1,   170,    28,    -1,    -1,  2519,
      -1,   889,    -1,    -1,    36,    -1,    -1,    -1,    -1,    41,
      -1,    -1,    -1,  2533,    -1,    -1,   191,   192,    -1,    -1,
      -1,    -1,    -1,   911,   912,    -1,  2546,    21,   916,    -1,
     918,   206,    -1,    -1,    -1,    -1,    -1,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,    -1,   936,   425,
      -1,   939,    -1,    -1,   942,   431,    -1,    -1,    -1,    53,
      -1,  2581,    -1,   238,    -1,   953,   241,    -1,    -1,    -1,
      -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,   254,
      74,    -1,   257,    -1,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   981,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1008,  1009,    -1,  1011,  2644,   119,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,    -1,
    1028,    -1,    -1,  2663,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   327,    -1,    -1,    -1,    -1,    -1,   152,   191,
     192,    -1,  1050,    -1,    -1,    -1,    -1,    -1,  2688,  1057,
    1058,    -1,    -1,    -1,   206,  1063,    -1,    -1,  1066,   173,
      -1,    -1,    -1,  1071,    -1,  1073,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2722,    -1,   198,    -1,   238,    -1,    -1,   241,
    1098,    -1,    -1,    -1,  1102,  1103,    -1,    -1,    -1,    -1,
      -1,    -1,   254,    -1,    -1,   257,    -1,    -1,    -1,    -1,
    2750,    -1,    -1,    -1,    -1,  1123,    -1,    -1,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1145,    -1,    -1,
     254,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1159,    -1,    -1,    -1,    -1,    -1,  1165,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    -1,   281,    -1,    -1,
    1178,    -1,    -1,    -1,    -1,   327,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2825,    -1,    36,    -1,    -1,
      -1,   305,    41,     8,    -1,   309,    11,   311,    -1,    -1,
      -1,    -1,    -1,   317,    -1,    -1,    -1,  1215,  1216,  1217,
    1218,  1219,    -1,    28,    -1,    -1,  1224,    -1,  1226,    -1,
      -1,    36,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,
      -1,  1239,   346,  1241,   348,    -1,    -1,    -1,   352,  1247,
    1248,    -1,    -1,    -1,    -1,  1253,   360,    -1,    -1,    -1,
      -1,   365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,    -1,    -1,   387,    -1,   427,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1311,    -1,    -1,    -1,    -1,    -1,  1317,
    1318,  1319,  1320,    -1,  2954,    -1,    -1,   166,  1326,    -1,
      -1,   170,    -1,    -1,    -1,    -1,  1334,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1343,    -1,  1345,    -1,    -1,
      -1,    -1,   191,   192,  1352,    -1,  1354,    -1,    -1,    -1,
    2990,   166,    -1,    -1,  1362,   170,    -1,   206,    -1,  1367,
      -1,    -1,     8,    -1,    -1,    11,    -1,    -1,  1376,    -1,
    1378,    -1,    -1,    -1,  1382,  1383,   191,   192,    -1,  1387,
      -1,  1389,    28,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      36,   206,   241,    -1,    -1,    41,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   254,    -1,    -1,  1416,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1424,    -1,    -1,    -1,
    1428,  1429,    -1,   238,    -1,    -1,   241,    -1,  1436,    -1,
      -1,    -1,  1440,    -1,    -1,    -1,    -1,    -1,    -1,   254,
      -1,    -1,   257,    -1,    -1,  1453,  1454,    -1,    -1,  1457,
      -1,  1459,    -1,  1461,    -1,    -1,    -1,    -1,    -1,    -1,
    1468,    -1,    -1,  1471,    -1,    -1,  1474,    -1,    -1,  3109,
      -1,    -1,    -1,    -1,  1482,  1483,    -1,    -1,   327,    -1,
    3120,    -1,  1490,    -1,  1492,  1493,  1494,  1495,  1496,    -1,
      -1,    -1,    -1,    -1,    -1,  1503,  1504,    -1,  1506,    -1,
    1508,    -1,    -1,  1511,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   327,    -1,    -1,    -1,    -1,    -1,    -1,  1527,
     166,    -1,    -1,  1531,   170,    -1,    -1,  1535,    -1,    -1,
      -1,  1539,    -1,  1541,  1542,  1543,  1544,  1545,  1546,  1547,
    1548,  1549,    -1,  1551,    -1,   191,   192,  1555,  1556,    -1,
    1558,    -1,    -1,    -1,  3194,    -1,  1564,    -1,    -1,    -1,
     206,    -1,    -1,    -1,  3204,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   238,    -1,    -1,   241,    -1,    -1,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   254,    -1,
      -1,   257,   427,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    41,    -1,
      -1,    -1,    -1,  1681,    -1,    -1,    -1,    -1,    -1,    -1,
    1688,   327,  1690,    -1,  1692,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3340,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,  3358,    -1,
      -1,    -1,    41,    -1,  1732,    -1,    -1,    -1,  1736,  1737,
      -1,    -1,    -1,    -1,    -1,  1743,    -1,  1745,    -1,    -1,
      -1,    -1,    -1,    -1,  3384,    -1,    -1,    -1,    -1,    -1,
      -1,  1759,  1760,    -1,    -1,    -1,    -1,    -1,    -1,  1767,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,    -1,    -1,    -1,
      -1,   427,    -1,  1791,    -1,  1793,    -1,    -1,    -1,    -1,
      -1,  1799,    -1,   166,    -1,    -1,  1804,   170,    -1,    -1,
      -1,    -1,  1810,  1811,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3452,    -1,  1822,  1823,    -1,    -1,   191,   192,
    1828,  1829,    -1,    -1,  1832,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   206,  1842,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1850,    -1,    -1,    -1,  1854,   166,    -1,    -1,
    1858,   170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1867,
      -1,    -1,    -1,    -1,    -1,   238,  1874,    -1,   241,    -1,
      -1,    -1,   191,   192,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   254,  1890,    -1,   257,    -1,    -1,   206,    -1,  1897,
    1898,  1899,  1900,  1901,  1902,  3535,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1912,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,
    3560,    -1,   241,    -1,    -1,    -1,  1934,    -1,    -1,    -1,
    1938,    -1,    -1,    -1,  1942,   254,    -1,    -1,   257,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   327,    -1,    -1,    -1,  1966,    -1,
      -1,    -1,    -1,  3603,  1972,  1973,    -1,  3607,  3608,    -1,
      -1,    -1,    -1,    -1,  1982,    -1,    -1,    -1,    -1,  1987,
    1988,    -1,    -1,    -1,  1992,  1993,    -1,    -1,    -1,  1997,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2009,  2010,  2011,  2012,    -1,    -1,    -1,   327,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2026,    -1,
      -1,    -1,    -1,  2031,    -1,  3665,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,    -1,  2044,    11,    -1,    -1,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
      -1,    -1,  2060,    -1,   427,    -1,    -1,    -1,    -1,  2067,
      -1,    -1,    36,    -1,    -1,    -1,    -1,    41,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2088,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
    2098,  2099,    -1,    -1,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,    -1,    28,    -1,    -1,   427,    -1,
      -1,    -1,    -1,    36,     8,    -1,    -1,    11,    41,    -1,
    2128,  2129,    -1,    -1,    -1,  2133,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    28,    -1,    -1,  2145,  2146,  2147,
    2148,    -1,    36,    -1,    -1,    -1,    -1,    41,    -1,  2157,
      -1,    -1,  2160,    -1,  2162,  2163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2172,  2173,     8,  2175,    -1,    11,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2188,    -1,  2190,    -1,  2192,    -1,  2194,    -1,    -1,    -1,
      -1,    -1,   166,    -1,    36,    -1,   170,    -1,    -1,    41,
      -1,    -1,  2210,    -1,    -1,    -1,  2214,    -1,    -1,    -1,
      -1,    -1,  2220,    -1,  2222,  2223,  2224,   191,   192,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2234,    -1,    -1,  2237,
      -1,    -1,   206,    -1,    -1,  2243,    -1,  2245,    -1,    -1,
      -1,    -1,    -1,   166,    -1,    -1,  2254,   170,    -1,    -1,
      -1,  2259,    -1,    -1,    -1,  2263,    -1,    -1,  2266,    -1,
      -1,    -1,    -1,    -1,   238,    -1,  2274,   241,   191,   192,
      -1,    -1,   166,    -1,    -1,    -1,   170,    -1,    -1,    -1,
     254,    -1,    -1,   206,  2292,    -1,  2294,    -1,    -1,    -1,
    2298,    -1,    -1,    -1,    -1,    -1,    -1,   191,   192,    -1,
      -1,    -1,    -1,    -1,     7,    -1,    -1,    -1,    -1,    -1,
      13,    14,   206,    -1,    -1,   238,    -1,    20,   241,    22,
      -1,    -1,    -1,    -1,   166,    28,    -1,    30,   170,    -1,
      -1,   254,    -1,    -1,   257,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   238,    48,    -1,   241,    -1,   191,
     192,    -1,    -1,   327,  2362,    -1,    -1,    -1,    -1,    -1,
     254,  2369,    -1,   257,   206,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,
      -1,    -1,    -1,    -1,   327,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   254,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2432,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   327,  2442,  2443,    -1,    -1,    -1,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,   181,    -1,
     183,    -1,   185,    -1,    -1,   327,    -1,    -1,    -1,    -1,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
      -1,    -1,    -1,    -1,   427,  2513,  2514,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2524,    -1,    -1,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,    -1,
      -1,  2539,    -1,   427,    -1,    -1,    -1,  2545,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2556,    -1,
      -1,  2559,    -1,    -1,  2562,    -1,    -1,    -1,  2566,    -1,
      -1,    -1,    -1,    -1,  2572,    -1,    -1,  2575,    -1,    -1,
      -1,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,     8,  2590,    -1,    11,  2593,    -1,    -1,  2596,    -1,
      -1,    -1,  2600,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2608,    28,    -1,  2611,    -1,    -1,    -1,    -1,    -1,    36,
    2618,    -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2631,    -1,  2633,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2641,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2650,    -1,    -1,    -1,    -1,    -1,  2656,    -1,
    2658,    -1,    -1,    -1,    -1,    -1,  2664,    -1,    -1,  2667,
    2668,  2669,  2670,  2671,  2672,  2673,  2674,  2675,  2676,    -1,
      -1,    -1,  2680,  2681,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2693,    -1,    -1,    -1,    -1,
      -1,  2699,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2709,    -1,    -1,  2712,    -1,  2714,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2723,  2724,  2725,    -1,    -1,
      -1,  2729,    -1,    -1,  2732,    -1,    -1,    -1,    -1,    -1,
      -1,  2739,  2740,    -1,  2742,    -1,    -1,    -1,    -1,   166,
    2748,    -1,    -1,   170,  2752,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   191,   192,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,   206,
      -1,    -1,    -1,    -1,  2792,  2793,  2794,    -1,    -1,    28,
    2798,    -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,   504,    41,    -1,    -1,    -1,    -1,    -1,    -1,  2817,
      -1,   238,    -1,    -1,   241,   518,   519,    -1,    -1,    -1,
     523,    -1,    -1,    -1,    -1,    -1,    -1,   254,    -1,   532,
     257,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   546,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2859,    -1,  2861,    -1,   558,    -1,    -1,   561,    -1,
     563,    -1,   565,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2887,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   600,    -1,    -1,
     327,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    11,    -1,    -1,  2924,    -1,    -1,    -1,
     623,    -1,   625,    -1,    -1,    -1,    -1,   166,  2936,    -1,
      28,   170,    -1,    -1,  2942,    -1,    -1,    -1,    36,    -1,
      -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2959,   191,   192,    -1,    -1,    -1,    -1,    -1,    -1,
    2968,    -1,    -1,    -1,    -1,    -1,  2974,   206,    -1,    -1,
    2978,    -1,  2980,    -1,    -1,   678,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2991,  2992,    -1,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,    -1,    -1,    -1,   238,
     427,  3009,   241,    -1,    -1,  3013,     8,    -1,    -1,    11,
    3018,    -1,    -1,  3021,  3022,   254,  3024,    -1,   257,    -1,
      -1,    -1,    -1,  3031,    -1,  3033,    28,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    41,
      -1,    -1,  3050,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,  3063,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   766,    -1,    -1,    -1,    -1,   166,    28,
      -1,    -1,   170,    -1,    -1,   778,    -1,    36,    -1,    -1,
      -1,    -1,    41,    -1,   787,    -1,    -1,    -1,   327,    -1,
     793,  3099,    -1,   191,   192,    -1,    -1,    -1,  3106,  3107,
      -1,   804,    -1,    -1,    -1,    -1,  3114,  3115,   206,    -1,
      -1,  3119,    -1,    -1,    -1,    -1,    -1,  3125,  3126,    -1,
      -1,  3129,    -1,  3131,  3132,  3133,  3134,    -1,    -1,    -1,
     833,    -1,  3140,    -1,    -1,    -1,    -1,    -1,  3146,    -1,
     238,    -1,    -1,   241,    -1,  3153,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3161,    -1,    -1,   254,    -1,    -1,   257,
      -1,    -1,  3170,    -1,   166,  3173,    -1,    -1,   170,  3177,
    3178,    -1,    -1,    -1,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,  3192,    -1,    -1,    -1,   427,   191,
     192,   894,  3200,   896,    -1,   898,    -1,   900,    -1,   902,
     903,   904,    -1,  3211,   206,    -1,   909,   166,    -1,    -1,
      -1,   170,    -1,    -1,    -1,    -1,  3224,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   327,
      -1,    -1,   191,   192,    -1,    -1,   238,    -1,    -1,   241,
      -1,    -1,    -1,  3251,    -1,    -1,    -1,   206,    -1,    -1,
      -1,  3259,   254,    -1,    -1,   257,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,
      -1,    -1,   241,    -1,  3292,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   254,    -1,    -1,   257,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   327,    -1,    -1,    -1,   427,
      -1,    -1,    -1,    -1,    -1,  3343,    -1,    -1,    -1,    -1,
      -1,  3349,    -1,    -1,    -1,  3353,    -1,    -1,  3356,    -1,
      -1,    -1,    -1,    -1,    -1,     8,   803,    -1,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3375,   327,    -1,
      -1,    -1,  3380,    -1,    -1,   166,    -1,    -1,    -1,    -1,
      -1,   172,    -1,    36,  1087,    -1,    -1,    -1,    41,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3404,  3405,    -1,    -1,
    3408,    -1,    -1,    -1,    -1,    -1,    -1,  3415,  3416,    -1,
      -1,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,  3429,    -1,  3431,    -1,   427,    -1,  3435,  3436,  3437,
      -1,    -1,  1135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3455,  3456,    -1,
      -1,    -1,    -1,    -1,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,    -1,    -1,    -1,    -1,   427,    -1,
      -1,    -1,    -1,  3481,    -1,    -1,   129,    -1,    -1,   926,
      -1,    -1,    -1,    -1,  3492,    -1,    -1,  3495,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3507,
      -1,  3509,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3518,    -1,    -1,   166,    -1,  3523,    -1,   170,    -1,    -1,
      -1,    -1,    -1,    -1,  3532,  3533,    -1,    -1,   645,    -1,
       8,    -1,    -1,    11,    -1,    -1,    -1,    -1,   191,   192,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      28,  3559,    -1,   206,  3562,    -1,  3564,    -1,    36,   676,
      -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,    -1,  3577,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3589,    -1,    -1,    -1,    -1,    -1,    -1,   241,  3597,
      -1,    -1,  3600,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1303,   254,  3610,  3611,  3612,  3613,  1053,    -1,    -1,    -1,
      -1,  3619,  1315,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3640,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1353,    -1,    -1,    -1,  1357,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1366,    -1,  1368,  1113,  1370,    -1,    -1,
      -1,    -1,  1375,    -1,   327,  3683,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3691,    -1,    -1,    -1,    -1,   166,    -1,
      -1,    -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,  1402,
      -1,  1404,    -1,  1406,    -1,  1408,  1153,  1410,    -1,    -1,
      -1,  1414,   503,   191,   192,    -1,  3724,    -1,    -1,  3727,
      -1,    -1,    -1,    -1,    -1,    -1,  3734,    -1,   206,  1176,
      -1,    -1,    -1,    -1,    -1,  3743,    -1,    -1,  3746,  3747,
      -1,  3749,    -1,    -1,    -1,    -1,    -1,    -1,  3756,    -1,
      -1,    -1,  3760,    -1,   545,    -1,    -1,    -1,    -1,    -1,
     238,   552,    -1,   241,   417,   418,   419,   420,   421,   422,
      -1,    -1,     8,    -1,  3782,    11,   254,    -1,    -1,   257,
      -1,    -1,    -1,    -1,  3792,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    28,    -1,    -1,    -1,  1243,    -1,  3806,     8,
      36,    -1,    11,    -1,    -1,    41,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1260,    -1,    -1,    -1,     8,    -1,    28,
      11,    -1,    -1,    32,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    -1,    41,  1280,    -1,    -1,   953,    28,  3846,    -1,
      -1,     8,    -1,  3851,    11,    36,    -1,  3855,    -1,   327,
      41,  3859,    -1,    -1,   645,  1302,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   981,    -1,    -1,    -1,    -1,    36,
      -1,    -1,    -1,     8,    41,    -1,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   676,    -1,    -1,    -1,    -1,
      -1,  1008,  1009,    28,  1011,    -1,    -1,    -1,    -1,    -1,
      -1,    36,    -1,   112,  1351,    -1,    41,    -1,    -1,   145,
      -1,  1028,    -1,    -1,   150,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     166,    -1,    -1,    -1,   170,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,    -1,  1066,
      -1,    -1,    -1,    -1,    -1,   191,   192,   166,    -1,    -1,
      -1,   170,   129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     206,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,
      -1,  1098,   191,   192,   775,  1102,  1103,    -1,    -1,    -1,
      -1,   782,    -1,    -1,    -1,    -1,    -1,   206,    -1,   166,
     191,   192,   238,   170,    -1,   241,    -1,    -1,    -1,   144,
      -1,    -1,   803,    -1,    -1,   206,    -1,    -1,   254,    -1,
      -1,   257,    -1,    -1,   191,   192,    -1,    -1,    -1,   238,
    1733,   166,   241,    -1,    -1,   170,  1739,    -1,    -1,   206,
      -1,   832,    -1,    -1,    -1,   254,  1749,   238,   257,    -1,
     241,    -1,    -1,  1756,    -1,    -1,   191,   192,    -1,  1762,
      -1,    -1,    -1,   254,    -1,  1768,   257,    -1,    -1,    -1,
    1773,   206,    -1,    -1,   241,    -1,    -1,    -1,    -1,  1526,
      -1,    -1,    -1,    -1,   275,    -1,    -1,   254,    -1,   880,
      -1,   327,    -1,    -1,    -1,    -1,    -1,  1800,  1801,  1802,
    1803,    -1,    -1,   238,  1807,  1808,   241,    -1,    -1,  1812,
      -1,    -1,  1815,    -1,    -1,    -1,    -1,    -1,   327,   254,
      -1,    -1,   257,    -1,    -1,   803,    -1,    -1,    -1,    -1,
    1833,     8,    -1,    -1,    11,   926,   327,    -1,   273,    -1,
    1843,    -1,  1845,    -1,    -1,    -1,    -1,    -1,    -1,   340,
      -1,    28,  1855,  1856,  1857,    -1,  1859,    -1,    -1,    36,
     327,    -1,   953,    -1,    41,  1868,  1869,   376,    -1,    -1,
      -1,    -1,    -1,  1876,  1877,    -1,    -1,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,    -1,    -1,    -1,
     981,    -1,   327,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,    -1,    -1,    -1,  1008,  1009,    -1,
    1011,    -1,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,    -1,    -1,    -1,    -1,    -1,  1028,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   926,    -1,
     417,   418,   419,   420,   421,   422,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1066,  1067,    -1,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,    -1,   166,
      -1,    -1,    -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1098,    -1,    -1,
      -1,  1102,  1103,    -1,   191,   192,    -1,    -1,    -1,    -1,
      -1,    -1,  1113,    -1,    -1,    -1,    -1,  1118,    -1,   206,
      -1,    -1,    -1,    -1,  1781,    -1,    -1,    -1,    -1,  1786,
    1787,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1797,  1468,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   238,  1153,    -1,   241,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1490,    -1,    -1,  1493,   254,    -1,  1496,
     257,  2084,    -1,    -1,    -1,  1176,  1503,  1504,    -1,    -1,
      -1,  1508,    -1,   270,  1511,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1527,    -1,    -1,    -1,  1531,    -1,    -1,    -1,  1535,    -1,
      -1,    -1,  1539,    -1,  1541,  1542,  1543,  1544,  1545,  1546,
    1547,  1548,  1549,    -1,  1551,  1113,    -1,    -1,    -1,  1556,
      -1,  1558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     327,     8,  1243,    -1,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1914,    -1,  1260,
      -1,    28,    -1,    -1,    31,  1153,    -1,    -1,    -1,    36,
      -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,  1280,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1176,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1302,    -1,    -1,    -1,    -1,  1307,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1979,    -1,    -1,    -1,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,    -1,    -1,     8,    -1,
      -1,    11,  1343,    -1,  1345,    -1,    -1,    -1,    -1,    -1,
    1351,    -1,    -1,  1354,    -1,  1243,    -1,    -1,    28,    -1,
      -1,    31,  2275,  2276,    -1,  1692,    36,    -1,    -1,    -1,
      -1,    41,  1260,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1280,    -1,  2307,    -1,    -1,    -1,    -1,   166,
      -1,    -1,    -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1302,    -1,    -1,    -1,    -1,    -1,
      -1,  2078,    -1,  1424,   191,   192,    -1,    -1,  2341,  2342,
    2343,  2344,    -1,  1760,    -1,    -1,    -1,    -1,    -1,   206,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1459,    -1,
    1461,    -1,    -1,  1351,    28,    -1,    -1,  1468,    -1,    -1,
    1471,   238,    36,  1474,   241,    -1,    -1,    41,    -1,    -1,
      -1,  1482,  1483,    -1,    -1,    -1,    -1,   254,    -1,  1490,
     257,    -1,  1493,  1494,  1495,  1496,   166,    -1,    -1,    -1,
     170,    -1,  1503,  1504,    -1,  1506,    -1,  1508,    -1,    -1,
    1511,    -1,    -1,    -1,   803,  2428,    -1,    -1,    -1,    -1,
    2433,   191,   192,    -1,    -1,  1526,  1527,  1528,    -1,    -1,
    1531,    -1,    -1,    -1,  1535,    -1,   206,    -1,  1539,    -1,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,    -1,
    1551,    -1,    -1,    -1,    -1,  1556,    -1,  1558,    -1,    -1,
     327,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,
      -1,   241,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   254,  1912,   150,   257,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   166,    -1,    -1,    -1,   170,  2520,  2521,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,   192,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   926,  1526,    -1,
      -1,    -1,   206,    -1,    -1,    -1,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,    -1,   327,    -1,    -1,
      -1,    -1,    -1,  2320,  2321,    -1,  2323,    -1,    -1,  2582,
    1997,    -1,    -1,    -1,   238,    -1,    -1,   241,    -1,    -1,
      -1,    -1,  2595,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     254,  1692,    -1,   257,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2031,    -1,    -1,    -1,    -1,  2366,
      -1,  2368,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1735,    -1,    -1,    -1,    -1,    -1,
    2067,    -1,    -1,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,    -1,    -1,    -1,    -1,    -1,    -1,  1760,
      -1,    -1,    -1,   327,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2099,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1781,  2438,    -1,    -1,    -1,  1786,  1787,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1797,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2463,    -1,    -1,    -1,
      -1,    -1,  1813,    -1,    -1,    -1,    -1,    -1,  2145,    -1,
    2147,  2148,    -1,    -1,  1113,    -1,    -1,    -1,    -1,    -1,
    2157,    -1,    -1,  2160,    -1,  2162,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2502,    -1,    -1,  1849,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,    -1,
      -1,  2188,  2519,  2190,  1153,    -1,    -1,  2194,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2533,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1176,    -1,  2546,
      -1,    -1,    -1,  1781,    -1,  2222,  2223,  2224,  1786,  1787,
      -1,    -1,  2815,    -1,    -1,    -1,    -1,    -1,    -1,  1797,
    2237,  1912,    -1,  1914,    -1,    -1,    -1,    -1,  2245,    -1,
      -1,    -1,    -1,    -1,  2581,    -1,    -1,  2254,    -1,    -1,
      -1,    -1,  2259,    -1,    -1,    -1,    -1,    -1,    -1,  2266,
      -1,    -1,  2855,    -1,    -1,    -1,    -1,  2860,    -1,  2862,
    2863,  2864,  2865,    -1,  1243,    -1,    -1,    -1,    -1,    -1,
      -1,   803,    -1,    -1,    -1,  2292,    -1,    -1,    -1,    -1,
      -1,  1260,    -1,    -1,    -1,    -1,    -1,    -1,  1979,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1987,  2644,    -1,    -1,
      -1,  1280,    -1,    -1,    -1,    -1,  1997,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2663,    -1,    -1,    -1,
      -1,    -1,    -1,  1302,    -1,    -1,    -1,    -1,  2931,  2932,
    2933,    -1,  2935,    -1,    -1,    -1,  1914,    -1,    -1,    -1,
    2031,  2688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1351,    -1,    -1,  2722,  2067,    -1,    -1,    -1,
      -1,   803,    -1,    -1,    -1,    -1,    -1,  2078,    -1,    -1,
      -1,    -1,    -1,    -1,   926,    -1,    -1,    -1,    -1,    -1,
      -1,  1979,    -1,    -1,  3007,    -1,    -1,  2098,  2099,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3026,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2128,  2129,    -1,
      -1,    -1,  2133,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2145,  2146,  2147,  2148,    -1,    -1,
      -1,    -1,  2153,    -1,    -1,    -1,  2157,  2158,    -1,  2160,
      -1,  2162,    -1,    -1,    -1,    -1,    -1,    -1,  2825,    -1,
      -1,  2172,  2173,    -1,  2175,    -1,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,  2188,    -1,  2190,
    2078,    -1,    -1,  2194,   926,    -1,    -1,    28,    -1,    -1,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,  2210,
      41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2220,
      -1,  2222,  2223,  2224,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2237,  1526,    -1,    -1,
      -1,    -1,    -1,    -1,  2245,    -1,    -1,    -1,  2575,    -1,
      -1,    -1,    -1,  2254,    -1,    -1,    -1,    -1,  2259,    -1,
      -1,    -1,    -1,    -1,    -1,  2266,    -1,    -1,    -1,    -1,
      -1,  1113,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3201,    -1,
      -1,  2292,    -1,    -1,    -1,    -1,    -1,  2954,    -1,  3212,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1153,    -1,    -1,  2641,    -1,    -1,    -1,    -1,  2320,
    2321,    -1,  2323,  2650,    -1,    -1,    -1,    -1,    -1,  2656,
      -1,  2658,    -1,  2990,  1176,   166,    -1,    -1,    -1,   170,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2680,  2681,    -1,    -1,    -1,    -1,    -1,
     191,   192,    -1,    -1,    -1,  2366,    -1,  2368,    -1,    -1,
      -1,    -1,  2699,    -1,    -1,   206,    -1,    -1,    -1,    -1,
      -1,  1113,  2709,    -1,    -1,  2712,    -1,  2714,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3308,  2723,    -1,  2399,  2400,
    2401,  1243,  2729,    -1,    -1,  2732,    -1,   238,    -1,    -1,
     241,    -1,    -1,    -1,    -1,  2742,    -1,  3330,  1260,    -1,
      -1,  1153,    -1,   254,    -1,  2752,   257,    -1,   803,    -1,
      -1,    -1,  2320,  2321,    -1,  2323,    -1,  2438,  1280,    -1,
      -1,    -1,    -1,    -1,  1176,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3109,     8,  3367,    -1,    11,    -1,    -1,  2460,
    1302,    -1,  2463,  3120,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    -1,    -1,    31,    -1,  2366,    -1,
    2368,    36,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,
      -1,    -1,  1781,    -1,    -1,    -1,   327,  1786,  1787,    -1,
    2501,  2502,    -1,    -1,    -1,    -1,    -1,    -1,  1797,  1351,
      -1,  1243,    -1,    -1,    -1,    -1,    -1,    -1,  2519,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1260,    -1,
      -1,    -1,  2533,    -1,    -1,    -1,    -1,  3194,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2546,    -1,  3204,  1280,    -1,
    2438,   926,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2562,    -1,    -1,    -1,  2566,    -1,    -1,    -1,    -1,
    1302,    -1,    -1,    -1,  2575,  2463,    -1,    -1,    -1,    -1,
    2581,    -1,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2608,    -1,    -1,
      -1,   166,    -1,    -1,  2502,   170,    -1,    -1,    -1,  1351,
      -1,    -1,    -1,    -1,    -1,  1914,    -1,  3540,    -1,    -1,
      -1,  2519,    -1,    -1,    -1,    -1,   191,   192,    -1,    -1,
    2641,    -1,    -1,  2644,    -1,  2533,    -1,    -1,    -1,  2650,
      -1,   206,    -1,    -1,    -1,  2656,    -1,  2658,  2546,    -1,
      -1,    -1,  2663,  2664,  2991,  2992,  2667,  2668,  2669,  2670,
    2671,  2672,  2673,  2674,  2675,  2676,    -1,    -1,    -1,  2680,
    2681,    -1,    -1,   238,  1526,    -1,   241,  2688,    -1,    -1,
    1979,    -1,  2693,  2581,    -1,    -1,  2697,    -1,  2699,   254,
      -1,  3358,   257,    -1,    -1,    -1,    -1,    -1,  2709,    -1,
      -1,  2712,    -1,  2714,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2722,  2723,  2724,  2725,    -1,    -1,  3384,  2729,    -1,
      -1,  2732,    -1,    -1,    -1,    -1,  3063,    -1,  1113,    -1,
      -1,  2742,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2750,
      -1,  2752,    -1,    -1,    -1,    -1,  2644,   803,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   327,    -1,    -1,  2663,    -1,    -1,  1153,  3106,
    3107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2078,
      -1,  2792,  3119,    -1,  1526,  3452,    -1,    -1,  3125,  3126,
    2688,  1176,  3129,    -1,    -1,    -1,    -1,    -1,    -1,  3722,
      -1,    -1,    -1,  3140,    -1,     8,    -1,    -1,    11,    -1,
      -1,    -1,    -1,  2824,  2825,  2826,  3153,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2722,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    36,    -1,    -1,  3173,    -1,    41,    -1,
    2851,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,  1243,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3535,    -1,
     926,    -1,    -1,    -1,    -1,  1260,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3560,    -1,  1280,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1302,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2936,   129,  2825,    -1,  1781,
      -1,    -1,    -1,    -1,  1786,  1787,  3603,    -1,    -1,    -1,
    3607,  3608,    -1,  2954,    -1,  1797,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,  3292,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   166,    -1,    -1,  1351,   170,    -1,    28,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,  2990,
    2991,  2992,    41,    -1,    -1,    -1,    -1,    -1,   191,   192,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3013,   206,    -1,    -1,    -1,  3018,    -1,    -1,
    3021,    -1,  3349,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2320,  2321,    -1,  2323,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,  1781,
      -1,    -1,    -1,    -1,  1786,  1787,    -1,    -1,    -1,    -1,
      -1,   254,  3063,    -1,    -1,  1797,  2954,  1113,    -1,    -1,
      -1,    -1,  1914,    -1,    -1,    -1,    -1,  2366,    -1,  2368,
      -1,  3408,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3416,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3099,    -1,
      -1,    -1,  2990,    -1,    -1,  3106,  3107,  1153,  3109,    -1,
      -1,    -1,    -1,  3114,  3115,    -1,    -1,   166,  3119,  3120,
      -1,   170,    -1,    -1,  3125,  3126,    -1,    -1,  3129,    -1,
    1176,    -1,    -1,    -1,   327,    -1,    -1,  1979,    -1,  3140,
      -1,    -1,   191,   192,    -1,    -1,    -1,    -1,    -1,  2438,
      -1,  1526,  3153,    -1,    -1,    -1,    -1,   206,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3173,    -1,  2463,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1914,    -1,    -1,    -1,    -1,    -1,    -1,   238,
      -1,    -1,   241,  3194,    -1,    -1,    -1,  1243,    -1,    -1,
      -1,    -1,    -1,  3204,    -1,   254,    -1,    -1,   257,    -1,
      -1,    -1,    -1,  2502,  1260,    -1,    -1,    -1,    -1,    -1,
      -1,  3109,    -1,    -1,   417,   418,   419,   420,   421,   422,
    2519,    -1,  3120,    -1,  1280,  3562,  2078,    -1,    -1,    -1,
      -1,    -1,    -1,     8,  2533,    -1,    11,  1979,  3249,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1302,  2546,    -1,    -1,
      -1,    -1,    -1,    28,    -1,    -1,    31,    -1,    -1,    -1,
      -1,    36,    -1,  3600,     8,    -1,    41,    11,   327,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3292,  2581,    -1,    28,    -1,    -1,    -1,    -1,    -1,
      -1,  3302,    36,    -1,   353,  1351,  3194,    41,    -1,    -1,
      -1,    -1,    -1,  3640,    -1,    -1,  3204,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3340,
      -1,    -1,    -1,    -1,    -1,    -1,  2078,    -1,  3349,    -1,
      -1,    -1,  3353,    -1,    -1,  2644,    -1,  3358,    -1,    -1,
      -1,    -1,    -1,    -1,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,  2663,    -1,    -1,    -1,    -1,  3380,
      -1,    -1,    -1,  3384,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2688,
      -1,   166,    -1,  3404,  3405,   170,  1781,  3408,    -1,    -1,
      -1,  1786,  1787,    -1,  3415,  3416,    -1,    -1,    -1,  3746,
    3747,    -1,  1797,    -1,    -1,    -1,   191,   192,     8,    -1,
      -1,    11,   166,  2722,  3435,    -1,   170,    -1,    -1,    -1,
      -1,   206,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,
      -1,  3452,    -1,    -1,  3455,  3782,    36,   191,   192,    -1,
      -1,    41,    -1,    -1,    -1,  3792,    -1,    -1,    -1,    -1,
    3358,    -1,   206,   238,    -1,    -1,   241,    -1,  2320,  2321,
    1526,  2323,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   254,
      -1,  3492,   257,    -1,    -1,    -1,  3384,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   238,    -1,    -1,   241,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3846,
     254,    -1,    -1,   257,  2366,    -1,  2368,    -1,    -1,    -1,
      -1,    -1,  3533,    -1,  3535,    -1,  2825,    -1,    -1,  1914,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3559,  3560,
      -1,  3562,   327,  3564,  3452,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,  2320,  2321,
     170,  2323,    -1,   327,    -1,    -1,  2438,    -1,    -1,  3600,
      -1,    -1,  3603,    -1,  1979,    -1,  3607,  3608,    -1,    -1,
      -1,   191,   192,    -1,    -1,    -1,    -1,    -1,    -1,  1024,
      -1,  2463,    -1,    -1,    -1,    -1,   206,    -1,    -1,    -1,
      -1,    -1,  3633,    -1,  2366,    -1,  2368,    -1,    -1,  3640,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3535,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   238,    -1,
    2502,   241,    -1,    -1,  3665,  2954,    -1,     8,    -1,    -1,
      11,    -1,  3560,    -1,   254,    -1,    -1,  2519,  1083,   413,
     414,   415,  3683,   417,   418,   419,   420,   421,   422,    -1,
       8,  2533,    -1,    11,    -1,    36,    -1,    -1,    -1,    -1,
      41,  2990,    -1,  2078,  2546,    -1,  2438,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3603,    -1,    -1,    36,  3607,
    3608,    -1,    -1,    41,    -1,    -1,  3727,    -1,    -1,    -1,
      -1,  2463,    -1,  3734,    -1,  1781,    -1,    -1,    -1,  2581,
    1786,  1787,    -1,    -1,    -1,  3746,  3747,   327,    -1,    -1,
      -1,  1797,    -1,    -1,    -1,  3756,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2502,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3782,    -1,    -1,    -1,    -1,    -1,  2519,   129,    -1,
      -1,  3792,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2533,  2644,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   129,    -1,    -1,  2546,    -1,    -1,    -1,    -1,    -1,
    3109,  2663,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,
      -1,  3120,    -1,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,    -1,    -1,  3846,  2688,    -1,   166,  2581,
     191,   192,   170,    -1,  3855,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   206,    -1,    -1,  1914,    -1,
      -1,    -1,    -1,   191,   192,    -1,    -1,    -1,    -1,    -1,
    2722,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    21,    -1,
     241,    -1,    -1,    -1,    -1,  3194,    -1,    -1,    -1,    -1,
      33,    -1,  2644,   254,    -1,  3204,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,    -1,    -1,
      53,  2663,    -1,  1979,    -1,    -1,   254,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2320,  2321,    -1,  2323,    -1,
      -1,    74,    -1,    -1,    -1,    78,  2688,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,
    1385,   104,    -1,  2825,    -1,    -1,   327,    -1,    -1,    -1,
    2722,  2366,    -1,  2368,    -1,    -1,   119,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   327,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   147,    -1,    -1,    -1,    -1,    -1,
      -1,   154,  2078,    -1,    -1,   158,    -1,    -1,    -1,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     173,    33,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1466,    -1,  2438,    -1,    -1,    -1,    -1,    -1,  3358,
      -1,    53,    -1,    -1,    -1,    -1,   417,   418,   419,   420,
     421,   422,    -1,    21,  1489,    -1,    -1,   210,  2463,  1494,
      -1,    -1,    -1,  2825,    -1,  3384,    78,    -1,    -1,   417,
     418,   419,   420,   421,   422,    -1,    -1,    -1,  1513,  1514,
      -1,  1516,  2954,    -1,    -1,    -1,    98,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2502,    -1,    -1,
      -1,   254,    -1,    -1,   257,    -1,    -1,   119,    -1,    -1,
      78,    -1,    -1,    -1,  2519,    -1,    -1,    -1,  2990,  1554,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2533,    -1,
      98,    -1,    -1,  3452,    -1,   147,   104,    -1,    -1,    -1,
     152,  2546,    -1,    -1,    -1,    -1,   158,    -1,    -1,    -1,
      -1,   119,   305,    -1,    -1,  1590,    -1,    -1,   311,    -1,
      14,   173,    -1,    -1,   317,    -1,    -1,   320,    -1,    -1,
      24,    -1,    26,    27,    -1,    -1,  2581,    -1,    -1,   147,
      -1,    -1,    -1,    -1,   152,    -1,    40,    -1,    -1,    -1,
     158,    -1,  2954,   346,    -1,   348,   349,    -1,   351,   352,
      -1,    -1,    -1,    -1,    -1,   173,    60,   360,    62,    63,
      -1,    -1,   365,    67,    -1,    69,  3535,   370,    -1,    -1,
      -1,    -1,   375,    -1,    -1,    79,    -1,    81,  2990,    -1,
     198,    -1,    -1,    -1,   387,    -1,    -1,  3109,    -1,  2644,
      -1,  3560,   254,    -1,  2320,  2321,   100,  2323,  3120,   103,
      -1,    -1,   264,    -1,    -1,   109,    -1,    -1,  2663,    -1,
      -1,   115,    -1,   117,    -1,    -1,  1701,   121,    -1,   281,
      -1,    -1,    -1,   127,    -1,    -1,  1711,    -1,    -1,  1714,
     134,    -1,   136,  2688,  3603,    -1,   254,   141,  3607,  3608,
    2366,    -1,  2368,   305,    -1,    -1,    -1,   309,    -1,   311,
      -1,   155,    -1,    -1,    -1,   317,    -1,    -1,   320,    -1,
      -1,    -1,    -1,   281,    -1,    -1,    -1,  2722,    -1,    -1,
      -1,    -1,  3194,    -1,    -1,    -1,    -1,    -1,    -1,   183,
      -1,    -1,  3204,    -1,   346,    -1,   348,   305,    -1,    -1,
     352,    -1,    -1,   311,    -1,    -1,    -1,  3109,   360,   317,
      -1,    -1,   320,   365,   208,   209,    -1,    -1,  3120,    -1,
     214,    -1,  2438,   375,    -1,    -1,    -1,    -1,    -1,   223,
      -1,    -1,    -1,    -1,    -1,   387,    -1,    -1,   346,    -1,
     348,    -1,    -1,    -1,   352,    -1,   240,  2463,    -1,    -1,
      -1,    -1,   360,    -1,    -1,    -1,    -1,   365,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   375,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   387,
    2825,    -1,   276,    -1,    -1,    -1,  2502,    -1,    -1,    -1,
      -1,    -1,  3194,   287,    -1,    -1,    -1,   291,    -1,   293,
      -1,    -1,  3204,  2519,   298,    -1,    -1,    -1,    -1,   303,
      -1,    -1,   306,    -1,    -1,    -1,   310,  2533,    -1,    -1,
      -1,    -1,   316,    -1,    -1,    -1,    -1,    -1,    -1,   323,
    2546,    -1,   326,    -1,    -1,    -1,    -1,    -1,    -1,   333,
      -1,    -1,    -1,    -1,    -1,    -1,  3358,    -1,    -1,    -1,
      -1,    -1,   346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2581,    -1,    -1,    -1,   363,
      -1,    -1,  3384,    -1,    -1,    -1,    -1,    -1,   372,    -1,
     374,    -1,    -1,   377,    -1,    -1,    -1,   381,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   393,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2954,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2644,    -1,
      -1,    -1,   426,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3452,    -1,    -1,    -1,    -1,  2990,    -1,  2663,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3358,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2722,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3535,    -1,    -1,    -1,  2102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3560,  2124,
    3452,  2126,    -1,  2128,  2129,  2130,    -1,    -1,  2133,    -1,
      -1,    -1,  2137,    -1,  3109,    -1,    -1,    -1,    -1,  2144,
      -1,    -1,    -1,    -1,  2149,  3120,    -1,    -1,    -1,  2154,
      -1,    -1,    -1,    -1,  2159,    -1,    -1,    -1,    -1,    -1,
      -1,  3603,    -1,  2168,    -1,  3607,  3608,  2172,  2173,  2174,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2825,
      -1,  2186,    -1,    -1,    -1,    -1,    -1,    -1,  2193,    -1,
    2195,  2196,  2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,
      -1,    -1,    -1,  3535,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3194,
      -1,    -1,  2227,    -1,    -1,    -1,    -1,    -1,  3560,  3204,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3603,    -1,    -1,    -1,  3607,  3608,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2302,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2954,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2990,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3358,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3384,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2466,    -1,  3109,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3120,    -1,    -1,  3452,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3194,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3204,    -1,
    3535,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2578,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3560,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2599,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3603,    -1,
      -1,    -1,  3607,  3608,    -1,  2640,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2661,  2662,    -1,  2664,
      -1,    -1,  2667,  2668,  2669,  2670,  2671,  2672,  2673,  2674,
    2675,  2676,  2677,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2700,    -1,    -1,  2703,    -1,
    2705,    -1,    -1,    -1,    -1,  2710,  2711,    -1,    -1,    -1,
      -1,    -1,  3358,    -1,    -1,    -1,    -1,    -1,    -1,  2724,
    2725,  2726,    -1,  2728,    -1,    -1,  2731,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3384,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2758,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2772,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2789,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3452,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3535,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3560,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2936,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3603,    -1,    -1,
      -1,  3607,  3608,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3064,
      -1,    -1,  3067,  3068,  3069,    -1,    -1,  3072,    -1,    -1,
      -1,    -1,  3077,  3078,  3079,  3080,  3081,  3082,  3083,  3084,
    3085,  3086,  3087,  3088,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3113,  3114,
    3115,  3116,    -1,  3118,    -1,    -1,    -1,  3122,  3123,  3124,
      -1,    -1,  3127,    -1,    -1,  3130,    -1,    -1,    -1,    -1,
      -1,    -1,  3137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3294,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3337,  3338,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3376,    -1,    -1,    -1,  3380,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3392,    -1,  3394,
      -1,    -1,    -1,    -1,  3399,  3400,  3401,    -1,    -1,  3404,
    3405,  3406,  3407,    -1,  3409,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3433,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3498,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3544,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3558,  3559,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3572,  3573,  3574,
      -1,  3576,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,  3673,    36,
      -1,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,  3697,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,  3726,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
    3785,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
    3825,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   424,    -1,    -1,
      -1,   428,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,   116,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,   149,    -1,
     151,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,    -1,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,    -1,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   417,   418,   419,    -1,
      -1,    -1,    -1,    -1,    -1,   426,   427,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,
     426,   427,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    31,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,   151,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    -1,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,    -1,
     136,   137,    -1,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,    -1,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,    -1,   204,   205,
     206,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,   237,    -1,   239,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,    -1,   264,   265,
     266,   267,   268,   269,    -1,   271,    -1,   273,    -1,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,    -1,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,    -1,   360,    -1,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   407,   408,   409,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,   427,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    -1,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,    -1,   136,   137,    -1,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,    -1,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,    -1,   204,   205,   206,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,   237,    -1,   239,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,    -1,   264,   265,   266,   267,   268,   269,
      -1,   271,    -1,   273,    -1,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,    -1,
     360,    -1,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,     3,
       4,     5,     6,     7,     8,     9,    10,   407,   408,   409,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,   427,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,   149,   150,   151,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,   166,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   417,   418,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   426,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   426,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   417,   418,    -1,    -1,    -1,    -1,    -1,   424,   425,
     426,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   417,   418,   419,    -1,    -1,
      -1,    -1,    -1,    -1,   426,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,
     418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,   149,    -1,   151,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,   166,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   417,   418,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   426,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
     150,   151,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   426,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     426,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   417,   418,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   426,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,
     418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,   149,    -1,   151,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,   166,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   417,   418,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   426,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   426,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     426,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   417,   418,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   426,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,
     418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,   149,    -1,   151,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,    -1,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   417,   418,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   426,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,    -1,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,    -1,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   426,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,    -1,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
      -1,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,
       3,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     426,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,   241,   242,
      -1,   244,   245,   246,   247,   248,    -1,    -1,   251,    -1,
     253,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   426,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,   241,   242,    -1,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,   253,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   426,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    53,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,   241,   242,    -1,   244,   245,   246,
     247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,   149,    -1,   151,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,   166,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,   241,   242,    -1,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,    -1,    -1,    -1,     9,    -1,
      -1,    -1,   426,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,   249,    -1,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,    -1,
      -1,    -1,    -1,    -1,    -1,     3,   417,   418,   419,    -1,
      -1,    -1,    -1,    -1,    -1,   426,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    26,    27,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   426,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   426,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
      -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     426,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,    -1,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,    -1,    -1,     8,     9,
      -1,    -1,    -1,   426,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,    -1,   136,   137,    -1,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,    -1,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,   237,   238,   239,
     240,   241,   242,   243,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,    -1,   264,   265,   266,   267,   268,   269,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,   408,   409,
      -1,    -1,    -1,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,     3,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
      -1,    -1,    -1,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,     3,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
      -1,    -1,    -1,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,     3,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
      -1,    -1,    -1,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,     3,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
      -1,    -1,    -1,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,     3,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
      -1,    -1,    -1,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,     3,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
      -1,    -1,     3,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   419,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   419,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      -1,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   419,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    -1,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,    -1,   136,   137,    -1,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,    -1,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,    -1,   204,   205,   206,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,   237,    -1,   239,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,    -1,
     260,   261,   262,    -1,   264,   265,   266,   267,   268,   269,
      -1,   271,    -1,   273,    -1,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,    -1,
     360,    -1,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,    -1,   382,    -1,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,   407,   408,   409,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,   419,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    -1,    91,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,    -1,   136,   137,    -1,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,    -1,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
      -1,   204,   205,   206,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,   237,    -1,   239,   240,   241,   242,
      -1,    -1,   245,   246,   247,   248,    -1,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,    -1,   260,   261,   262,
      -1,   264,   265,   266,   267,   268,   269,    -1,   271,    -1,
     273,    -1,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,    -1,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,    -1,   360,    -1,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,    -1,   382,
      -1,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,     3,     4,     5,
      -1,    -1,    -1,     9,   407,   408,   409,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,   419,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,   249,    -1,   251,   252,    -1,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,     4,     5,    -1,    -1,    -1,
       9,   417,   418,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
     249,    -1,   251,   252,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,     4,     5,    -1,    -1,    -1,     9,   417,   418,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,   249,    -1,   251,
     252,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,     9,   417,   418,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,   150,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,   417,   418,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,   149,    -1,   151,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,   166,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,   241,   242,    -1,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,   241,   242,    -1,   244,   245,   246,
     247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,   241,   242,    -1,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,    -1,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,   370,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
     206,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,   155,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
      -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,   155,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,   370,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,   249,    -1,   251,   252,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,     4,     5,     6,     7,    -1,     9,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,    -1,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      -1,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    26,    27,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,    -1,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,     5,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
      -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    26,    27,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,    -1,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      -1,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,    -1,    -1,   251,    -1,
     253,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,     5,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
      -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,    -1,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    31,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    31,    -1,    33,    34,    -1,    36,
      -1,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,   158,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,    -1,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
      -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,    -1,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      -1,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,    -1,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
      -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,    -1,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      -1,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,    -1,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    31,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,    -1,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
      -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,    -1,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    -1,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,    -1,   136,
     137,    -1,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
      -1,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,    -1,   204,   205,   206,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
     237,    -1,   239,   240,   241,   242,    -1,    -1,   245,   246,
     247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,    -1,   264,   265,   266,
     267,   268,   269,    -1,   271,    -1,   273,    -1,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,    -1,   360,    -1,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     407,   408,   409,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,    -1,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    -1,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,    -1,   136,
     137,    -1,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
      -1,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,    -1,   204,   205,   206,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
     237,    -1,   239,   240,   241,   242,   243,    -1,   245,   246,
     247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,    -1,   260,   261,   262,    -1,   264,   265,   266,
     267,   268,   269,    -1,   271,    -1,   273,    -1,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,    -1,   360,    -1,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,    -1,   382,    -1,   384,   385,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     407,   408,   409,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    -1,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      91,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,    -1,   136,   137,    -1,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,   149,    -1,
     151,   152,   153,   154,    -1,   156,    -1,    -1,   159,    -1,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,    -1,   204,   205,   206,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
     241,   242,    -1,    -1,   245,   246,   247,   248,    -1,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,    -1,   260,
     261,   262,    -1,   264,   265,   266,   267,   268,   269,    -1,
     271,    -1,   273,    -1,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,   304,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
      -1,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,    -1,   360,
      -1,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
      -1,   382,    -1,   384,   385,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   407,   408,   409,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    -1,
      -1,    -1,    67,    68,    69,    70,    71,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
      -1,   136,   137,    -1,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,    -1,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,    -1,   204,
     205,   206,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,   241,   242,    -1,    -1,
     245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,    -1,   260,   261,   262,    -1,   264,
     265,   266,   267,   268,   269,    -1,   271,    -1,   273,    -1,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    -1,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,    -1,   360,    -1,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,    -1,   382,    -1,   384,
     385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   407,   408,   409,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
      -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,    -1,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,    -1,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    -1,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,    -1,   136,   137,    -1,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,    -1,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,    -1,   204,   205,   206,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,   237,    -1,   239,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,    -1,   260,   261,
     262,    -1,   264,   265,   266,   267,   268,   269,    -1,   271,
      -1,   273,    -1,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,    -1,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,    -1,   360,    -1,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,    -1,
     382,    -1,   384,   385,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   407,   408,   409,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    -1,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,    -1,
     136,   137,    -1,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,    -1,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,    -1,   204,   205,
     206,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,   237,    -1,   239,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,    -1,   260,   261,   262,    -1,   264,   265,
     266,   267,   268,   269,    -1,   271,    -1,   273,    -1,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,    -1,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,    -1,   360,    -1,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,    -1,   382,    -1,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   407,   408,   409,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    -1,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,    -1,   136,   137,    -1,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,    -1,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,    -1,   204,   205,   206,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,   237,    -1,   239,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,    -1,
     260,   261,   262,    -1,   264,   265,   266,   267,   268,   269,
      -1,   271,    -1,   273,    -1,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,    -1,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,    -1,
     360,    -1,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,    -1,   382,    -1,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,   408,   409,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      -1,    -1,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    -1,    -1,    58,    -1,    60,    61,    62,    63,
      -1,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,    -1,    -1,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,    -1,   136,   137,    -1,    -1,   140,    -1,   142,    -1,
     144,    -1,   146,    -1,   148,   149,    -1,   151,   152,   153,
     154,    -1,   156,    -1,    -1,   159,    -1,   161,   162,   163,
     164,   165,   166,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,   179,    -1,   181,   182,   183,
     184,    -1,    -1,    -1,    -1,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,    -1,
     204,   205,   206,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,    -1,   229,   230,   231,   232,   233,
     234,   235,    -1,   237,    -1,   239,   240,   241,   242,    -1,
      -1,   245,    -1,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,    -1,   260,   261,   262,    -1,
     264,   265,   266,   267,   268,   269,    -1,   271,    -1,   273,
      -1,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,    -1,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
      -1,   325,   326,   327,   328,    -1,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,    -1,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
      -1,    -1,    -1,    -1,   358,    -1,   360,    -1,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,    -1,    -1,    -1,
     384,   385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   407,   408,   409
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    14,    24,    26,    27,    40,    60,    62,    63,    67,
      69,    79,    81,   100,   103,   109,   115,   117,   121,   127,
     134,   136,   141,   155,   183,   208,   209,   214,   223,   240,
     276,   287,   291,   293,   298,   303,   306,   310,   316,   323,
     326,   333,   346,   363,   372,   374,   377,   381,   393,   426,
     433,   434,   435,   436,   442,   443,   445,   446,   447,   448,
     449,   450,   451,   453,   454,   458,   468,   470,   471,   474,
     475,   476,   486,   487,   502,   537,   543,   544,   550,   556,
     558,   560,   561,   562,   563,   572,   576,   577,   578,   580,
     581,   582,   596,   597,   598,   599,   610,   616,   617,   620,
     621,   622,   623,   624,   629,   631,   634,   638,   639,   649,
     650,   653,   658,   668,   687,   690,   691,   692,   695,   698,
     700,   702,   705,   708,   709,   710,   712,   719,   720,   722,
     723,   724,   729,   731,   732,   736,   737,   740,   741,   742,
     744,   745,   746,   747,   749,   752,   753,   758,   764,   767,
     769,   770,   775,   777,   781,   788,   792,   793,   794,   795,
     796,   797,   826,   358,   395,   725,    21,    78,    98,   104,
     119,   147,   152,   158,   173,   198,   254,   281,   305,   311,
     317,   320,   346,   348,   352,   360,   365,   375,   387,   557,
     725,     3,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    33,    34,    36,    38,    39,    40,
      41,    42,    44,    45,    47,    48,    49,    50,    51,    54,
      55,    56,    57,    58,    60,    61,    62,    63,    64,    67,
      68,    69,    70,    72,    73,    75,    76,    77,    78,    79,
      80,    82,    83,    84,    86,    87,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   105,   107,   108,   109,   110,
     111,   113,   114,   115,   118,   119,   120,   121,   122,   124,
     125,   126,   128,   129,   131,   132,   133,   134,   135,   136,
     137,   138,   140,   142,   143,   144,   146,   148,   152,   153,
     154,   156,   157,   159,   161,   162,   163,   164,   165,   167,
     168,   169,   171,   172,   173,   174,   175,   176,   178,   180,
     181,   182,   183,   184,   185,   186,   188,   190,   193,   195,
     196,   197,   198,   199,   200,   201,   203,   205,   208,   209,
     210,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   239,   240,   242,   244,   245,
     246,   247,   248,   251,   254,   255,   256,   259,   263,   264,
     265,   266,   267,   268,   269,   271,   272,   273,   274,   275,
     276,   277,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   302,   303,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   317,   318,   319,   320,
     321,   323,   324,   325,   326,   328,   329,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   344,
     345,   347,   348,   349,   350,   351,   352,   354,   355,   358,
     359,   360,   361,   363,   364,   365,   366,   367,   368,   371,
     372,   373,   374,   377,   378,   379,   380,   381,   382,   384,
     386,   387,   388,   391,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     789,   929,   942,   945,   946,   385,   754,   252,   277,   725,
      43,   493,   793,    21,    33,    53,    74,    98,   104,   119,
     147,   154,   158,   210,   254,   257,   305,   311,   320,   348,
     349,   351,   352,   360,   365,   370,   375,   503,   613,   659,
     669,    22,   276,   929,   789,   150,    22,   271,   349,   351,
       5,   197,   696,   697,   938,    21,    33,    53,    78,    98,
     119,   147,   152,   158,   173,   254,   264,   305,   309,   311,
     317,   320,   346,   348,   352,   360,   365,   375,   387,   557,
     625,   725,   929,    81,   385,   426,   537,   753,   759,   767,
     770,   775,   781,   788,   792,     9,    15,    22,    38,   142,
     148,   150,   170,   199,   229,   279,   292,   417,   418,   635,
     636,   789,   937,   940,    22,    81,   290,   316,   640,   641,
     642,   942,   189,   942,   934,   938,   346,   802,   635,   942,
     358,   929,   264,    98,   173,   345,   346,   703,   310,   942,
      22,   321,   354,   358,   460,   942,    19,   155,   640,   641,
     277,   725,   942,    22,   116,   804,    54,    75,   210,   225,
     305,   311,   321,   354,   358,   398,   459,   460,    22,   321,
     354,   358,   460,   358,   253,   835,   927,   942,   802,   419,
     942,   835,   837,   151,   426,   755,   426,   923,   289,   798,
     799,   929,   793,   794,     0,   429,   754,   130,   187,   258,
     369,   805,   806,   793,   795,   796,   430,     3,    37,    43,
      71,    85,    91,   149,   151,   166,   179,   191,   192,   194,
     204,   206,   227,   241,   260,   261,   262,   304,   327,   385,
     935,   942,   943,   945,   947,   627,   942,   930,   942,   280,
     627,    97,   648,   935,   939,   942,   927,   247,     8,    61,
     140,   413,   414,   415,   417,   418,   419,   420,   421,   422,
     694,   890,   891,   942,   939,   929,   927,   929,   835,   929,
     313,   929,   627,   216,   939,   927,   197,   193,   285,   726,
     727,   728,   927,   933,   942,    21,    53,    66,    74,    78,
      98,   119,   152,   173,   198,   254,   305,   309,   311,   317,
     346,   348,   352,   360,   365,   387,   557,   632,   938,   927,
     356,   935,   929,   426,   360,   930,   627,    97,   349,   351,
     939,   349,   351,    61,   140,   694,   296,   939,   455,   942,
     929,   929,   313,   929,   627,   216,   939,   317,   346,   387,
      78,   173,   152,   309,   364,   551,    22,   929,   790,   837,
     467,   938,   942,   697,   165,   935,   929,   165,   701,   165,
     930,    97,   165,   935,   165,   928,   929,    61,   140,   165,
     694,    47,   165,   928,   165,   929,   165,   929,   165,   929,
     313,   165,   929,   165,   216,   928,   197,   165,   626,   627,
     426,   768,   503,   759,   381,   385,   753,   760,   761,   762,
     942,   754,   940,   636,   637,    22,   637,   940,   637,    22,
     637,   940,   637,   637,   637,   940,   937,   937,   789,   637,
     280,   426,   426,   521,   521,   521,   252,   356,   430,   521,
     927,   835,   836,   430,   721,   938,   426,   765,    47,   929,
     929,   927,   942,    37,   409,   193,   428,   255,   255,   252,
     150,   938,   356,   252,     4,     6,     7,     8,    10,    30,
      42,    44,    45,    52,    53,    56,    57,    64,    88,    89,
      90,    91,    92,    93,    94,   101,   102,   120,   135,   138,
     139,   143,   157,   185,   186,   188,   203,   211,   212,   226,
     228,   238,   243,   244,   246,   254,   263,   272,   286,   307,
     322,   329,   341,   354,   355,   359,   361,   362,   370,   375,
     382,   400,   401,   402,   403,   404,   405,   406,   417,   418,
     419,   426,   793,   846,   849,   852,   853,   854,   856,   857,
     858,   859,   862,   863,   867,   869,   870,   888,   892,   911,
     916,   924,   925,   935,   936,   937,   938,   942,   938,    22,
     472,   926,   927,   321,   459,   104,   466,   938,   467,   938,
      37,    58,   459,   409,   727,   255,   150,   356,   413,    37,
     409,   193,   728,   426,   927,   419,   424,   428,   917,   918,
     836,    31,   942,   323,   149,   151,   385,   750,   751,   753,
     149,   756,   104,   867,   921,   922,   798,   430,   426,   757,
     427,   427,   435,   927,    22,   116,   803,   803,    47,   803,
     141,   145,   207,   250,   809,   811,   812,   821,   823,   824,
     805,   806,   923,   426,   604,   918,   265,   294,   428,   628,
     265,   294,   315,   323,   393,   437,   468,   469,   711,   654,
      18,   121,   265,   323,   479,   396,    49,    80,   137,   168,
     265,   294,   302,   308,   315,   323,   331,   339,   388,   469,
     681,   688,   711,   426,   670,    18,   121,   294,   452,    18,
      24,    63,   114,   121,   124,   175,   230,   265,   294,   298,
     323,   477,   478,   937,   627,   627,   426,   693,   428,   170,
     294,   437,   444,   265,   294,   711,    48,    96,   172,   218,
     220,   230,   264,   294,   299,   323,   333,   477,   546,   547,
     711,   256,   265,   386,   566,   574,    24,   294,   323,   477,
     711,   265,   294,   298,   323,    72,   113,   266,   350,   252,
     265,   294,   323,   711,   145,   294,   323,   437,   469,   294,
     323,   477,   711,   929,   205,   253,   397,   430,   726,   376,
     748,   252,   935,   426,   929,   935,   247,    61,   140,   694,
     929,   313,   929,   197,   627,   521,   336,   337,   489,   938,
     426,   604,   605,    59,     3,    42,    44,    45,    56,    57,
     101,   102,   143,   185,   186,   188,   226,   228,   246,   286,
     324,   329,   354,   355,   382,   843,   845,   847,   849,   851,
     853,   854,   855,   857,   858,   862,   863,   943,   945,   929,
     437,    31,   743,   396,   437,   627,   627,   426,   600,   503,
     437,    37,   456,   365,   573,   265,   559,    72,   113,   266,
     350,    20,    39,   583,    31,   600,   145,   437,   927,   538,
     927,   927,   627,    71,   660,   935,   929,   557,    43,    95,
     182,   230,   312,   376,   776,   135,   604,    50,   300,   480,
     135,   426,   135,   396,   135,   670,   135,   430,   165,   627,
     165,   627,   135,   693,   928,   135,   135,   252,   135,   480,
     135,    72,   113,   266,   350,   135,   252,   135,   145,   165,
     165,   467,   135,   430,   480,   867,   895,   346,   427,   430,
       4,   139,   249,   252,   362,   418,   464,   467,   549,   763,
     940,   759,   637,   789,   637,   789,   637,   789,   637,   789,
     637,   789,   789,   789,   637,   789,   426,   522,   523,   942,
     522,    22,    98,   147,   152,   197,   198,   311,   317,   346,
     348,   643,   926,   928,   642,   104,   426,   771,   792,   170,
     430,   778,   938,   843,   898,    31,   928,   146,   704,   704,
     704,   205,   942,   145,   145,   643,   928,   310,   942,   426,
     919,   424,   793,   899,   384,   860,   867,   915,   426,   860,
     860,   426,   426,   426,   426,   848,   848,   274,   793,   426,
     426,   850,   426,   426,   426,   426,    56,    57,   860,   867,
     426,   848,   426,   426,   426,   426,   426,   394,   412,   426,
     864,   426,   864,   426,   426,   793,   426,   426,   426,   426,
     426,   426,   426,   867,   867,   793,   867,   895,   938,    57,
     426,   861,   426,   938,     3,     8,    11,    28,    31,    36,
      41,   166,   170,   191,   192,   206,   238,   241,   254,   257,
     327,   413,   414,   415,   417,   418,   419,   420,   421,   422,
     890,   892,   894,   262,   867,   189,   430,   800,   426,   938,
     918,   107,   167,   473,   430,    58,   104,   467,    31,     3,
     104,   210,   465,   549,   863,   938,    76,   118,   876,    87,
     104,   461,   462,   464,   467,   549,   104,   461,   205,   927,
     867,     3,    22,    26,    27,    28,    29,    30,    31,    32,
      35,    46,    52,    53,    59,    65,    66,    74,    81,    88,
      89,    90,    92,    93,    94,   104,   106,   112,   116,   117,
     123,   127,   130,   139,   141,   145,   147,   150,   155,   158,
     160,   170,   177,   187,   189,   202,   207,   211,   212,   238,
     243,   249,   250,   252,   253,   257,   258,   270,   278,   290,
     301,   316,   322,   330,   343,   346,   353,   356,   357,   362,
     369,   370,   375,   376,   383,   389,   390,   392,   393,   419,
     932,   944,   945,   946,   947,   948,   917,    77,   299,   630,
     942,   426,   782,   783,   784,   785,   786,   942,   427,   430,
     754,   427,   430,   799,   928,    31,   757,   795,   795,   807,
     808,   867,   795,   142,   229,   818,   285,   325,   374,    22,
     813,   867,   814,   816,   867,   869,   821,   822,   812,   811,
     809,   810,   145,   824,   809,   821,   419,   898,   265,   294,
     323,   711,   356,   356,   932,   428,   356,   356,   196,   348,
     459,   738,   145,   155,   170,   303,   655,   656,    59,    74,
     131,   147,   278,   370,   519,   520,    74,   104,   238,   356,
     104,   238,   311,   929,   252,   549,   315,   356,   356,   243,
     549,   108,   190,   311,   300,   315,   681,   689,   170,   180,
     259,   324,   383,   427,   671,   674,   675,   676,   678,   843,
     943,   356,   375,    66,   131,   510,   519,   942,    66,   706,
     252,   309,   360,    74,   706,    25,   297,   309,   360,   927,
     175,   356,   356,   426,   482,   348,   393,   394,   482,   430,
     265,   711,   376,   376,   236,   843,   265,   694,    98,   356,
     439,   469,   356,   356,   549,    47,   548,   549,   549,    96,
     218,   220,    47,   356,   437,   311,   437,   230,   547,   426,
     356,   243,   938,   566,   706,   356,   706,   311,   356,   356,
     482,   482,   627,   627,   627,   627,   927,   356,   356,   311,
      94,   375,   579,   939,   356,   439,   356,   311,   265,   294,
     285,   295,   319,   463,   726,   933,   942,   927,   604,   843,
     252,   670,   549,   627,   627,   693,   191,   252,    72,   113,
     266,   350,   252,   627,   191,   393,   494,   437,     3,   606,
     607,   600,   426,   845,    31,    30,   844,    99,   163,   219,
     222,   314,   407,   426,   865,   866,   628,   848,    20,   733,
     843,   929,   438,   613,   376,   601,   602,   944,   387,   438,
     939,    81,   155,   457,   502,   543,   582,   638,   658,   729,
     938,   574,   575,   929,   213,   627,   627,   627,   627,   109,
     183,   363,   374,   584,   585,   128,   426,   579,   438,   545,
     546,    31,   248,   426,   539,   521,   145,   661,   933,   426,
     672,    31,   197,   393,   394,   791,   312,   426,   793,   828,
     829,   830,   835,   838,   870,   935,   942,   390,   840,   935,
     480,   843,   930,   165,   929,   935,   480,   928,   929,   135,
     376,   135,   376,   694,   480,   480,   928,   929,   927,   929,
     929,   929,   927,   928,   579,   135,   135,   480,   626,   627,
     427,   430,   927,   759,   761,     4,   789,   789,   789,   789,
     789,   789,   522,   427,   430,   427,   153,   318,   347,   928,
      97,   320,   647,   648,   928,   247,   928,   926,   926,   928,
     356,   393,   651,   381,   772,   773,   942,   301,   774,    16,
     133,   307,   325,   779,   835,   242,   780,   427,   430,   766,
     770,   775,   781,   792,   356,   641,   640,   641,   150,   156,
     652,   942,   895,   917,   425,   895,   899,   900,   426,   389,
     912,   913,   867,   895,   937,   937,   895,     3,    99,   163,
     219,   222,   314,   407,   901,   902,   938,   937,   895,   895,
     937,   937,   860,   860,   867,   694,   867,   903,   417,   418,
     868,   869,   888,   892,   905,   427,   895,   867,   895,   906,
     354,   409,   937,   937,   867,    46,   150,   202,   357,   867,
     895,   909,   895,   224,   867,   874,   875,   876,   224,   867,
     876,   427,   430,   323,   937,   937,   865,   843,   867,   944,
     354,    35,   343,   920,   867,   426,   793,   910,   116,   118,
     139,   238,   243,   248,   362,   371,   867,    41,   166,   170,
     206,   327,   426,   867,   356,   867,   867,   867,   867,   867,
     867,   867,   867,   867,   867,    22,    29,   330,   889,   307,
     426,   888,   154,   210,   346,   349,   351,   801,   927,   925,
     150,   827,    22,   116,   383,   419,   427,   867,   896,   897,
     927,   358,   426,   938,   430,   427,   425,   431,   164,   164,
     480,   786,   787,   430,   827,   413,   919,   927,   751,   752,
     927,   921,   427,   793,   430,    32,   112,   376,   666,   426,
     815,   940,   253,   248,   825,   825,   430,   307,   308,   817,
     822,   810,   427,   427,   356,   356,   311,   939,   929,   932,
     939,   930,   356,   929,    73,   739,   305,   375,   640,   311,
     155,   640,   426,   929,   376,   662,   195,   195,   426,   929,
     243,   939,   867,   243,   929,   230,   265,   379,   554,   566,
     243,   108,   190,   939,   929,   252,   929,   259,   943,   427,
     430,   676,   678,   675,   678,   943,   628,   939,   928,   510,
     843,   942,   929,   929,    22,   375,   929,   165,   929,   165,
     942,   309,   360,   309,   360,   929,    22,   375,   929,   927,
     939,   929,   484,   485,   944,   929,   251,   315,    63,   251,
     315,   478,   356,   931,   942,   931,   430,   427,   430,   356,
     930,   939,    73,    82,    83,    84,   126,   175,   215,   231,
     232,   233,   234,   235,   237,   269,   342,   368,   375,   378,
     440,   939,   929,   549,   627,   929,   549,   929,   549,    18,
     121,   323,   567,   568,   569,   570,   944,   939,   942,   929,
     929,   929,   939,   929,    18,    24,   121,   265,   294,   265,
     294,   600,   294,   294,   294,   939,   929,   929,   320,   939,
     929,   929,   356,   356,    70,   367,   285,   191,    31,   627,
     191,   191,   376,   376,   191,   243,   633,   938,   627,   627,
     627,   627,   627,   627,   191,   633,   251,   150,   356,   488,
     426,   490,   491,   413,   427,   430,   867,    30,   844,   843,
     424,   424,   356,   356,   356,   426,   356,   937,   848,   584,
      73,   125,   200,   201,   213,   265,   348,   350,   734,   512,
     554,   555,    19,   170,   305,   344,   440,   441,   145,   931,
     427,   430,   413,   927,   456,   257,   503,   147,   938,   600,
     600,   600,   600,   248,   252,   257,   426,   841,   842,   942,
     320,   134,   792,   627,   206,   504,   506,   508,   510,   516,
     519,   540,   541,   942,   393,   394,   533,    31,   938,   252,
     427,   673,   674,   679,    31,   197,   302,   392,   680,   681,
     682,   252,   467,   162,   162,   145,   793,   829,   830,    31,
     831,   942,   430,    85,   151,   179,   194,   204,   227,   304,
     832,   831,    31,   831,   942,   426,   918,    87,   867,   774,
     604,    31,   135,   480,   670,   627,   931,   627,   931,   693,
     252,   480,   480,   252,   480,   320,   145,   467,   480,   867,
     426,   427,   523,   170,   170,   170,   396,   928,   430,   937,
     941,   158,   644,   645,   939,    19,   652,   427,   430,   919,
     924,   133,   325,   133,   325,   307,   374,   221,   843,   929,
     150,   252,   644,    47,   480,   427,   425,   425,   430,   895,
     867,   123,   913,   914,    31,   427,   427,   427,   427,   427,
     150,   427,   427,   427,   427,   427,   430,   427,   270,   904,
     427,   868,   868,    11,   170,   191,   254,   413,   414,   415,
     417,   418,   419,   420,   421,   422,   892,   868,   427,   427,
     145,   150,   907,   908,   427,   409,   427,   427,    31,   909,
     895,   909,   909,   150,   427,   427,   944,    31,   427,   430,
     867,   944,   430,   867,   919,   867,   942,   427,   427,   409,
     868,   868,   129,   895,   150,   116,   118,   139,   243,   248,
     362,   371,   426,   129,   343,   920,   867,   910,   867,   356,
     694,   867,   426,   793,   349,   351,   349,   351,   927,   802,
     802,   828,   390,   839,   896,   896,   897,   427,   261,   881,
      31,   427,   430,   806,   727,   937,   865,   462,   867,   427,
     430,   783,   840,   921,   757,   808,   254,   890,   893,   410,
     411,   667,   867,   817,   926,   780,   780,   814,   939,   929,
     929,   938,   207,   928,   928,   252,   928,   255,   252,   867,
     520,   931,   426,   426,   426,   522,   480,   379,   356,   552,
     929,   566,   181,   243,   628,   674,   678,   678,   421,   512,
     121,   298,   323,   479,   707,   135,   480,   135,   480,   929,
     929,   929,   929,   427,   430,   413,   428,   196,   196,   939,
     265,   294,    18,   121,   265,   294,   843,   236,   843,   939,
     207,   269,   243,   938,   269,   928,   373,   569,   570,   569,
     427,   430,   571,   938,   711,   356,   216,   216,   216,   356,
     356,   356,   356,   356,   356,   356,   929,   939,   929,   633,
     843,   191,   633,   633,   931,   931,   633,   191,   191,   191,
     191,   191,   191,   633,   489,   497,   498,   944,    43,    86,
     110,   129,   146,   161,   243,   251,   283,   492,   254,   417,
     418,   549,   603,   678,   893,   938,   948,     3,   607,   427,
     424,   427,   937,   425,   937,   163,   219,   866,   219,   866,
     866,   937,   222,   427,   252,   207,   413,   735,   735,   735,
     735,   735,   735,   735,    59,    74,   104,   106,   177,   238,
     243,   278,   290,   370,   513,   514,   515,   256,   564,   928,
     158,   305,   928,   937,   365,   602,   603,   521,   296,   346,
      97,   522,   927,   585,   608,   609,   938,   427,   430,   843,
     929,   929,   393,   542,   426,   505,   927,   427,   430,   427,
     430,   251,   482,   251,   252,   534,   792,   356,   927,   427,
     430,   104,   413,   683,   938,   467,   346,   677,   678,   393,
     682,   684,   109,   183,   316,   374,   717,   159,   792,   427,
     942,   426,   829,   194,   260,   833,   829,   833,   194,   832,
     833,   194,   426,   942,   426,   896,   248,   480,   843,   929,
     480,   376,   480,   376,   480,   480,   927,   927,   929,   579,
     480,   942,   311,   311,   311,   928,   648,   430,   939,   393,
     430,   646,   255,   792,   773,   133,   133,   928,   643,   480,
     939,   899,   427,   353,   867,   127,   843,   867,   867,   867,
     907,   843,   868,   116,   118,   238,   248,   868,   868,   868,
     868,   868,   868,   868,   868,   868,   868,   867,   867,   908,
     907,   864,   864,   843,   427,   427,   427,   895,   427,   430,
     944,   875,   275,   340,   877,   427,   430,   386,   871,    31,
     427,   861,   938,   867,    28,    28,   867,   427,   867,   150,
     426,   898,   867,   868,   868,   129,   129,   867,   427,   129,
     867,   802,   802,   802,   802,   927,   927,   867,   158,   819,
     430,   805,   806,   805,   427,   881,   426,   882,   942,   676,
     943,   881,   938,   383,   897,   427,   427,   425,   413,   786,
     774,   426,   667,   427,   253,   735,   153,   318,   347,   657,
     145,   657,   427,   426,   525,   526,   664,   870,   942,   522,
     522,   427,   939,   628,   181,   421,   365,   238,   482,    97,
     238,   335,   338,   482,   365,   929,   942,   485,   603,   944,
     356,   356,   152,   254,   338,   611,   612,   152,   254,   618,
     619,   356,   356,   427,   427,   427,   940,   938,   938,   938,
     568,   929,   145,   145,   296,   145,   165,   939,   929,   939,
     929,   929,   929,   929,   566,   427,   633,   191,   191,   633,
     633,   633,   633,   633,   633,   376,   495,   496,   427,   430,
     419,   426,   464,   467,   499,   549,   743,   743,   238,   283,
     743,   743,   106,   177,   238,   593,   594,   595,   937,   393,
     394,   425,   425,   427,   865,   927,   735,   104,   937,   938,
     104,   938,   104,   938,   104,   938,   104,   929,   104,   929,
     104,   929,   426,   929,   868,   107,   167,   106,   243,   195,
     927,   684,   426,   928,   928,   843,    31,   927,   396,   145,
     586,   427,   430,   842,   564,   768,    97,   230,   507,   509,
     511,   519,   942,   533,   517,   176,   532,   508,   541,    69,
     348,   535,   393,   730,   938,   662,   679,   867,   867,   430,
     426,   680,   600,   356,   552,   831,   426,   928,   829,   252,
     376,   834,   829,   194,   829,   841,   426,   841,   942,   427,
     929,   427,   480,   931,   931,   480,   480,   320,   928,   928,
     928,   937,   155,   645,   652,   150,   867,   427,   427,   908,
     150,   116,   118,   248,   426,   427,   399,   873,   895,   391,
     391,   427,   867,   230,   867,   430,   872,   845,   865,   868,
     868,   867,   898,   427,    28,    28,   867,   867,   129,   867,
     427,   927,   927,   927,   927,    47,   160,   820,   427,   427,
     881,   883,   942,   897,   881,   938,   923,   694,   940,   356,
     640,   150,   593,   867,   427,   430,   393,   376,   627,   665,
     665,   427,   427,   684,   365,   243,   243,   940,   942,   843,
     480,   480,   413,   939,   929,   937,   937,   843,   430,   937,
     937,   430,   939,   929,   928,   928,   627,   928,   135,   191,
     633,   633,   437,   111,   498,   464,   467,   500,   501,   938,
     938,   243,   419,   522,   938,   938,   107,   167,   106,   595,
     594,   425,   152,   180,   152,   150,   592,   940,   867,   238,
     514,   684,   521,   376,   536,   565,   569,   376,   792,   426,
     929,   122,   587,   389,   589,   938,    97,   427,   430,   393,
     534,   132,   171,   426,   533,   109,   121,   275,   929,    51,
      59,   210,   150,   426,   938,   676,   685,   686,   684,   927,
     178,   553,   928,   427,   867,   426,   829,   834,   427,   841,
     427,   480,   480,   480,   929,   255,   480,   644,   868,   150,
     426,   898,   426,   427,   430,   427,   427,   380,   332,   427,
     427,   427,   868,   868,   867,   895,   867,   392,   878,   881,
     881,   268,   884,   427,   865,   427,   644,   252,   644,   427,
     684,   526,   254,   694,   627,   666,   666,   290,   684,   536,
     376,   481,   603,   426,   935,   694,   612,   426,   426,   619,
     393,   296,   393,   393,   145,   633,   490,   938,   427,   430,
     522,   648,    31,   699,   699,   927,   593,   427,   536,   217,
     524,   173,   427,   430,   931,   730,   564,   307,   334,   588,
     426,   134,   509,   256,   535,    22,    68,    75,   105,   174,
     338,   518,   518,   926,   534,   308,   308,    59,   255,    59,
     627,   663,   664,   678,   427,   430,   839,   552,   555,   427,
     928,   427,   480,   868,   898,   427,   874,   895,   230,   408,
     879,   880,   942,    47,   805,   881,   646,   657,   480,   665,
     536,   426,   667,   667,   927,   536,   593,   867,   898,   670,
     288,   615,   693,   898,   898,   626,   627,   626,   627,   928,
     501,   699,    34,   169,   145,   151,   267,   328,   252,   528,
     529,   530,   348,   569,   140,   614,   867,   282,   512,   427,
     535,   255,   255,   427,   430,   680,   685,   117,   427,   427,
     427,   427,   380,   430,    31,   895,   284,   308,   885,   150,
     666,   390,   527,   694,   521,   593,   427,   615,   427,   427,
     393,   122,   109,   374,   252,   530,   252,   529,   929,   627,
      31,   427,   935,   393,   483,   664,   684,    23,   184,   718,
     880,   882,    41,    87,   366,   867,   886,   887,   886,   427,
     644,   667,   426,   593,   427,   524,   935,   627,   307,    50,
     230,   300,   323,   531,   531,   611,   426,   482,   535,   239,
     426,   713,   715,   720,   770,   775,   781,   792,   887,   307,
     144,   273,   144,   273,   480,   867,   528,   670,   589,    17,
     104,   243,     4,     6,     7,   590,   591,   937,   938,   942,
     839,   714,   715,   716,   793,   794,    28,   427,   593,   134,
     427,   430,   427,   429,   887,   282,   591,   716,   935,   426,
     590,   427
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc, yyscanner)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
  YYUSE (yyscanner);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule, yyscanner)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
    core_yyscan_t yyscanner;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule, yyscanner); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp, yyscanner)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (core_yyscan_t yyscanner);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (core_yyscan_t yyscanner)
#else
int
yyparse (yyscanner)
    core_yyscan_t yyscanner;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1464 of yacc.c  */
#line 626 "gram.y"
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[(1) - (1)].list);
			;}
    break;

  case 3:

/* Line 1464 of yacc.c  */
#line 633 "gram.y"
    {
					if ((yyvsp[(3) - (3)].node) != NULL)
						(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
					else
						(yyval.list) = (yyvsp[(1) - (3)].list);
				;}
    break;

  case 4:

/* Line 1464 of yacc.c  */
#line 640 "gram.y"
    {
					if ((yyvsp[(1) - (1)].node) != NULL)
						(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
					else
						(yyval.list) = NIL;
				;}
    break;

  case 108:

/* Line 1464 of yacc.c  */
#line 753 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 109:

/* Line 1464 of yacc.c  */
#line 764 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 110:

/* Line 1464 of yacc.c  */
#line 774 "gram.y"
    {;}
    break;

  case 111:

/* Line 1464 of yacc.c  */
#line 775 "gram.y"
    {;}
    break;

  case 112:

/* Line 1464 of yacc.c  */
#line 784 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 113:

/* Line 1464 of yacc.c  */
#line 785 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 114:

/* Line 1464 of yacc.c  */
#line 789 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 115:

/* Line 1464 of yacc.c  */
#line 790 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 116:

/* Line 1464 of yacc.c  */
#line 795 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[(2) - (2)].str)));
				;}
    break;

  case 117:

/* Line 1464 of yacc.c  */
#line 800 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password", NULL);
				;}
    break;

  case 118:

/* Line 1464 of yacc.c  */
#line 804 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 119:

/* Line 1464 of yacc.c  */
#line 809 "gram.y"
    {
					(yyval.defelt) = makeDefElem("unencryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 120:

/* Line 1464 of yacc.c  */
#line 814 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
				;}
    break;

  case 121:

/* Line 1464 of yacc.c  */
#line 818 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
				;}
    break;

  case 122:

/* Line 1464 of yacc.c  */
#line 822 "gram.y"
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE));
				;}
    break;

  case 123:

/* Line 1464 of yacc.c  */
#line 826 "gram.y"
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE));
				;}
    break;

  case 124:

/* Line 1464 of yacc.c  */
#line 830 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE));
				;}
    break;

  case 125:

/* Line 1464 of yacc.c  */
#line 834 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE));
				;}
    break;

  case 126:

/* Line 1464 of yacc.c  */
#line 838 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE));
				;}
    break;

  case 127:

/* Line 1464 of yacc.c  */
#line 842 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE));
				;}
    break;

  case 128:

/* Line 1464 of yacc.c  */
#line 846 "gram.y"
    {
					/* For backwards compatibility, synonym for SUPERUSER */
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
				;}
    break;

  case 129:

/* Line 1464 of yacc.c  */
#line 851 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
				;}
    break;

  case 130:

/* Line 1464 of yacc.c  */
#line 855 "gram.y"
    {
					(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE));
				;}
    break;

  case 131:

/* Line 1464 of yacc.c  */
#line 859 "gram.y"
    {
					(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE));
				;}
    break;

  case 132:

/* Line 1464 of yacc.c  */
#line 863 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				;}
    break;

  case 133:

/* Line 1464 of yacc.c  */
#line 867 "gram.y"
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 134:

/* Line 1464 of yacc.c  */
#line 872 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 135:

/* Line 1464 of yacc.c  */
#line 878 "gram.y"
    { (yyval.defelt) = (yyvsp[(1) - (1)].defelt); ;}
    break;

  case 136:

/* Line 1464 of yacc.c  */
#line 881 "gram.y"
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[(2) - (2)].ival)));
				;}
    break;

  case 137:

/* Line 1464 of yacc.c  */
#line 885 "gram.y"
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 138:

/* Line 1464 of yacc.c  */
#line 889 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 139:

/* Line 1464 of yacc.c  */
#line 893 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 140:

/* Line 1464 of yacc.c  */
#line 897 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 141:

/* Line 1464 of yacc.c  */
#line 911 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 142:

/* Line 1464 of yacc.c  */
#line 929 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 143:

/* Line 1464 of yacc.c  */
#line 939 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 144:

/* Line 1464 of yacc.c  */
#line 940 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); ;}
    break;

  case 145:

/* Line 1464 of yacc.c  */
#line 945 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->database = (yyvsp[(4) - (5)].str);
					n->setstmt = (yyvsp[(5) - (5)].vsetstmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 146:

/* Line 1464 of yacc.c  */
#line 963 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 147:

/* Line 1464 of yacc.c  */
#line 975 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (4)].str);
					n->database = NULL;
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 148:

/* Line 1464 of yacc.c  */
#line 996 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 149:

/* Line 1464 of yacc.c  */
#line 1003 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 150:

/* Line 1464 of yacc.c  */
#line 1022 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 151:

/* Line 1464 of yacc.c  */
#line 1029 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[(5) - (5)].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 152:

/* Line 1464 of yacc.c  */
#line 1046 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 153:

/* Line 1464 of yacc.c  */
#line 1064 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[(6) - (6)].list)));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 154:

/* Line 1464 of yacc.c  */
#line 1074 "gram.y"
    { (yyval.ival) = +1; ;}
    break;

  case 155:

/* Line 1464 of yacc.c  */
#line 1075 "gram.y"
    { (yyval.ival) = -1; ;}
    break;

  case 156:

/* Line 1464 of yacc.c  */
#line 1088 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 157:

/* Line 1464 of yacc.c  */
#line 1095 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 158:

/* Line 1464 of yacc.c  */
#line 1112 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[(3) - (6)].str) != NULL)
						n->schemaname = (yyvsp[(3) - (6)].str);
					else
						n->schemaname = (yyvsp[(5) - (6)].str);
					n->authid = (yyvsp[(5) - (6)].str);
					n->schemaElts = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 159:

/* Line 1464 of yacc.c  */
#line 1124 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[(3) - (4)].str);
					n->authid = NULL;
					n->schemaElts = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 160:

/* Line 1464 of yacc.c  */
#line 1135 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 161:

/* Line 1464 of yacc.c  */
#line 1136 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 162:

/* Line 1464 of yacc.c  */
#line 1140 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 163:

/* Line 1464 of yacc.c  */
#line 1141 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 170:

/* Line 1464 of yacc.c  */
#line 1169 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(2) - (2)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 171:

/* Line 1464 of yacc.c  */
#line 1175 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 172:

/* Line 1464 of yacc.c  */
#line 1181 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 173:

/* Line 1464 of yacc.c  */
#line 1190 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 174:

/* Line 1464 of yacc.c  */
#line 1198 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 175:

/* Line 1464 of yacc.c  */
#line 1206 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 176:

/* Line 1464 of yacc.c  */
#line 1213 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 177:

/* Line 1464 of yacc.c  */
#line 1220 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 178:

/* Line 1464 of yacc.c  */
#line 1228 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[(3) - (3)].node) != NULL)
						n->args = list_make1((yyvsp[(3) - (3)].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				;}
    break;

  case 179:

/* Line 1464 of yacc.c  */
#line 1239 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 180:

/* Line 1464 of yacc.c  */
#line 1247 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[(5) - (5)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 181:

/* Line 1464 of yacc.c  */
#line 1255 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[(2) - (2)]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				;}
    break;

  case 182:

/* Line 1464 of yacc.c  */
#line 1263 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 183:

/* Line 1464 of yacc.c  */
#line 1271 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[(2) - (2)].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				;}
    break;

  case 184:

/* Line 1464 of yacc.c  */
#line 1282 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 185:

/* Line 1464 of yacc.c  */
#line 1290 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 186:

/* Line 1464 of yacc.c  */
#line 1298 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				;}
    break;

  case 187:

/* Line 1464 of yacc.c  */
#line 1305 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 188:

/* Line 1464 of yacc.c  */
#line 1314 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 189:

/* Line 1464 of yacc.c  */
#line 1316 "gram.y"
    {
					(yyval.str) = palloc(strlen((yyvsp[(1) - (3)].str)) + strlen((yyvsp[(3) - (3)].str)) + 2);
					sprintf((yyval.str), "%s.%s", (yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str));
				;}
    break;

  case 190:

/* Line 1464 of yacc.c  */
#line 1322 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 191:

/* Line 1464 of yacc.c  */
#line 1323 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 192:

/* Line 1464 of yacc.c  */
#line 1327 "gram.y"
    { (yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)])); ;}
    break;

  case 193:

/* Line 1464 of yacc.c  */
#line 1329 "gram.y"
    { (yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)])); ;}
    break;

  case 194:

/* Line 1464 of yacc.c  */
#line 1331 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); ;}
    break;

  case 195:

/* Line 1464 of yacc.c  */
#line 1334 "gram.y"
    { (yyval.str) = "read uncommitted"; ;}
    break;

  case 196:

/* Line 1464 of yacc.c  */
#line 1335 "gram.y"
    { (yyval.str) = "read committed"; ;}
    break;

  case 197:

/* Line 1464 of yacc.c  */
#line 1336 "gram.y"
    { (yyval.str) = "repeatable read"; ;}
    break;

  case 198:

/* Line 1464 of yacc.c  */
#line 1337 "gram.y"
    { (yyval.str) = "serializable"; ;}
    break;

  case 199:

/* Line 1464 of yacc.c  */
#line 1341 "gram.y"
    { (yyval.str) = "true"; ;}
    break;

  case 200:

/* Line 1464 of yacc.c  */
#line 1342 "gram.y"
    { (yyval.str) = "false"; ;}
    break;

  case 201:

/* Line 1464 of yacc.c  */
#line 1343 "gram.y"
    { (yyval.str) = "on"; ;}
    break;

  case 202:

/* Line 1464 of yacc.c  */
#line 1344 "gram.y"
    { (yyval.str) = "off"; ;}
    break;

  case 203:

/* Line 1464 of yacc.c  */
#line 1357 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 204:

/* Line 1464 of yacc.c  */
#line 1361 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 205:

/* Line 1464 of yacc.c  */
#line 1365 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					if ((yyvsp[(3) - (3)].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[(3) - (3)].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[(3) - (3)]))));
					}
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				;}
    break;

  case 206:

/* Line 1464 of yacc.c  */
#line 1380 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (6)].typnam);
					if ((yyvsp[(6) - (6)].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[(6) - (6)].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[(6) - (6)]))));
						if (list_length((yyvsp[(6) - (6)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (6)]))));
						t->typmods = lappend((yyvsp[(6) - (6)].list), makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (6)].str), (yylsp[(5) - (6)]), t);
				;}
    break;

  case 207:

/* Line 1464 of yacc.c  */
#line 1402 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); ;}
    break;

  case 208:

/* Line 1464 of yacc.c  */
#line 1403 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 209:

/* Line 1464 of yacc.c  */
#line 1404 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 210:

/* Line 1464 of yacc.c  */
#line 1408 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 211:

/* Line 1464 of yacc.c  */
#line 1409 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 212:

/* Line 1464 of yacc.c  */
#line 1410 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 213:

/* Line 1464 of yacc.c  */
#line 1414 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 214:

/* Line 1464 of yacc.c  */
#line 1415 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 215:

/* Line 1464 of yacc.c  */
#line 1420 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 216:

/* Line 1464 of yacc.c  */
#line 1427 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 217:

/* Line 1464 of yacc.c  */
#line 1434 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 218:

/* Line 1464 of yacc.c  */
#line 1441 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 219:

/* Line 1464 of yacc.c  */
#line 1448 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 220:

/* Line 1464 of yacc.c  */
#line 1457 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(2) - (2)].vsetstmt); ;}
    break;

  case 221:

/* Line 1464 of yacc.c  */
#line 1458 "gram.y"
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[(1) - (1)].node); ;}
    break;

  case 222:

/* Line 1464 of yacc.c  */
#line 1464 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 223:

/* Line 1464 of yacc.c  */
#line 1470 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 224:

/* Line 1464 of yacc.c  */
#line 1476 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 225:

/* Line 1464 of yacc.c  */
#line 1482 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 226:

/* Line 1464 of yacc.c  */
#line 1488 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 227:

/* Line 1464 of yacc.c  */
#line 1498 "gram.y"
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[(3) - (4)].list);
					n->deferred    = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 228:

/* Line 1464 of yacc.c  */
#line 1507 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 229:

/* Line 1464 of yacc.c  */
#line 1508 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 230:

/* Line 1464 of yacc.c  */
#line 1512 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 231:

/* Line 1464 of yacc.c  */
#line 1513 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 232:

/* Line 1464 of yacc.c  */
#line 1522 "gram.y"
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 233:

/* Line 1464 of yacc.c  */
#line 1537 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 234:

/* Line 1464 of yacc.c  */
#line 1543 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 235:

/* Line 1464 of yacc.c  */
#line 1549 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 236:

/* Line 1464 of yacc.c  */
#line 1555 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 237:

/* Line 1464 of yacc.c  */
#line 1573 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_TABLE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 238:

/* Line 1464 of yacc.c  */
#line 1581 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_INDEX;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 239:

/* Line 1464 of yacc.c  */
#line 1589 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_SEQUENCE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 240:

/* Line 1464 of yacc.c  */
#line 1597 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_VIEW;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 241:

/* Line 1464 of yacc.c  */
#line 1607 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 242:

/* Line 1464 of yacc.c  */
#line 1608 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 243:

/* Line 1464 of yacc.c  */
#line 1614 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 244:

/* Line 1464 of yacc.c  */
#line 1622 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(3) - (3)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 245:

/* Line 1464 of yacc.c  */
#line 1630 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[(3) - (4)].str);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 246:

/* Line 1464 of yacc.c  */
#line 1639 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 247:

/* Line 1464 of yacc.c  */
#line 1647 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 248:

/* Line 1464 of yacc.c  */
#line 1655 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeInteger((yyvsp[(6) - (6)].ival));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 249:

/* Line 1464 of yacc.c  */
#line 1664 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[(3) - (5)].str);
					n->def = (Node *) (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 250:

/* Line 1464 of yacc.c  */
#line 1673 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[(3) - (5)].str);
					n->def = (Node *) (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 251:

/* Line 1464 of yacc.c  */
#line 1682 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeString((yyvsp[(6) - (6)].str));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 252:

/* Line 1464 of yacc.c  */
#line 1691 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 253:

/* Line 1464 of yacc.c  */
#line 1701 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 254:

/* Line 1464 of yacc.c  */
#line 1714 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[(3) - (7)].str);
					n->def = (Node *) (yyvsp[(6) - (7)].typnam);
					n->transform = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 255:

/* Line 1464 of yacc.c  */
#line 1724 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 256:

/* Line 1464 of yacc.c  */
#line 1732 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 257:

/* Line 1464 of yacc.c  */
#line 1742 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 258:

/* Line 1464 of yacc.c  */
#line 1752 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddOids;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 259:

/* Line 1464 of yacc.c  */
#line 1759 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 260:

/* Line 1464 of yacc.c  */
#line 1766 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddSecLabel;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 261:

/* Line 1464 of yacc.c  */
#line 1773 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropSecLabel;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 262:

/* Line 1464 of yacc.c  */
#line 1780 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 263:

/* Line 1464 of yacc.c  */
#line 1788 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 264:

/* Line 1464 of yacc.c  */
#line 1796 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 265:

/* Line 1464 of yacc.c  */
#line 1804 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 266:

/* Line 1464 of yacc.c  */
#line 1812 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 267:

/* Line 1464 of yacc.c  */
#line 1820 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 268:

/* Line 1464 of yacc.c  */
#line 1827 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 269:

/* Line 1464 of yacc.c  */
#line 1834 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 270:

/* Line 1464 of yacc.c  */
#line 1842 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 271:

/* Line 1464 of yacc.c  */
#line 1849 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 272:

/* Line 1464 of yacc.c  */
#line 1856 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 273:

/* Line 1464 of yacc.c  */
#line 1864 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 274:

/* Line 1464 of yacc.c  */
#line 1872 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 275:

/* Line 1464 of yacc.c  */
#line 1880 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 276:

/* Line 1464 of yacc.c  */
#line 1888 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[(2) - (2)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 277:

/* Line 1464 of yacc.c  */
#line 1896 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[(3) - (3)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 278:

/* Line 1464 of yacc.c  */
#line 1904 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 279:

/* Line 1464 of yacc.c  */
#line 1912 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 280:

/* Line 1464 of yacc.c  */
#line 1920 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 281:

/* Line 1464 of yacc.c  */
#line 1928 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 282:

/* Line 1464 of yacc.c  */
#line 1937 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (3)].node); ;}
    break;

  case 283:

/* Line 1464 of yacc.c  */
#line 1938 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 284:

/* Line 1464 of yacc.c  */
#line 1942 "gram.y"
    { (yyval.dbehavior) = DROP_CASCADE; ;}
    break;

  case 285:

/* Line 1464 of yacc.c  */
#line 1943 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; ;}
    break;

  case 286:

/* Line 1464 of yacc.c  */
#line 1944 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ ;}
    break;

  case 287:

/* Line 1464 of yacc.c  */
#line 1948 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 288:

/* Line 1464 of yacc.c  */
#line 1949 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 289:

/* Line 1464 of yacc.c  */
#line 1953 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 290:

/* Line 1464 of yacc.c  */
#line 1956 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 291:

/* Line 1464 of yacc.c  */
#line 1957 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 292:

/* Line 1464 of yacc.c  */
#line 1961 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 293:

/* Line 1464 of yacc.c  */
#line 1962 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 294:

/* Line 1464 of yacc.c  */
#line 1968 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				;}
    break;

  case 295:

/* Line 1464 of yacc.c  */
#line 1972 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				;}
    break;

  case 296:

/* Line 1464 of yacc.c  */
#line 1976 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (5)].str), (yyvsp[(3) - (5)].str), (Node *) (yyvsp[(5) - (5)].node),
											 DEFELEM_UNSPEC);
				;}
    break;

  case 297:

/* Line 1464 of yacc.c  */
#line 1981 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str), NULL, DEFELEM_UNSPEC);
				;}
    break;

  case 298:

/* Line 1464 of yacc.c  */
#line 1996 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 299:

/* Line 1464 of yacc.c  */
#line 2002 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 300:

/* Line 1464 of yacc.c  */
#line 2030 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[(3) - (10)].range);
					n->query = NULL;
					n->attlist = (yyvsp[(4) - (10)].list);
					n->is_from = (yyvsp[(6) - (10)].boolean);
					n->filename = (yyvsp[(7) - (10)].str);

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[(2) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(2) - (10)].defelt));
					if ((yyvsp[(5) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(5) - (10)].defelt));
					if ((yyvsp[(8) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(8) - (10)].defelt));
					if ((yyvsp[(10) - (10)].list))
						n->options = list_concat(n->options, (yyvsp[(10) - (10)].list));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 301:

/* Line 1464 of yacc.c  */
#line 2051 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[(2) - (6)].node);
					n->attlist = NIL;
					n->is_from = false;
					n->filename = (yyvsp[(4) - (6)].str);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 302:

/* Line 1464 of yacc.c  */
#line 2064 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 303:

/* Line 1464 of yacc.c  */
#line 2065 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 304:

/* Line 1464 of yacc.c  */
#line 2074 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 305:

/* Line 1464 of yacc.c  */
#line 2075 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 306:

/* Line 1464 of yacc.c  */
#line 2076 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 307:

/* Line 1464 of yacc.c  */
#line 2079 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 308:

/* Line 1464 of yacc.c  */
#line 2080 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 309:

/* Line 1464 of yacc.c  */
#line 2085 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 310:

/* Line 1464 of yacc.c  */
#line 2086 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 311:

/* Line 1464 of yacc.c  */
#line 2091 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				;}
    break;

  case 312:

/* Line 1464 of yacc.c  */
#line 2095 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				;}
    break;

  case 313:

/* Line 1464 of yacc.c  */
#line 2099 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 314:

/* Line 1464 of yacc.c  */
#line 2103 "gram.y"
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 315:

/* Line 1464 of yacc.c  */
#line 2107 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"));
				;}
    break;

  case 316:

/* Line 1464 of yacc.c  */
#line 2111 "gram.y"
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
				;}
    break;

  case 317:

/* Line 1464 of yacc.c  */
#line 2115 "gram.y"
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 318:

/* Line 1464 of yacc.c  */
#line 2119 "gram.y"
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 319:

/* Line 1464 of yacc.c  */
#line 2123 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 320:

/* Line 1464 of yacc.c  */
#line 2127 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star));
				;}
    break;

  case 321:

/* Line 1464 of yacc.c  */
#line 2131 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[(4) - (4)].list));
				;}
    break;

  case 322:

/* Line 1464 of yacc.c  */
#line 2140 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				;}
    break;

  case 323:

/* Line 1464 of yacc.c  */
#line 2143 "gram.y"
    { (yyval.defelt) = NULL; ;}
    break;

  case 324:

/* Line 1464 of yacc.c  */
#line 2148 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				;}
    break;

  case 325:

/* Line 1464 of yacc.c  */
#line 2151 "gram.y"
    { (yyval.defelt) = NULL; ;}
    break;

  case 326:

/* Line 1464 of yacc.c  */
#line 2156 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 327:

/* Line 1464 of yacc.c  */
#line 2159 "gram.y"
    { (yyval.defelt) = NULL; ;}
    break;

  case 328:

/* Line 1464 of yacc.c  */
#line 2163 "gram.y"
    {;}
    break;

  case 329:

/* Line 1464 of yacc.c  */
#line 2164 "gram.y"
    {;}
    break;

  case 330:

/* Line 1464 of yacc.c  */
#line 2170 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				;}
    break;

  case 331:

/* Line 1464 of yacc.c  */
#line 2174 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				;}
    break;

  case 332:

/* Line 1464 of yacc.c  */
#line 2181 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				;}
    break;

  case 333:

/* Line 1464 of yacc.c  */
#line 2187 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 334:

/* Line 1464 of yacc.c  */
#line 2188 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 335:

/* Line 1464 of yacc.c  */
#line 2189 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].value); ;}
    break;

  case 336:

/* Line 1464 of yacc.c  */
#line 2190 "gram.y"
    { (yyval.node) = (Node *) makeNode(A_Star); ;}
    break;

  case 337:

/* Line 1464 of yacc.c  */
#line 2191 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(2) - (3)].list); ;}
    break;

  case 338:

/* Line 1464 of yacc.c  */
#line 2192 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 339:

/* Line 1464 of yacc.c  */
#line 2197 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 340:

/* Line 1464 of yacc.c  */
#line 2201 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 341:

/* Line 1464 of yacc.c  */
#line 2208 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 342:

/* Line 1464 of yacc.c  */
#line 2209 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 343:

/* Line 1464 of yacc.c  */
#line 2222 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (11)].range)->istemp = (yyvsp[(2) - (11)].boolean);
					n->relation = (yyvsp[(4) - (11)].range);
					n->tableElts = (yyvsp[(6) - (11)].list);
					n->inhRelations = (yyvsp[(8) - (11)].list);
					n->constraints = NIL;
					n->options = (yyvsp[(9) - (11)].list);
					n->oncommit = (yyvsp[(10) - (11)].oncommit);
					n->tablespacename = (yyvsp[(11) - (11)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 344:

/* Line 1464 of yacc.c  */
#line 2236 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (10)].range)->istemp = (yyvsp[(2) - (10)].boolean);
					n->relation = (yyvsp[(4) - (10)].range);
					n->tableElts = (yyvsp[(7) - (10)].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[(6) - (10)].list));
					n->ofTypename->location = (yylsp[(6) - (10)]);
					n->constraints = NIL;
					n->options = (yyvsp[(8) - (10)].list);
					n->oncommit = (yyvsp[(9) - (10)].oncommit);
					n->tablespacename = (yyvsp[(10) - (10)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 345:

/* Line 1464 of yacc.c  */
#line 2258 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 346:

/* Line 1464 of yacc.c  */
#line 2259 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 347:

/* Line 1464 of yacc.c  */
#line 2260 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 348:

/* Line 1464 of yacc.c  */
#line 2261 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 349:

/* Line 1464 of yacc.c  */
#line 2262 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 350:

/* Line 1464 of yacc.c  */
#line 2263 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 351:

/* Line 1464 of yacc.c  */
#line 2264 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 352:

/* Line 1464 of yacc.c  */
#line 2268 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 353:

/* Line 1464 of yacc.c  */
#line 2269 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 354:

/* Line 1464 of yacc.c  */
#line 2273 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 355:

/* Line 1464 of yacc.c  */
#line 2274 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 356:

/* Line 1464 of yacc.c  */
#line 2279 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 357:

/* Line 1464 of yacc.c  */
#line 2283 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 358:

/* Line 1464 of yacc.c  */
#line 2290 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 359:

/* Line 1464 of yacc.c  */
#line 2294 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 360:

/* Line 1464 of yacc.c  */
#line 2300 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 361:

/* Line 1464 of yacc.c  */
#line 2301 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 362:

/* Line 1464 of yacc.c  */
#line 2302 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 363:

/* Line 1464 of yacc.c  */
#line 2306 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 364:

/* Line 1464 of yacc.c  */
#line 2307 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 365:

/* Line 1464 of yacc.c  */
#line 2311 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (3)].str);
					n->typeName = (yyvsp[(2) - (3)].typnam);
					n->constraints = (yyvsp[(3) - (3)].list);
					n->is_local = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 366:

/* Line 1464 of yacc.c  */
#line 2322 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (4)].str);
					n->constraints = (yyvsp[(4) - (4)].list);
					n->is_local = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 367:

/* Line 1464 of yacc.c  */
#line 2332 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 368:

/* Line 1464 of yacc.c  */
#line 2333 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 369:

/* Line 1464 of yacc.c  */
#line 2338 "gram.y"
    {
					Constraint *n = (Constraint *) (yyvsp[(3) - (3)].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[(2) - (3)].str);
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 370:

/* Line 1464 of yacc.c  */
#line 2345 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 371:

/* Line 1464 of yacc.c  */
#line 2346 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 372:

/* Line 1464 of yacc.c  */
#line 2366 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 373:

/* Line 1464 of yacc.c  */
#line 2373 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 374:

/* Line 1464 of yacc.c  */
#line 2380 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (3)]);
					n->keys = NULL;
					n->options = (yyvsp[(2) - (3)].list);
					n->indexspace = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 375:

/* Line 1464 of yacc.c  */
#line 2390 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (4)]);
					n->keys = NULL;
					n->options = (yyvsp[(3) - (4)].list);
					n->indexspace = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 376:

/* Line 1464 of yacc.c  */
#line 2400 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[(1) - (4)]);
					n->raw_expr = (yyvsp[(3) - (4)].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 377:

/* Line 1464 of yacc.c  */
#line 2409 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[(1) - (2)]);
					n->raw_expr = (yyvsp[(2) - (2)].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 378:

/* Line 1464 of yacc.c  */
#line 2418 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[(1) - (5)]);
					n->pktable			= (yyvsp[(2) - (5)].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[(3) - (5)].list);
					n->fk_matchtype		= (yyvsp[(4) - (5)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(5) - (5)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(5) - (5)].ival) & 0xFF);
					n->skip_validation  = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 379:

/* Line 1464 of yacc.c  */
#line 2447 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 380:

/* Line 1464 of yacc.c  */
#line 2454 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 381:

/* Line 1464 of yacc.c  */
#line 2461 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 382:

/* Line 1464 of yacc.c  */
#line 2468 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 383:

/* Line 1464 of yacc.c  */
#line 2487 "gram.y"
    {
					InhRelation *n = makeNode(InhRelation);
					n->relation = (yyvsp[(2) - (3)].range);
					n->options = (yyvsp[(3) - (3)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 384:

/* Line 1464 of yacc.c  */
#line 2496 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival); ;}
    break;

  case 385:

/* Line 1464 of yacc.c  */
#line 2497 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) & ~(yyvsp[(3) - (3)].ival); ;}
    break;

  case 386:

/* Line 1464 of yacc.c  */
#line 2498 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 387:

/* Line 1464 of yacc.c  */
#line 2502 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; ;}
    break;

  case 388:

/* Line 1464 of yacc.c  */
#line 2503 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; ;}
    break;

  case 389:

/* Line 1464 of yacc.c  */
#line 2504 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; ;}
    break;

  case 390:

/* Line 1464 of yacc.c  */
#line 2505 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; ;}
    break;

  case 391:

/* Line 1464 of yacc.c  */
#line 2506 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; ;}
    break;

  case 392:

/* Line 1464 of yacc.c  */
#line 2507 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; ;}
    break;

  case 393:

/* Line 1464 of yacc.c  */
#line 2517 "gram.y"
    {
					Constraint *n = (Constraint *) (yyvsp[(3) - (3)].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[(2) - (3)].str);
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 394:

/* Line 1464 of yacc.c  */
#line 2524 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 395:

/* Line 1464 of yacc.c  */
#line 2529 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[(1) - (5)]);
					n->raw_expr = (yyvsp[(3) - (5)].node);
					n->cooked_expr = NULL;
					if ((yyvsp[(5) - (5)].ival) != 0)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CHECK constraints cannot be deferred"),
								 parser_errposition((yylsp[(5) - (5)]))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 396:

/* Line 1464 of yacc.c  */
#line 2544 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (7)]);
					n->keys = (yyvsp[(3) - (7)].list);
					n->options = (yyvsp[(5) - (7)].list);
					n->indexspace = (yyvsp[(6) - (7)].str);
					n->deferrable = ((yyvsp[(7) - (7)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(7) - (7)].ival) & 2) != 0;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 397:

/* Line 1464 of yacc.c  */
#line 2557 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (8)]);
					n->keys = (yyvsp[(4) - (8)].list);
					n->options = (yyvsp[(6) - (8)].list);
					n->indexspace = (yyvsp[(7) - (8)].str);
					n->deferrable = ((yyvsp[(8) - (8)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(8) - (8)].ival) & 2) != 0;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 398:

/* Line 1464 of yacc.c  */
#line 2571 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[(1) - (9)]);
					n->access_method	= (yyvsp[(2) - (9)].str);
					n->exclusions		= (yyvsp[(4) - (9)].list);
					n->options			= (yyvsp[(6) - (9)].list);
					n->indexspace		= (yyvsp[(7) - (9)].str);
					n->where_clause		= (yyvsp[(8) - (9)].node);
					n->deferrable		= ((yyvsp[(9) - (9)].ival) & 1) != 0;
					n->initdeferred		= ((yyvsp[(9) - (9)].ival) & 2) != 0;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 399:

/* Line 1464 of yacc.c  */
#line 2586 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[(1) - (11)]);
					n->pktable			= (yyvsp[(7) - (11)].range);
					n->fk_attrs			= (yyvsp[(4) - (11)].list);
					n->pk_attrs			= (yyvsp[(8) - (11)].list);
					n->fk_matchtype		= (yyvsp[(9) - (11)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(10) - (11)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(10) - (11)].ival) & 0xFF);
					n->skip_validation  = FALSE;
					n->deferrable		= ((yyvsp[(11) - (11)].ival) & 1) != 0;
					n->initdeferred		= ((yyvsp[(11) - (11)].ival) & 2) != 0;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 400:

/* Line 1464 of yacc.c  */
#line 2604 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 401:

/* Line 1464 of yacc.c  */
#line 2605 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 402:

/* Line 1464 of yacc.c  */
#line 2609 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 403:

/* Line 1464 of yacc.c  */
#line 2610 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 404:

/* Line 1464 of yacc.c  */
#line 2614 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str));
				;}
    break;

  case 405:

/* Line 1464 of yacc.c  */
#line 2620 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			;}
    break;

  case 406:

/* Line 1464 of yacc.c  */
#line 2624 "gram.y"
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[(1) - (2)]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			;}
    break;

  case 407:

/* Line 1464 of yacc.c  */
#line 2632 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_UNSPECIFIED;
			;}
    break;

  case 408:

/* Line 1464 of yacc.c  */
#line 2636 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_UNSPECIFIED;
			;}
    break;

  case 409:

/* Line 1464 of yacc.c  */
#line 2642 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); ;}
    break;

  case 410:

/* Line 1464 of yacc.c  */
#line 2644 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); ;}
    break;

  case 411:

/* Line 1464 of yacc.c  */
#line 2648 "gram.y"
    {
				(yyval.list) = list_make2((yyvsp[(1) - (3)].ielem), (yyvsp[(3) - (3)].list));
			;}
    break;

  case 412:

/* Line 1464 of yacc.c  */
#line 2653 "gram.y"
    {
				(yyval.list) = list_make2((yyvsp[(1) - (6)].ielem), (yyvsp[(5) - (6)].list));
			;}
    break;

  case 413:

/* Line 1464 of yacc.c  */
#line 2659 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (4)].node); ;}
    break;

  case 414:

/* Line 1464 of yacc.c  */
#line 2660 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 415:

/* Line 1464 of yacc.c  */
#line 2671 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (1)].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); ;}
    break;

  case 416:

/* Line 1464 of yacc.c  */
#line 2673 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[(1) - (1)].ival) & 0xFF); ;}
    break;

  case 417:

/* Line 1464 of yacc.c  */
#line 2675 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (2)].ival) << 8) | ((yyvsp[(2) - (2)].ival) & 0xFF); ;}
    break;

  case 418:

/* Line 1464 of yacc.c  */
#line 2677 "gram.y"
    { (yyval.ival) = ((yyvsp[(2) - (2)].ival) << 8) | ((yyvsp[(1) - (2)].ival) & 0xFF); ;}
    break;

  case 419:

/* Line 1464 of yacc.c  */
#line 2679 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); ;}
    break;

  case 420:

/* Line 1464 of yacc.c  */
#line 2682 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); ;}
    break;

  case 421:

/* Line 1464 of yacc.c  */
#line 2685 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); ;}
    break;

  case 422:

/* Line 1464 of yacc.c  */
#line 2689 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; ;}
    break;

  case 423:

/* Line 1464 of yacc.c  */
#line 2690 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; ;}
    break;

  case 424:

/* Line 1464 of yacc.c  */
#line 2691 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; ;}
    break;

  case 425:

/* Line 1464 of yacc.c  */
#line 2692 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; ;}
    break;

  case 426:

/* Line 1464 of yacc.c  */
#line 2693 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; ;}
    break;

  case 427:

/* Line 1464 of yacc.c  */
#line 2696 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 428:

/* Line 1464 of yacc.c  */
#line 2697 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 429:

/* Line 1464 of yacc.c  */
#line 2702 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 430:

/* Line 1464 of yacc.c  */
#line 2703 "gram.y"
    { (yyval.list) = list_make1(defWithOids(true)); ;}
    break;

  case 431:

/* Line 1464 of yacc.c  */
#line 2704 "gram.y"
    { (yyval.list) = list_make1(defWithOids(false)); ;}
    break;

  case 432:

/* Line 1464 of yacc.c  */
#line 2705 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 433:

/* Line 1464 of yacc.c  */
#line 2708 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DROP; ;}
    break;

  case 434:

/* Line 1464 of yacc.c  */
#line 2709 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; ;}
    break;

  case 435:

/* Line 1464 of yacc.c  */
#line 2710 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; ;}
    break;

  case 436:

/* Line 1464 of yacc.c  */
#line 2711 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_NOOP; ;}
    break;

  case 437:

/* Line 1464 of yacc.c  */
#line 2714 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 438:

/* Line 1464 of yacc.c  */
#line 2715 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 439:

/* Line 1464 of yacc.c  */
#line 2718 "gram.y"
    { (yyval.str) = (yyvsp[(4) - (4)].str); ;}
    break;

  case 440:

/* Line 1464 of yacc.c  */
#line 2719 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 441:

/* Line 1464 of yacc.c  */
#line 2730 "gram.y"
    {
					/*
					 * When the SelectStmt is a set-operation tree, we must
					 * stuff the INTO information into the leftmost component
					 * Select, because that's where analyze.c will expect
					 * to find it.	Similarly, the output column names must
					 * be attached to that Select's target list.
					 */
					SelectStmt *n = findLeftmostSelect((SelectStmt *) (yyvsp[(6) - (7)].node));
					if (n->intoClause != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("CREATE TABLE AS cannot specify INTO"),
								 parser_errposition(exprLocation((Node *) n->intoClause))));
					(yyvsp[(4) - (7)].into)->rel->istemp = (yyvsp[(2) - (7)].boolean);
					n->intoClause = (yyvsp[(4) - (7)].into);
					/* Implement WITH NO DATA by forcing top-level LIMIT 0 */
					if (!(yyvsp[(7) - (7)].boolean))
						((SelectStmt *) (yyvsp[(6) - (7)].node))->limitCount = makeIntConst(0, -1);
					(yyval.node) = (yyvsp[(6) - (7)].node);
				;}
    break;

  case 442:

/* Line 1464 of yacc.c  */
#line 2755 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(1) - (5)].range);
					(yyval.into)->colNames = (yyvsp[(2) - (5)].list);
					(yyval.into)->options = (yyvsp[(3) - (5)].list);
					(yyval.into)->onCommit = (yyvsp[(4) - (5)].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[(5) - (5)].str);
				;}
    break;

  case 443:

/* Line 1464 of yacc.c  */
#line 2766 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 444:

/* Line 1464 of yacc.c  */
#line 2767 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 445:

/* Line 1464 of yacc.c  */
#line 2771 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 446:

/* Line 1464 of yacc.c  */
#line 2772 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 447:

/* Line 1464 of yacc.c  */
#line 2777 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (1)].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->constraints = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 448:

/* Line 1464 of yacc.c  */
#line 2792 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 449:

/* Line 1464 of yacc.c  */
#line 2793 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 450:

/* Line 1464 of yacc.c  */
#line 2794 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 451:

/* Line 1464 of yacc.c  */
#line 2808 "gram.y"
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[(4) - (5)].range)->istemp = (yyvsp[(2) - (5)].boolean);
					n->sequence = (yyvsp[(4) - (5)].range);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 452:

/* Line 1464 of yacc.c  */
#line 2819 "gram.y"
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[(3) - (4)].range);
					n->options = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 453:

/* Line 1464 of yacc.c  */
#line 2827 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 454:

/* Line 1464 of yacc.c  */
#line 2828 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 455:

/* Line 1464 of yacc.c  */
#line 2831 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 456:

/* Line 1464 of yacc.c  */
#line 2832 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 457:

/* Line 1464 of yacc.c  */
#line 2836 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 458:

/* Line 1464 of yacc.c  */
#line 2840 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE));
				;}
    break;

  case 459:

/* Line 1464 of yacc.c  */
#line 2844 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE));
				;}
    break;

  case 460:

/* Line 1464 of yacc.c  */
#line 2848 "gram.y"
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[(3) - (3)].value));
				;}
    break;

  case 461:

/* Line 1464 of yacc.c  */
#line 2852 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 462:

/* Line 1464 of yacc.c  */
#line 2856 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 463:

/* Line 1464 of yacc.c  */
#line 2860 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL);
				;}
    break;

  case 464:

/* Line 1464 of yacc.c  */
#line 2864 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL);
				;}
    break;

  case 465:

/* Line 1464 of yacc.c  */
#line 2868 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 466:

/* Line 1464 of yacc.c  */
#line 2872 "gram.y"
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[(3) - (3)].value));
				;}
    break;

  case 467:

/* Line 1464 of yacc.c  */
#line 2876 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", NULL);
				;}
    break;

  case 468:

/* Line 1464 of yacc.c  */
#line 2880 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[(3) - (3)].value));
				;}
    break;

  case 469:

/* Line 1464 of yacc.c  */
#line 2885 "gram.y"
    {;}
    break;

  case 470:

/* Line 1464 of yacc.c  */
#line 2886 "gram.y"
    {;}
    break;

  case 471:

/* Line 1464 of yacc.c  */
#line 2890 "gram.y"
    { (yyval.value) = makeFloat((yyvsp[(1) - (1)].str)); ;}
    break;

  case 472:

/* Line 1464 of yacc.c  */
#line 2892 "gram.y"
    {
					(yyval.value) = makeFloat((yyvsp[(2) - (2)].str));
					doNegateFloat((yyval.value));
				;}
    break;

  case 473:

/* Line 1464 of yacc.c  */
#line 2896 "gram.y"
    { (yyval.value) = makeInteger((yyvsp[(1) - (1)].ival)); ;}
    break;

  case 474:

/* Line 1464 of yacc.c  */
#line 2909 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[(2) - (6)].boolean);
				n->plname = (yyvsp[(6) - (6)].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plinline = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			;}
    break;

  case 475:

/* Line 1464 of yacc.c  */
#line 2922 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[(2) - (10)].boolean);
				n->plname = (yyvsp[(6) - (10)].str);
				n->plhandler = (yyvsp[(8) - (10)].list);
				n->plinline = (yyvsp[(9) - (10)].list);
				n->plvalidator = (yyvsp[(10) - (10)].list);
				n->pltrusted = (yyvsp[(3) - (10)].boolean);
				(yyval.node) = (Node *)n;
			;}
    break;

  case 476:

/* Line 1464 of yacc.c  */
#line 2935 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 477:

/* Line 1464 of yacc.c  */
#line 2936 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 478:

/* Line 1464 of yacc.c  */
#line 2944 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 479:

/* Line 1464 of yacc.c  */
#line 2945 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); ;}
    break;

  case 480:

/* Line 1464 of yacc.c  */
#line 2949 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 481:

/* Line 1464 of yacc.c  */
#line 2950 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 482:

/* Line 1464 of yacc.c  */
#line 2954 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 483:

/* Line 1464 of yacc.c  */
#line 2955 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 484:

/* Line 1464 of yacc.c  */
#line 2959 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 485:

/* Line 1464 of yacc.c  */
#line 2960 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 486:

/* Line 1464 of yacc.c  */
#line 2965 "gram.y"
    {
					DropPLangStmt *n = makeNode(DropPLangStmt);
					n->plname = (yyvsp[(4) - (5)].str);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 487:

/* Line 1464 of yacc.c  */
#line 2973 "gram.y"
    {
					DropPLangStmt *n = makeNode(DropPLangStmt);
					n->plname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 488:

/* Line 1464 of yacc.c  */
#line 2983 "gram.y"
    {;}
    break;

  case 489:

/* Line 1464 of yacc.c  */
#line 2984 "gram.y"
    {;}
    break;

  case 490:

/* Line 1464 of yacc.c  */
#line 2995 "gram.y"
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (6)].str);
					n->owner = (yyvsp[(4) - (6)].str);
					n->location = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 491:

/* Line 1464 of yacc.c  */
#line 3004 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 492:

/* Line 1464 of yacc.c  */
#line 3005 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 493:

/* Line 1464 of yacc.c  */
#line 3019 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (3)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 494:

/* Line 1464 of yacc.c  */
#line 3026 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(5) - (5)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 495:

/* Line 1464 of yacc.c  */
#line 3042 "gram.y"
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->validator = (yyvsp[(6) - (7)].list);
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 496:

/* Line 1464 of yacc.c  */
#line 3059 "gram.y"
    {
					DropFdwStmt *n = makeNode(DropFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 497:

/* Line 1464 of yacc.c  */
#line 3067 "gram.y"
    {
					DropFdwStmt *n = makeNode(DropFdwStmt);
					n->fdwname = (yyvsp[(7) - (8)].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 498:

/* Line 1464 of yacc.c  */
#line 3084 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->validator = (yyvsp[(6) - (7)].list);
					n->change_validator = true;
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 499:

/* Line 1464 of yacc.c  */
#line 3093 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->validator = (yyvsp[(6) - (6)].list);
					n->change_validator = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 500:

/* Line 1464 of yacc.c  */
#line 3101 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 501:

/* Line 1464 of yacc.c  */
#line 3111 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 502:

/* Line 1464 of yacc.c  */
#line 3112 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 503:

/* Line 1464 of yacc.c  */
#line 3117 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				;}
    break;

  case 504:

/* Line 1464 of yacc.c  */
#line 3121 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				;}
    break;

  case 505:

/* Line 1464 of yacc.c  */
#line 3128 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 506:

/* Line 1464 of yacc.c  */
#line 3133 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				;}
    break;

  case 507:

/* Line 1464 of yacc.c  */
#line 3137 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				;}
    break;

  case 508:

/* Line 1464 of yacc.c  */
#line 3144 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				;}
    break;

  case 509:

/* Line 1464 of yacc.c  */
#line 3148 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				;}
    break;

  case 510:

/* Line 1464 of yacc.c  */
#line 3153 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				;}
    break;

  case 511:

/* Line 1464 of yacc.c  */
#line 3158 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[(2) - (2)].str), NULL, DEFELEM_DROP);
				;}
    break;

  case 512:

/* Line 1464 of yacc.c  */
#line 3165 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				;}
    break;

  case 513:

/* Line 1464 of yacc.c  */
#line 3171 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 514:

/* Line 1464 of yacc.c  */
#line 3176 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 515:

/* Line 1464 of yacc.c  */
#line 3188 "gram.y"
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[(3) - (10)].str);
					n->servertype = (yyvsp[(4) - (10)].str);
					n->version = (yyvsp[(5) - (10)].str);
					n->fdwname = (yyvsp[(9) - (10)].str);
					n->options = (yyvsp[(10) - (10)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 516:

/* Line 1464 of yacc.c  */
#line 3200 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 517:

/* Line 1464 of yacc.c  */
#line 3201 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 518:

/* Line 1464 of yacc.c  */
#line 3206 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 519:

/* Line 1464 of yacc.c  */
#line 3207 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 520:

/* Line 1464 of yacc.c  */
#line 3211 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 521:

/* Line 1464 of yacc.c  */
#line 3212 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 522:

/* Line 1464 of yacc.c  */
#line 3223 "gram.y"
    {
					DropForeignServerStmt *n = makeNode(DropForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 523:

/* Line 1464 of yacc.c  */
#line 3231 "gram.y"
    {
					DropForeignServerStmt *n = makeNode(DropForeignServerStmt);
					n->servername = (yyvsp[(5) - (6)].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 524:

/* Line 1464 of yacc.c  */
#line 3248 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (5)].str);
					n->version = (yyvsp[(4) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 525:

/* Line 1464 of yacc.c  */
#line 3257 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->version = (yyvsp[(4) - (4)].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 526:

/* Line 1464 of yacc.c  */
#line 3265 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->options = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 527:

/* Line 1464 of yacc.c  */
#line 3281 "gram.y"
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->username = (yyvsp[(5) - (8)].str);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 528:

/* Line 1464 of yacc.c  */
#line 3292 "gram.y"
    { (yyval.str) = "current_user"; ;}
    break;

  case 529:

/* Line 1464 of yacc.c  */
#line 3293 "gram.y"
    { (yyval.str) = "current_user"; ;}
    break;

  case 530:

/* Line 1464 of yacc.c  */
#line 3294 "gram.y"
    { (yyval.str) = (strcmp((yyvsp[(1) - (1)].str), "public") == 0) ? NULL : (yyvsp[(1) - (1)].str); ;}
    break;

  case 531:

/* Line 1464 of yacc.c  */
#line 3305 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[(5) - (7)].str);
					n->servername = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 532:

/* Line 1464 of yacc.c  */
#line 3313 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[(7) - (9)].str);
					n->servername = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 533:

/* Line 1464 of yacc.c  */
#line 3330 "gram.y"
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->username = (yyvsp[(5) - (8)].str);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 534:

/* Line 1464 of yacc.c  */
#line 3351 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (15)].str);
					n->relation = (yyvsp[(7) - (15)].range);
					n->funcname = (yyvsp[(12) - (15)].list);
					n->args = (yyvsp[(14) - (15)].list);
					n->before = (yyvsp[(4) - (15)].boolean);
					n->row = (yyvsp[(8) - (15)].boolean);
					n->events = intVal(linitial((yyvsp[(5) - (15)].list)));
					n->columns = (List *) lsecond((yyvsp[(5) - (15)].list));
					n->whenClause = (yyvsp[(9) - (15)].node);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 535:

/* Line 1464 of yacc.c  */
#line 3372 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(4) - (20)].str);
					n->relation = (yyvsp[(8) - (20)].range);
					n->funcname = (yyvsp[(17) - (20)].list);
					n->args = (yyvsp[(19) - (20)].list);
					n->before = FALSE;
					n->row = TRUE;
					n->events = intVal(linitial((yyvsp[(6) - (20)].list)));
					n->columns = (List *) lsecond((yyvsp[(6) - (20)].list));
					n->whenClause = (yyvsp[(14) - (20)].node);
					n->isconstraint  = TRUE;
					n->deferrable = ((yyvsp[(10) - (20)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(10) - (20)].ival) & 2) != 0;
					n->constrrel = (yyvsp[(9) - (20)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 536:

/* Line 1464 of yacc.c  */
#line 3392 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 537:

/* Line 1464 of yacc.c  */
#line 3393 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 538:

/* Line 1464 of yacc.c  */
#line 3398 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 539:

/* Line 1464 of yacc.c  */
#line 3400 "gram.y"
    {
					int		events1 = intVal(linitial((yyvsp[(1) - (3)].list)));
					int		events2 = intVal(linitial((yyvsp[(3) - (3)].list)));
					List   *columns1 = (List *) lsecond((yyvsp[(1) - (3)].list));
					List   *columns2 = (List *) lsecond((yyvsp[(3) - (3)].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				;}
    break;

  case 540:

/* Line 1464 of yacc.c  */
#line 3422 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); ;}
    break;

  case 541:

/* Line 1464 of yacc.c  */
#line 3424 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); ;}
    break;

  case 542:

/* Line 1464 of yacc.c  */
#line 3426 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); ;}
    break;

  case 543:

/* Line 1464 of yacc.c  */
#line 3428 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[(3) - (3)].list)); ;}
    break;

  case 544:

/* Line 1464 of yacc.c  */
#line 3430 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); ;}
    break;

  case 545:

/* Line 1464 of yacc.c  */
#line 3435 "gram.y"
    {
					(yyval.boolean) = (yyvsp[(3) - (3)].boolean);
				;}
    break;

  case 546:

/* Line 1464 of yacc.c  */
#line 3439 "gram.y"
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				;}
    break;

  case 547:

/* Line 1464 of yacc.c  */
#line 3449 "gram.y"
    {;}
    break;

  case 548:

/* Line 1464 of yacc.c  */
#line 3450 "gram.y"
    {;}
    break;

  case 549:

/* Line 1464 of yacc.c  */
#line 3454 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 550:

/* Line 1464 of yacc.c  */
#line 3455 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 551:

/* Line 1464 of yacc.c  */
#line 3459 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (4)].node); ;}
    break;

  case 552:

/* Line 1464 of yacc.c  */
#line 3460 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 553:

/* Line 1464 of yacc.c  */
#line 3464 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); ;}
    break;

  case 554:

/* Line 1464 of yacc.c  */
#line 3465 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); ;}
    break;

  case 555:

/* Line 1464 of yacc.c  */
#line 3466 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 556:

/* Line 1464 of yacc.c  */
#line 3471 "gram.y"
    {
					char buf[64];
					snprintf(buf, sizeof(buf), "%d", (yyvsp[(1) - (1)].ival));
					(yyval.value) = makeString(pstrdup(buf));
				;}
    break;

  case 557:

/* Line 1464 of yacc.c  */
#line 3476 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 558:

/* Line 1464 of yacc.c  */
#line 3477 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 559:

/* Line 1464 of yacc.c  */
#line 3478 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 560:

/* Line 1464 of yacc.c  */
#line 3479 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 561:

/* Line 1464 of yacc.c  */
#line 3480 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 562:

/* Line 1464 of yacc.c  */
#line 3484 "gram.y"
    { (yyval.range) = (yyvsp[(2) - (2)].range); ;}
    break;

  case 563:

/* Line 1464 of yacc.c  */
#line 3485 "gram.y"
    { (yyval.range) = NULL; ;}
    break;

  case 564:

/* Line 1464 of yacc.c  */
#line 3490 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 565:

/* Line 1464 of yacc.c  */
#line 3492 "gram.y"
    {
					if ((yyvsp[(1) - (2)].ival) == 0 && (yyvsp[(2) - (2)].ival) != 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival);
				;}
    break;

  case 566:

/* Line 1464 of yacc.c  */
#line 3501 "gram.y"
    {
					if ((yyvsp[(1) - (1)].ival) != 0)
						(yyval.ival) = 3;
					else
						(yyval.ival) = 0;
				;}
    break;

  case 567:

/* Line 1464 of yacc.c  */
#line 3508 "gram.y"
    {
					if ((yyvsp[(2) - (2)].ival) == 0 && (yyvsp[(1) - (2)].ival) != 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival);
				;}
    break;

  case 568:

/* Line 1464 of yacc.c  */
#line 3517 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 569:

/* Line 1464 of yacc.c  */
#line 3521 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 570:

/* Line 1464 of yacc.c  */
#line 3522 "gram.y"
    { (yyval.ival) = 1; ;}
    break;

  case 571:

/* Line 1464 of yacc.c  */
#line 3526 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 572:

/* Line 1464 of yacc.c  */
#line 3527 "gram.y"
    { (yyval.ival) = 2; ;}
    break;

  case 573:

/* Line 1464 of yacc.c  */
#line 3533 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->property = (yyvsp[(3) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->removeType = OBJECT_TRIGGER;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 574:

/* Line 1464 of yacc.c  */
#line 3543 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(7) - (8)].range);
					n->property = (yyvsp[(5) - (8)].str);
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->removeType = OBJECT_TRIGGER;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 575:

/* Line 1464 of yacc.c  */
#line 3566 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (8)].str);
					n->args = list_make1((yyvsp[(6) - (8)].node));
					n->isconstraint  = TRUE;
					n->deferrable = ((yyvsp[(8) - (8)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(8) - (8)].ival) & 2) != 0;

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				;}
    break;

  case 576:

/* Line 1464 of yacc.c  */
#line 3584 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = NULL;
					n->property = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 577:

/* Line 1464 of yacc.c  */
#line 3607 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->definition = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 578:

/* Line 1464 of yacc.c  */
#line 3617 "gram.y"
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 579:

/* Line 1464 of yacc.c  */
#line 3628 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 580:

/* Line 1464 of yacc.c  */
#line 3638 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 581:

/* Line 1464 of yacc.c  */
#line 3648 "gram.y"
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (3)].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 582:

/* Line 1464 of yacc.c  */
#line 3659 "gram.y"
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);
					RangeVar *r = makeNode(RangeVar);

					/* can't use qualified_name, sigh */
					switch (list_length((yyvsp[(3) - (7)].list)))
					{
						case 1:
							r->catalogname = NULL;
							r->schemaname = NULL;
							r->relname = strVal(linitial((yyvsp[(3) - (7)].list)));
							break;
						case 2:
							r->catalogname = NULL;
							r->schemaname = strVal(linitial((yyvsp[(3) - (7)].list)));
							r->relname = strVal(lsecond((yyvsp[(3) - (7)].list)));
							break;
						case 3:
							r->catalogname = strVal(linitial((yyvsp[(3) - (7)].list)));
							r->schemaname = strVal(lsecond((yyvsp[(3) - (7)].list)));
							r->relname = strVal(lthird((yyvsp[(3) - (7)].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString((yyvsp[(3) - (7)].list))),
											parser_errposition((yylsp[(3) - (7)]))));
							break;
					}
					r->location = (yylsp[(3) - (7)]);
					n->typevar = r;
					n->coldeflist = (yyvsp[(6) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 583:

/* Line 1464 of yacc.c  */
#line 3695 "gram.y"
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[(3) - (8)].list);
					n->vals = (yyvsp[(7) - (8)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 584:

/* Line 1464 of yacc.c  */
#line 3702 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 585:

/* Line 1464 of yacc.c  */
#line 3711 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 586:

/* Line 1464 of yacc.c  */
#line 3720 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 587:

/* Line 1464 of yacc.c  */
#line 3729 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 588:

/* Line 1464 of yacc.c  */
#line 3739 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 589:

/* Line 1464 of yacc.c  */
#line 3742 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 590:

/* Line 1464 of yacc.c  */
#line 3743 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 591:

/* Line 1464 of yacc.c  */
#line 3747 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				;}
    break;

  case 592:

/* Line 1464 of yacc.c  */
#line 3751 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				;}
    break;

  case 593:

/* Line 1464 of yacc.c  */
#line 3757 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].typnam); ;}
    break;

  case 594:

/* Line 1464 of yacc.c  */
#line 3758 "gram.y"
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[(1) - (1)].keyword))); ;}
    break;

  case 595:

/* Line 1464 of yacc.c  */
#line 3759 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].list); ;}
    break;

  case 596:

/* Line 1464 of yacc.c  */
#line 3760 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].value); ;}
    break;

  case 597:

/* Line 1464 of yacc.c  */
#line 3761 "gram.y"
    { (yyval.node) = (Node *)makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 598:

/* Line 1464 of yacc.c  */
#line 3764 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 599:

/* Line 1464 of yacc.c  */
#line 3765 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 600:

/* Line 1464 of yacc.c  */
#line 3768 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 601:

/* Line 1464 of yacc.c  */
#line 3771 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 602:

/* Line 1464 of yacc.c  */
#line 3772 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 603:

/* Line 1464 of yacc.c  */
#line 3781 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *)(yyvsp[(3) - (3)].node));
				;}
    break;

  case 604:

/* Line 1464 of yacc.c  */
#line 3787 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 605:

/* Line 1464 of yacc.c  */
#line 3788 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 606:

/* Line 1464 of yacc.c  */
#line 3792 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 607:

/* Line 1464 of yacc.c  */
#line 3794 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); ;}
    break;

  case 608:

/* Line 1464 of yacc.c  */
#line 3812 "gram.y"
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[(4) - (13)].list);
					n->isDefault = (yyvsp[(5) - (13)].boolean);
					n->datatype = (yyvsp[(8) - (13)].typnam);
					n->amname = (yyvsp[(10) - (13)].str);
					n->opfamilyname = (yyvsp[(11) - (13)].list);
					n->items = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 609:

/* Line 1464 of yacc.c  */
#line 3825 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 610:

/* Line 1464 of yacc.c  */
#line 3826 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 611:

/* Line 1464 of yacc.c  */
#line 3831 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->number = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 612:

/* Line 1464 of yacc.c  */
#line 3840 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->number = (yyvsp[(2) - (5)].ival);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 613:

/* Line 1464 of yacc.c  */
#line 3849 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(3) - (4)].list);
					n->args = extractArgTypes((yyvsp[(4) - (4)].list));
					n->number = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 614:

/* Line 1464 of yacc.c  */
#line 3858 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(6) - (7)].list);
					n->args = extractArgTypes((yyvsp[(7) - (7)].list));
					n->number = (yyvsp[(2) - (7)].ival);
					n->class_args = (yyvsp[(4) - (7)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 615:

/* Line 1464 of yacc.c  */
#line 3868 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[(2) - (2)].typnam);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 616:

/* Line 1464 of yacc.c  */
#line 3876 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 617:

/* Line 1464 of yacc.c  */
#line 3877 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 618:

/* Line 1464 of yacc.c  */
#line 3880 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 619:

/* Line 1464 of yacc.c  */
#line 3881 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 620:

/* Line 1464 of yacc.c  */
#line 3885 "gram.y"
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[(1) - (1)]))));
					(yyval.boolean) = TRUE;
				;}
    break;

  case 621:

/* Line 1464 of yacc.c  */
#line 3898 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 622:

/* Line 1464 of yacc.c  */
#line 3904 "gram.y"
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (6)].list);
					n->amname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 623:

/* Line 1464 of yacc.c  */
#line 3914 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = false;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 624:

/* Line 1464 of yacc.c  */
#line 3923 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = true;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 625:

/* Line 1464 of yacc.c  */
#line 3934 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 626:

/* Line 1464 of yacc.c  */
#line 3935 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 627:

/* Line 1464 of yacc.c  */
#line 3940 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 628:

/* Line 1464 of yacc.c  */
#line 3948 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 629:

/* Line 1464 of yacc.c  */
#line 3960 "gram.y"
    {
					RemoveOpClassStmt *n = makeNode(RemoveOpClassStmt);
					n->opclassname = (yyvsp[(4) - (7)].list);
					n->amname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 630:

/* Line 1464 of yacc.c  */
#line 3969 "gram.y"
    {
					RemoveOpClassStmt *n = makeNode(RemoveOpClassStmt);
					n->opclassname = (yyvsp[(6) - (9)].list);
					n->amname = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 631:

/* Line 1464 of yacc.c  */
#line 3981 "gram.y"
    {
					RemoveOpFamilyStmt *n = makeNode(RemoveOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (7)].list);
					n->amname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 632:

/* Line 1464 of yacc.c  */
#line 3990 "gram.y"
    {
					RemoveOpFamilyStmt *n = makeNode(RemoveOpFamilyStmt);
					n->opfamilyname = (yyvsp[(6) - (9)].list);
					n->amname = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 633:

/* Line 1464 of yacc.c  */
#line 4011 "gram.y"
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 634:

/* Line 1464 of yacc.c  */
#line 4021 "gram.y"
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[(4) - (6)].list);
					n->newrole = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 635:

/* Line 1464 of yacc.c  */
#line 4039 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (6)].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(5) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 636:

/* Line 1464 of yacc.c  */
#line 4048 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (4)].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(3) - (4)].list);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 637:

/* Line 1464 of yacc.c  */
#line 4059 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; ;}
    break;

  case 638:

/* Line 1464 of yacc.c  */
#line 4060 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; ;}
    break;

  case 639:

/* Line 1464 of yacc.c  */
#line 4061 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; ;}
    break;

  case 640:

/* Line 1464 of yacc.c  */
#line 4062 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; ;}
    break;

  case 641:

/* Line 1464 of yacc.c  */
#line 4063 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; ;}
    break;

  case 642:

/* Line 1464 of yacc.c  */
#line 4064 "gram.y"
    { (yyval.objtype) = OBJECT_DOMAIN; ;}
    break;

  case 643:

/* Line 1464 of yacc.c  */
#line 4065 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; ;}
    break;

  case 644:

/* Line 1464 of yacc.c  */
#line 4066 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; ;}
    break;

  case 645:

/* Line 1464 of yacc.c  */
#line 4067 "gram.y"
    { (yyval.objtype) = OBJECT_TSPARSER; ;}
    break;

  case 646:

/* Line 1464 of yacc.c  */
#line 4068 "gram.y"
    { (yyval.objtype) = OBJECT_TSDICTIONARY; ;}
    break;

  case 647:

/* Line 1464 of yacc.c  */
#line 4069 "gram.y"
    { (yyval.objtype) = OBJECT_TSTEMPLATE; ;}
    break;

  case 648:

/* Line 1464 of yacc.c  */
#line 4070 "gram.y"
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; ;}
    break;

  case 649:

/* Line 1464 of yacc.c  */
#line 4074 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); ;}
    break;

  case 650:

/* Line 1464 of yacc.c  */
#line 4075 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); ;}
    break;

  case 651:

/* Line 1464 of yacc.c  */
#line 4078 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 652:

/* Line 1464 of yacc.c  */
#line 4079 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); ;}
    break;

  case 653:

/* Line 1464 of yacc.c  */
#line 4083 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(2) - (2)].str))); ;}
    break;

  case 654:

/* Line 1464 of yacc.c  */
#line 4085 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); ;}
    break;

  case 655:

/* Line 1464 of yacc.c  */
#line 4098 "gram.y"
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[(3) - (5)].list);
					n->restart_seqs = (yyvsp[(4) - (5)].boolean);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 656:

/* Line 1464 of yacc.c  */
#line 4108 "gram.y"
    { (yyval.boolean) = false; ;}
    break;

  case 657:

/* Line 1464 of yacc.c  */
#line 4109 "gram.y"
    { (yyval.boolean) = true; ;}
    break;

  case 658:

/* Line 1464 of yacc.c  */
#line 4110 "gram.y"
    { (yyval.boolean) = false; ;}
    break;

  case 659:

/* Line 1464 of yacc.c  */
#line 4136 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[(3) - (6)].objtype);
					n->objname = (yyvsp[(4) - (6)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 660:

/* Line 1464 of yacc.c  */
#line 4145 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = (yyvsp[(5) - (7)].list);
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 661:

/* Line 1464 of yacc.c  */
#line 4154 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = extractArgTypes((yyvsp[(5) - (7)].list));
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 662:

/* Line 1464 of yacc.c  */
#line 4163 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = (yyvsp[(5) - (7)].list);
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 663:

/* Line 1464 of yacc.c  */
#line 4172 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CONSTRAINT;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 664:

/* Line 1464 of yacc.c  */
#line 4181 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 665:

/* Line 1464 of yacc.c  */
#line 4190 "gram.y"
    {
					/* Obsolete syntax supported for awhile for compatibility */
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = list_make1(makeString((yyvsp[(4) - (6)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 666:

/* Line 1464 of yacc.c  */
#line 4200 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 667:

/* Line 1464 of yacc.c  */
#line 4209 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 668:

/* Line 1464 of yacc.c  */
#line 4218 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 669:

/* Line 1464 of yacc.c  */
#line 4227 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[(5) - (7)].value));
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 670:

/* Line 1464 of yacc.c  */
#line 4236 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[(5) - (10)].typnam));
					n->objargs = list_make1((yyvsp[(7) - (10)].typnam));
					n->comment = (yyvsp[(10) - (10)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 671:

/* Line 1464 of yacc.c  */
#line 4245 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[(5) - (7)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 672:

/* Line 1464 of yacc.c  */
#line 4254 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 673:

/* Line 1464 of yacc.c  */
#line 4262 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 674:

/* Line 1464 of yacc.c  */
#line 4270 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 675:

/* Line 1464 of yacc.c  */
#line 4278 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 676:

/* Line 1464 of yacc.c  */
#line 4288 "gram.y"
    { (yyval.objtype) = OBJECT_COLUMN; ;}
    break;

  case 677:

/* Line 1464 of yacc.c  */
#line 4289 "gram.y"
    { (yyval.objtype) = OBJECT_DATABASE; ;}
    break;

  case 678:

/* Line 1464 of yacc.c  */
#line 4290 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; ;}
    break;

  case 679:

/* Line 1464 of yacc.c  */
#line 4291 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; ;}
    break;

  case 680:

/* Line 1464 of yacc.c  */
#line 4292 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; ;}
    break;

  case 681:

/* Line 1464 of yacc.c  */
#line 4293 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; ;}
    break;

  case 682:

/* Line 1464 of yacc.c  */
#line 4294 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; ;}
    break;

  case 683:

/* Line 1464 of yacc.c  */
#line 4295 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; ;}
    break;

  case 684:

/* Line 1464 of yacc.c  */
#line 4296 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; ;}
    break;

  case 685:

/* Line 1464 of yacc.c  */
#line 4297 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; ;}
    break;

  case 686:

/* Line 1464 of yacc.c  */
#line 4298 "gram.y"
    { (yyval.objtype) = OBJECT_TABLESPACE; ;}
    break;

  case 687:

/* Line 1464 of yacc.c  */
#line 4299 "gram.y"
    { (yyval.objtype) = OBJECT_ROLE; ;}
    break;

  case 688:

/* Line 1464 of yacc.c  */
#line 4303 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 689:

/* Line 1464 of yacc.c  */
#line 4304 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 690:

/* Line 1464 of yacc.c  */
#line 4315 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (2)].node);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 691:

/* Line 1464 of yacc.c  */
#line 4321 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (2)].node);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 692:

/* Line 1464 of yacc.c  */
#line 4329 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(1) - (1)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 693:

/* Line 1464 of yacc.c  */
#line 4337 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 694:

/* Line 1464 of yacc.c  */
#line 4345 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 695:

/* Line 1464 of yacc.c  */
#line 4353 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 696:

/* Line 1464 of yacc.c  */
#line 4361 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 697:

/* Line 1464 of yacc.c  */
#line 4369 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 698:

/* Line 1464 of yacc.c  */
#line 4377 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 699:

/* Line 1464 of yacc.c  */
#line 4385 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 700:

/* Line 1464 of yacc.c  */
#line 4393 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(1) - (3)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 701:

/* Line 1464 of yacc.c  */
#line 4401 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 702:

/* Line 1464 of yacc.c  */
#line 4409 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 703:

/* Line 1464 of yacc.c  */
#line 4417 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 704:

/* Line 1464 of yacc.c  */
#line 4425 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 705:

/* Line 1464 of yacc.c  */
#line 4433 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 706:

/* Line 1464 of yacc.c  */
#line 4441 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 707:

/* Line 1464 of yacc.c  */
#line 4449 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 708:

/* Line 1464 of yacc.c  */
#line 4458 "gram.y"
    {;}
    break;

  case 709:

/* Line 1464 of yacc.c  */
#line 4459 "gram.y"
    {;}
    break;

  case 710:

/* Line 1464 of yacc.c  */
#line 4462 "gram.y"
    {;}
    break;

  case 711:

/* Line 1464 of yacc.c  */
#line 4463 "gram.y"
    {;}
    break;

  case 712:

/* Line 1464 of yacc.c  */
#line 4475 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ((yyvsp[(4) - (7)].privtarget))->targtype;
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 713:

/* Line 1464 of yacc.c  */
#line 4491 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ((yyvsp[(4) - (7)].privtarget))->targtype;
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 714:

/* Line 1464 of yacc.c  */
#line 4505 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->targtype = ((yyvsp[(7) - (10)].privtarget))->targtype;
					n->objtype = ((yyvsp[(7) - (10)].privtarget))->objtype;
					n->objects = ((yyvsp[(7) - (10)].privtarget))->objs;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 715:

/* Line 1464 of yacc.c  */
#line 4530 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 716:

/* Line 1464 of yacc.c  */
#line 4532 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 717:

/* Line 1464 of yacc.c  */
#line 4534 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 718:

/* Line 1464 of yacc.c  */
#line 4536 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(3) - (4)].list);
					(yyval.list) = list_make1(n);
				;}
    break;

  case 719:

/* Line 1464 of yacc.c  */
#line 4543 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(4) - (5)].list);
					(yyval.list) = list_make1(n);
				;}
    break;

  case 720:

/* Line 1464 of yacc.c  */
#line 4551 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].accesspriv)); ;}
    break;

  case 721:

/* Line 1464 of yacc.c  */
#line 4552 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].accesspriv)); ;}
    break;

  case 722:

/* Line 1464 of yacc.c  */
#line 4556 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 723:

/* Line 1464 of yacc.c  */
#line 4563 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 724:

/* Line 1464 of yacc.c  */
#line 4570 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 725:

/* Line 1464 of yacc.c  */
#line 4577 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[(1) - (2)].str);
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 726:

/* Line 1464 of yacc.c  */
#line 4591 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(1) - (1)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 727:

/* Line 1464 of yacc.c  */
#line 4599 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 728:

/* Line 1464 of yacc.c  */
#line 4607 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 729:

/* Line 1464 of yacc.c  */
#line 4615 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FDW;
					n->objs = (yyvsp[(4) - (4)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 730:

/* Line 1464 of yacc.c  */
#line 4623 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 731:

/* Line 1464 of yacc.c  */
#line 4631 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 732:

/* Line 1464 of yacc.c  */
#line 4639 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 733:

/* Line 1464 of yacc.c  */
#line 4647 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 734:

/* Line 1464 of yacc.c  */
#line 4655 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 735:

/* Line 1464 of yacc.c  */
#line 4663 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 736:

/* Line 1464 of yacc.c  */
#line 4671 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 737:

/* Line 1464 of yacc.c  */
#line 4679 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 738:

/* Line 1464 of yacc.c  */
#line 4687 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 739:

/* Line 1464 of yacc.c  */
#line 4695 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 740:

/* Line 1464 of yacc.c  */
#line 4706 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 741:

/* Line 1464 of yacc.c  */
#line 4707 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 742:

/* Line 1464 of yacc.c  */
#line 4711 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* This hack lets us avoid reserving PUBLIC as a keyword*/
					if (strcmp((yyvsp[(1) - (1)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(1) - (1)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 743:

/* Line 1464 of yacc.c  */
#line 4721 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* Treat GROUP PUBLIC as a synonym for PUBLIC */
					if (strcmp((yyvsp[(2) - (2)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 744:

/* Line 1464 of yacc.c  */
#line 4734 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 745:

/* Line 1464 of yacc.c  */
#line 4735 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 746:

/* Line 1464 of yacc.c  */
#line 4739 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].funwithargs)); ;}
    break;

  case 747:

/* Line 1464 of yacc.c  */
#line 4741 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].funwithargs)); ;}
    break;

  case 748:

/* Line 1464 of yacc.c  */
#line 4746 "gram.y"
    {
					FuncWithArgs *n = makeNode(FuncWithArgs);
					n->funcname = (yyvsp[(1) - (2)].list);
					n->funcargs = extractArgTypes((yyvsp[(2) - (2)].list));
					(yyval.funwithargs) = n;
				;}
    break;

  case 749:

/* Line 1464 of yacc.c  */
#line 4762 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->admin_opt = (yyvsp[(5) - (6)].boolean);
					n->grantor = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 750:

/* Line 1464 of yacc.c  */
#line 4775 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 751:

/* Line 1464 of yacc.c  */
#line 4785 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[(5) - (9)].list);
					n->grantee_roles = (yyvsp[(7) - (9)].list);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 752:

/* Line 1464 of yacc.c  */
#line 4796 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 753:

/* Line 1464 of yacc.c  */
#line 4797 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 754:

/* Line 1464 of yacc.c  */
#line 4800 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); ;}
    break;

  case 755:

/* Line 1464 of yacc.c  */
#line 4801 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 756:

/* Line 1464 of yacc.c  */
#line 4812 "gram.y"
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[(4) - (5)].list);
					n->action = (GrantStmt *) (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 757:

/* Line 1464 of yacc.c  */
#line 4821 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 758:

/* Line 1464 of yacc.c  */
#line 4822 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 759:

/* Line 1464 of yacc.c  */
#line 4827 "gram.y"
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 760:

/* Line 1464 of yacc.c  */
#line 4831 "gram.y"
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 761:

/* Line 1464 of yacc.c  */
#line 4835 "gram.y"
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 762:

/* Line 1464 of yacc.c  */
#line 4847 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(4) - (7)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 763:

/* Line 1464 of yacc.c  */
#line 4860 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(4) - (7)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 764:

/* Line 1464 of yacc.c  */
#line 4874 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(7) - (10)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 765:

/* Line 1464 of yacc.c  */
#line 4889 "gram.y"
    { (yyval.ival) = ACL_OBJECT_RELATION; ;}
    break;

  case 766:

/* Line 1464 of yacc.c  */
#line 4890 "gram.y"
    { (yyval.ival) = ACL_OBJECT_FUNCTION; ;}
    break;

  case 767:

/* Line 1464 of yacc.c  */
#line 4891 "gram.y"
    { (yyval.ival) = ACL_OBJECT_SEQUENCE; ;}
    break;

  case 768:

/* Line 1464 of yacc.c  */
#line 4906 "gram.y"
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[(2) - (14)].boolean);
					n->concurrent = (yyvsp[(4) - (14)].boolean);
					n->idxname = (yyvsp[(5) - (14)].str);
					n->relation = (yyvsp[(7) - (14)].range);
					n->accessMethod = (yyvsp[(8) - (14)].str);
					n->indexParams = (yyvsp[(10) - (14)].list);
					n->options = (yyvsp[(12) - (14)].list);
					n->tableSpace = (yyvsp[(13) - (14)].str);
					n->whereClause = (yyvsp[(14) - (14)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 769:

/* Line 1464 of yacc.c  */
#line 4922 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 770:

/* Line 1464 of yacc.c  */
#line 4923 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 771:

/* Line 1464 of yacc.c  */
#line 4927 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 772:

/* Line 1464 of yacc.c  */
#line 4928 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 773:

/* Line 1464 of yacc.c  */
#line 4932 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 774:

/* Line 1464 of yacc.c  */
#line 4933 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 775:

/* Line 1464 of yacc.c  */
#line 4937 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 776:

/* Line 1464 of yacc.c  */
#line 4938 "gram.y"
    { (yyval.str) = DEFAULT_INDEX_TYPE; ;}
    break;

  case 777:

/* Line 1464 of yacc.c  */
#line 4941 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].ielem)); ;}
    break;

  case 778:

/* Line 1464 of yacc.c  */
#line 4942 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].ielem)); ;}
    break;

  case 779:

/* Line 1464 of yacc.c  */
#line 4951 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[(1) - (4)].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->opclass = (yyvsp[(2) - (4)].list);
					(yyval.ielem)->ordering = (yyvsp[(3) - (4)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(4) - (4)].ival);
				;}
    break;

  case 780:

/* Line 1464 of yacc.c  */
#line 4961 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(1) - (4)].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->opclass = (yyvsp[(2) - (4)].list);
					(yyval.ielem)->ordering = (yyvsp[(3) - (4)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(4) - (4)].ival);
				;}
    break;

  case 781:

/* Line 1464 of yacc.c  */
#line 4971 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(2) - (6)].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->opclass = (yyvsp[(4) - (6)].list);
					(yyval.ielem)->ordering = (yyvsp[(5) - (6)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(6) - (6)].ival);
				;}
    break;

  case 782:

/* Line 1464 of yacc.c  */
#line 4982 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 783:

/* Line 1464 of yacc.c  */
#line 4983 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 784:

/* Line 1464 of yacc.c  */
#line 4984 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 785:

/* Line 1464 of yacc.c  */
#line 4987 "gram.y"
    { (yyval.ival) = SORTBY_ASC; ;}
    break;

  case 786:

/* Line 1464 of yacc.c  */
#line 4988 "gram.y"
    { (yyval.ival) = SORTBY_DESC; ;}
    break;

  case 787:

/* Line 1464 of yacc.c  */
#line 4989 "gram.y"
    { (yyval.ival) = SORTBY_DEFAULT; ;}
    break;

  case 788:

/* Line 1464 of yacc.c  */
#line 4992 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_FIRST; ;}
    break;

  case 789:

/* Line 1464 of yacc.c  */
#line 4993 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_LAST; ;}
    break;

  case 790:

/* Line 1464 of yacc.c  */
#line 4994 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; ;}
    break;

  case 791:

/* Line 1464 of yacc.c  */
#line 5012 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (9)].boolean);
					n->funcname = (yyvsp[(4) - (9)].list);
					n->parameters = (yyvsp[(5) - (9)].list);
					n->returnType = (yyvsp[(7) - (9)].typnam);
					n->options = (yyvsp[(8) - (9)].list);
					n->withClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 792:

/* Line 1464 of yacc.c  */
#line 5024 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (12)].boolean);
					n->funcname = (yyvsp[(4) - (12)].list);
					n->parameters = mergeTableFuncParameters((yyvsp[(5) - (12)].list), (yyvsp[(9) - (12)].list));
					n->returnType = TableFuncTypeName((yyvsp[(9) - (12)].list));
					n->returnType->location = (yylsp[(7) - (12)]);
					n->options = (yyvsp[(11) - (12)].list);
					n->withClause = (yyvsp[(12) - (12)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 793:

/* Line 1464 of yacc.c  */
#line 5037 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (7)].boolean);
					n->funcname = (yyvsp[(4) - (7)].list);
					n->parameters = (yyvsp[(5) - (7)].list);
					n->returnType = NULL;
					n->options = (yyvsp[(6) - (7)].list);
					n->withClause = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 794:

/* Line 1464 of yacc.c  */
#line 5050 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 795:

/* Line 1464 of yacc.c  */
#line 5051 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 796:

/* Line 1464 of yacc.c  */
#line 5054 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 797:

/* Line 1464 of yacc.c  */
#line 5055 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 798:

/* Line 1464 of yacc.c  */
#line 5059 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); ;}
    break;

  case 799:

/* Line 1464 of yacc.c  */
#line 5060 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); ;}
    break;

  case 800:

/* Line 1464 of yacc.c  */
#line 5068 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 801:

/* Line 1464 of yacc.c  */
#line 5069 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 802:

/* Line 1464 of yacc.c  */
#line 5073 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); ;}
    break;

  case 803:

/* Line 1464 of yacc.c  */
#line 5075 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); ;}
    break;

  case 804:

/* Line 1464 of yacc.c  */
#line 5090 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(2) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(1) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 805:

/* Line 1464 of yacc.c  */
#line 5099 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(2) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 806:

/* Line 1464 of yacc.c  */
#line 5108 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 807:

/* Line 1464 of yacc.c  */
#line 5117 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = (yyvsp[(1) - (2)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 808:

/* Line 1464 of yacc.c  */
#line 5126 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(1) - (1)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 809:

/* Line 1464 of yacc.c  */
#line 5137 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; ;}
    break;

  case 810:

/* Line 1464 of yacc.c  */
#line 5138 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; ;}
    break;

  case 811:

/* Line 1464 of yacc.c  */
#line 5139 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; ;}
    break;

  case 812:

/* Line 1464 of yacc.c  */
#line 5140 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; ;}
    break;

  case 813:

/* Line 1464 of yacc.c  */
#line 5141 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; ;}
    break;

  case 815:

/* Line 1464 of yacc.c  */
#line 5152 "gram.y"
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 816:

/* Line 1464 of yacc.c  */
#line 5166 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 817:

/* Line 1464 of yacc.c  */
#line 5168 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (4)].str)), (yyvsp[(2) - (4)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[(1) - (4)]);
				;}
    break;

  case 818:

/* Line 1464 of yacc.c  */
#line 5174 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(2) - (5)].str)), (yyvsp[(3) - (5)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[(2) - (5)]);
				;}
    break;

  case 819:

/* Line 1464 of yacc.c  */
#line 5184 "gram.y"
    {
				    (yyval.fun_param) = (yyvsp[(1) - (1)].fun_param);
			    ;}
    break;

  case 820:

/* Line 1464 of yacc.c  */
#line 5188 "gram.y"
    {
				    (yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
				    (yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
			    ;}
    break;

  case 821:

/* Line 1464 of yacc.c  */
#line 5193 "gram.y"
    {
				    (yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
				    (yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
			    ;}
    break;

  case 822:

/* Line 1464 of yacc.c  */
#line 5202 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 823:

/* Line 1464 of yacc.c  */
#line 5203 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 824:

/* Line 1464 of yacc.c  */
#line 5211 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE));
				;}
    break;

  case 825:

/* Line 1464 of yacc.c  */
#line 5215 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				;}
    break;

  case 826:

/* Line 1464 of yacc.c  */
#line 5219 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				;}
    break;

  case 827:

/* Line 1464 of yacc.c  */
#line 5223 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"));
				;}
    break;

  case 828:

/* Line 1464 of yacc.c  */
#line 5227 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"));
				;}
    break;

  case 829:

/* Line 1464 of yacc.c  */
#line 5231 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"));
				;}
    break;

  case 830:

/* Line 1464 of yacc.c  */
#line 5235 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				;}
    break;

  case 831:

/* Line 1464 of yacc.c  */
#line 5239 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				;}
    break;

  case 832:

/* Line 1464 of yacc.c  */
#line 5243 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				;}
    break;

  case 833:

/* Line 1464 of yacc.c  */
#line 5247 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				;}
    break;

  case 834:

/* Line 1464 of yacc.c  */
#line 5251 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 835:

/* Line 1464 of yacc.c  */
#line 5255 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 836:

/* Line 1464 of yacc.c  */
#line 5259 "gram.y"
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[(1) - (1)].vsetstmt));
				;}
    break;

  case 837:

/* Line 1464 of yacc.c  */
#line 5267 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 838:

/* Line 1464 of yacc.c  */
#line 5271 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				;}
    break;

  case 839:

/* Line 1464 of yacc.c  */
#line 5275 "gram.y"
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(TRUE));
				;}
    break;

  case 840:

/* Line 1464 of yacc.c  */
#line 5279 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				;}
    break;

  case 841:

/* Line 1464 of yacc.c  */
#line 5284 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 842:

/* Line 1464 of yacc.c  */
#line 5286 "gram.y"
    {
					(yyval.list) = list_make2(makeString((yyvsp[(1) - (3)].str)), makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 843:

/* Line 1464 of yacc.c  */
#line 5292 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 844:

/* Line 1464 of yacc.c  */
#line 5293 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 845:

/* Line 1464 of yacc.c  */
#line 5297 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 846:

/* Line 1464 of yacc.c  */
#line 5309 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param));
				;}
    break;

  case 847:

/* Line 1464 of yacc.c  */
#line 5313 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param));
				;}
    break;

  case 848:

/* Line 1464 of yacc.c  */
#line 5328 "gram.y"
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[(3) - (5)].funwithargs);
					n->actions = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 849:

/* Line 1464 of yacc.c  */
#line 5338 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 850:

/* Line 1464 of yacc.c  */
#line 5339 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 853:

/* Line 1464 of yacc.c  */
#line 5361 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_FUNCTION;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = extractArgTypes((yyvsp[(4) - (5)].list));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 854:

/* Line 1464 of yacc.c  */
#line 5371 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_FUNCTION;
					n->name = (yyvsp[(5) - (7)].list);
					n->args = extractArgTypes((yyvsp[(6) - (7)].list));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 855:

/* Line 1464 of yacc.c  */
#line 5384 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_AGGREGATE;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 856:

/* Line 1464 of yacc.c  */
#line 5394 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_AGGREGATE;
					n->name = (yyvsp[(5) - (7)].list);
					n->args = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 857:

/* Line 1464 of yacc.c  */
#line 5407 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_OPERATOR;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 858:

/* Line 1464 of yacc.c  */
#line 5417 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_OPERATOR;
					n->name = (yyvsp[(5) - (7)].list);
					n->args = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 859:

/* Line 1464 of yacc.c  */
#line 5430 "gram.y"
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[(3) - (3)]))));
				;}
    break;

  case 860:

/* Line 1464 of yacc.c  */
#line 5438 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), (yyvsp[(4) - (5)].typnam)); ;}
    break;

  case 861:

/* Line 1464 of yacc.c  */
#line 5440 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(4) - (5)].typnam)); ;}
    break;

  case 862:

/* Line 1464 of yacc.c  */
#line 5442 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), NULL); ;}
    break;

  case 863:

/* Line 1464 of yacc.c  */
#line 5447 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 864:

/* Line 1464 of yacc.c  */
#line 5449 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(3) - (3)].list)); ;}
    break;

  case 865:

/* Line 1464 of yacc.c  */
#line 5462 "gram.y"
    {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 866:

/* Line 1464 of yacc.c  */
#line 5470 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 867:

/* Line 1464 of yacc.c  */
#line 5471 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 868:

/* Line 1464 of yacc.c  */
#line 5476 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[(1) - (1)].str)));
				;}
    break;

  case 869:

/* Line 1464 of yacc.c  */
#line 5480 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				;}
    break;

  case 870:

/* Line 1464 of yacc.c  */
#line 5493 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (11)].typnam);
					n->targettype = (yyvsp[(6) - (11)].typnam);
					n->func = (yyvsp[(10) - (11)].funwithargs);
					n->context = (CoercionContext) (yyvsp[(11) - (11)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 871:

/* Line 1464 of yacc.c  */
#line 5504 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 872:

/* Line 1464 of yacc.c  */
#line 5515 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 873:

/* Line 1464 of yacc.c  */
#line 5526 "gram.y"
    { (yyval.ival) = COERCION_IMPLICIT; ;}
    break;

  case 874:

/* Line 1464 of yacc.c  */
#line 5527 "gram.y"
    { (yyval.ival) = COERCION_ASSIGNMENT; ;}
    break;

  case 875:

/* Line 1464 of yacc.c  */
#line 5528 "gram.y"
    { (yyval.ival) = COERCION_EXPLICIT; ;}
    break;

  case 876:

/* Line 1464 of yacc.c  */
#line 5533 "gram.y"
    {
					DropCastStmt *n = makeNode(DropCastStmt);
					n->sourcetype = (yyvsp[(5) - (9)].typnam);
					n->targettype = (yyvsp[(7) - (9)].typnam);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = (yyvsp[(3) - (9)].boolean);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 877:

/* Line 1464 of yacc.c  */
#line 5543 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 878:

/* Line 1464 of yacc.c  */
#line 5544 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 879:

/* Line 1464 of yacc.c  */
#line 5559 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[(2) - (4)].objtype);
					n->relation = (yyvsp[(3) - (4)].range);
					n->name = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 880:

/* Line 1464 of yacc.c  */
#line 5567 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 881:

/* Line 1464 of yacc.c  */
#line 5577 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 882:

/* Line 1464 of yacc.c  */
#line 5589 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; ;}
    break;

  case 883:

/* Line 1464 of yacc.c  */
#line 5590 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; ;}
    break;

  case 884:

/* Line 1464 of yacc.c  */
#line 5593 "gram.y"
    {  (yyval.boolean) = TRUE; ;}
    break;

  case 885:

/* Line 1464 of yacc.c  */
#line 5594 "gram.y"
    {  (yyval.boolean) = FALSE; ;}
    break;

  case 886:

/* Line 1464 of yacc.c  */
#line 5605 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newname = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 887:

/* Line 1464 of yacc.c  */
#line 5614 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 888:

/* Line 1464 of yacc.c  */
#line 5622 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 889:

/* Line 1464 of yacc.c  */
#line 5630 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 890:

/* Line 1464 of yacc.c  */
#line 5639 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 891:

/* Line 1464 of yacc.c  */
#line 5647 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->subname = (yyvsp[(4) - (7)].str);
					n->newname = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 892:

/* Line 1464 of yacc.c  */
#line 5655 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 893:

/* Line 1464 of yacc.c  */
#line 5664 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 894:

/* Line 1464 of yacc.c  */
#line 5673 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 895:

/* Line 1464 of yacc.c  */
#line 5681 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 896:

/* Line 1464 of yacc.c  */
#line 5690 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 897:

/* Line 1464 of yacc.c  */
#line 5699 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 898:

/* Line 1464 of yacc.c  */
#line 5708 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 899:

/* Line 1464 of yacc.c  */
#line 5717 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relation = (yyvsp[(3) - (8)].range);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 900:

/* Line 1464 of yacc.c  */
#line 5726 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = (yyvsp[(3) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 901:

/* Line 1464 of yacc.c  */
#line 5735 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 902:

/* Line 1464 of yacc.c  */
#line 5743 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 903:

/* Line 1464 of yacc.c  */
#line 5751 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 904:

/* Line 1464 of yacc.c  */
#line 5759 "gram.y"
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->isReset = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 905:

/* Line 1464 of yacc.c  */
#line 5768 "gram.y"
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->isReset = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 906:

/* Line 1464 of yacc.c  */
#line 5777 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 907:

/* Line 1464 of yacc.c  */
#line 5785 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 908:

/* Line 1464 of yacc.c  */
#line 5793 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 909:

/* Line 1464 of yacc.c  */
#line 5801 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 910:

/* Line 1464 of yacc.c  */
#line 5809 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 911:

/* Line 1464 of yacc.c  */
#line 5818 "gram.y"
    { (yyval.ival) = COLUMN; ;}
    break;

  case 912:

/* Line 1464 of yacc.c  */
#line 5819 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 913:

/* Line 1464 of yacc.c  */
#line 5822 "gram.y"
    { (yyval.ival) = 1; ;}
    break;

  case 914:

/* Line 1464 of yacc.c  */
#line 5823 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 915:

/* Line 1464 of yacc.c  */
#line 5834 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newschema = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 916:

/* Line 1464 of yacc.c  */
#line 5843 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 917:

/* Line 1464 of yacc.c  */
#line 5851 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 918:

/* Line 1464 of yacc.c  */
#line 5860 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 919:

/* Line 1464 of yacc.c  */
#line 5868 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 920:

/* Line 1464 of yacc.c  */
#line 5876 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 921:

/* Line 1464 of yacc.c  */
#line 5884 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 922:

/* Line 1464 of yacc.c  */
#line 5900 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 923:

/* Line 1464 of yacc.c  */
#line 5909 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 924:

/* Line 1464 of yacc.c  */
#line 5917 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 925:

/* Line 1464 of yacc.c  */
#line 5925 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 926:

/* Line 1464 of yacc.c  */
#line 5933 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 927:

/* Line 1464 of yacc.c  */
#line 5942 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 928:

/* Line 1464 of yacc.c  */
#line 5950 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1(makeInteger((yyvsp[(4) - (7)].ival)));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 929:

/* Line 1464 of yacc.c  */
#line 5958 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 930:

/* Line 1464 of yacc.c  */
#line 5967 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->addname = (yyvsp[(6) - (9)].str);
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 931:

/* Line 1464 of yacc.c  */
#line 5976 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->addname = (yyvsp[(6) - (9)].str);
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 932:

/* Line 1464 of yacc.c  */
#line 5985 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 933:

/* Line 1464 of yacc.c  */
#line 5993 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 934:

/* Line 1464 of yacc.c  */
#line 6001 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 935:

/* Line 1464 of yacc.c  */
#line 6009 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 936:

/* Line 1464 of yacc.c  */
#line 6017 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 937:

/* Line 1464 of yacc.c  */
#line 6025 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[(5) - (8)].str)));
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 938:

/* Line 1464 of yacc.c  */
#line 6033 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 939:

/* Line 1464 of yacc.c  */
#line 6049 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[(3) - (4)].str)));
					n->secLabel = (yyvsp[(4) - (4)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 940:

/* Line 1464 of yacc.c  */
#line 6057 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[(3) - (4)].str)));
					n->secLabel = (yyvsp[(4) - (4)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 941:

/* Line 1464 of yacc.c  */
#line 6065 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (4)].range);
					n->secLabel = (yyvsp[(4) - (4)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 942:

/* Line 1464 of yacc.c  */
#line 6073 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_COLUMN;
					n->relation = (yyvsp[(3) - (7)].range);
					n->addname = (yyvsp[(6) - (7)].str);
					n->secLabel = (yyvsp[(7) - (7)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 943:

/* Line 1464 of yacc.c  */
#line 6082 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (4)].range);
					n->secLabel = (yyvsp[(4) - (4)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 944:

/* Line 1464 of yacc.c  */
#line 6090 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (4)].range);
					n->secLabel = (yyvsp[(4) - (4)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 945:

/* Line 1464 of yacc.c  */
#line 6098 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (4)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (4)].funwithargs)->funcargs;
					n->secLabel = (yyvsp[(4) - (4)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 946:

/* Line 1464 of yacc.c  */
#line 6107 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (5)].list);
					n->objarg = (yyvsp[(4) - (5)].list);
					n->secLabel = (yyvsp[(5) - (5)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 947:

/* Line 1464 of yacc.c  */
#line 6116 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1(makeInteger((yyvsp[(4) - (5)].ival)));
					n->secLabel = (yyvsp[(5) - (5)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 948:

/* Line 1464 of yacc.c  */
#line 6124 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (4)].list);
					n->secLabel = (yyvsp[(4) - (4)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 949:

/* Line 1464 of yacc.c  */
#line 6134 "gram.y"
    {
					(yyval.value) = makeString((yyvsp[(4) - (4)].str));
				;}
    break;

  case 950:

/* Line 1464 of yacc.c  */
#line 6148 "gram.y"
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[(2) - (13)].boolean);
					n->relation = (yyvsp[(9) - (13)].range);
					n->rulename = (yyvsp[(4) - (13)].str);
					n->whereClause = (yyvsp[(10) - (13)].node);
					n->event = (yyvsp[(7) - (13)].ival);
					n->instead = (yyvsp[(12) - (13)].boolean);
					n->actions = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 951:

/* Line 1464 of yacc.c  */
#line 6162 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 952:

/* Line 1464 of yacc.c  */
#line 6163 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 953:

/* Line 1464 of yacc.c  */
#line 6164 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 954:

/* Line 1464 of yacc.c  */
#line 6170 "gram.y"
    { if ((yyvsp[(3) - (3)].node) != NULL)
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				  else
					(yyval.list) = (yyvsp[(1) - (3)].list);
				;}
    break;

  case 955:

/* Line 1464 of yacc.c  */
#line 6176 "gram.y"
    { if ((yyvsp[(1) - (1)].node) != NULL)
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				  else
					(yyval.list) = NIL;
				;}
    break;

  case 961:

/* Line 1464 of yacc.c  */
#line 6192 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 962:

/* Line 1464 of yacc.c  */
#line 6193 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 963:

/* Line 1464 of yacc.c  */
#line 6196 "gram.y"
    { (yyval.ival) = CMD_SELECT; ;}
    break;

  case 964:

/* Line 1464 of yacc.c  */
#line 6197 "gram.y"
    { (yyval.ival) = CMD_UPDATE; ;}
    break;

  case 965:

/* Line 1464 of yacc.c  */
#line 6198 "gram.y"
    { (yyval.ival) = CMD_DELETE; ;}
    break;

  case 966:

/* Line 1464 of yacc.c  */
#line 6199 "gram.y"
    { (yyval.ival) = CMD_INSERT; ;}
    break;

  case 967:

/* Line 1464 of yacc.c  */
#line 6203 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 968:

/* Line 1464 of yacc.c  */
#line 6204 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 969:

/* Line 1464 of yacc.c  */
#line 6205 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 970:

/* Line 1464 of yacc.c  */
#line 6211 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->property = (yyvsp[(3) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->removeType = OBJECT_RULE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 971:

/* Line 1464 of yacc.c  */
#line 6221 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(7) - (8)].range);
					n->property = (yyvsp[(5) - (8)].str);
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->removeType = OBJECT_RULE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 972:

/* Line 1464 of yacc.c  */
#line 6242 "gram.y"
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[(2) - (3)].str);
					n->payload = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 973:

/* Line 1464 of yacc.c  */
#line 6251 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 974:

/* Line 1464 of yacc.c  */
#line 6252 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 975:

/* Line 1464 of yacc.c  */
#line 6256 "gram.y"
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 976:

/* Line 1464 of yacc.c  */
#line 6265 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 977:

/* Line 1464 of yacc.c  */
#line 6271 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 978:

/* Line 1464 of yacc.c  */
#line 6290 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 979:

/* Line 1464 of yacc.c  */
#line 6297 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 980:

/* Line 1464 of yacc.c  */
#line 6304 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 981:

/* Line 1464 of yacc.c  */
#line 6311 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 982:

/* Line 1464 of yacc.c  */
#line 6318 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 983:

/* Line 1464 of yacc.c  */
#line 6325 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 984:

/* Line 1464 of yacc.c  */
#line 6332 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 985:

/* Line 1464 of yacc.c  */
#line 6340 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(3) - (3)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 986:

/* Line 1464 of yacc.c  */
#line 6348 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 987:

/* Line 1464 of yacc.c  */
#line 6356 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(5) - (5)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 988:

/* Line 1464 of yacc.c  */
#line 6364 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(4) - (4)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 989:

/* Line 1464 of yacc.c  */
#line 6372 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 990:

/* Line 1464 of yacc.c  */
#line 6379 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 991:

/* Line 1464 of yacc.c  */
#line 6386 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 992:

/* Line 1464 of yacc.c  */
#line 6394 "gram.y"
    {;}
    break;

  case 993:

/* Line 1464 of yacc.c  */
#line 6395 "gram.y"
    {;}
    break;

  case 994:

/* Line 1464 of yacc.c  */
#line 6396 "gram.y"
    {;}
    break;

  case 995:

/* Line 1464 of yacc.c  */
#line 6401 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)]))); ;}
    break;

  case 996:

/* Line 1464 of yacc.c  */
#line 6404 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE, (yylsp[(1) - (2)]))); ;}
    break;

  case 997:

/* Line 1464 of yacc.c  */
#line 6407 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE, (yylsp[(1) - (2)]))); ;}
    break;

  case 998:

/* Line 1464 of yacc.c  */
#line 6414 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 999:

/* Line 1464 of yacc.c  */
#line 6416 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 1000:

/* Line 1464 of yacc.c  */
#line 6418 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 1002:

/* Line 1464 of yacc.c  */
#line 6424 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1003:

/* Line 1464 of yacc.c  */
#line 6438 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(4) - (8)].range);
					n->view->istemp = (yyvsp[(2) - (8)].boolean);
					n->aliases = (yyvsp[(5) - (8)].list);
					n->query = (yyvsp[(7) - (8)].node);
					n->replace = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1004:

/* Line 1464 of yacc.c  */
#line 6449 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(6) - (10)].range);
					n->view->istemp = (yyvsp[(4) - (10)].boolean);
					n->aliases = (yyvsp[(7) - (10)].list);
					n->query = (yyvsp[(9) - (10)].node);
					n->replace = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1005:

/* Line 1464 of yacc.c  */
#line 6462 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				;}
    break;

  case 1006:

/* Line 1464 of yacc.c  */
#line 6468 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				;}
    break;

  case 1007:

/* Line 1464 of yacc.c  */
#line 6474 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				;}
    break;

  case 1008:

/* Line 1464 of yacc.c  */
#line 6479 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1009:

/* Line 1464 of yacc.c  */
#line 6490 "gram.y"
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1010:

/* Line 1464 of yacc.c  */
#line 6506 "gram.y"
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1011:

/* Line 1464 of yacc.c  */
#line 6515 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 1012:

/* Line 1464 of yacc.c  */
#line 6516 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1013:

/* Line 1464 of yacc.c  */
#line 6521 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1014:

/* Line 1464 of yacc.c  */
#line 6525 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", NULL);
				;}
    break;

  case 1015:

/* Line 1464 of yacc.c  */
#line 6529 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1016:

/* Line 1464 of yacc.c  */
#line 6533 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", NULL);
				;}
    break;

  case 1017:

/* Line 1464 of yacc.c  */
#line 6537 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1018:

/* Line 1464 of yacc.c  */
#line 6541 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", NULL);
				;}
    break;

  case 1019:

/* Line 1464 of yacc.c  */
#line 6545 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1020:

/* Line 1464 of yacc.c  */
#line 6549 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				;}
    break;

  case 1021:

/* Line 1464 of yacc.c  */
#line 6553 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", NULL);
				;}
    break;

  case 1022:

/* Line 1464 of yacc.c  */
#line 6557 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_collate", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1023:

/* Line 1464 of yacc.c  */
#line 6561 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_collate", NULL);
				;}
    break;

  case 1024:

/* Line 1464 of yacc.c  */
#line 6565 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_ctype", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1025:

/* Line 1464 of yacc.c  */
#line 6569 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_ctype", NULL);
				;}
    break;

  case 1026:

/* Line 1464 of yacc.c  */
#line 6573 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				;}
    break;

  case 1027:

/* Line 1464 of yacc.c  */
#line 6577 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1028:

/* Line 1464 of yacc.c  */
#line 6581 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", NULL);
				;}
    break;

  case 1029:

/* Line 1464 of yacc.c  */
#line 6590 "gram.y"
    {;}
    break;

  case 1030:

/* Line 1464 of yacc.c  */
#line 6591 "gram.y"
    {;}
    break;

  case 1031:

/* Line 1464 of yacc.c  */
#line 6603 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 1032:

/* Line 1464 of yacc.c  */
#line 6610 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (6)].str);
					n->options = list_make1(makeDefElem("tablespace",
													(Node *)makeString((yyvsp[(6) - (6)].str))));
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 1033:

/* Line 1464 of yacc.c  */
#line 6621 "gram.y"
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[(3) - (4)].str);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1034:

/* Line 1464 of yacc.c  */
#line 6631 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 1035:

/* Line 1464 of yacc.c  */
#line 6632 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1036:

/* Line 1464 of yacc.c  */
#line 6637 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				;}
    break;

  case 1037:

/* Line 1464 of yacc.c  */
#line 6651 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(3) - (3)].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1038:

/* Line 1464 of yacc.c  */
#line 6658 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(5) - (5)].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1039:

/* Line 1464 of yacc.c  */
#line 6675 "gram.y"
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[(3) - (6)].list);
					n->typeName = (yyvsp[(5) - (6)].typnam);
					n->constraints = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1040:

/* Line 1464 of yacc.c  */
#line 6687 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[(3) - (4)].list);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1041:

/* Line 1464 of yacc.c  */
#line 6696 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1042:

/* Line 1464 of yacc.c  */
#line 6704 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1043:

/* Line 1464 of yacc.c  */
#line 6712 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[(3) - (5)].list);
					n->def = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1044:

/* Line 1464 of yacc.c  */
#line 6721 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[(3) - (7)].list);
					n->name = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1045:

/* Line 1464 of yacc.c  */
#line 6731 "gram.y"
    {;}
    break;

  case 1046:

/* Line 1464 of yacc.c  */
#line 6732 "gram.y"
    {;}
    break;

  case 1047:

/* Line 1464 of yacc.c  */
#line 6744 "gram.y"
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[(5) - (6)].list);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1048:

/* Line 1464 of yacc.c  */
#line 6754 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1049:

/* Line 1464 of yacc.c  */
#line 6764 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1050:

/* Line 1464 of yacc.c  */
#line 6774 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[(9) - (11)].list),(yyvsp[(11) - (11)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1051:

/* Line 1464 of yacc.c  */
#line 6784 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (13)].list);
					n->tokentype = (yyvsp[(9) - (13)].list);
					n->dicts = list_make2((yyvsp[(11) - (13)].list),(yyvsp[(13) - (13)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1052:

/* Line 1464 of yacc.c  */
#line 6794 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (9)].list);
					n->tokentype = (yyvsp[(9) - (9)].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1053:

/* Line 1464 of yacc.c  */
#line 6802 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(11) - (11)].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1054:

/* Line 1464 of yacc.c  */
#line 6824 "gram.y"
    {
			  CreateConversionStmt *n = makeNode(CreateConversionStmt);
			  n->conversion_name = (yyvsp[(4) - (10)].list);
			  n->for_encoding_name = (yyvsp[(6) - (10)].str);
			  n->to_encoding_name = (yyvsp[(8) - (10)].str);
			  n->func_name = (yyvsp[(10) - (10)].list);
			  n->def = (yyvsp[(2) - (10)].boolean);
			  (yyval.node) = (Node *)n;
			;}
    break;

  case 1055:

/* Line 1464 of yacc.c  */
#line 6846 "gram.y"
    {
			       ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = (yyvsp[(3) - (4)].range);
				   n->indexname = (yyvsp[(4) - (4)].str);
				   n->verbose = (yyvsp[(2) - (4)].boolean);
				   (yyval.node) = (Node*)n;
				;}
    break;

  case 1056:

/* Line 1464 of yacc.c  */
#line 6854 "gram.y"
    {
				   ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = NULL;
				   n->indexname = NULL;
				   n->verbose = (yyvsp[(2) - (2)].boolean);
				   (yyval.node) = (Node*)n;
				;}
    break;

  case 1057:

/* Line 1464 of yacc.c  */
#line 6863 "gram.y"
    {
				   ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = (yyvsp[(5) - (5)].range);
				   n->indexname = (yyvsp[(3) - (5)].str);
				   n->verbose = (yyvsp[(2) - (5)].boolean);
				   (yyval.node) = (Node*)n;
				;}
    break;

  case 1058:

/* Line 1464 of yacc.c  */
#line 6873 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 1059:

/* Line 1464 of yacc.c  */
#line 6874 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 1060:

/* Line 1464 of yacc.c  */
#line 6887 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[(2) - (4)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (4)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1061:

/* Line 1464 of yacc.c  */
#line 6901 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[(2) - (5)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (5)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->relation = (yyvsp[(5) - (5)].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1062:

/* Line 1464 of yacc.c  */
#line 6915 "gram.y"
    {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[(5) - (5)].node);
					n->options |= VACOPT_VACUUM;
					if ((yyvsp[(2) - (5)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (5)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1063:

/* Line 1464 of yacc.c  */
#line 6927 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[(3) - (4)].ival);
					if (n->options & VACOPT_FREEZE)
						n->freeze_min_age = n->freeze_table_age = 0;
					else
						n->freeze_min_age = n->freeze_table_age = -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1064:

/* Line 1464 of yacc.c  */
#line 6939 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[(3) - (6)].ival);
					if (n->options & VACOPT_FREEZE)
						n->freeze_min_age = n->freeze_table_age = 0;
					else
						n->freeze_min_age = n->freeze_table_age = -1;
					n->relation = (yyvsp[(5) - (6)].range);
					n->va_cols = (yyvsp[(6) - (6)].list);
					if (n->va_cols != NIL)	/* implies analyze */
						n->options |= VACOPT_ANALYZE;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1065:

/* Line 1464 of yacc.c  */
#line 6955 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 1066:

/* Line 1464 of yacc.c  */
#line 6956 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival); ;}
    break;

  case 1067:

/* Line 1464 of yacc.c  */
#line 6960 "gram.y"
    { (yyval.ival) = VACOPT_ANALYZE; ;}
    break;

  case 1068:

/* Line 1464 of yacc.c  */
#line 6961 "gram.y"
    { (yyval.ival) = VACOPT_VERBOSE; ;}
    break;

  case 1069:

/* Line 1464 of yacc.c  */
#line 6962 "gram.y"
    { (yyval.ival) = VACOPT_FREEZE; ;}
    break;

  case 1070:

/* Line 1464 of yacc.c  */
#line 6963 "gram.y"
    { (yyval.ival) = VACOPT_FULL; ;}
    break;

  case 1071:

/* Line 1464 of yacc.c  */
#line 6968 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[(2) - (2)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1072:

/* Line 1464 of yacc.c  */
#line 6980 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[(2) - (4)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->relation = (yyvsp[(3) - (4)].range);
					n->va_cols = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1073:

/* Line 1464 of yacc.c  */
#line 6994 "gram.y"
    {;}
    break;

  case 1074:

/* Line 1464 of yacc.c  */
#line 6995 "gram.y"
    {;}
    break;

  case 1075:

/* Line 1464 of yacc.c  */
#line 6999 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1076:

/* Line 1464 of yacc.c  */
#line 7000 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1077:

/* Line 1464 of yacc.c  */
#line 7003 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1078:

/* Line 1464 of yacc.c  */
#line 7004 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1079:

/* Line 1464 of yacc.c  */
#line 7007 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1080:

/* Line 1464 of yacc.c  */
#line 7008 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1081:

/* Line 1464 of yacc.c  */
#line 7012 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1082:

/* Line 1464 of yacc.c  */
#line 7013 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1083:

/* Line 1464 of yacc.c  */
#line 7027 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(2) - (2)].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1084:

/* Line 1464 of yacc.c  */
#line 7034 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(4) - (4)].node);
					n->options = list_make1(makeDefElem("analyze", NULL));
					if ((yyvsp[(3) - (4)].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1085:

/* Line 1464 of yacc.c  */
#line 7044 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(3) - (3)].node);
					n->options = list_make1(makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1086:

/* Line 1464 of yacc.c  */
#line 7051 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(5) - (5)].node);
					n->options = (yyvsp[(3) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1094:

/* Line 1464 of yacc.c  */
#line 7071 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				;}
    break;

  case 1095:

/* Line 1464 of yacc.c  */
#line 7075 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				;}
    break;

  case 1096:

/* Line 1464 of yacc.c  */
#line 7082 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				;}
    break;

  case 1097:

/* Line 1464 of yacc.c  */
#line 7088 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1098:

/* Line 1464 of yacc.c  */
#line 7089 "gram.y"
    { (yyval.str) = "analyze"; ;}
    break;

  case 1099:

/* Line 1464 of yacc.c  */
#line 7090 "gram.y"
    { (yyval.str) = "verbose"; ;}
    break;

  case 1100:

/* Line 1464 of yacc.c  */
#line 7094 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 1101:

/* Line 1464 of yacc.c  */
#line 7095 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 1102:

/* Line 1464 of yacc.c  */
#line 7096 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].value); ;}
    break;

  case 1103:

/* Line 1464 of yacc.c  */
#line 7097 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1104:

/* Line 1464 of yacc.c  */
#line 7108 "gram.y"
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[(2) - (5)].str);
					n->argtypes = (yyvsp[(3) - (5)].list);
					n->query = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1105:

/* Line 1464 of yacc.c  */
#line 7117 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1106:

/* Line 1464 of yacc.c  */
#line 7118 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1111:

/* Line 1464 of yacc.c  */
#line 7136 "gram.y"
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(2) - (3)].str);
					n->params = (yyvsp[(3) - (3)].list);
					n->into = NULL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1112:

/* Line 1464 of yacc.c  */
#line 7145 "gram.y"
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(7) - (8)].str);
					n->params = (yyvsp[(8) - (8)].list);
					(yyvsp[(4) - (8)].into)->rel->istemp = (yyvsp[(2) - (8)].boolean);
					n->into = (yyvsp[(4) - (8)].into);
					if ((yyvsp[(4) - (8)].into)->colNames)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("column name list not allowed in CREATE TABLE / AS EXECUTE")));
					/* ... because it's not implemented, but it could be */
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1113:

/* Line 1464 of yacc.c  */
#line 7160 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1114:

/* Line 1464 of yacc.c  */
#line 7161 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1115:

/* Line 1464 of yacc.c  */
#line 7172 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(2) - (2)].str);
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1116:

/* Line 1464 of yacc.c  */
#line 7178 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(3) - (3)].str);
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1117:

/* Line 1464 of yacc.c  */
#line 7184 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1118:

/* Line 1464 of yacc.c  */
#line 7190 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1119:

/* Line 1464 of yacc.c  */
#line 7206 "gram.y"
    {
					(yyvsp[(4) - (5)].istmt)->relation = (yyvsp[(3) - (5)].range);
					(yyvsp[(4) - (5)].istmt)->returningList = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *) (yyvsp[(4) - (5)].istmt);
				;}
    break;

  case 1120:

/* Line 1464 of yacc.c  */
#line 7215 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[(1) - (1)].node);
				;}
    break;

  case 1121:

/* Line 1464 of yacc.c  */
#line 7221 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[(2) - (4)].list);
					(yyval.istmt)->selectStmt = (yyvsp[(4) - (4)].node);
				;}
    break;

  case 1122:

/* Line 1464 of yacc.c  */
#line 7227 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				;}
    break;

  case 1123:

/* Line 1464 of yacc.c  */
#line 7236 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1124:

/* Line 1464 of yacc.c  */
#line 7238 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); ;}
    break;

  case 1125:

/* Line 1464 of yacc.c  */
#line 7243 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1126:

/* Line 1464 of yacc.c  */
#line 7253 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1127:

/* Line 1464 of yacc.c  */
#line 7254 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1128:

/* Line 1464 of yacc.c  */
#line 7267 "gram.y"
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[(3) - (6)].range);
					n->usingClause = (yyvsp[(4) - (6)].list);
					n->whereClause = (yyvsp[(5) - (6)].node);
					n->returningList = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1129:

/* Line 1464 of yacc.c  */
#line 7278 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1130:

/* Line 1464 of yacc.c  */
#line 7279 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1131:

/* Line 1464 of yacc.c  */
#line 7291 "gram.y"
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[(3) - (5)].list);
					n->mode = (yyvsp[(4) - (5)].ival);
					n->nowait = (yyvsp[(5) - (5)].boolean);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1132:

/* Line 1464 of yacc.c  */
#line 7301 "gram.y"
    { (yyval.ival) = (yyvsp[(2) - (3)].ival); ;}
    break;

  case 1133:

/* Line 1464 of yacc.c  */
#line 7302 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; ;}
    break;

  case 1134:

/* Line 1464 of yacc.c  */
#line 7305 "gram.y"
    { (yyval.ival) = AccessShareLock; ;}
    break;

  case 1135:

/* Line 1464 of yacc.c  */
#line 7306 "gram.y"
    { (yyval.ival) = RowShareLock; ;}
    break;

  case 1136:

/* Line 1464 of yacc.c  */
#line 7307 "gram.y"
    { (yyval.ival) = RowExclusiveLock; ;}
    break;

  case 1137:

/* Line 1464 of yacc.c  */
#line 7308 "gram.y"
    { (yyval.ival) = ShareUpdateExclusiveLock; ;}
    break;

  case 1138:

/* Line 1464 of yacc.c  */
#line 7309 "gram.y"
    { (yyval.ival) = ShareLock; ;}
    break;

  case 1139:

/* Line 1464 of yacc.c  */
#line 7310 "gram.y"
    { (yyval.ival) = ShareRowExclusiveLock; ;}
    break;

  case 1140:

/* Line 1464 of yacc.c  */
#line 7311 "gram.y"
    { (yyval.ival) = ExclusiveLock; ;}
    break;

  case 1141:

/* Line 1464 of yacc.c  */
#line 7312 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; ;}
    break;

  case 1142:

/* Line 1464 of yacc.c  */
#line 7315 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1143:

/* Line 1464 of yacc.c  */
#line 7316 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1144:

/* Line 1464 of yacc.c  */
#line 7332 "gram.y"
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[(2) - (7)].range);
					n->targetList = (yyvsp[(4) - (7)].list);
					n->fromClause = (yyvsp[(5) - (7)].list);
					n->whereClause = (yyvsp[(6) - (7)].node);
					n->returningList = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1145:

/* Line 1464 of yacc.c  */
#line 7344 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1146:

/* Line 1464 of yacc.c  */
#line 7345 "gram.y"
    { (yyval.list) = list_concat((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].list)); ;}
    break;

  case 1147:

/* Line 1464 of yacc.c  */
#line 7349 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1148:

/* Line 1464 of yacc.c  */
#line 7350 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1149:

/* Line 1464 of yacc.c  */
#line 7355 "gram.y"
    {
					(yyval.target) = (yyvsp[(1) - (3)].target);
					(yyval.target)->val = (Node *) (yyvsp[(3) - (3)].node);
				;}
    break;

  case 1150:

/* Line 1464 of yacc.c  */
#line 7363 "gram.y"
    {
					ListCell *col_cell;
					ListCell *val_cell;

					/*
					 * Break the ctext_row apart, merge individual expressions
					 * into the destination ResTargets.  XXX this approach
					 * cannot work for general row expressions as sources.
					 */
					if (list_length((yyvsp[(2) - (5)].list)) != list_length((yyvsp[(5) - (5)].list)))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("number of columns does not match number of values"),
								 parser_errposition((yylsp[(1) - (5)]))));
					forboth(col_cell, (yyvsp[(2) - (5)].list), val_cell, (yyvsp[(5) - (5)].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						Node *res_val = (Node *) lfirst(val_cell);

						res_col->val = res_val;
					}

					(yyval.list) = (yyvsp[(2) - (5)].list);
				;}
    break;

  case 1151:

/* Line 1464 of yacc.c  */
#line 7391 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1152:

/* Line 1464 of yacc.c  */
#line 7401 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1153:

/* Line 1464 of yacc.c  */
#line 7402 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].target)); ;}
    break;

  case 1154:

/* Line 1464 of yacc.c  */
#line 7413 "gram.y"
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[(2) - (7)].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[(3) - (7)].ival) | (yyvsp[(5) - (7)].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1155:

/* Line 1464 of yacc.c  */
#line 7423 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1156:

/* Line 1464 of yacc.c  */
#line 7426 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1157:

/* Line 1464 of yacc.c  */
#line 7427 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | CURSOR_OPT_NO_SCROLL; ;}
    break;

  case 1158:

/* Line 1464 of yacc.c  */
#line 7428 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_SCROLL; ;}
    break;

  case 1159:

/* Line 1464 of yacc.c  */
#line 7429 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_BINARY; ;}
    break;

  case 1160:

/* Line 1464 of yacc.c  */
#line 7430 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_INSENSITIVE; ;}
    break;

  case 1161:

/* Line 1464 of yacc.c  */
#line 7433 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1162:

/* Line 1464 of yacc.c  */
#line 7434 "gram.y"
    { (yyval.ival) = CURSOR_OPT_HOLD; ;}
    break;

  case 1163:

/* Line 1464 of yacc.c  */
#line 7435 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1166:

/* Line 1464 of yacc.c  */
#line 7488 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 1167:

/* Line 1464 of yacc.c  */
#line 7489 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 1168:

/* Line 1464 of yacc.c  */
#line 7503 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1169:

/* Line 1464 of yacc.c  */
#line 7505 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].list), NIL,
										NULL, NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (2)].node);
				;}
    break;

  case 1170:

/* Line 1464 of yacc.c  */
#line 7512 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(3) - (4)].list),
										list_nth((yyvsp[(4) - (4)].list), 0), list_nth((yyvsp[(4) - (4)].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				;}
    break;

  case 1171:

/* Line 1464 of yacc.c  */
#line 7520 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(4) - (4)].list),
										list_nth((yyvsp[(3) - (4)].list), 0), list_nth((yyvsp[(3) - (4)].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				;}
    break;

  case 1172:

/* Line 1464 of yacc.c  */
#line 7528 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (2)].node), NULL, NIL,
										NULL, NULL,
										(yyvsp[(1) - (2)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (2)].node);
				;}
    break;

  case 1173:

/* Line 1464 of yacc.c  */
#line 7536 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].list), NIL,
										NULL, NULL,
										(yyvsp[(1) - (3)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (3)].node);
				;}
    break;

  case 1174:

/* Line 1464 of yacc.c  */
#line 7544 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(4) - (5)].list),
										list_nth((yyvsp[(5) - (5)].list), 0), list_nth((yyvsp[(5) - (5)].list), 1),
										(yyvsp[(1) - (5)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (5)].node);
				;}
    break;

  case 1175:

/* Line 1464 of yacc.c  */
#line 7552 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(5) - (5)].list),
										list_nth((yyvsp[(4) - (5)].list), 0), list_nth((yyvsp[(4) - (5)].list), 1),
										(yyvsp[(1) - (5)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (5)].node);
				;}
    break;

  case 1176:

/* Line 1464 of yacc.c  */
#line 7562 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1177:

/* Line 1464 of yacc.c  */
#line 7563 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1178:

/* Line 1464 of yacc.c  */
#line 7593 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[(2) - (9)].list);
					n->targetList = (yyvsp[(3) - (9)].list);
					n->intoClause = (yyvsp[(4) - (9)].into);
					n->fromClause = (yyvsp[(5) - (9)].list);
					n->whereClause = (yyvsp[(6) - (9)].node);
					n->groupClause = (yyvsp[(7) - (9)].list);
					n->havingClause = (yyvsp[(8) - (9)].node);
					n->windowClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1179:

/* Line 1464 of yacc.c  */
#line 7605 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1180:

/* Line 1464 of yacc.c  */
#line 7607 "gram.y"
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[(2) - (2)].range));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1181:

/* Line 1464 of yacc.c  */
#line 7626 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1182:

/* Line 1464 of yacc.c  */
#line 7630 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1183:

/* Line 1464 of yacc.c  */
#line 7634 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1184:

/* Line 1464 of yacc.c  */
#line 7649 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(2) - (2)].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[(1) - (2)]);
			;}
    break;

  case 1185:

/* Line 1464 of yacc.c  */
#line 7656 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(3) - (3)].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[(1) - (3)]);
			;}
    break;

  case 1186:

/* Line 1464 of yacc.c  */
#line 7665 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1187:

/* Line 1464 of yacc.c  */
#line 7666 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1188:

/* Line 1464 of yacc.c  */
#line 7670 "gram.y"
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[(1) - (4)].str);
				n->aliascolnames = (yyvsp[(2) - (4)].list);
				n->ctequery = (yyvsp[(4) - (4)].node);
				n->location = (yylsp[(1) - (4)]);
				(yyval.node) = (Node *) n;
			;}
    break;

  case 1189:

/* Line 1464 of yacc.c  */
#line 7682 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(2) - (2)].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
				;}
    break;

  case 1190:

/* Line 1464 of yacc.c  */
#line 7691 "gram.y"
    { (yyval.into) = NULL; ;}
    break;

  case 1191:

/* Line 1464 of yacc.c  */
#line 7700 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1192:

/* Line 1464 of yacc.c  */
#line 7705 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1193:

/* Line 1464 of yacc.c  */
#line 7710 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1194:

/* Line 1464 of yacc.c  */
#line 7715 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1195:

/* Line 1464 of yacc.c  */
#line 7720 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1196:

/* Line 1464 of yacc.c  */
#line 7725 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1197:

/* Line 1464 of yacc.c  */
#line 7730 "gram.y"
    {
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->istemp = false;
				;}
    break;

  case 1198:

/* Line 1464 of yacc.c  */
#line 7735 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->istemp = false;
				;}
    break;

  case 1199:

/* Line 1464 of yacc.c  */
#line 7741 "gram.y"
    {;}
    break;

  case 1200:

/* Line 1464 of yacc.c  */
#line 7742 "gram.y"
    {;}
    break;

  case 1201:

/* Line 1464 of yacc.c  */
#line 7745 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1202:

/* Line 1464 of yacc.c  */
#line 7746 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1203:

/* Line 1464 of yacc.c  */
#line 7747 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1204:

/* Line 1464 of yacc.c  */
#line 7754 "gram.y"
    { (yyval.list) = list_make1(NIL); ;}
    break;

  case 1205:

/* Line 1464 of yacc.c  */
#line 7755 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (5)].list); ;}
    break;

  case 1206:

/* Line 1464 of yacc.c  */
#line 7756 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1207:

/* Line 1464 of yacc.c  */
#line 7757 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1208:

/* Line 1464 of yacc.c  */
#line 7761 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list);;}
    break;

  case 1209:

/* Line 1464 of yacc.c  */
#line 7762 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1210:

/* Line 1464 of yacc.c  */
#line 7766 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); ;}
    break;

  case 1211:

/* Line 1464 of yacc.c  */
#line 7770 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].sortby)); ;}
    break;

  case 1212:

/* Line 1464 of yacc.c  */
#line 7771 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].sortby)); ;}
    break;

  case 1213:

/* Line 1464 of yacc.c  */
#line 7775 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (4)].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[(4) - (4)].ival);
					(yyval.sortby)->useOp = (yyvsp[(3) - (4)].list);
					(yyval.sortby)->location = (yylsp[(3) - (4)]);
				;}
    break;

  case 1214:

/* Line 1464 of yacc.c  */
#line 7784 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (3)].node);
					(yyval.sortby)->sortby_dir = (yyvsp[(2) - (3)].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[(3) - (3)].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				;}
    break;

  case 1215:

/* Line 1464 of yacc.c  */
#line 7796 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (2)].node), (yyvsp[(1) - (2)].node)); ;}
    break;

  case 1216:

/* Line 1464 of yacc.c  */
#line 7797 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1217:

/* Line 1464 of yacc.c  */
#line 7798 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(1) - (1)].node)); ;}
    break;

  case 1218:

/* Line 1464 of yacc.c  */
#line 7799 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (1)].node), NULL); ;}
    break;

  case 1219:

/* Line 1464 of yacc.c  */
#line 7803 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1220:

/* Line 1464 of yacc.c  */
#line 7804 "gram.y"
    { (yyval.list) = list_make2(NULL,NULL); ;}
    break;

  case 1221:

/* Line 1464 of yacc.c  */
#line 7809 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1222:

/* Line 1464 of yacc.c  */
#line 7811 "gram.y"
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[(1) - (4)]))));
				;}
    break;

  case 1223:

/* Line 1464 of yacc.c  */
#line 7821 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (5)].node); ;}
    break;

  case 1224:

/* Line 1464 of yacc.c  */
#line 7826 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1225:

/* Line 1464 of yacc.c  */
#line 7829 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 1226:

/* Line 1464 of yacc.c  */
#line 7833 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1227:

/* Line 1464 of yacc.c  */
#line 7835 "gram.y"
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				;}
    break;

  case 1228:

/* Line 1464 of yacc.c  */
#line 7842 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1229:

/* Line 1464 of yacc.c  */
#line 7852 "gram.y"
    { (yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)])); ;}
    break;

  case 1230:

/* Line 1464 of yacc.c  */
#line 7853 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 1231:

/* Line 1464 of yacc.c  */
#line 7854 "gram.y"
    { (yyval.node) = makeIntConst(1, -1); ;}
    break;

  case 1232:

/* Line 1464 of yacc.c  */
#line 7862 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1233:

/* Line 1464 of yacc.c  */
#line 7866 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1234:

/* Line 1464 of yacc.c  */
#line 7867 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1235:

/* Line 1464 of yacc.c  */
#line 7870 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1236:

/* Line 1464 of yacc.c  */
#line 7871 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1237:

/* Line 1464 of yacc.c  */
#line 7876 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); ;}
    break;

  case 1238:

/* Line 1464 of yacc.c  */
#line 7877 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1239:

/* Line 1464 of yacc.c  */
#line 7881 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1240:

/* Line 1464 of yacc.c  */
#line 7882 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1241:

/* Line 1464 of yacc.c  */
#line 7886 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1242:

/* Line 1464 of yacc.c  */
#line 7887 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1243:

/* Line 1464 of yacc.c  */
#line 7891 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1244:

/* Line 1464 of yacc.c  */
#line 7892 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1245:

/* Line 1464 of yacc.c  */
#line 7896 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1246:

/* Line 1464 of yacc.c  */
#line 7897 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1247:

/* Line 1464 of yacc.c  */
#line 7902 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(3) - (4)].list);
					n->forUpdate = TRUE;
					n->noWait = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1248:

/* Line 1464 of yacc.c  */
#line 7910 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(3) - (4)].list);
					n->forUpdate = FALSE;
					n->noWait = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1249:

/* Line 1464 of yacc.c  */
#line 7920 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1250:

/* Line 1464 of yacc.c  */
#line 7921 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1251:

/* Line 1464 of yacc.c  */
#line 7927 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[(2) - (2)].list));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1252:

/* Line 1464 of yacc.c  */
#line 7933 "gram.y"
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[(1) - (3)].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[(3) - (3)].list));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1253:

/* Line 1464 of yacc.c  */
#line 7950 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1254:

/* Line 1464 of yacc.c  */
#line 7951 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1255:

/* Line 1464 of yacc.c  */
#line 7955 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1256:

/* Line 1464 of yacc.c  */
#line 7956 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1257:

/* Line 1464 of yacc.c  */
#line 7967 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].range);
				;}
    break;

  case 1258:

/* Line 1464 of yacc.c  */
#line 7971 "gram.y"
    {
					(yyvsp[(1) - (2)].range)->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) (yyvsp[(1) - (2)].range);
				;}
    break;

  case 1259:

/* Line 1464 of yacc.c  */
#line 7976 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (1)].node);
					n->coldeflist = NIL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1260:

/* Line 1464 of yacc.c  */
#line 7983 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					n->coldeflist = NIL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1261:

/* Line 1464 of yacc.c  */
#line 7991 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (5)].node);
					n->coldeflist = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1262:

/* Line 1464 of yacc.c  */
#line 7998 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					Alias *a = makeNode(Alias);
					n->funccallnode = (yyvsp[(1) - (6)].node);
					a->aliasname = (yyvsp[(3) - (6)].str);
					n->alias = a;
					n->coldeflist = (yyvsp[(5) - (6)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1263:

/* Line 1464 of yacc.c  */
#line 8008 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					Alias *a = makeNode(Alias);
					n->funccallnode = (yyvsp[(1) - (5)].node);
					a->aliasname = (yyvsp[(2) - (5)].str);
					n->alias = a;
					n->coldeflist = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1264:

/* Line 1464 of yacc.c  */
#line 8018 "gram.y"
    {
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if (IsA((yyvsp[(1) - (1)].node), SelectStmt) &&
						((SelectStmt *) (yyvsp[(1) - (1)].node))->valuesLists)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("VALUES in FROM must have an alias"),
								 errhint("For example, FROM (VALUES ...) [AS] foo."),
								 parser_errposition((yylsp[(1) - (1)]))));
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("subquery in FROM must have an alias"),
								 errhint("For example, FROM (SELECT ...) [AS] foo."),
								 parser_errposition((yylsp[(1) - (1)]))));
					(yyval.node) = NULL;
				;}
    break;

  case 1265:

/* Line 1464 of yacc.c  */
#line 8046 "gram.y"
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->subquery = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1266:

/* Line 1464 of yacc.c  */
#line 8053 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].jexpr);
				;}
    break;

  case 1267:

/* Line 1464 of yacc.c  */
#line 8057 "gram.y"
    {
					(yyvsp[(2) - (4)].jexpr)->alias = (yyvsp[(4) - (4)].alias);
					(yyval.node) = (Node *) (yyvsp[(2) - (4)].jexpr);
				;}
    break;

  case 1268:

/* Line 1464 of yacc.c  */
#line 8083 "gram.y"
    {
					(yyval.jexpr) = (yyvsp[(2) - (3)].jexpr);
				;}
    break;

  case 1269:

/* Line 1464 of yacc.c  */
#line 8087 "gram.y"
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->usingClause = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				;}
    break;

  case 1270:

/* Line 1464 of yacc.c  */
#line 8099 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(2) - (5)].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(4) - (5)].node);
					if ((yyvsp[(5) - (5)].node) != NULL && IsA((yyvsp[(5) - (5)].node), List))
						n->usingClause = (List *) (yyvsp[(5) - (5)].node); /* USING clause */
					else
						n->quals = (yyvsp[(5) - (5)].node); /* ON clause */
					(yyval.jexpr) = n;
				;}
    break;

  case 1271:

/* Line 1464 of yacc.c  */
#line 8112 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(3) - (4)].node);
					if ((yyvsp[(4) - (4)].node) != NULL && IsA((yyvsp[(4) - (4)].node), List))
						n->usingClause = (List *) (yyvsp[(4) - (4)].node); /* USING clause */
					else
						n->quals = (yyvsp[(4) - (4)].node); /* ON clause */
					(yyval.jexpr) = n;
				;}
    break;

  case 1272:

/* Line 1464 of yacc.c  */
#line 8126 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(3) - (5)].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(5) - (5)].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				;}
    break;

  case 1273:

/* Line 1464 of yacc.c  */
#line 8137 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				;}
    break;

  case 1274:

/* Line 1464 of yacc.c  */
#line 8152 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (5)].str);
					(yyval.alias)->colnames = (yyvsp[(4) - (5)].list);
				;}
    break;

  case 1275:

/* Line 1464 of yacc.c  */
#line 8158 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (2)].str);
				;}
    break;

  case 1276:

/* Line 1464 of yacc.c  */
#line 8163 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (4)].str);
					(yyval.alias)->colnames = (yyvsp[(3) - (4)].list);
				;}
    break;

  case 1277:

/* Line 1464 of yacc.c  */
#line 8169 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (1)].str);
				;}
    break;

  case 1278:

/* Line 1464 of yacc.c  */
#line 8175 "gram.y"
    { (yyval.jtype) = JOIN_FULL; ;}
    break;

  case 1279:

/* Line 1464 of yacc.c  */
#line 8176 "gram.y"
    { (yyval.jtype) = JOIN_LEFT; ;}
    break;

  case 1280:

/* Line 1464 of yacc.c  */
#line 8177 "gram.y"
    { (yyval.jtype) = JOIN_RIGHT; ;}
    break;

  case 1281:

/* Line 1464 of yacc.c  */
#line 8178 "gram.y"
    { (yyval.jtype) = JOIN_INNER; ;}
    break;

  case 1282:

/* Line 1464 of yacc.c  */
#line 8182 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1283:

/* Line 1464 of yacc.c  */
#line 8183 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1284:

/* Line 1464 of yacc.c  */
#line 8195 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(3) - (4)].list); ;}
    break;

  case 1285:

/* Line 1464 of yacc.c  */
#line 8196 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1286:

/* Line 1464 of yacc.c  */
#line 8202 "gram.y"
    {
					/* default inheritance */
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->inhOpt = INH_DEFAULT;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1287:

/* Line 1464 of yacc.c  */
#line 8209 "gram.y"
    {
					/* inheritance query */
					(yyval.range) = (yyvsp[(1) - (2)].range);
					(yyval.range)->inhOpt = INH_YES;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1288:

/* Line 1464 of yacc.c  */
#line 8216 "gram.y"
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1289:

/* Line 1464 of yacc.c  */
#line 8223 "gram.y"
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[(3) - (4)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1290:

/* Line 1464 of yacc.c  */
#line 8233 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); ;}
    break;

  case 1291:

/* Line 1464 of yacc.c  */
#line 8234 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); ;}
    break;

  case 1292:

/* Line 1464 of yacc.c  */
#line 8248 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
				;}
    break;

  case 1293:

/* Line 1464 of yacc.c  */
#line 8252 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(2) - (2)].str);
					(yyvsp[(1) - (2)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (2)].range);
				;}
    break;

  case 1294:

/* Line 1464 of yacc.c  */
#line 8259 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(3) - (3)].str);
					(yyvsp[(1) - (3)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (3)].range);
				;}
    break;

  case 1295:

/* Line 1464 of yacc.c  */
#line 8268 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1296:

/* Line 1464 of yacc.c  */
#line 8273 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1297:

/* Line 1464 of yacc.c  */
#line 8274 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1298:

/* Line 1464 of yacc.c  */
#line 8279 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1299:

/* Line 1464 of yacc.c  */
#line 8281 "gram.y"
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[(4) - (4)].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1300:

/* Line 1464 of yacc.c  */
#line 8288 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1301:

/* Line 1464 of yacc.c  */
#line 8294 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 1302:

/* Line 1464 of yacc.c  */
#line 8298 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1303:

/* Line 1464 of yacc.c  */
#line 8304 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (2)].str);
					n->typeName = (yyvsp[(2) - (2)].typnam);
					n->constraints = NIL;
					n->is_local = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1304:

/* Line 1464 of yacc.c  */
#line 8325 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(2) - (2)].list);
				;}
    break;

  case 1305:

/* Line 1464 of yacc.c  */
#line 8330 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->setof = TRUE;
				;}
    break;

  case 1306:

/* Line 1464 of yacc.c  */
#line 8337 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(4) - (5)].ival)));
				;}
    break;

  case 1307:

/* Line 1464 of yacc.c  */
#line 8342 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (6)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(5) - (6)].ival)));
					(yyval.typnam)->setof = TRUE;
				;}
    break;

  case 1308:

/* Line 1464 of yacc.c  */
#line 8348 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				;}
    break;

  case 1309:

/* Line 1464 of yacc.c  */
#line 8353 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = TRUE;
				;}
    break;

  case 1310:

/* Line 1464 of yacc.c  */
#line 8362 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeInteger(-1)); ;}
    break;

  case 1311:

/* Line 1464 of yacc.c  */
#line 8364 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (4)].list), makeInteger((yyvsp[(3) - (4)].ival))); ;}
    break;

  case 1312:

/* Line 1464 of yacc.c  */
#line 8366 "gram.y"
    {  (yyval.list) = NIL; ;}
    break;

  case 1313:

/* Line 1464 of yacc.c  */
#line 8370 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1314:

/* Line 1464 of yacc.c  */
#line 8371 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1315:

/* Line 1464 of yacc.c  */
#line 8372 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1316:

/* Line 1464 of yacc.c  */
#line 8373 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1317:

/* Line 1464 of yacc.c  */
#line 8374 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1318:

/* Line 1464 of yacc.c  */
#line 8376 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
				;}
    break;

  case 1319:

/* Line 1464 of yacc.c  */
#line 8381 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					if ((yyvsp[(5) - (5)].list) != NIL)
					{
						if (list_length((yyvsp[(5) - (5)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (5)]))));
						(yyval.typnam)->typmods = lappend((yyvsp[(5) - (5)].list), makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					}
					else
						(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												 makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
				;}
    break;

  case 1320:

/* Line 1464 of yacc.c  */
#line 8410 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1321:

/* Line 1464 of yacc.c  */
#line 8411 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1322:

/* Line 1464 of yacc.c  */
#line 8412 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1323:

/* Line 1464 of yacc.c  */
#line 8413 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1324:

/* Line 1464 of yacc.c  */
#line 8425 "gram.y"
    {
					(yyval.typnam) = makeTypeName((yyvsp[(1) - (2)].str));
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1325:

/* Line 1464 of yacc.c  */
#line 8431 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(2) - (3)].list)));
					(yyval.typnam)->typmods = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->location = (yylsp[(1) - (3)]);
				;}
    break;

  case 1326:

/* Line 1464 of yacc.c  */
#line 8438 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1327:

/* Line 1464 of yacc.c  */
#line 8439 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1328:

/* Line 1464 of yacc.c  */
#line 8446 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1329:

/* Line 1464 of yacc.c  */
#line 8451 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1330:

/* Line 1464 of yacc.c  */
#line 8456 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1331:

/* Line 1464 of yacc.c  */
#line 8461 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1332:

/* Line 1464 of yacc.c  */
#line 8466 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1333:

/* Line 1464 of yacc.c  */
#line 8471 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (2)].typnam);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1334:

/* Line 1464 of yacc.c  */
#line 8476 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1335:

/* Line 1464 of yacc.c  */
#line 8481 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1336:

/* Line 1464 of yacc.c  */
#line 8487 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1337:

/* Line 1464 of yacc.c  */
#line 8493 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1338:

/* Line 1464 of yacc.c  */
#line 8499 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1339:

/* Line 1464 of yacc.c  */
#line 8506 "gram.y"
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[(2) - (3)].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[(2) - (3)]))));
					else if ((yyvsp[(2) - (3)].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[(2) - (3)].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[(2) - (3)]))));
				;}
    break;

  case 1340:

/* Line 1464 of yacc.c  */
#line 8527 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
				;}
    break;

  case 1341:

/* Line 1464 of yacc.c  */
#line 8537 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1342:

/* Line 1464 of yacc.c  */
#line 8541 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1343:

/* Line 1464 of yacc.c  */
#line 8549 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1344:

/* Line 1464 of yacc.c  */
#line 8553 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				;}
    break;

  case 1345:

/* Line 1464 of yacc.c  */
#line 8561 "gram.y"
    {
					char *typname;

					typname = (yyvsp[(2) - (5)].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[(4) - (5)].list);
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1346:

/* Line 1464 of yacc.c  */
#line 8573 "gram.y"
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[(2) - (2)].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1347:

/* Line 1464 of yacc.c  */
#line 8594 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1348:

/* Line 1464 of yacc.c  */
#line 8598 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1349:

/* Line 1464 of yacc.c  */
#line 8604 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1350:

/* Line 1464 of yacc.c  */
#line 8608 "gram.y"
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				;}
    break;

  case 1351:

/* Line 1464 of yacc.c  */
#line 8621 "gram.y"
    {
					if (((yyvsp[(5) - (5)].str) != NULL) && (strcmp((yyvsp[(5) - (5)].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[(1) - (5)].str)) + 1 + strlen((yyvsp[(5) - (5)].str)) + 1);
						strcpy(type, (yyvsp[(1) - (5)].str));
						strcat(type, "_");
						strcat(type, (yyvsp[(5) - (5)].str));
						(yyvsp[(1) - (5)].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (5)].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1352:

/* Line 1464 of yacc.c  */
#line 8640 "gram.y"
    {
					if (((yyvsp[(2) - (2)].str) != NULL) && (strcmp((yyvsp[(2) - (2)].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[(1) - (2)].str)) + 1 + strlen((yyvsp[(2) - (2)].str)) + 1);
						strcpy(type, (yyvsp[(1) - (2)].str));
						strcat(type, "_");
						strcat(type, (yyvsp[(2) - (2)].str));
						(yyvsp[(1) - (2)].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (2)].str));

					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[(1) - (2)].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));

					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1353:

/* Line 1464 of yacc.c  */
#line 8663 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1354:

/* Line 1464 of yacc.c  */
#line 8665 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1355:

/* Line 1464 of yacc.c  */
#line 8667 "gram.y"
    { (yyval.str) = "varchar"; ;}
    break;

  case 1356:

/* Line 1464 of yacc.c  */
#line 8669 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1357:

/* Line 1464 of yacc.c  */
#line 8671 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1358:

/* Line 1464 of yacc.c  */
#line 8673 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1359:

/* Line 1464 of yacc.c  */
#line 8677 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1360:

/* Line 1464 of yacc.c  */
#line 8678 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1361:

/* Line 1464 of yacc.c  */
#line 8682 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); ;}
    break;

  case 1362:

/* Line 1464 of yacc.c  */
#line 8683 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 1363:

/* Line 1464 of yacc.c  */
#line 8691 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1364:

/* Line 1464 of yacc.c  */
#line 8700 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1365:

/* Line 1464 of yacc.c  */
#line 8708 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1366:

/* Line 1464 of yacc.c  */
#line 8717 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1367:

/* Line 1464 of yacc.c  */
#line 8728 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1368:

/* Line 1464 of yacc.c  */
#line 8735 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1369:

/* Line 1464 of yacc.c  */
#line 8736 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1370:

/* Line 1464 of yacc.c  */
#line 8737 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1371:

/* Line 1464 of yacc.c  */
#line 8742 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[(1) - (1)]))); ;}
    break;

  case 1372:

/* Line 1464 of yacc.c  */
#line 8744 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[(1) - (1)]))); ;}
    break;

  case 1373:

/* Line 1464 of yacc.c  */
#line 8746 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[(1) - (1)]))); ;}
    break;

  case 1374:

/* Line 1464 of yacc.c  */
#line 8748 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[(1) - (1)]))); ;}
    break;

  case 1375:

/* Line 1464 of yacc.c  */
#line 8750 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[(1) - (1)]))); ;}
    break;

  case 1376:

/* Line 1464 of yacc.c  */
#line 8752 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1377:

/* Line 1464 of yacc.c  */
#line 8754 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[(1) - (3)])));
				;}
    break;

  case 1378:

/* Line 1464 of yacc.c  */
#line 8759 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[(1) - (3)])));
				;}
    break;

  case 1379:

/* Line 1464 of yacc.c  */
#line 8764 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				;}
    break;

  case 1380:

/* Line 1464 of yacc.c  */
#line 8770 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				;}
    break;

  case 1381:

/* Line 1464 of yacc.c  */
#line 8778 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				;}
    break;

  case 1382:

/* Line 1464 of yacc.c  */
#line 8783 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				;}
    break;

  case 1383:

/* Line 1464 of yacc.c  */
#line 8790 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				;}
    break;

  case 1384:

/* Line 1464 of yacc.c  */
#line 8796 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1385:

/* Line 1464 of yacc.c  */
#line 8801 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (1)])));
				;}
    break;

  case 1386:

/* Line 1464 of yacc.c  */
#line 8805 "gram.y"
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (4)])),
									makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
				;}
    break;

  case 1387:

/* Line 1464 of yacc.c  */
#line 8834 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1388:

/* Line 1464 of yacc.c  */
#line 8836 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); ;}
    break;

  case 1389:

/* Line 1464 of yacc.c  */
#line 8838 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("timezone");
					n->args = list_make2((yyvsp[(5) - (5)].node), (yyvsp[(1) - (5)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1390:

/* Line 1464 of yacc.c  */
#line 8860 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1391:

/* Line 1464 of yacc.c  */
#line 8862 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1392:

/* Line 1464 of yacc.c  */
#line 8864 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1393:

/* Line 1464 of yacc.c  */
#line 8866 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1394:

/* Line 1464 of yacc.c  */
#line 8868 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1395:

/* Line 1464 of yacc.c  */
#line 8870 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1396:

/* Line 1464 of yacc.c  */
#line 8872 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1397:

/* Line 1464 of yacc.c  */
#line 8874 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1398:

/* Line 1464 of yacc.c  */
#line 8876 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1399:

/* Line 1464 of yacc.c  */
#line 8878 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1400:

/* Line 1464 of yacc.c  */
#line 8880 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1401:

/* Line 1464 of yacc.c  */
#line 8883 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1402:

/* Line 1464 of yacc.c  */
#line 8885 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1403:

/* Line 1464 of yacc.c  */
#line 8887 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); ;}
    break;

  case 1404:

/* Line 1464 of yacc.c  */
#line 8890 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1405:

/* Line 1464 of yacc.c  */
#line 8892 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1406:

/* Line 1464 of yacc.c  */
#line 8894 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1407:

/* Line 1464 of yacc.c  */
#line 8897 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1408:

/* Line 1464 of yacc.c  */
#line 8899 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				;}
    break;

  case 1409:

/* Line 1464 of yacc.c  */
#line 8912 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); ;}
    break;

  case 1410:

/* Line 1464 of yacc.c  */
#line 8914 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				;}
    break;

  case 1411:

/* Line 1464 of yacc.c  */
#line 8927 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1412:

/* Line 1464 of yacc.c  */
#line 8929 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				;}
    break;

  case 1413:

/* Line 1464 of yacc.c  */
#line 8942 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); ;}
    break;

  case 1414:

/* Line 1464 of yacc.c  */
#line 8944 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				;}
    break;

  case 1415:

/* Line 1464 of yacc.c  */
#line 8958 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(4) - (4)].node), makeNullAConst(-1));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (4)].node), (Node *) n, (yylsp[(2) - (4)]));
				;}
    break;

  case 1416:

/* Line 1464 of yacc.c  */
#line 8971 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				;}
    break;

  case 1417:

/* Line 1464 of yacc.c  */
#line 8984 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(5) - (5)].node), makeNullAConst(-1));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				;}
    break;

  case 1418:

/* Line 1464 of yacc.c  */
#line 8997 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(5) - (7)].node), (yyvsp[(7) - (7)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (7)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (7)].node), (Node *) n, (yylsp[(2) - (7)]));
				;}
    break;

  case 1419:

/* Line 1464 of yacc.c  */
#line 9020 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (3)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1420:

/* Line 1464 of yacc.c  */
#line 9027 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1421:

/* Line 1464 of yacc.c  */
#line 9034 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (4)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1422:

/* Line 1464 of yacc.c  */
#line 9041 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1423:

/* Line 1464 of yacc.c  */
#line 9048 "gram.y"
    {
					(yyval.node) = (Node *)makeOverlaps((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list), (yylsp[(2) - (3)]), yyscanner);
				;}
    break;

  case 1424:

/* Line 1464 of yacc.c  */
#line 9052 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_TRUE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1425:

/* Line 1464 of yacc.c  */
#line 9059 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_TRUE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1426:

/* Line 1464 of yacc.c  */
#line 9066 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_FALSE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1427:

/* Line 1464 of yacc.c  */
#line 9073 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_FALSE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1428:

/* Line 1464 of yacc.c  */
#line 9080 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_UNKNOWN;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1429:

/* Line 1464 of yacc.c  */
#line 9087 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1430:

/* Line 1464 of yacc.c  */
#line 9094 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				;}
    break;

  case 1431:

/* Line 1464 of yacc.c  */
#line 9098 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
									(Node *) makeSimpleA_Expr(AEXPR_DISTINCT,
															  "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));

				;}
    break;

  case 1432:

/* Line 1464 of yacc.c  */
#line 9106 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				;}
    break;

  case 1433:

/* Line 1464 of yacc.c  */
#line 9110 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				;}
    break;

  case 1434:

/* Line 1464 of yacc.c  */
#line 9120 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				;}
    break;

  case 1435:

/* Line 1464 of yacc.c  */
#line 9127 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				;}
    break;

  case 1436:

/* Line 1464 of yacc.c  */
#line 9134 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeA_Expr(AEXPR_AND, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
						(Node *) makeA_Expr(AEXPR_AND, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				;}
    break;

  case 1437:

/* Line 1464 of yacc.c  */
#line 9147 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeA_Expr(AEXPR_OR, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
						(Node *) makeA_Expr(AEXPR_OR, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				;}
    break;

  case 1438:

/* Line 1464 of yacc.c  */
#line 9160 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(3) - (3)].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[(3) - (3)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (3)].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[(2) - (3)]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)]));
					}
				;}
    break;

  case 1439:

/* Line 1464 of yacc.c  */
#line 9179 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(4) - (4)].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[(4) - (4)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (4)].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[(3) - (4)]);
						/* Stick a NOT on top */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (Node *) n, (yylsp[(2) - (4)]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)]));
					}
				;}
    break;

  case 1440:

/* Line 1464 of yacc.c  */
#line 9200 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[(3) - (4)].ival);
					n->testexpr = (yyvsp[(1) - (4)].node);
					n->operName = (yyvsp[(2) - (4)].list);
					n->subselect = (yyvsp[(4) - (4)].node);
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1441:

/* Line 1464 of yacc.c  */
#line 9210 "gram.y"
    {
					if ((yyvsp[(3) - (6)].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
				;}
    break;

  case 1442:

/* Line 1464 of yacc.c  */
#line 9217 "gram.y"
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[(1) - (2)]))));
				;}
    break;

  case 1443:

/* Line 1464 of yacc.c  */
#line 9233 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				;}
    break;

  case 1444:

/* Line 1464 of yacc.c  */
#line 9238 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
											 (yylsp[(2) - (4)]));
				;}
    break;

  case 1445:

/* Line 1464 of yacc.c  */
#line 9256 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1446:

/* Line 1464 of yacc.c  */
#line 9258 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); ;}
    break;

  case 1447:

/* Line 1464 of yacc.c  */
#line 9260 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1448:

/* Line 1464 of yacc.c  */
#line 9262 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1449:

/* Line 1464 of yacc.c  */
#line 9264 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1450:

/* Line 1464 of yacc.c  */
#line 9266 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1451:

/* Line 1464 of yacc.c  */
#line 9268 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1452:

/* Line 1464 of yacc.c  */
#line 9270 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1453:

/* Line 1464 of yacc.c  */
#line 9272 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1454:

/* Line 1464 of yacc.c  */
#line 9274 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1455:

/* Line 1464 of yacc.c  */
#line 9276 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1456:

/* Line 1464 of yacc.c  */
#line 9278 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1457:

/* Line 1464 of yacc.c  */
#line 9280 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1458:

/* Line 1464 of yacc.c  */
#line 9282 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1459:

/* Line 1464 of yacc.c  */
#line 9284 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1460:

/* Line 1464 of yacc.c  */
#line 9286 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); ;}
    break;

  case 1461:

/* Line 1464 of yacc.c  */
#line 9288 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				;}
    break;

  case 1462:

/* Line 1464 of yacc.c  */
#line 9292 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL,
						NULL, (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])), (yylsp[(2) - (6)]));
				;}
    break;

  case 1463:

/* Line 1464 of yacc.c  */
#line 9297 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				;}
    break;

  case 1464:

/* Line 1464 of yacc.c  */
#line 9301 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				;}
    break;

  case 1465:

/* Line 1464 of yacc.c  */
#line 9305 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				;}
    break;

  case 1466:

/* Line 1464 of yacc.c  */
#line 9310 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
											 (yylsp[(2) - (4)]));
				;}
    break;

  case 1467:

/* Line 1464 of yacc.c  */
#line 9326 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1468:

/* Line 1464 of yacc.c  */
#line 9327 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1469:

/* Line 1464 of yacc.c  */
#line 9329 "gram.y"
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[(1) - (2)].ival);
					p->location = (yylsp[(1) - (2)]);
					if ((yyvsp[(2) - (2)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				;}
    break;

  case 1470:

/* Line 1464 of yacc.c  */
#line 9344 "gram.y"
    {
					if ((yyvsp[(4) - (4)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[(2) - (4)].node);
						n->indirection = check_indirection((yyvsp[(4) - (4)].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else
						(yyval.node) = (yyvsp[(2) - (4)].node);
				;}
    break;

  case 1471:

/* Line 1464 of yacc.c  */
#line 9356 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1472:

/* Line 1464 of yacc.c  */
#line 9358 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1473:

/* Line 1464 of yacc.c  */
#line 9360 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(1) - (1)].node);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1474:

/* Line 1464 of yacc.c  */
#line 9370 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1475:

/* Line 1464 of yacc.c  */
#line 9380 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1476:

/* Line 1464 of yacc.c  */
#line 9390 "gram.y"
    {
					A_ArrayExpr *n = (A_ArrayExpr *) (yyvsp[(2) - (2)].node);
					Assert(IsA(n, A_ArrayExpr));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1477:

/* Line 1464 of yacc.c  */
#line 9398 "gram.y"
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[(1) - (1)].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)r;
				;}
    break;

  case 1478:

/* Line 1464 of yacc.c  */
#line 9416 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (4)].list);
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(4) - (4)].windef);
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1479:

/* Line 1464 of yacc.c  */
#line 9429 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (5)].list);
					n->args = (yyvsp[(3) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(5) - (5)].windef);
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1480:

/* Line 1464 of yacc.c  */
#line 9442 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (6)].list);
					n->args = list_make1((yyvsp[(4) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = TRUE;
					n->over = (yyvsp[(6) - (6)].windef);
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1481:

/* Line 1464 of yacc.c  */
#line 9455 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (8)].list);
					n->args = lappend((yyvsp[(3) - (8)].list), (yyvsp[(6) - (8)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = TRUE;
					n->over = (yyvsp[(8) - (8)].windef);
					n->location = (yylsp[(1) - (8)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1482:

/* Line 1464 of yacc.c  */
#line 9468 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (6)].list);
					n->args = (yyvsp[(3) - (6)].list);
					n->agg_order = (yyvsp[(4) - (6)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(6) - (6)].windef);
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1483:

/* Line 1464 of yacc.c  */
#line 9481 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (7)].list);
					n->args = (yyvsp[(4) - (7)].list);
					n->agg_order = (yyvsp[(5) - (7)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					n->func_variadic = FALSE;
					n->over = (yyvsp[(7) - (7)].windef);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1484:

/* Line 1464 of yacc.c  */
#line 9498 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (7)].list);
					n->args = (yyvsp[(4) - (7)].list);
					n->agg_order = (yyvsp[(5) - (7)].list);
					n->agg_star = FALSE;
					n->agg_distinct = TRUE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(7) - (7)].windef);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1485:

/* Line 1464 of yacc.c  */
#line 9511 "gram.y"
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL92 that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (5)].list);
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = TRUE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(5) - (5)].windef);
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1486:

/* Line 1464 of yacc.c  */
#line 9534 "gram.y"
    {
					/*
					 * Translate as "'now'::text::date".
					 *
					 * We cannot use "'now'::date" because coerce_type() will
					 * immediately reduce that to a constant representing
					 * today's date.  We need to delay the conversion until
					 * runtime, else the wrong things will happen when
					 * CURRENT_DATE is used in a column default value or rule.
					 *
					 * This could be simplified if we had a way to generate
					 * an expression tree representing runtime application
					 * of type-input conversion functions.  (As of PG 7.3
					 * that is actually possible, but not clear that we want
					 * to rely on it.)
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("date"), -1);
				;}
    break;

  case 1487:

/* Line 1464 of yacc.c  */
#line 9555 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timetz"), -1);
				;}
    break;

  case 1488:

/* Line 1464 of yacc.c  */
#line 9565 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("timetz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, -1);
				;}
    break;

  case 1489:

/* Line 1464 of yacc.c  */
#line 9578 "gram.y"
    {
					/*
					 * Translate as "now()", since we have a function that
					 * does exactly what is needed.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("now");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1490:

/* Line 1464 of yacc.c  */
#line 9595 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamptz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("timestamptz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, -1);
				;}
    break;

  case 1491:

/* Line 1464 of yacc.c  */
#line 9608 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast((Node *)n, SystemTypeName("time"), -1);
				;}
    break;

  case 1492:

/* Line 1464 of yacc.c  */
#line 9618 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("time");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast((Node *)n, d, -1);
				;}
    break;

  case 1493:

/* Line 1464 of yacc.c  */
#line 9631 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timestamp"), -1);
				;}
    break;

  case 1494:

/* Line 1464 of yacc.c  */
#line 9641 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("timestamp");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, -1);
				;}
    break;

  case 1495:

/* Line 1464 of yacc.c  */
#line 9654 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1496:

/* Line 1464 of yacc.c  */
#line 9667 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1497:

/* Line 1464 of yacc.c  */
#line 9680 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("session_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1498:

/* Line 1464 of yacc.c  */
#line 9693 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1499:

/* Line 1464 of yacc.c  */
#line 9706 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_database");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1500:

/* Line 1464 of yacc.c  */
#line 9719 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_schema");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1501:

/* Line 1464 of yacc.c  */
#line 9732 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].typnam), (yylsp[(1) - (6)])); ;}
    break;

  case 1502:

/* Line 1464 of yacc.c  */
#line 9734 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("date_part");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1503:

/* Line 1464 of yacc.c  */
#line 9747 "gram.y"
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * overlay(A, B, C, D)
					 * overlay(A PLACING B FROM C) is converted to
					 * overlay(A, B, C)
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("overlay");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1504:

/* Line 1464 of yacc.c  */
#line 9765 "gram.y"
    {
					/* position(A in B) is converted to position(B, A) */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("position");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1505:

/* Line 1464 of yacc.c  */
#line 9779 "gram.y"
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("substring");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1506:

/* Line 1464 of yacc.c  */
#line 9795 "gram.y"
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 */
					FuncCall *n = makeNode(FuncCall);
					/* Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					n->funcname = SystemFuncName(((Value *)llast((yyvsp[(5) - (6)].typnam)->names))->val.str);
					n->args = list_make1((yyvsp[(3) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1507:

/* Line 1464 of yacc.c  */
#line 9817 "gram.y"
    {
					/* various trim expressions are defined in SQL92
					 * - thomas 1997-07-19
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1508:

/* Line 1464 of yacc.c  */
#line 9833 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("ltrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1509:

/* Line 1464 of yacc.c  */
#line 9846 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("rtrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1510:

/* Line 1464 of yacc.c  */
#line 9859 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1511:

/* Line 1464 of yacc.c  */
#line 9872 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(1) - (6)]));
				;}
    break;

  case 1512:

/* Line 1464 of yacc.c  */
#line 9876 "gram.y"
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[(3) - (4)].list);
					c->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)c;
				;}
    break;

  case 1513:

/* Line 1464 of yacc.c  */
#line 9883 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				;}
    break;

  case 1514:

/* Line 1464 of yacc.c  */
#line 9891 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_LEAST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				;}
    break;

  case 1515:

/* Line 1464 of yacc.c  */
#line 9899 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				;}
    break;

  case 1516:

/* Line 1464 of yacc.c  */
#line 9903 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (5)].str), NIL, NIL, (yylsp[(1) - (5)]));
				;}
    break;

  case 1517:

/* Line 1464 of yacc.c  */
#line 9907 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), (yyvsp[(6) - (7)].list), NIL, (yylsp[(1) - (7)]));
				;}
    break;

  case 1518:

/* Line 1464 of yacc.c  */
#line 9911 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), NIL, (yyvsp[(6) - (7)].list), (yylsp[(1) - (7)]));
				;}
    break;

  case 1519:

/* Line 1464 of yacc.c  */
#line 9915 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (9)].str), (yyvsp[(6) - (9)].list), (yyvsp[(8) - (9)].list), (yylsp[(1) - (9)]));
				;}
    break;

  case 1520:

/* Line 1464 of yacc.c  */
#line 9919 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[(3) - (4)].list), NIL, (yylsp[(1) - (4)]));
				;}
    break;

  case 1521:

/* Line 1464 of yacc.c  */
#line 9923 "gram.y"
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[(4) - (6)].node), makeBoolAConst((yyvsp[(5) - (6)].boolean), -1)),
									(yylsp[(1) - (6)]));
					x->xmloption = (yyvsp[(3) - (6)].ival);
					(yyval.node) = (Node *)x;
				;}
    break;

  case 1522:

/* Line 1464 of yacc.c  */
#line 9932 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (5)].str), NULL, NIL, (yylsp[(1) - (5)]));
				;}
    break;

  case 1523:

/* Line 1464 of yacc.c  */
#line 9936 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (7)].str), NULL, list_make1((yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				;}
    break;

  case 1524:

/* Line 1464 of yacc.c  */
#line 9940 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[(3) - (7)].node), (yyvsp[(5) - (7)].node), (yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				;}
    break;

  case 1525:

/* Line 1464 of yacc.c  */
#line 9945 "gram.y"
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[(3) - (7)].ival);
					n->expr = (yyvsp[(4) - (7)].node);
					n->typeName = (yyvsp[(6) - (7)].typnam);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1526:

/* Line 1464 of yacc.c  */
#line 9959 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1527:

/* Line 1464 of yacc.c  */
#line 9961 "gram.y"
    { (yyval.node) = makeNullAConst(-1); ;}
    break;

  case 1528:

/* Line 1464 of yacc.c  */
#line 9965 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); ;}
    break;

  case 1529:

/* Line 1464 of yacc.c  */
#line 9967 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); ;}
    break;

  case 1530:

/* Line 1464 of yacc.c  */
#line 9969 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); ;}
    break;

  case 1531:

/* Line 1464 of yacc.c  */
#line 9971 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); ;}
    break;

  case 1532:

/* Line 1464 of yacc.c  */
#line 9974 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1533:

/* Line 1464 of yacc.c  */
#line 9977 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1534:

/* Line 1464 of yacc.c  */
#line 9978 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); ;}
    break;

  case 1535:

/* Line 1464 of yacc.c  */
#line 9982 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				;}
    break;

  case 1536:

/* Line 1464 of yacc.c  */
#line 9990 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1537:

/* Line 1464 of yacc.c  */
#line 9999 "gram.y"
    { (yyval.ival) = XMLOPTION_DOCUMENT; ;}
    break;

  case 1538:

/* Line 1464 of yacc.c  */
#line 10000 "gram.y"
    { (yyval.ival) = XMLOPTION_CONTENT; ;}
    break;

  case 1539:

/* Line 1464 of yacc.c  */
#line 10003 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1540:

/* Line 1464 of yacc.c  */
#line 10004 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1541:

/* Line 1464 of yacc.c  */
#line 10005 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1542:

/* Line 1464 of yacc.c  */
#line 10012 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1543:

/* Line 1464 of yacc.c  */
#line 10013 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1544:

/* Line 1464 of yacc.c  */
#line 10017 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].windef)); ;}
    break;

  case 1545:

/* Line 1464 of yacc.c  */
#line 10019 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].windef)); ;}
    break;

  case 1546:

/* Line 1464 of yacc.c  */
#line 10024 "gram.y"
    {
					WindowDef *n = (yyvsp[(3) - (3)].windef);
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.windef) = n;
				;}
    break;

  case 1547:

/* Line 1464 of yacc.c  */
#line 10032 "gram.y"
    { (yyval.windef) = (yyvsp[(2) - (2)].windef); ;}
    break;

  case 1548:

/* Line 1464 of yacc.c  */
#line 10034 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[(2) - (2)].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[(2) - (2)]);
					(yyval.windef) = n;
				;}
    break;

  case 1549:

/* Line 1464 of yacc.c  */
#line 10047 "gram.y"
    { (yyval.windef) = NULL; ;}
    break;

  case 1550:

/* Line 1464 of yacc.c  */
#line 10052 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[(2) - (6)].str);
					n->partitionClause = (yyvsp[(3) - (6)].list);
					n->orderClause = (yyvsp[(4) - (6)].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[(5) - (6)].windef)->frameOptions;
					n->startOffset = (yyvsp[(5) - (6)].windef)->startOffset;
					n->endOffset = (yyvsp[(5) - (6)].windef)->endOffset;
					n->location = (yylsp[(1) - (6)]);
					(yyval.windef) = n;
				;}
    break;

  case 1551:

/* Line 1464 of yacc.c  */
#line 10077 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1552:

/* Line 1464 of yacc.c  */
#line 10078 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 1553:

/* Line 1464 of yacc.c  */
#line 10081 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); ;}
    break;

  case 1554:

/* Line 1464 of yacc.c  */
#line 10082 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1555:

/* Line 1464 of yacc.c  */
#line 10094 "gram.y"
    {
					WindowDef *n = (yyvsp[(2) - (2)].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
										   FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE PRECEDING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[(1) - (2)]))));
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
										   FRAMEOPTION_END_VALUE_FOLLOWING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE FOLLOWING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.windef) = n;
				;}
    break;

  case 1556:

/* Line 1464 of yacc.c  */
#line 10112 "gram.y"
    {
					WindowDef *n = (yyvsp[(2) - (2)].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					(yyval.windef) = n;
				;}
    break;

  case 1557:

/* Line 1464 of yacc.c  */
#line 10118 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1558:

/* Line 1464 of yacc.c  */
#line 10128 "gram.y"
    {
					WindowDef *n = (yyvsp[(1) - (1)].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[(1) - (1)]))));
					if (n->frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[(1) - (1)]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				;}
    break;

  case 1559:

/* Line 1464 of yacc.c  */
#line 10145 "gram.y"
    {
					WindowDef *n1 = (yyvsp[(2) - (4)].windef);
					WindowDef *n2 = (yyvsp[(4) - (4)].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[(2) - (4)]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[(4) - (4)]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[(4) - (4)]))));
					if ((frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_VALUE_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[(4) - (4)]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				;}
    break;

  case 1560:

/* Line 1464 of yacc.c  */
#line 10190 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1561:

/* Line 1464 of yacc.c  */
#line 10198 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1562:

/* Line 1464 of yacc.c  */
#line 10206 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1563:

/* Line 1464 of yacc.c  */
#line 10214 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_PRECEDING;
					n->startOffset = (yyvsp[(1) - (2)].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1564:

/* Line 1464 of yacc.c  */
#line 10222 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_FOLLOWING;
					n->startOffset = (yyvsp[(1) - (2)].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1565:

/* Line 1464 of yacc.c  */
#line 10242 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1566:

/* Line 1464 of yacc.c  */
#line 10243 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1567:

/* Line 1464 of yacc.c  */
#line 10244 "gram.y"
    { (yyval.list) = lappend((yyvsp[(2) - (5)].list), (yyvsp[(4) - (5)].node)); ;}
    break;

  case 1568:

/* Line 1464 of yacc.c  */
#line 10247 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; ;}
    break;

  case 1569:

/* Line 1464 of yacc.c  */
#line 10248 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; ;}
    break;

  case 1570:

/* Line 1464 of yacc.c  */
#line 10249 "gram.y"
    { (yyval.ival) = ALL_SUBLINK; ;}
    break;

  case 1571:

/* Line 1464 of yacc.c  */
#line 10252 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1572:

/* Line 1464 of yacc.c  */
#line 10253 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1573:

/* Line 1464 of yacc.c  */
#line 10256 "gram.y"
    { (yyval.str) = "+"; ;}
    break;

  case 1574:

/* Line 1464 of yacc.c  */
#line 10257 "gram.y"
    { (yyval.str) = "-"; ;}
    break;

  case 1575:

/* Line 1464 of yacc.c  */
#line 10258 "gram.y"
    { (yyval.str) = "*"; ;}
    break;

  case 1576:

/* Line 1464 of yacc.c  */
#line 10259 "gram.y"
    { (yyval.str) = "/"; ;}
    break;

  case 1577:

/* Line 1464 of yacc.c  */
#line 10260 "gram.y"
    { (yyval.str) = "%"; ;}
    break;

  case 1578:

/* Line 1464 of yacc.c  */
#line 10261 "gram.y"
    { (yyval.str) = "^"; ;}
    break;

  case 1579:

/* Line 1464 of yacc.c  */
#line 10262 "gram.y"
    { (yyval.str) = "<"; ;}
    break;

  case 1580:

/* Line 1464 of yacc.c  */
#line 10263 "gram.y"
    { (yyval.str) = ">"; ;}
    break;

  case 1581:

/* Line 1464 of yacc.c  */
#line 10264 "gram.y"
    { (yyval.str) = "="; ;}
    break;

  case 1582:

/* Line 1464 of yacc.c  */
#line 10268 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1583:

/* Line 1464 of yacc.c  */
#line 10270 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1584:

/* Line 1464 of yacc.c  */
#line 10275 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1585:

/* Line 1464 of yacc.c  */
#line 10277 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1586:

/* Line 1464 of yacc.c  */
#line 10282 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1587:

/* Line 1464 of yacc.c  */
#line 10284 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1588:

/* Line 1464 of yacc.c  */
#line 10286 "gram.y"
    { (yyval.list) = list_make1(makeString("~~")); ;}
    break;

  case 1589:

/* Line 1464 of yacc.c  */
#line 10288 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~")); ;}
    break;

  case 1590:

/* Line 1464 of yacc.c  */
#line 10290 "gram.y"
    { (yyval.list) = list_make1(makeString("~~*")); ;}
    break;

  case 1591:

/* Line 1464 of yacc.c  */
#line 10292 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~*")); ;}
    break;

  case 1592:

/* Line 1464 of yacc.c  */
#line 10304 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 1593:

/* Line 1464 of yacc.c  */
#line 10308 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1594:

/* Line 1464 of yacc.c  */
#line 10315 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 1595:

/* Line 1464 of yacc.c  */
#line 10319 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1596:

/* Line 1464 of yacc.c  */
#line 10325 "gram.y"
    {
					(yyval.node) = (yyvsp[(1) - (1)].node);
				;}
    break;

  case 1597:

/* Line 1464 of yacc.c  */
#line 10329 "gram.y"
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->arg = (Expr *) (yyvsp[(1) - (3)].node);
					na->name = (yyvsp[(3) - (3)].str);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[(3) - (3)]);
					(yyval.node) = (Node *) na;
				;}
    break;

  case 1598:

/* Line 1464 of yacc.c  */
#line 10339 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].typnam)); ;}
    break;

  case 1599:

/* Line 1464 of yacc.c  */
#line 10340 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].typnam)); ;}
    break;

  case 1600:

/* Line 1464 of yacc.c  */
#line 10344 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				;}
    break;

  case 1601:

/* Line 1464 of yacc.c  */
#line 10348 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				;}
    break;

  case 1602:

/* Line 1464 of yacc.c  */
#line 10352 "gram.y"
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[(1) - (2)]));
				;}
    break;

  case 1603:

/* Line 1464 of yacc.c  */
#line 10357 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1604:

/* Line 1464 of yacc.c  */
#line 10358 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1605:

/* Line 1464 of yacc.c  */
#line 10364 "gram.y"
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[(1) - (3)].str), (yylsp[(1) - (3)])), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1606:

/* Line 1464 of yacc.c  */
#line 10367 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1607:

/* Line 1464 of yacc.c  */
#line 10374 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1608:

/* Line 1464 of yacc.c  */
#line 10375 "gram.y"
    { (yyval.str) = "year"; ;}
    break;

  case 1609:

/* Line 1464 of yacc.c  */
#line 10376 "gram.y"
    { (yyval.str) = "month"; ;}
    break;

  case 1610:

/* Line 1464 of yacc.c  */
#line 10377 "gram.y"
    { (yyval.str) = "day"; ;}
    break;

  case 1611:

/* Line 1464 of yacc.c  */
#line 10378 "gram.y"
    { (yyval.str) = "hour"; ;}
    break;

  case 1612:

/* Line 1464 of yacc.c  */
#line 10379 "gram.y"
    { (yyval.str) = "minute"; ;}
    break;

  case 1613:

/* Line 1464 of yacc.c  */
#line 10380 "gram.y"
    { (yyval.str) = "second"; ;}
    break;

  case 1614:

/* Line 1464 of yacc.c  */
#line 10381 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1615:

/* Line 1464 of yacc.c  */
#line 10392 "gram.y"
    {
					(yyval.list) = list_make4((yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].node), (yyvsp[(3) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1616:

/* Line 1464 of yacc.c  */
#line 10396 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1617:

/* Line 1464 of yacc.c  */
#line 10403 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1618:

/* Line 1464 of yacc.c  */
#line 10409 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(3) - (3)].node), (yyvsp[(1) - (3)].node)); ;}
    break;

  case 1619:

/* Line 1464 of yacc.c  */
#line 10410 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1620:

/* Line 1464 of yacc.c  */
#line 10427 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1621:

/* Line 1464 of yacc.c  */
#line 10431 "gram.y"
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yyvsp[(2) - (3)].node));
				;}
    break;

  case 1622:

/* Line 1464 of yacc.c  */
#line 10436 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node));
				;}
    break;

  case 1623:

/* Line 1464 of yacc.c  */
#line 10440 "gram.y"
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[(1) - (2)].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[(2) - (2)].node),
												 SystemTypeName("int4"), -1));
				;}
    break;

  case 1624:

/* Line 1464 of yacc.c  */
#line 10455 "gram.y"
    {
					(yyval.list) = (yyvsp[(1) - (1)].list);
				;}
    break;

  case 1625:

/* Line 1464 of yacc.c  */
#line 10459 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1626:

/* Line 1464 of yacc.c  */
#line 10463 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1627:

/* Line 1464 of yacc.c  */
#line 10466 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1628:

/* Line 1464 of yacc.c  */
#line 10469 "gram.y"
    { (yyval.list) = lappend((yyvsp[(3) - (3)].list), (yyvsp[(1) - (3)].node)); ;}
    break;

  case 1629:

/* Line 1464 of yacc.c  */
#line 10470 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1630:

/* Line 1464 of yacc.c  */
#line 10471 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1631:

/* Line 1464 of yacc.c  */
#line 10475 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[(1) - (1)].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1632:

/* Line 1464 of yacc.c  */
#line 10481 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(2) - (3)].list); ;}
    break;

  case 1633:

/* Line 1464 of yacc.c  */
#line 10492 "gram.y"
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[(2) - (5)].node);
					c->args = (yyvsp[(3) - (5)].list);
					c->defresult = (Expr *) (yyvsp[(4) - (5)].node);
					c->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)c;
				;}
    break;

  case 1634:

/* Line 1464 of yacc.c  */
#line 10505 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1635:

/* Line 1464 of yacc.c  */
#line 10506 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1636:

/* Line 1464 of yacc.c  */
#line 10511 "gram.y"
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[(2) - (4)].node);
					w->result = (Expr *) (yyvsp[(4) - (4)].node);
					w->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)w;
				;}
    break;

  case 1637:

/* Line 1464 of yacc.c  */
#line 10521 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1638:

/* Line 1464 of yacc.c  */
#line 10522 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1639:

/* Line 1464 of yacc.c  */
#line 10525 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1640:

/* Line 1464 of yacc.c  */
#line 10526 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1641:

/* Line 1464 of yacc.c  */
#line 10530 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (1)].str), NIL, (yylsp[(1) - (1)]), yyscanner);
				;}
    break;

  case 1642:

/* Line 1464 of yacc.c  */
#line 10534 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].list), (yylsp[(1) - (2)]), yyscanner);
				;}
    break;

  case 1643:

/* Line 1464 of yacc.c  */
#line 10541 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(2) - (2)].str));
				;}
    break;

  case 1644:

/* Line 1464 of yacc.c  */
#line 10545 "gram.y"
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				;}
    break;

  case 1645:

/* Line 1464 of yacc.c  */
#line 10549 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = NULL;
					ai->uidx = (yyvsp[(2) - (3)].node);
					(yyval.node) = (Node *) ai;
				;}
    break;

  case 1646:

/* Line 1464 of yacc.c  */
#line 10556 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = (yyvsp[(2) - (5)].node);
					ai->uidx = (yyvsp[(4) - (5)].node);
					(yyval.node) = (Node *) ai;
				;}
    break;

  case 1647:

/* Line 1464 of yacc.c  */
#line 10565 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1648:

/* Line 1464 of yacc.c  */
#line 10566 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1649:

/* Line 1464 of yacc.c  */
#line 10570 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1650:

/* Line 1464 of yacc.c  */
#line 10571 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1653:

/* Line 1464 of yacc.c  */
#line 10586 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].node); ;}
    break;

  case 1654:

/* Line 1464 of yacc.c  */
#line 10588 "gram.y"
    {
					SetToDefault *n = makeNode(SetToDefault);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1655:

/* Line 1464 of yacc.c  */
#line 10596 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1656:

/* Line 1464 of yacc.c  */
#line 10597 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1657:

/* Line 1464 of yacc.c  */
#line 10605 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1658:

/* Line 1464 of yacc.c  */
#line 10616 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1659:

/* Line 1464 of yacc.c  */
#line 10617 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); ;}
    break;

  case 1660:

/* Line 1464 of yacc.c  */
#line 10621 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				;}
    break;

  case 1661:

/* Line 1464 of yacc.c  */
#line 10637 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(2) - (2)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (2)].node);
					(yyval.target)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1662:

/* Line 1464 of yacc.c  */
#line 10645 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1663:

/* Line 1464 of yacc.c  */
#line 10653 "gram.y"
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[(1) - (1)]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1664:

/* Line 1464 of yacc.c  */
#line 10674 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); ;}
    break;

  case 1665:

/* Line 1464 of yacc.c  */
#line 10675 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); ;}
    break;

  case 1666:

/* Line 1464 of yacc.c  */
#line 10687 "gram.y"
    {
					(yyval.range) = makeNode(RangeVar);
					(yyval.range)->catalogname = NULL;
					(yyval.range)->schemaname = NULL;
					(yyval.range)->relname = (yyvsp[(1) - (1)].str);
					(yyval.range)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1667:

/* Line 1464 of yacc.c  */
#line 10695 "gram.y"
    {
					check_qualified_name((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.range) = makeNode(RangeVar);
					switch (list_length((yyvsp[(2) - (2)].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[(1) - (2)].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[(2) - (2)].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[(1) - (2)].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[(2) - (2)].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[(2) - (2)].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)))),
									 parser_errposition((yylsp[(1) - (2)]))));
							break;
					}
					(yyval.range)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1668:

/* Line 1464 of yacc.c  */
#line 10723 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1669:

/* Line 1464 of yacc.c  */
#line 10725 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); ;}
    break;

  case 1670:

/* Line 1464 of yacc.c  */
#line 10729 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1671:

/* Line 1464 of yacc.c  */
#line 10732 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1672:

/* Line 1464 of yacc.c  */
#line 10735 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1673:

/* Line 1464 of yacc.c  */
#line 10737 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1674:

/* Line 1464 of yacc.c  */
#line 10739 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1675:

/* Line 1464 of yacc.c  */
#line 10741 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1676:

/* Line 1464 of yacc.c  */
#line 10752 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1677:

/* Line 1464 of yacc.c  */
#line 10754 "gram.y"
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)),
											 yyscanner);
					;}
    break;

  case 1678:

/* Line 1464 of yacc.c  */
#line 10765 "gram.y"
    {
					(yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)]));
				;}
    break;

  case 1679:

/* Line 1464 of yacc.c  */
#line 10769 "gram.y"
    {
					(yyval.node) = makeFloatConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1680:

/* Line 1464 of yacc.c  */
#line 10773 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1681:

/* Line 1464 of yacc.c  */
#line 10777 "gram.y"
    {
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1682:

/* Line 1464 of yacc.c  */
#line 10781 "gram.y"
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1683:

/* Line 1464 of yacc.c  */
#line 10790 "gram.y"
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (2)].list));
					t->location = (yylsp[(1) - (2)]);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), t);
				;}
    break;

  case 1684:

/* Line 1464 of yacc.c  */
#line 10797 "gram.y"
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (5)].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list in the production to avoid
					 * reduce/reduce conflicts, but we don't actually wish
					 * to allow NamedArgExpr in this context.
					 */
					foreach(lc, (yyvsp[(3) - (5)].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
								    (errcode(ERRCODE_SYNTAX_ERROR),
								     errmsg("type modifier cannot have AS name"),
								     parser_errposition(arg->location)));
					}
					t->typmods = (yyvsp[(3) - (5)].list);
					t->location = (yylsp[(1) - (5)]);
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (5)].str), (yylsp[(5) - (5)]), t);
				;}
    break;

  case 1685:

/* Line 1464 of yacc.c  */
#line 10822 "gram.y"
    {
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), (yyvsp[(1) - (2)].typnam));
				;}
    break;

  case 1686:

/* Line 1464 of yacc.c  */
#line 10826 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				;}
    break;

  case 1687:

/* Line 1464 of yacc.c  */
#line 10832 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (6)].typnam);
					if ((yyvsp[(6) - (6)].list) != NIL)
					{
						if (list_length((yyvsp[(6) - (6)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (6)]))));
						t->typmods = lappend((yyvsp[(6) - (6)].list), makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (6)].str), (yylsp[(5) - (6)]), t);
				;}
    break;

  case 1688:

/* Line 1464 of yacc.c  */
#line 10849 "gram.y"
    {
					(yyval.node) = makeBoolAConst(TRUE, (yylsp[(1) - (1)]));
				;}
    break;

  case 1689:

/* Line 1464 of yacc.c  */
#line 10853 "gram.y"
    {
					(yyval.node) = makeBoolAConst(FALSE, (yylsp[(1) - (1)]));
				;}
    break;

  case 1690:

/* Line 1464 of yacc.c  */
#line 10857 "gram.y"
    {
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				;}
    break;

  case 1691:

/* Line 1464 of yacc.c  */
#line 10862 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 1692:

/* Line 1464 of yacc.c  */
#line 10863 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1693:

/* Line 1464 of yacc.c  */
#line 10864 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1694:

/* Line 1464 of yacc.c  */
#line 10866 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 1695:

/* Line 1464 of yacc.c  */
#line 10867 "gram.y"
    { (yyval.ival) = + (yyvsp[(2) - (2)].ival); ;}
    break;

  case 1696:

/* Line 1464 of yacc.c  */
#line 10868 "gram.y"
    { (yyval.ival) = - (yyvsp[(2) - (2)].ival); ;}
    break;

  case 1697:

/* Line 1464 of yacc.c  */
#line 10871 "gram.y"
    { (yyval.list) = list_make1(makeInteger((yyvsp[(1) - (1)].ival))); ;}
    break;

  case 1698:

/* Line 1464 of yacc.c  */
#line 10872 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeInteger((yyvsp[(3) - (3)].ival))); ;}
    break;

  case 1699:

/* Line 1464 of yacc.c  */
#line 10888 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1700:

/* Line 1464 of yacc.c  */
#line 10889 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1701:

/* Line 1464 of yacc.c  */
#line 10890 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1702:

/* Line 1464 of yacc.c  */
#line 10895 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1703:

/* Line 1464 of yacc.c  */
#line 10896 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1704:

/* Line 1464 of yacc.c  */
#line 10897 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1705:

/* Line 1464 of yacc.c  */
#line 10903 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1706:

/* Line 1464 of yacc.c  */
#line 10904 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1707:

/* Line 1464 of yacc.c  */
#line 10905 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1708:

/* Line 1464 of yacc.c  */
#line 10906 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1709:

/* Line 1464 of yacc.c  */
#line 10907 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;



/* Line 1464 of yacc.c  */
#line 33762 "gram.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (&yylloc, yyscanner, yymsg);
	  }
	else
	  {
	    yyerror (&yylloc, yyscanner, YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc, yyscanner);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc, yyscanner);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1684 of yacc.c  */
#line 11360 "gram.y"


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* makeOverlaps()
 * Create and populate a FuncCall node to support the OVERLAPS operator.
 */
static FuncCall *
makeOverlaps(List *largs, List *rargs, int location, core_yyscan_t yyscanner)
{
	FuncCall *n = makeNode(FuncCall);

	n->funcname = SystemFuncName("overlaps");
	if (list_length(largs) == 1)
		largs = lappend(largs, largs);
	else if (list_length(largs) != 2)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
				 parser_errposition(location)));
	if (list_length(rargs) == 1)
		rargs = lappend(rargs, rargs);
	else if (list_length(rargs) != 2)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
				 parser_errposition(location)));
	n->args = list_concat(largs, rargs);
	n->agg_order = NIL;
	n->agg_star = FALSE;
	n->agg_distinct = FALSE;
	n->func_variadic = FALSE;
	n->over = NULL;
	n->location = location;
	return n;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* findLeftmostSelect()
 * Find the leftmost component SelectStmt in a set-operation parsetree.
 */
static SelectStmt *
findLeftmostSelect(SelectStmt *node)
{
	while (node && node->op != SETOP_NONE)
		node = node->larg;
	Assert(node && IsA(node, SelectStmt) && node->larg == NULL);
	return node;
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitOffset))));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitCount))));
		stmt->limitCount = limitCount;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
	{
		char   *newval = (char *) palloc(strlen(oldval) + 2);

		*newval = '-';
		strcpy(newval+1, oldval);
		v->val.str = newval;
	}
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr    *x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->location = location;
	return (Node *) x;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = (TypeName *) copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Must undefine this stuff before including scan.c, since it has different
 * definitions for these macros.
 */
#undef yyerror
#undef yylval
#undef yylloc

#include "scan.c"

